/* AppSystem.c generated by valac 0.56.18, the Vala compiler
 * generated from AppSystem.vala, do not modify */

/*
 * Copyright 2011-2021 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include "slingshot.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gio/gdesktopappinfo.h>

#define SLINGSHOT_BACKEND_APP_SYSTEM_MENU_REFRESH_TIMEOUT_SECONDS 3
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SLINGSHOT_BACKEND_APP_SYSTEM_0_PROPERTY,
	SLINGSHOT_BACKEND_APP_SYSTEM_APPS_PROPERTY,
	SLINGSHOT_BACKEND_APP_SYSTEM_NUM_PROPERTIES
};
static GParamSpec* slingshot_backend_app_system_properties[SLINGSHOT_BACKEND_APP_SYSTEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	SLINGSHOT_BACKEND_APP_SYSTEM_CHANGED_SIGNAL,
	SLINGSHOT_BACKEND_APP_SYSTEM_NUM_SIGNALS
};
static guint slingshot_backend_app_system_signals[SLINGSHOT_BACKEND_APP_SYSTEM_NUM_SIGNALS] = {0};

struct _SlingshotBackendAppSystemPrivate {
	GeeHashMap* _apps;
	guint refresh_timeout_id;
	GeeArrayList* categories_cache;
	GAppInfoMonitor* app_monitor;
};

static gint SlingshotBackendAppSystem_private_offset;
static gpointer slingshot_backend_app_system_parent_class = NULL;
static GType slingshot_backend_app_system_type_id = 0;

static void slingshot_backend_app_system_queue_update_app_system (SlingshotBackendAppSystem* self);
static gboolean __lambda33_ (SlingshotBackendAppSystem* self);
static void slingshot_backend_app_system_update_app_system (SlingshotBackendAppSystem* self);
static gboolean ___lambda33__gsource_func (gpointer self);
static void slingshot_backend_app_system_update_categories_index (SlingshotBackendAppSystem* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static gint slingshot_backend_app_system_sort_apps_by_name (SlingshotBackendApp* a,
                                                     SlingshotBackendApp* b);
static gint _slingshot_backend_app_system_sort_apps_by_name_gcompare_data_func (gconstpointer a,
                                                                         gconstpointer b,
                                                                         gpointer self);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void slingshot_backend_app_system_set_apps (SlingshotBackendAppSystem* self,
                                            GeeHashMap* value);
static GObject * slingshot_backend_app_system_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties);
static void _slingshot_backend_app_system_queue_update_app_system_g_app_info_monitor_changed (GAppInfoMonitor* _sender,
                                                                                       gpointer self);
static void slingshot_backend_app_system_finalize (GObject * obj);
static void _vala_slingshot_backend_app_system_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_slingshot_backend_app_system_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
slingshot_backend_app_system_get_instance_private (SlingshotBackendAppSystem* self)
{
	return G_STRUCT_MEMBER_P (self, SlingshotBackendAppSystem_private_offset);
}

static gboolean
__lambda33_ (SlingshotBackendAppSystem* self)
{
	gboolean result;
#line 56 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	slingshot_backend_app_system_update_app_system (self);
#line 57 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	self->priv->refresh_timeout_id = (guint) 0;
#line 59 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	result = G_SOURCE_REMOVE;
#line 59 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	return result;
#line 127 "AppSystem.c"
}

static gboolean
___lambda33__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda33_ ((SlingshotBackendAppSystem*) self);
#line 55 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	return result;
#line 137 "AppSystem.c"
}

static void
slingshot_backend_app_system_queue_update_app_system (SlingshotBackendAppSystem* self)
{
#line 49 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	g_return_if_fail (self != NULL);
#line 50 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	if (self->priv->refresh_timeout_id != ((guint) 0)) {
#line 51 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		g_source_remove (self->priv->refresh_timeout_id);
#line 52 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		self->priv->refresh_timeout_id = (guint) 0;
#line 151 "AppSystem.c"
	}
#line 55 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	self->priv->refresh_timeout_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) SLINGSHOT_BACKEND_APP_SYSTEM_MENU_REFRESH_TIMEOUT_SECONDS, ___lambda33__gsource_func, g_object_ref (self), g_object_unref);
#line 155 "AppSystem.c"
}

static void
slingshot_backend_app_system_update_app_system (SlingshotBackendAppSystem* self)
{
#line 63 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	g_return_if_fail (self != NULL);
#line 64 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	g_debug ("AppSystem.vala:64: Updating Applications menu tree…");
#line 69 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	slingshot_backend_app_system_update_categories_index (self);
#line 70 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	g_signal_emit (self, slingshot_backend_app_system_signals[SLINGSHOT_BACKEND_APP_SYSTEM_CHANGED_SIGNAL], 0);
#line 169 "AppSystem.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 158 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	return self ? g_object_ref (self) : NULL;
#line 177 "AppSystem.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 196 "AppSystem.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 158 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 204 "AppSystem.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 158 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 212 "AppSystem.c"
}

static void
slingshot_backend_app_system_update_categories_index (SlingshotBackendAppSystem* self)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar** _tmp6_;
	gchar* _tmp7_;
	gchar** _tmp8_;
	SlingshotBackendCategory* _tmp9_ = NULL;
	SlingshotBackendCategory* _tmp10_;
	GeeArrayList* _tmp11_;
	gchar* _tmp12_;
	gchar** _tmp13_;
	SlingshotBackendCategory* _tmp14_ = NULL;
	SlingshotBackendCategory* _tmp15_;
	GeeArrayList* _tmp16_;
	gchar* _tmp17_;
	gchar** _tmp18_;
	SlingshotBackendCategory* _tmp19_ = NULL;
	SlingshotBackendCategory* _tmp20_;
	GeeArrayList* _tmp21_;
	gchar* _tmp22_;
	gchar** _tmp23_;
	gchar* _tmp24_;
	gchar** _tmp25_;
	SlingshotBackendCategory* _tmp26_ = NULL;
	SlingshotBackendCategory* _tmp27_;
	GeeArrayList* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar** _tmp31_;
	gchar* _tmp32_;
	gchar** _tmp33_;
	SlingshotBackendCategory* _tmp34_ = NULL;
	SlingshotBackendCategory* _tmp35_;
	GeeArrayList* _tmp36_;
	gchar* _tmp37_;
	gchar** _tmp38_;
	SlingshotBackendCategory* _tmp39_ = NULL;
	SlingshotBackendCategory* _tmp40_;
	GeeArrayList* _tmp41_;
	gchar* _tmp42_;
	gchar** _tmp43_;
	SlingshotBackendCategory* _tmp44_ = NULL;
	SlingshotBackendCategory* _tmp45_;
	GeeArrayList* _tmp46_;
	gchar* _tmp47_;
	gchar** _tmp48_;
	SlingshotBackendCategory* _tmp49_ = NULL;
	SlingshotBackendCategory* _tmp50_;
	GeeArrayList* _tmp51_;
	gchar* _tmp52_;
	gchar** _tmp53_;
	SlingshotBackendCategory* _tmp54_ = NULL;
	SlingshotBackendCategory* _tmp55_;
	GeeArrayList* _tmp56_;
	gchar* _tmp57_;
	gchar** _tmp58_;
	SlingshotBackendCategory* _tmp59_ = NULL;
	SlingshotBackendCategory* _tmp60_;
	GeeArrayList* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	gchar** _tmp65_;
	gchar* _tmp66_;
	gchar** _tmp67_;
	gchar* _tmp68_;
	gchar** _tmp69_;
	SlingshotBackendCategory* _tmp70_ = NULL;
	SlingshotBackendCategory* _tmp71_;
	SlingshotBackendCategory* other_category = NULL;
	gchar* _tmp72_;
	gchar* _tmp73_;
	gchar* _tmp74_;
	gchar** _tmp75_;
	SlingshotBackendCategory* _tmp76_ = NULL;
	GList* _tmp77_;
	SlingshotBackendCategory* _tmp112_;
	GeeArrayList* _tmp113_;
	GeeArrayList* _tmp114_;
	gint _tmp115_;
	gint _tmp116_;
	GeeHashMap* _tmp119_;
#line 73 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	g_return_if_fail (self != NULL);
#line 74 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp0_ = self->priv->categories_cache;
#line 74 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp1_ = self->priv->categories_cache;
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp2_ = g_strdup ("Utility");
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp3_ = g_new0 (gchar*, 1 + 1);
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp3_[0] = _tmp2_;
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp4_ = g_strdup ("Accessibility");
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp5_ = g_strdup ("System");
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp6_ = g_new0 (gchar*, 2 + 1);
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp6_[0] = _tmp4_;
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp6_[1] = _tmp5_;
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp7_ = g_strdup ("plank.desktop");
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp8_ = g_new0 (gchar*, 1 + 1);
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp8_[0] = _tmp7_;
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp9_ = slingshot_backend_category_new (_ ("Accessories"), FALSE);
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp9_->included_categories = (_vala_array_free (_tmp9_->included_categories, _tmp9_->included_categories_length1, (GDestroyNotify) g_free), NULL);
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp9_->included_categories = _tmp3_;
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp9_->included_categories_length1 = 1;
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp9_->excluded_categories = (_vala_array_free (_tmp9_->excluded_categories, _tmp9_->excluded_categories_length1, (GDestroyNotify) g_free), NULL);
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp9_->excluded_categories = _tmp6_;
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp9_->excluded_categories_length1 = 2;
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp9_->excluded_applications = (_vala_array_free (_tmp9_->excluded_applications, _tmp9_->excluded_applications_length1, (GDestroyNotify) g_free), NULL);
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp9_->excluded_applications = _tmp8_;
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp9_->excluded_applications_length1 = 1;
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp10_ = _tmp9_;
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, _tmp10_);
#line 76 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_g_object_unref0 (_tmp10_);
#line 86 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp11_ = self->priv->categories_cache;
#line 86 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp12_ = g_strdup ("Accessibility");
#line 86 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp13_ = g_new0 (gchar*, 1 + 1);
#line 86 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp13_[0] = _tmp12_;
#line 86 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp14_ = slingshot_backend_category_new (_ ("Universal Access"), FALSE);
#line 86 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp14_->included_categories = (_vala_array_free (_tmp14_->included_categories, _tmp14_->included_categories_length1, (GDestroyNotify) g_free), NULL);
#line 86 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp14_->included_categories = _tmp13_;
#line 86 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp14_->included_categories_length1 = 1;
#line 86 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp15_ = _tmp14_;
#line 86 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp15_);
#line 86 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_g_object_unref0 (_tmp15_);
#line 95 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp16_ = self->priv->categories_cache;
#line 95 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp17_ = g_strdup ("Development");
#line 95 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp18_ = g_new0 (gchar*, 1 + 1);
#line 95 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp18_[0] = _tmp17_;
#line 95 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp19_ = slingshot_backend_category_new (_ ("Programming"), FALSE);
#line 95 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp19_->included_categories = (_vala_array_free (_tmp19_->included_categories, _tmp19_->included_categories_length1, (GDestroyNotify) g_free), NULL);
#line 95 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp19_->included_categories = _tmp18_;
#line 95 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp19_->included_categories_length1 = 1;
#line 95 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp20_ = _tmp19_;
#line 95 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp20_);
#line 95 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_g_object_unref0 (_tmp20_);
#line 101 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp21_ = self->priv->categories_cache;
#line 101 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp22_ = g_strdup ("Education");
#line 101 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp23_ = g_new0 (gchar*, 1 + 1);
#line 101 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp23_[0] = _tmp22_;
#line 101 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp24_ = g_strdup ("Science");
#line 101 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp25_ = g_new0 (gchar*, 1 + 1);
#line 101 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp25_[0] = _tmp24_;
#line 101 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp26_ = slingshot_backend_category_new (_ ("Education"), FALSE);
#line 101 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp26_->included_categories = (_vala_array_free (_tmp26_->included_categories, _tmp26_->included_categories_length1, (GDestroyNotify) g_free), NULL);
#line 101 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp26_->included_categories = _tmp23_;
#line 101 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp26_->included_categories_length1 = 1;
#line 101 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp26_->excluded_categories = (_vala_array_free (_tmp26_->excluded_categories, _tmp26_->excluded_categories_length1, (GDestroyNotify) g_free), NULL);
#line 101 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp26_->excluded_categories = _tmp25_;
#line 101 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp26_->excluded_categories_length1 = 1;
#line 101 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp27_ = _tmp26_;
#line 101 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, _tmp27_);
#line 101 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_g_object_unref0 (_tmp27_);
#line 108 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp28_ = self->priv->categories_cache;
#line 108 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp29_ = g_strdup ("Science");
#line 108 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp30_ = g_strdup ("Education");
#line 108 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp31_ = g_new0 (gchar*, 2 + 1);
#line 108 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp31_[0] = _tmp29_;
#line 108 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp31_[1] = _tmp30_;
#line 108 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp32_ = g_strdup ("libreoffice-math.desktop");
#line 108 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp33_ = g_new0 (gchar*, 1 + 1);
#line 108 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp33_[0] = _tmp32_;
#line 108 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp34_ = slingshot_backend_category_new (_ ("Science"), FALSE);
#line 108 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp34_->included_categories = (_vala_array_free (_tmp34_->included_categories, _tmp34_->included_categories_length1, (GDestroyNotify) g_free), NULL);
#line 108 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp34_->included_categories = _tmp31_;
#line 108 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp34_->included_categories_length1 = 2;
#line 108 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp34_->excluded_applications = (_vala_array_free (_tmp34_->excluded_applications, _tmp34_->excluded_applications_length1, (GDestroyNotify) g_free), NULL);
#line 108 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp34_->excluded_applications = _tmp33_;
#line 108 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp34_->excluded_applications_length1 = 1;
#line 108 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp35_ = _tmp34_;
#line 108 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp35_);
#line 108 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_g_object_unref0 (_tmp35_);
#line 115 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp36_ = self->priv->categories_cache;
#line 115 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp37_ = g_strdup ("Game");
#line 115 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp38_ = g_new0 (gchar*, 1 + 1);
#line 115 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp38_[0] = _tmp37_;
#line 115 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp39_ = slingshot_backend_category_new (_ ("Games"), FALSE);
#line 115 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp39_->included_categories = (_vala_array_free (_tmp39_->included_categories, _tmp39_->included_categories_length1, (GDestroyNotify) g_free), NULL);
#line 115 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp39_->included_categories = _tmp38_;
#line 115 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp39_->included_categories_length1 = 1;
#line 115 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp40_ = _tmp39_;
#line 115 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, _tmp40_);
#line 115 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_g_object_unref0 (_tmp40_);
#line 121 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp41_ = self->priv->categories_cache;
#line 121 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp42_ = g_strdup ("Graphics");
#line 121 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp43_ = g_new0 (gchar*, 1 + 1);
#line 121 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp43_[0] = _tmp42_;
#line 121 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp44_ = slingshot_backend_category_new (_ ("Graphics"), FALSE);
#line 121 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp44_->included_categories = (_vala_array_free (_tmp44_->included_categories, _tmp44_->included_categories_length1, (GDestroyNotify) g_free), NULL);
#line 121 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp44_->included_categories = _tmp43_;
#line 121 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp44_->included_categories_length1 = 1;
#line 121 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp45_ = _tmp44_;
#line 121 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp41_, _tmp45_);
#line 121 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_g_object_unref0 (_tmp45_);
#line 127 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp46_ = self->priv->categories_cache;
#line 127 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp47_ = g_strdup ("Network");
#line 127 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp48_ = g_new0 (gchar*, 1 + 1);
#line 127 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp48_[0] = _tmp47_;
#line 127 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp49_ = slingshot_backend_category_new (_ ("Internet"), FALSE);
#line 127 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp49_->included_categories = (_vala_array_free (_tmp49_->included_categories, _tmp49_->included_categories_length1, (GDestroyNotify) g_free), NULL);
#line 127 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp49_->included_categories = _tmp48_;
#line 127 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp49_->included_categories_length1 = 1;
#line 127 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp50_ = _tmp49_;
#line 127 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp46_, _tmp50_);
#line 127 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_g_object_unref0 (_tmp50_);
#line 133 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp51_ = self->priv->categories_cache;
#line 133 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp52_ = g_strdup ("AudioVideo");
#line 133 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp53_ = g_new0 (gchar*, 1 + 1);
#line 133 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp53_[0] = _tmp52_;
#line 133 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp54_ = slingshot_backend_category_new (_ ("Sound & Video"), FALSE);
#line 133 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp54_->included_categories = (_vala_array_free (_tmp54_->included_categories, _tmp54_->included_categories_length1, (GDestroyNotify) g_free), NULL);
#line 133 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp54_->included_categories = _tmp53_;
#line 133 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp54_->included_categories_length1 = 1;
#line 133 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp55_ = _tmp54_;
#line 133 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp51_, _tmp55_);
#line 133 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_g_object_unref0 (_tmp55_);
#line 139 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp56_ = self->priv->categories_cache;
#line 139 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp57_ = g_strdup ("Office");
#line 139 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp58_ = g_new0 (gchar*, 1 + 1);
#line 139 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp58_[0] = _tmp57_;
#line 139 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp59_ = slingshot_backend_category_new (_ ("Office"), FALSE);
#line 139 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp59_->included_categories = (_vala_array_free (_tmp59_->included_categories, _tmp59_->included_categories_length1, (GDestroyNotify) g_free), NULL);
#line 139 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp59_->included_categories = _tmp58_;
#line 139 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp59_->included_categories_length1 = 1;
#line 139 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp60_ = _tmp59_;
#line 139 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp56_, _tmp60_);
#line 139 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_g_object_unref0 (_tmp60_);
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp61_ = self->priv->categories_cache;
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp62_ = g_strdup ("System");
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp63_ = g_strdup ("Administration");
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp64_ = g_strdup ("Settings");
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp65_ = g_new0 (gchar*, 3 + 1);
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp65_[0] = _tmp62_;
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp65_[1] = _tmp63_;
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp65_[2] = _tmp64_;
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp66_ = g_strdup ("Game");
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp67_ = g_new0 (gchar*, 1 + 1);
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp67_[0] = _tmp66_;
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp68_ = g_strdup ("onboard-settings.desktop");
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp69_ = g_new0 (gchar*, 1 + 1);
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp69_[0] = _tmp68_;
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp70_ = slingshot_backend_category_new (_ ("System Tools"), FALSE);
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp70_->included_categories = (_vala_array_free (_tmp70_->included_categories, _tmp70_->included_categories_length1, (GDestroyNotify) g_free), NULL);
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp70_->included_categories = _tmp65_;
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp70_->included_categories_length1 = 3;
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp70_->excluded_categories = (_vala_array_free (_tmp70_->excluded_categories, _tmp70_->excluded_categories_length1, (GDestroyNotify) g_free), NULL);
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp70_->excluded_categories = _tmp67_;
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp70_->excluded_categories_length1 = 1;
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp70_->excluded_applications = (_vala_array_free (_tmp70_->excluded_applications, _tmp70_->excluded_applications_length1, (GDestroyNotify) g_free), NULL);
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp70_->excluded_applications = _tmp69_;
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp70_->excluded_applications_length1 = 1;
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp71_ = _tmp70_;
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp61_, _tmp71_);
#line 145 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_g_object_unref0 (_tmp71_);
#line 153 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp72_ = g_strdup ("Core");
#line 153 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp73_ = g_strdup ("Screensaver");
#line 153 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp74_ = g_strdup ("Settings");
#line 153 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp75_ = g_new0 (gchar*, 3 + 1);
#line 153 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp75_[0] = _tmp72_;
#line 153 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp75_[1] = _tmp73_;
#line 153 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp75_[2] = _tmp74_;
#line 153 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp76_ = slingshot_backend_category_new (_ ("Other"), TRUE);
#line 153 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp76_->excluded_categories = (_vala_array_free (_tmp76_->excluded_categories, _tmp76_->excluded_categories_length1, (GDestroyNotify) g_free), NULL);
#line 153 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp76_->excluded_categories = _tmp75_;
#line 153 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp76_->excluded_categories_length1 = 3;
#line 153 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	other_category = _tmp76_;
#line 158 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp77_ = g_app_info_get_all ();
#line 665 "AppSystem.c"
	{
		GList* app_collection = NULL;
		GList* app_it = NULL;
#line 158 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		app_collection = _tmp77_;
#line 158 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		for (app_it = app_collection; app_it != NULL; app_it = app_it->next) {
#line 673 "AppSystem.c"
			GAppInfo* _tmp78_;
			GAppInfo* app = NULL;
#line 158 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			_tmp78_ = _g_object_ref0 ((GAppInfo*) app_it->data);
#line 158 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			app = _tmp78_;
#line 680 "AppSystem.c"
			{
				GDesktopAppInfo* desktop_app = NULL;
				GAppInfo* _tmp79_;
				GDesktopAppInfo* _tmp80_;
				GDesktopAppInfo* _tmp81_;
				gchar* control_center = NULL;
				gchar* _tmp82_;
				gchar* _tmp83_;
				gchar* _tmp84_;
				gboolean _tmp85_;
				gboolean _tmp87_ = FALSE;
				GAppInfo* _tmp88_;
				const gchar* _tmp89_;
				const gchar* _tmp90_;
				GAppInfo* _tmp98_;
				const gchar* _tmp99_;
				gboolean found_category = FALSE;
#line 159 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp79_ = app;
#line 159 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				desktop_app = G_TYPE_CHECK_INSTANCE_TYPE (_tmp79_, G_TYPE_DESKTOP_APP_INFO) ? ((GDesktopAppInfo*) _tmp79_) : NULL;
#line 160 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp80_ = desktop_app;
#line 160 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				if (_tmp80_ == NULL) {
#line 161 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_g_object_unref0 (app);
#line 161 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					continue;
#line 710 "AppSystem.c"
				}
#line 164 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp81_ = desktop_app;
#line 164 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				if (!g_app_info_should_show ((GAppInfo*) _tmp81_)) {
#line 165 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_g_object_unref0 (app);
#line 165 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					continue;
#line 720 "AppSystem.c"
				}
#line 168 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp82_ = g_strdup ("gnome-control-center");
#line 168 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				control_center = _tmp82_;
#line 170 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp83_ = g_find_program_in_path ("budgie-control-center");
#line 170 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp84_ = _tmp83_;
#line 170 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp85_ = _tmp84_ != NULL;
#line 170 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_g_free0 (_tmp84_);
#line 170 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				if (_tmp85_) {
#line 736 "AppSystem.c"
					gchar* _tmp86_;
#line 171 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp86_ = g_strdup ("budgie-control-center");
#line 171 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_g_free0 (control_center);
#line 171 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					control_center = _tmp86_;
#line 744 "AppSystem.c"
				}
#line 173 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp88_ = app;
#line 173 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp89_ = g_app_info_get_commandline (_tmp88_);
#line 173 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp90_ = control_center;
#line 173 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				if (string_contains (_tmp89_, _tmp90_)) {
#line 754 "AppSystem.c"
					GAppInfo* _tmp91_;
					const gchar* _tmp92_;
					gint _tmp93_;
					gint _tmp94_;
					const gchar* _tmp95_;
					gint _tmp96_;
					gint _tmp97_;
#line 173 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp91_ = app;
#line 173 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp92_ = g_app_info_get_commandline (_tmp91_);
#line 173 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp93_ = strlen (_tmp92_);
#line 173 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp94_ = _tmp93_;
#line 173 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp95_ = control_center;
#line 173 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp96_ = strlen (_tmp95_);
#line 173 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp97_ = _tmp96_;
#line 173 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp87_ = _tmp94_ != _tmp97_;
#line 778 "AppSystem.c"
				} else {
#line 173 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp87_ = FALSE;
#line 782 "AppSystem.c"
				}
#line 173 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				if (_tmp87_) {
#line 174 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_g_free0 (control_center);
#line 174 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_g_object_unref0 (app);
#line 174 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					continue;
#line 792 "AppSystem.c"
				}
#line 177 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp98_ = app;
#line 177 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp99_ = g_app_info_get_commandline (_tmp98_);
#line 177 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				if (g_strcmp0 (_tmp99_, "plank") == 0) {
#line 178 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_g_free0 (control_center);
#line 178 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_g_object_unref0 (app);
#line 178 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					continue;
#line 806 "AppSystem.c"
				}
#line 181 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				found_category = FALSE;
#line 810 "AppSystem.c"
				{
					GeeArrayList* _category_list = NULL;
					GeeArrayList* _tmp100_;
					gint _category_size = 0;
					GeeArrayList* _tmp101_;
					gint _tmp102_;
					gint _tmp103_;
					gint _category_index = 0;
#line 182 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp100_ = self->priv->categories_cache;
#line 182 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_category_list = _tmp100_;
#line 182 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp101_ = _category_list;
#line 182 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp102_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp101_);
#line 182 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp103_ = _tmp102_;
#line 182 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_category_size = _tmp103_;
#line 182 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_category_index = -1;
#line 182 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					while (TRUE) {
#line 835 "AppSystem.c"
						gint _tmp104_;
						gint _tmp105_;
						SlingshotBackendCategory* category = NULL;
						GeeArrayList* _tmp106_;
						gpointer _tmp107_;
						SlingshotBackendCategory* _tmp108_;
						GDesktopAppInfo* _tmp109_;
#line 182 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
						_category_index = _category_index + 1;
#line 182 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
						_tmp104_ = _category_index;
#line 182 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
						_tmp105_ = _category_size;
#line 182 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
						if (!(_tmp104_ < _tmp105_)) {
#line 182 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
							break;
#line 853 "AppSystem.c"
						}
#line 182 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
						_tmp106_ = _category_list;
#line 182 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
						_tmp107_ = gee_abstract_list_get ((GeeAbstractList*) _tmp106_, _category_index);
#line 182 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
						category = (SlingshotBackendCategory*) _tmp107_;
#line 183 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
						_tmp108_ = category;
#line 183 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
						_tmp109_ = desktop_app;
#line 183 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
						if (slingshot_backend_category_add_app_if_matches (_tmp108_, _tmp109_)) {
#line 184 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
							found_category = TRUE;
#line 869 "AppSystem.c"
						}
#line 182 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
						_g_object_unref0 (category);
#line 873 "AppSystem.c"
					}
				}
#line 188 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				if (!found_category) {
#line 878 "AppSystem.c"
					SlingshotBackendCategory* _tmp110_;
					GDesktopAppInfo* _tmp111_;
#line 189 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp110_ = other_category;
#line 189 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp111_ = desktop_app;
#line 189 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					slingshot_backend_category_add_app_if_matches (_tmp110_, _tmp111_);
#line 887 "AppSystem.c"
				}
#line 158 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_g_free0 (control_center);
#line 158 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_g_object_unref0 (app);
#line 893 "AppSystem.c"
			}
		}
#line 158 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		(app_collection == NULL) ? NULL : (app_collection = (_g_list_free__g_object_unref0_ (app_collection), NULL));
#line 898 "AppSystem.c"
	}
#line 193 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp112_ = other_category;
#line 193 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp113_ = slingshot_backend_category_get_apps (_tmp112_);
#line 193 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp114_ = _tmp113_;
#line 193 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp115_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp114_);
#line 193 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp116_ = _tmp115_;
#line 193 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	if (_tmp116_ > 0) {
#line 912 "AppSystem.c"
		GeeArrayList* _tmp117_;
		SlingshotBackendCategory* _tmp118_;
#line 194 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		_tmp117_ = self->priv->categories_cache;
#line 194 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		_tmp118_ = other_category;
#line 194 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp117_, _tmp118_);
#line 921 "AppSystem.c"
	}
#line 197 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp119_ = self->priv->_apps;
#line 197 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp119_);
#line 927 "AppSystem.c"
	{
		GeeArrayList* _cat_list = NULL;
		GeeArrayList* _tmp120_;
		gint _cat_size = 0;
		GeeArrayList* _tmp121_;
		gint _tmp122_;
		gint _tmp123_;
		gint _cat_index = 0;
#line 198 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		_tmp120_ = self->priv->categories_cache;
#line 198 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		_cat_list = _tmp120_;
#line 198 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		_tmp121_ = _cat_list;
#line 198 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		_tmp122_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp121_);
#line 198 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		_tmp123_ = _tmp122_;
#line 198 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		_cat_size = _tmp123_;
#line 198 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		_cat_index = -1;
#line 198 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		while (TRUE) {
#line 952 "AppSystem.c"
			gint _tmp124_;
			gint _tmp125_;
			SlingshotBackendCategory* cat = NULL;
			GeeArrayList* _tmp126_;
			gpointer _tmp127_;
			SlingshotBackendCategory* _tmp128_;
			GeeArrayList* _tmp129_;
			GeeArrayList* _tmp130_;
			gint _tmp131_;
			gint _tmp132_;
#line 198 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			_cat_index = _cat_index + 1;
#line 198 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			_tmp124_ = _cat_index;
#line 198 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			_tmp125_ = _cat_size;
#line 198 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			if (!(_tmp124_ < _tmp125_)) {
#line 198 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				break;
#line 973 "AppSystem.c"
			}
#line 198 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			_tmp126_ = _cat_list;
#line 198 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			_tmp127_ = gee_abstract_list_get ((GeeAbstractList*) _tmp126_, _cat_index);
#line 198 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			cat = (SlingshotBackendCategory*) _tmp127_;
#line 199 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			_tmp128_ = cat;
#line 199 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			_tmp129_ = slingshot_backend_category_get_apps (_tmp128_);
#line 199 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			_tmp130_ = _tmp129_;
#line 199 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			_tmp131_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp130_);
#line 199 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			_tmp132_ = _tmp131_;
#line 199 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			if (_tmp132_ > 0) {
#line 993 "AppSystem.c"
				GeeHashMap* _tmp133_;
				SlingshotBackendCategory* _tmp134_;
				const gchar* _tmp135_;
				const gchar* _tmp136_;
				SlingshotBackendCategory* _tmp137_;
				GeeArrayList* _tmp138_;
				GeeArrayList* _tmp139_;
#line 200 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp133_ = self->priv->_apps;
#line 200 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp134_ = cat;
#line 200 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp135_ = slingshot_backend_category_get_name (_tmp134_);
#line 200 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp136_ = _tmp135_;
#line 200 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp137_ = cat;
#line 200 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp138_ = slingshot_backend_category_get_apps (_tmp137_);
#line 200 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp139_ = _tmp138_;
#line 200 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp133_, _tmp136_, _tmp139_);
#line 1017 "AppSystem.c"
			}
#line 198 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			_g_object_unref0 (cat);
#line 1021 "AppSystem.c"
		}
	}
#line 73 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_g_object_unref0 (other_category);
#line 1026 "AppSystem.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 219 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	for (i = 0; i < stack_length; i++) {
#line 219 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 219 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			return TRUE;
#line 1041 "AppSystem.c"
		}
	}
#line 219 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	return FALSE;
#line 1046 "AppSystem.c"
}

static gint
_slingshot_backend_app_system_sort_apps_by_name_gcompare_data_func (gconstpointer a,
                                                                    gconstpointer b,
                                                                    gpointer self)
{
	gint result;
	result = slingshot_backend_app_system_sort_apps_by_name ((SlingshotBackendApp*) a, (SlingshotBackendApp*) b);
#line 220 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	return result;
#line 1058 "AppSystem.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 221 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	if ((*length) == (*size)) {
#line 221 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 221 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1073 "AppSystem.c"
	}
#line 221 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	(*array)[(*length)++] = value;
#line 221 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	(*array)[*length] = NULL;
#line 1079 "AppSystem.c"
}

GSList*
slingshot_backend_app_system_get_apps_by_name (SlingshotBackendAppSystem* self)
{
	GSList* sorted_apps = NULL;
	gchar** sorted_apps_execs = NULL;
	gchar** _tmp0_;
	gint sorted_apps_execs_length1;
	gint _sorted_apps_execs_size_;
	GSList* result;
#line 213 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 214 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	sorted_apps = NULL;
#line 215 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 215 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	sorted_apps_execs = _tmp0_;
#line 215 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	sorted_apps_execs_length1 = 0;
#line 215 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_sorted_apps_execs_size_ = sorted_apps_execs_length1;
#line 1103 "AppSystem.c"
	{
		GeeIterator* _category_it = NULL;
		GeeHashMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 217 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		_tmp1_ = self->priv->_apps;
#line 217 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 217 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		_tmp3_ = _tmp2_;
#line 217 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		_tmp4_ = _tmp3_;
#line 217 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 217 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		_tmp6_ = _tmp5_;
#line 217 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		_g_object_unref0 (_tmp4_);
#line 217 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		_category_it = _tmp6_;
#line 217 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		while (TRUE) {
#line 1130 "AppSystem.c"
			GeeIterator* _tmp7_;
			GeeArrayList* category = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
#line 217 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			_tmp7_ = _category_it;
#line 217 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 217 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				break;
#line 1141 "AppSystem.c"
			}
#line 217 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			_tmp8_ = _category_it;
#line 217 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 217 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			category = (GeeArrayList*) _tmp9_;
#line 1149 "AppSystem.c"
			{
				GeeArrayList* _app_list = NULL;
				GeeArrayList* _tmp10_;
				gint _app_size = 0;
				GeeArrayList* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				gint _app_index = 0;
#line 218 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp10_ = category;
#line 218 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_app_list = _tmp10_;
#line 218 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp11_ = _app_list;
#line 218 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 218 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_tmp13_ = _tmp12_;
#line 218 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_app_size = _tmp13_;
#line 218 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				_app_index = -1;
#line 218 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
				while (TRUE) {
#line 1174 "AppSystem.c"
					gint _tmp14_;
					gint _tmp15_;
					SlingshotBackendApp* app = NULL;
					GeeArrayList* _tmp16_;
					gpointer _tmp17_;
					SlingshotBackendApp* _tmp18_;
					const gchar* _tmp19_;
					const gchar* _tmp20_;
					gchar** _tmp21_;
					gint _tmp21__length1;
#line 218 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_app_index = _app_index + 1;
#line 218 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp14_ = _app_index;
#line 218 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp15_ = _app_size;
#line 218 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					if (!(_tmp14_ < _tmp15_)) {
#line 218 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
						break;
#line 1195 "AppSystem.c"
					}
#line 218 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp16_ = _app_list;
#line 218 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp16_, _app_index);
#line 218 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					app = (SlingshotBackendApp*) _tmp17_;
#line 219 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp18_ = app;
#line 219 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp19_ = slingshot_backend_app_get_exec (_tmp18_);
#line 219 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp20_ = _tmp19_;
#line 219 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp21_ = sorted_apps_execs;
#line 219 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_tmp21__length1 = sorted_apps_execs_length1;
#line 219 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					if (!_vala_string_array_contains (_tmp21_, _tmp21__length1, _tmp20_)) {
#line 1215 "AppSystem.c"
						SlingshotBackendApp* _tmp22_;
						SlingshotBackendApp* _tmp23_;
						SlingshotBackendApp* _tmp24_;
						const gchar* _tmp25_;
						const gchar* _tmp26_;
						gchar* _tmp27_;
#line 220 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
						_tmp22_ = app;
#line 220 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
						_tmp23_ = _g_object_ref0 (_tmp22_);
#line 220 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
						sorted_apps = g_slist_insert_sorted_with_data (sorted_apps, _tmp23_, _slingshot_backend_app_system_sort_apps_by_name_gcompare_data_func, NULL);
#line 221 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
						_tmp24_ = app;
#line 221 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
						_tmp25_ = slingshot_backend_app_get_exec (_tmp24_);
#line 221 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
						_tmp26_ = _tmp25_;
#line 221 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
						_tmp27_ = g_strdup (_tmp26_);
#line 221 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
						_vala_array_add2 (&sorted_apps_execs, &sorted_apps_execs_length1, &_sorted_apps_execs_size_, _tmp27_);
#line 1238 "AppSystem.c"
					}
#line 218 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
					_g_object_unref0 (app);
#line 1242 "AppSystem.c"
				}
			}
#line 217 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
			_g_object_unref0 (category);
#line 1247 "AppSystem.c"
		}
#line 217 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		_g_object_unref0 (_category_it);
#line 1251 "AppSystem.c"
	}
#line 226 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	result = sorted_apps;
#line 226 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	sorted_apps_execs = (_vala_array_free (sorted_apps_execs, sorted_apps_execs_length1, (GDestroyNotify) g_free), NULL);
#line 226 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	return result;
#line 1259 "AppSystem.c"
}

static gint
slingshot_backend_app_system_sort_apps_by_name (SlingshotBackendApp* a,
                                                SlingshotBackendApp* b)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint result;
#line 229 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 229 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 230 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp0_ = slingshot_backend_app_get_name (a);
#line 230 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp1_ = _tmp0_;
#line 230 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp2_ = slingshot_backend_app_get_name (b);
#line 230 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp3_ = _tmp2_;
#line 230 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	result = g_utf8_collate (_tmp1_, _tmp3_);
#line 230 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	return result;
#line 1287 "AppSystem.c"
}

SlingshotBackendAppSystem*
slingshot_backend_app_system_construct (GType object_type)
{
	SlingshotBackendAppSystem * self = NULL;
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	self = (SlingshotBackendAppSystem*) g_object_new (object_type, NULL);
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	return self;
#line 1298 "AppSystem.c"
}

SlingshotBackendAppSystem*
slingshot_backend_app_system_new (void)
{
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	return slingshot_backend_app_system_construct (SLINGSHOT_BACKEND_TYPE_APP_SYSTEM);
#line 1306 "AppSystem.c"
}

GeeHashMap*
slingshot_backend_app_system_get_apps (SlingshotBackendAppSystem* self)
{
	GeeHashMap* result;
	GeeHashMap* _tmp0_;
#line 21 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp0_ = self->priv->_apps;
#line 21 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	result = _tmp0_;
#line 21 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	return result;
#line 1322 "AppSystem.c"
}

static void
slingshot_backend_app_system_set_apps (SlingshotBackendAppSystem* self,
                                       GeeHashMap* value)
{
	GeeHashMap* old_value;
#line 21 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	g_return_if_fail (self != NULL);
#line 21 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	old_value = slingshot_backend_app_system_get_apps (self);
#line 21 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	if (old_value != value) {
#line 1336 "AppSystem.c"
		GeeHashMap* _tmp0_;
#line 21 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 21 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		_g_object_unref0 (self->priv->_apps);
#line 21 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		self->priv->_apps = _tmp0_;
#line 21 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_backend_app_system_properties[SLINGSHOT_BACKEND_APP_SYSTEM_APPS_PROPERTY]);
#line 1346 "AppSystem.c"
	}
}

static void
_slingshot_backend_app_system_queue_update_app_system_g_app_info_monitor_changed (GAppInfoMonitor* _sender,
                                                                                  gpointer self)
{
#line 41 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	slingshot_backend_app_system_queue_update_app_system ((SlingshotBackendAppSystem*) self);
#line 1356 "AppSystem.c"
}

static GObject *
slingshot_backend_app_system_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SlingshotBackendAppSystem * self;
	GAppInfoMonitor* _tmp0_;
	GAppInfoMonitor* _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeArrayList* _tmp4_;
#line 34 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	parent_class = G_OBJECT_CLASS (slingshot_backend_app_system_parent_class);
#line 34 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 34 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SLINGSHOT_BACKEND_TYPE_APP_SYSTEM, SlingshotBackendAppSystem);
#line 40 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp0_ = g_app_info_monitor_get ();
#line 40 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_g_object_unref0 (self->priv->app_monitor);
#line 40 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	self->priv->app_monitor = _tmp0_;
#line 41 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp1_ = self->priv->app_monitor;
#line 41 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	g_signal_connect_object (_tmp1_, "changed", (GCallback) _slingshot_backend_app_system_queue_update_app_system_g_app_info_monitor_changed, self, 0);
#line 43 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 43 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp3_ = _tmp2_;
#line 43 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	slingshot_backend_app_system_set_apps (self, _tmp3_);
#line 43 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_g_object_unref0 (_tmp3_);
#line 44 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_tmp4_ = gee_array_list_new (SLINGSHOT_BACKEND_TYPE_CATEGORY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 44 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_g_object_unref0 (self->priv->categories_cache);
#line 44 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	self->priv->categories_cache = _tmp4_;
#line 46 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	slingshot_backend_app_system_update_app_system (self);
#line 34 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	return obj;
#line 1406 "AppSystem.c"
}

static void
slingshot_backend_app_system_class_init (SlingshotBackendAppSystemClass * klass,
                                         gpointer klass_data)
{
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	slingshot_backend_app_system_parent_class = g_type_class_peek_parent (klass);
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	g_type_class_adjust_private_offset (klass, &SlingshotBackendAppSystem_private_offset);
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_slingshot_backend_app_system_get_property;
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_slingshot_backend_app_system_set_property;
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	G_OBJECT_CLASS (klass)->constructor = slingshot_backend_app_system_constructor;
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	G_OBJECT_CLASS (klass)->finalize = slingshot_backend_app_system_finalize;
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_BACKEND_APP_SYSTEM_APPS_PROPERTY, slingshot_backend_app_system_properties[SLINGSHOT_BACKEND_APP_SYSTEM_APPS_PROPERTY] = g_param_spec_object ("apps", "apps", "apps", GEE_TYPE_HASH_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	slingshot_backend_app_system_signals[SLINGSHOT_BACKEND_APP_SYSTEM_CHANGED_SIGNAL] = g_signal_new ("changed", SLINGSHOT_BACKEND_TYPE_APP_SYSTEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1429 "AppSystem.c"
}

static void
slingshot_backend_app_system_instance_init (SlingshotBackendAppSystem * self,
                                            gpointer klass)
{
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	self->priv = slingshot_backend_app_system_get_instance_private (self);
#line 21 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	self->priv->_apps = NULL;
#line 24 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	self->priv->refresh_timeout_id = (guint) 0;
#line 26 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	self->priv->categories_cache = NULL;
#line 1444 "AppSystem.c"
}

static void
slingshot_backend_app_system_finalize (GObject * obj)
{
	SlingshotBackendAppSystem * self;
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SLINGSHOT_BACKEND_TYPE_APP_SYSTEM, SlingshotBackendAppSystem);
#line 21 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_g_object_unref0 (self->priv->_apps);
#line 26 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_g_object_unref0 (self->priv->categories_cache);
#line 28 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	_g_object_unref0 (self->priv->app_monitor);
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	G_OBJECT_CLASS (slingshot_backend_app_system_parent_class)->finalize (obj);
#line 1461 "AppSystem.c"
}

GType
slingshot_backend_app_system_get_type (void)
{
	return slingshot_backend_app_system_type_id;
}

GType
slingshot_backend_app_system_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (SlingshotBackendAppSystemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) slingshot_backend_app_system_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SlingshotBackendAppSystem), 0, (GInstanceInitFunc) slingshot_backend_app_system_instance_init, NULL };
	slingshot_backend_app_system_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "SlingshotBackendAppSystem", &g_define_type_info, 0);
	SlingshotBackendAppSystem_private_offset = sizeof (SlingshotBackendAppSystemPrivate);
	return slingshot_backend_app_system_type_id;
}

static void
_vala_slingshot_backend_app_system_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	SlingshotBackendAppSystem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SLINGSHOT_BACKEND_TYPE_APP_SYSTEM, SlingshotBackendAppSystem);
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	switch (property_id) {
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		case SLINGSHOT_BACKEND_APP_SYSTEM_APPS_PROPERTY:
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		g_value_set_object (value, slingshot_backend_app_system_get_apps (self));
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		break;
#line 1495 "AppSystem.c"
		default:
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		break;
#line 1501 "AppSystem.c"
	}
}

static void
_vala_slingshot_backend_app_system_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	SlingshotBackendAppSystem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SLINGSHOT_BACKEND_TYPE_APP_SYSTEM, SlingshotBackendAppSystem);
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
	switch (property_id) {
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		case SLINGSHOT_BACKEND_APP_SYSTEM_APPS_PROPERTY:
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		slingshot_backend_app_system_set_apps (self, g_value_get_object (value));
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		break;
#line 1521 "AppSystem.c"
		default:
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../budgie-applications-menu/applications-menu/src/Backend/AppSystem.vala"
		break;
#line 1527 "AppSystem.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

