/* SlingshotView.c generated by valac 0.56.18, the Vala compiler
 * generated from SlingshotView.vala, do not modify */

/*
 * Copyright 2019–2021 elementary, Inc. (https://elementary.io)
 *           2011-2012 Giulio Collura
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include "slingshot.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <glib.h>
#include <plugin.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <gee.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define APP_MENU_TYPE_POWER_STRIP (app_menu_power_strip_get_type ())
#define APP_MENU_POWER_STRIP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_MENU_TYPE_POWER_STRIP, AppMenuPowerStrip))
#define APP_MENU_POWER_STRIP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_MENU_TYPE_POWER_STRIP, AppMenuPowerStripClass))
#define APP_MENU_IS_POWER_STRIP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_MENU_TYPE_POWER_STRIP))
#define APP_MENU_IS_POWER_STRIP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_MENU_TYPE_POWER_STRIP))
#define APP_MENU_POWER_STRIP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_MENU_TYPE_POWER_STRIP, AppMenuPowerStripClass))

typedef struct _AppMenuPowerStrip AppMenuPowerStrip;
typedef struct _AppMenuPowerStripClass AppMenuPowerStripClass;
typedef enum  {
	SLINGSHOT_SLINGSHOT_VIEW_MODALITY_NORMAL_VIEW = 0,
	SLINGSHOT_SLINGSHOT_VIEW_MODALITY_CATEGORY_VIEW = 1,
	SLINGSHOT_SLINGSHOT_VIEW_MODALITY_SEARCH_VIEW
} SlingshotSlingshotViewModality;

#define SLINGSHOT_SLINGSHOT_VIEW_TYPE_MODALITY (slingshot_slingshot_view_modality_get_type ())
enum  {
	SLINGSHOT_SLINGSHOT_VIEW_0_PROPERTY,
	SLINGSHOT_SLINGSHOT_VIEW_NUM_PROPERTIES
};
static GParamSpec* slingshot_slingshot_view_properties[SLINGSHOT_SLINGSHOT_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
typedef struct _SlingshotSlingshotViewSearchData SlingshotSlingshotViewSearchData;
enum  {
	SLINGSHOT_SLINGSHOT_VIEW_CLOSE_INDICATOR_SIGNAL,
	SLINGSHOT_SLINGSHOT_VIEW_NUM_SIGNALS
};
static guint slingshot_slingshot_view_signals[SLINGSHOT_SLINGSHOT_VIEW_NUM_SIGNALS] = {0};

struct _SlingshotSlingshotViewPrivate {
	AppMenuPowerStrip* powerstrip;
	SlingshotBackendSynapseSearch* synapse;
	GdkScreen* screen;
	GtkRevealer* view_selector_revealer;
	SlingshotSlingshotViewModality modality;
	SlingshotWidgetsGrid* grid_view;
	GtkGrid* container;
	GtkGrid* top;
	SlingshotWidgetsSearchView* search_view;
	SlingshotWidgetsCategoryView* category_view;
};

struct _Block1Data {
	int _ref_count_;
	SlingshotSlingshotView* self;
	GeeList* matches;
	gchar* text;
	gpointer _async_data_;
};

struct _SlingshotSlingshotViewSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SlingshotSlingshotView* self;
	gchar* text;
	SynapseSearchMatch* search_match;
	SynapseMatch* target;
	Block1Data* _data1_;
	gchar* stripped;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	SlingshotBackendSynapseSearch* _tmp2_;
	GeeList* _tmp3_;
	SlingshotBackendSynapseSearch* _tmp4_;
	GeeList* _tmp5_;
};

static gint SlingshotSlingshotView_private_offset;
static gpointer slingshot_slingshot_view_parent_class = NULL;
static GSettings* slingshot_slingshot_view__settings;
static GSettings* slingshot_slingshot_view__settings = NULL;
static GType slingshot_slingshot_view_type_id = 0;

GType app_menu_power_strip_register_type (GTypeModule * module);
VALA_EXTERN GType app_menu_power_strip_get_type (void) G_GNUC_CONST ;
static GType slingshot_slingshot_view_modality_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void slingshot_slingshot_view_search_entry_activated (SlingshotSlingshotView* self);
static void slingshot_slingshot_view_set_modality (SlingshotSlingshotView* self,
                                            SlingshotSlingshotViewModality new_modality);
static GSettings* slingshot_slingshot_view_get_settings (void);
static void slingshot_slingshot_view_search_data_free (gpointer _data);
static void slingshot_slingshot_view_search (SlingshotSlingshotView* self,
                                      const gchar* text,
                                      SynapseSearchMatch* search_match,
                                      SynapseMatch* target,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static void slingshot_slingshot_view_search_finish (SlingshotSlingshotView* self,
                                             GAsyncResult* _res_);
static gboolean slingshot_slingshot_view_search_co (SlingshotSlingshotViewSearchData* _data_);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean ___lambda75_ (SlingshotSlingshotView* self);
static gboolean ____lambda75__gsource_func (gpointer self);
static void slingshot_slingshot_view_search_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static gboolean __lambda76_ (Block1Data* _data1_);
static gboolean ___lambda76__gsource_func (gpointer self);
static void slingshot_slingshot_view_set_settings (GSettings* value);
static GObject * slingshot_slingshot_view_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
VALA_EXTERN AppMenuPowerStrip* app_menu_power_strip_new (void);
VALA_EXTERN AppMenuPowerStrip* app_menu_power_strip_construct (GType object_type);
static gboolean _slingshot_slingshot_view___lambda77_ (SlingshotSlingshotView* self);
static gboolean __slingshot_slingshot_view___lambda77__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                                           GdkEventFocus* event,
                                                                           gpointer self);
static gboolean _slingshot_slingshot_view_on_event_box_key_press_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                                      GdkEventKey* event,
                                                                                      gpointer self);
static gboolean _slingshot_slingshot_view_on_search_view_key_press_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                                        GdkEventKey* event,
                                                                                        gpointer self);
static void _slingshot_slingshot_view___lambda78_ (SlingshotSlingshotView* self);
static void __slingshot_slingshot_view___lambda78__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                                             gpointer self);
static void _slingshot_slingshot_view_search_entry_activated_gtk_entry_activate (GtkEntry* _sender,
                                                                          gpointer self);
static void _slingshot_slingshot_view___lambda79_ (SlingshotSlingshotView* self);
static void __slingshot_slingshot_view___lambda79__slingshot_widgets_category_view_search_focus_request (SlingshotWidgetsCategoryView* _sender,
                                                                                                  gpointer self);
static void _slingshot_slingshot_view___lambda80_ (SlingshotSlingshotView* self);
static void __slingshot_slingshot_view___lambda80__slingshot_widgets_grid_app_launched (SlingshotWidgetsGrid* _sender,
                                                                                 gpointer self);
static void _slingshot_slingshot_view___lambda81_ (SlingshotSlingshotView* self);
static void __slingshot_slingshot_view___lambda81__slingshot_widgets_search_view_app_launched (SlingshotWidgetsSearchView* _sender,
                                                                                        gpointer self);
static void _slingshot_slingshot_view___lambda82_ (SlingshotSlingshotView* self);
static void __slingshot_slingshot_view___lambda82__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                                                      GtkWidget* widget,
                                                                                      gpointer self);
static void _slingshot_slingshot_view___lambda83_ (SlingshotSlingshotView* self);
static void __slingshot_slingshot_view___lambda83__slingshot_backend_app_system_changed (SlingshotBackendAppSystem* _sender,
                                                                                  gpointer self);
static void _slingshot_slingshot_view___lambda84_ (SlingshotSlingshotView* self);
static void __slingshot_slingshot_view___lambda84__g_settings_changed (GSettings* _sender,
                                                                const gchar* key,
                                                                gpointer self);
static void _slingshot_slingshot_view___lambda85_ (SlingshotSlingshotView* self);
static void __slingshot_slingshot_view___lambda85__g_settings_changed (GSettings* _sender,
                                                                const gchar* key,
                                                                gpointer self);
static void _slingshot_slingshot_view___lambda86_ (SlingshotSlingshotView* self);
static void __slingshot_slingshot_view___lambda86__g_settings_changed (GSettings* _sender,
                                                                const gchar* key,
                                                                gpointer self);
static void _slingshot_slingshot_view___lambda87_ (SlingshotSlingshotView* self);
static void __slingshot_slingshot_view___lambda87__app_menu_power_strip_invoke_action (AppMenuPowerStrip* _sender,
                                                                                gpointer self);
static void slingshot_slingshot_view_finalize (GObject * obj);
static void _vala_slingshot_slingshot_view_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_slingshot_slingshot_view_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
slingshot_slingshot_view_get_instance_private (SlingshotSlingshotView* self)
{
	return G_STRUCT_MEMBER_P (self, SlingshotSlingshotView_private_offset);
}

static GType
slingshot_slingshot_view_modality_get_type_once (void)
{
	static const GEnumValue values[] = {{SLINGSHOT_SLINGSHOT_VIEW_MODALITY_NORMAL_VIEW, "SLINGSHOT_SLINGSHOT_VIEW_MODALITY_NORMAL_VIEW", "normal-view"}, {SLINGSHOT_SLINGSHOT_VIEW_MODALITY_CATEGORY_VIEW, "SLINGSHOT_SLINGSHOT_VIEW_MODALITY_CATEGORY_VIEW", "category-view"}, {SLINGSHOT_SLINGSHOT_VIEW_MODALITY_SEARCH_VIEW, "SLINGSHOT_SLINGSHOT_VIEW_MODALITY_SEARCH_VIEW", "search-view"}, {0, NULL, NULL}};
	GType slingshot_slingshot_view_modality_type_id;
	slingshot_slingshot_view_modality_type_id = g_enum_register_static ("SlingshotSlingshotViewModality", values);
	return slingshot_slingshot_view_modality_type_id;
}

static GType
slingshot_slingshot_view_modality_get_type (void)
{
	static volatile gsize slingshot_slingshot_view_modality_type_id__once = 0;
	if (g_once_init_enter (&slingshot_slingshot_view_modality_type_id__once)) {
		GType slingshot_slingshot_view_modality_type_id;
		slingshot_slingshot_view_modality_type_id = slingshot_slingshot_view_modality_get_type_once ();
		g_once_init_leave (&slingshot_slingshot_view_modality_type_id__once, slingshot_slingshot_view_modality_type_id);
	}
	return slingshot_slingshot_view_modality_type_id__once;
}

void
slingshot_slingshot_view_panel_position_changed (SlingshotSlingshotView* self,
                                                 BudgiePanelPosition position)
{
	GtkGrid* _tmp16_;
#line 199 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_return_if_fail (self != NULL);
#line 200 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	if (position == BUDGIE_PANEL_POSITION_BOTTOM) {
#line 253 "SlingshotView.c"
		GtkGrid* _tmp0_;
		GtkGrid* _tmp1_;
		GtkGrid* _tmp2_;
		GtkGrid* _tmp3_;
		GtkGrid* _tmp4_;
		GtkGrid* _tmp5_;
		GtkGrid* _tmp6_;
		GtkStack* _tmp7_;
#line 201 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp0_ = self->priv->container;
#line 201 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		gtk_widget_set_margin_bottom ((GtkWidget*) _tmp0_, 12);
#line 202 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp1_ = self->priv->container;
#line 202 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		gtk_widget_set_margin_top ((GtkWidget*) _tmp1_, 0);
#line 204 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp2_ = self->priv->container;
#line 204 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		gtk_grid_remove_row (_tmp2_, 1);
#line 205 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp3_ = self->priv->container;
#line 205 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		gtk_grid_remove_row (_tmp3_, 0);
#line 207 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp4_ = self->priv->container;
#line 207 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp5_ = self->priv->top;
#line 207 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		gtk_grid_attach (_tmp4_, (GtkWidget*) _tmp5_, 0, 1, 1, 1);
#line 208 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp6_ = self->priv->container;
#line 208 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp7_ = self->stack;
#line 208 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		gtk_grid_attach (_tmp6_, (GtkWidget*) _tmp7_, 0, 0, 1, 1);
#line 290 "SlingshotView.c"
	} else {
		GtkGrid* _tmp8_;
		GtkGrid* _tmp9_;
		GtkGrid* _tmp10_;
		GtkGrid* _tmp11_;
		GtkGrid* _tmp12_;
		GtkGrid* _tmp13_;
		GtkGrid* _tmp14_;
		GtkStack* _tmp15_;
#line 211 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp8_ = self->priv->container;
#line 211 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		gtk_widget_set_margin_bottom ((GtkWidget*) _tmp8_, 0);
#line 212 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp9_ = self->priv->container;
#line 212 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		gtk_widget_set_margin_top ((GtkWidget*) _tmp9_, 12);
#line 214 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp10_ = self->priv->container;
#line 214 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		gtk_grid_remove_row (_tmp10_, 1);
#line 215 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp11_ = self->priv->container;
#line 215 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		gtk_grid_remove_row (_tmp11_, 0);
#line 217 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp12_ = self->priv->container;
#line 217 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp13_ = self->priv->top;
#line 217 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		gtk_grid_attach (_tmp12_, (GtkWidget*) _tmp13_, 0, 0, 1, 1);
#line 218 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp14_ = self->priv->container;
#line 218 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp15_ = self->stack;
#line 218 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		gtk_grid_attach (_tmp14_, (GtkWidget*) _tmp15_, 0, 1, 1, 1);
#line 328 "SlingshotView.c"
	}
#line 220 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp16_ = self->priv->container;
#line 220 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp16_);
#line 334 "SlingshotView.c"
}

static void
slingshot_slingshot_view_search_entry_activated (SlingshotSlingshotView* self)
{
#line 254 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_return_if_fail (self != NULL);
#line 255 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	if (self->priv->modality == SLINGSHOT_SLINGSHOT_VIEW_MODALITY_SEARCH_VIEW) {
#line 344 "SlingshotView.c"
		SlingshotWidgetsSearchView* _tmp0_;
#line 256 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp0_ = self->priv->search_view;
#line 256 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		slingshot_widgets_search_view_activate_selection (_tmp0_);
#line 350 "SlingshotView.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 373 "SlingshotView.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 377 "SlingshotView.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 383 "SlingshotView.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 387 "SlingshotView.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 391 "SlingshotView.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 399 "SlingshotView.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 427 "SlingshotView.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 436 "SlingshotView.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 450 "SlingshotView.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 459 "SlingshotView.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 473 "SlingshotView.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 482 "SlingshotView.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 491 "SlingshotView.c"
}

gboolean
slingshot_slingshot_view_on_search_view_key_press (SlingshotSlingshotView* self,
                                                   GdkEventKey* event)
{
	gchar* key = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
#line 266 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	static GQuark _tmp4_label0 = 0;
#line 266 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	static GQuark _tmp4_label1 = 0;
#line 508 "SlingshotView.c"
	gboolean result;
#line 263 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 263 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 264 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp0_ = gdk_keyval_name (event->keyval);
#line 264 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp1_ = string_replace (_tmp0_, "KP_", "");
#line 264 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	key = _tmp1_;
#line 266 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp2_ = key;
#line 266 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp3_ = _tmp2_;
#line 266 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 266 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("Down")))) {
#line 266 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		switch (0) {
#line 530 "SlingshotView.c"
			default:
			{
				GtkSearchEntry* _tmp6_;
#line 268 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				_tmp6_ = self->search_entry;
#line 268 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				g_signal_emit_by_name ((GtkWidget*) _tmp6_, "move-focus", GTK_DIR_TAB_FORWARD);
#line 269 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				result = GDK_EVENT_STOP;
#line 269 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				_g_free0 (key);
#line 269 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				return result;
#line 544 "SlingshotView.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("Escape")))) {
#line 266 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		switch (0) {
#line 550 "SlingshotView.c"
			default:
			{
				GtkSearchEntry* _tmp7_;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
#line 272 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				_tmp7_ = self->search_entry;
#line 272 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				_tmp8_ = gtk_entry_get_text ((GtkEntry*) _tmp7_);
#line 272 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				_tmp9_ = _tmp8_;
#line 272 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				_tmp10_ = strlen (_tmp9_);
#line 272 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				_tmp11_ = _tmp10_;
#line 272 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				if (_tmp11_ > 0) {
#line 570 "SlingshotView.c"
					GtkSearchEntry* _tmp12_;
#line 273 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					_tmp12_ = self->search_entry;
#line 273 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					gtk_entry_set_text ((GtkEntry*) _tmp12_, "");
#line 576 "SlingshotView.c"
				} else {
#line 275 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					g_signal_emit (self, slingshot_slingshot_view_signals[SLINGSHOT_SLINGSHOT_VIEW_CLOSE_INDICATOR_SIGNAL], 0);
#line 580 "SlingshotView.c"
				}
#line 278 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				result = GDK_EVENT_STOP;
#line 278 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				_g_free0 (key);
#line 278 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				return result;
#line 588 "SlingshotView.c"
			}
		}
	}
#line 281 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	result = GDK_EVENT_PROPAGATE;
#line 281 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_free0 (key);
#line 281 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	return result;
#line 598 "SlingshotView.c"
}

gboolean
slingshot_slingshot_view_on_event_box_key_press (SlingshotSlingshotView* self,
                                                 GdkEventKey* event)
{
	gchar* key = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	GQuark _tmp20_ = 0U;
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	static GQuark _tmp19_label0 = 0;
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	static GQuark _tmp19_label1 = 0;
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	static GQuark _tmp19_label2 = 0;
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	static GQuark _tmp19_label3 = 0;
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	static GQuark _tmp19_label4 = 0;
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	static GQuark _tmp19_label5 = 0;
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	static GQuark _tmp19_label6 = 0;
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	static GQuark _tmp19_label7 = 0;
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	static GQuark _tmp19_label8 = 0;
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	static GQuark _tmp19_label9 = 0;
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	static GQuark _tmp19_label10 = 0;
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	static GQuark _tmp19_label11 = 0;
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	static GQuark _tmp19_label12 = 0;
#line 637 "SlingshotView.c"
	gboolean result;
#line 284 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 284 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 285 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp0_ = gdk_keyval_name (event->keyval);
#line 285 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp1_ = string_replace (_tmp0_, "KP_", "");
#line 285 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	key = _tmp1_;
#line 286 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	if ((event->state & GDK_CONTROL_MASK) != 0) {
#line 651 "SlingshotView.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		GQuark _tmp5_ = 0U;
#line 287 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		static GQuark _tmp4_label0 = 0;
#line 287 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		static GQuark _tmp4_label1 = 0;
#line 287 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp2_ = key;
#line 287 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp3_ = _tmp2_;
#line 287 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 287 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("1")))) {
#line 287 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			switch (0) {
#line 669 "SlingshotView.c"
				default:
				{
					GraniteWidgetsModeButton* _tmp6_;
#line 289 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					_tmp6_ = self->view_selector;
#line 289 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					granite_widgets_mode_button_set_selected (_tmp6_, 0);
#line 290 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					result = GDK_EVENT_STOP;
#line 290 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					_g_free0 (key);
#line 290 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					return result;
#line 683 "SlingshotView.c"
				}
			}
		} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("2")))) {
#line 287 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			switch (0) {
#line 689 "SlingshotView.c"
				default:
				{
					GraniteWidgetsModeButton* _tmp7_;
#line 292 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					_tmp7_ = self->view_selector;
#line 292 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					granite_widgets_mode_button_set_selected (_tmp7_, 1);
#line 293 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					result = GDK_EVENT_STOP;
#line 293 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					_g_free0 (key);
#line 293 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					return result;
#line 703 "SlingshotView.c"
				}
			}
		}
	}
#line 298 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	if ((event->state & GDK_MOD1_MASK) != 0) {
#line 710 "SlingshotView.c"
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		GQuark _tmp11_ = 0U;
#line 299 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		static GQuark _tmp10_label0 = 0;
#line 299 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		static GQuark _tmp10_label1 = 0;
#line 299 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		static GQuark _tmp10_label2 = 0;
#line 299 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		static GQuark _tmp10_label3 = 0;
#line 299 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		static GQuark _tmp10_label4 = 0;
#line 299 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		static GQuark _tmp10_label5 = 0;
#line 299 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		static GQuark _tmp10_label6 = 0;
#line 299 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		static GQuark _tmp10_label7 = 0;
#line 299 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		static GQuark _tmp10_label8 = 0;
#line 299 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		static GQuark _tmp10_label9 = 0;
#line 299 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		static GQuark _tmp10_label10 = 0;
#line 299 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp8_ = key;
#line 299 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp9_ = _tmp8_;
#line 299 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp11_ = (NULL == _tmp9_) ? 0 : g_quark_from_string (_tmp9_);
#line 299 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		if (_tmp11_ == ((0 != _tmp10_label0) ? _tmp10_label0 : (_tmp10_label0 = g_quark_from_static_string ("F4")))) {
#line 299 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			switch (0) {
#line 746 "SlingshotView.c"
				default:
				{
#line 301 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					g_signal_emit (self, slingshot_slingshot_view_signals[SLINGSHOT_SLINGSHOT_VIEW_CLOSE_INDICATOR_SIGNAL], 0);
#line 302 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					result = GDK_EVENT_STOP;
#line 302 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					_g_free0 (key);
#line 302 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					return result;
#line 757 "SlingshotView.c"
				}
			}
		} else if ((((((((((_tmp11_ == ((0 != _tmp10_label1) ? _tmp10_label1 : (_tmp10_label1 = g_quark_from_static_string ("0")))) || (_tmp11_ == ((0 != _tmp10_label2) ? _tmp10_label2 : (_tmp10_label2 = g_quark_from_static_string ("1"))))) || (_tmp11_ == ((0 != _tmp10_label3) ? _tmp10_label3 : (_tmp10_label3 = g_quark_from_static_string ("2"))))) || (_tmp11_ == ((0 != _tmp10_label4) ? _tmp10_label4 : (_tmp10_label4 = g_quark_from_static_string ("3"))))) || (_tmp11_ == ((0 != _tmp10_label5) ? _tmp10_label5 : (_tmp10_label5 = g_quark_from_static_string ("4"))))) || (_tmp11_ == ((0 != _tmp10_label6) ? _tmp10_label6 : (_tmp10_label6 = g_quark_from_static_string ("5"))))) || (_tmp11_ == ((0 != _tmp10_label7) ? _tmp10_label7 : (_tmp10_label7 = g_quark_from_static_string ("6"))))) || (_tmp11_ == ((0 != _tmp10_label8) ? _tmp10_label8 : (_tmp10_label8 = g_quark_from_static_string ("7"))))) || (_tmp11_ == ((0 != _tmp10_label9) ? _tmp10_label9 : (_tmp10_label9 = g_quark_from_static_string ("8"))))) || (_tmp11_ == ((0 != _tmp10_label10) ? _tmp10_label10 : (_tmp10_label10 = g_quark_from_static_string ("9"))))) {
#line 299 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			switch (0) {
#line 763 "SlingshotView.c"
				default:
				{
					GtkSearchEntry* _tmp16_;
#line 314 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					if (self->priv->modality == SLINGSHOT_SLINGSHOT_VIEW_MODALITY_NORMAL_VIEW) {
#line 769 "SlingshotView.c"
						gint page = 0;
						const gchar* _tmp12_;
						gboolean _tmp13_ = FALSE;
#line 315 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
						_tmp12_ = key;
#line 315 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
						page = atoi (_tmp12_);
#line 316 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
						if (page < 0) {
#line 316 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
							_tmp13_ = TRUE;
#line 781 "SlingshotView.c"
						} else {
#line 316 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
							_tmp13_ = page == 9;
#line 785 "SlingshotView.c"
						}
#line 316 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
						if (_tmp13_) {
#line 789 "SlingshotView.c"
							SlingshotWidgetsGrid* _tmp14_;
#line 317 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
							_tmp14_ = self->priv->grid_view;
#line 317 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
							slingshot_widgets_grid_go_to_last (_tmp14_);
#line 795 "SlingshotView.c"
						} else {
							SlingshotWidgetsGrid* _tmp15_;
#line 319 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
							_tmp15_ = self->priv->grid_view;
#line 319 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
							slingshot_widgets_grid_go_to_number (_tmp15_, page);
#line 802 "SlingshotView.c"
						}
					}
#line 324 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					_tmp16_ = self->search_entry;
#line 324 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					gtk_widget_grab_focus ((GtkWidget*) _tmp16_);
#line 325 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					result = GDK_EVENT_STOP;
#line 325 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					_g_free0 (key);
#line 325 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					return result;
#line 815 "SlingshotView.c"
				}
			}
		}
	}
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp17_ = key;
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp18_ = _tmp17_;
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp20_ = (NULL == _tmp18_) ? 0 : g_quark_from_string (_tmp18_);
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	if (((((((((_tmp20_ == ((0 != _tmp19_label0) ? _tmp19_label0 : (_tmp19_label0 = g_quark_from_static_string ("Down")))) || (_tmp20_ == ((0 != _tmp19_label1) ? _tmp19_label1 : (_tmp19_label1 = g_quark_from_static_string ("Enter"))))) || (_tmp20_ == ((0 != _tmp19_label2) ? _tmp19_label2 : (_tmp19_label2 = g_quark_from_static_string ("Home"))))) || (_tmp20_ == ((0 != _tmp19_label3) ? _tmp19_label3 : (_tmp19_label3 = g_quark_from_static_string ("KP_Enter"))))) || (_tmp20_ == ((0 != _tmp19_label4) ? _tmp19_label4 : (_tmp19_label4 = g_quark_from_static_string ("Left"))))) || (_tmp20_ == ((0 != _tmp19_label5) ? _tmp19_label5 : (_tmp19_label5 = g_quark_from_static_string ("Return"))))) || (_tmp20_ == ((0 != _tmp19_label6) ? _tmp19_label6 : (_tmp19_label6 = g_quark_from_static_string ("Right"))))) || (_tmp20_ == ((0 != _tmp19_label7) ? _tmp19_label7 : (_tmp19_label7 = g_quark_from_static_string ("Tab"))))) || (_tmp20_ == ((0 != _tmp19_label8) ? _tmp19_label8 : (_tmp19_label8 = g_quark_from_static_string ("Up"))))) {
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		switch (0) {
#line 830 "SlingshotView.c"
			default:
			{
#line 339 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				result = GDK_EVENT_PROPAGATE;
#line 339 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				_g_free0 (key);
#line 339 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				return result;
#line 839 "SlingshotView.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label9) ? _tmp19_label9 : (_tmp19_label9 = g_quark_from_static_string ("Page_Up")))) {
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		switch (0) {
#line 845 "SlingshotView.c"
			default:
			{
#line 342 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				if (self->priv->modality == SLINGSHOT_SLINGSHOT_VIEW_MODALITY_NORMAL_VIEW) {
#line 850 "SlingshotView.c"
					SlingshotWidgetsGrid* _tmp21_;
#line 343 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					_tmp21_ = self->priv->grid_view;
#line 343 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					slingshot_widgets_grid_go_to_previous (_tmp21_);
#line 856 "SlingshotView.c"
				} else {
#line 344 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					if (self->priv->modality == SLINGSHOT_SLINGSHOT_VIEW_MODALITY_CATEGORY_VIEW) {
#line 860 "SlingshotView.c"
						SlingshotWidgetsCategoryView* _tmp22_;
#line 345 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
						_tmp22_ = self->priv->category_view;
#line 345 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
						slingshot_widgets_category_view_page_up (_tmp22_);
#line 866 "SlingshotView.c"
					}
				}
#line 347 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				break;
#line 871 "SlingshotView.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label10) ? _tmp19_label10 : (_tmp19_label10 = g_quark_from_static_string ("Page_Down")))) {
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		switch (0) {
#line 877 "SlingshotView.c"
			default:
			{
#line 350 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				if (self->priv->modality == SLINGSHOT_SLINGSHOT_VIEW_MODALITY_NORMAL_VIEW) {
#line 882 "SlingshotView.c"
					SlingshotWidgetsGrid* _tmp23_;
#line 351 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					_tmp23_ = self->priv->grid_view;
#line 351 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					slingshot_widgets_grid_go_to_next (_tmp23_);
#line 888 "SlingshotView.c"
				} else {
#line 352 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					if (self->priv->modality == SLINGSHOT_SLINGSHOT_VIEW_MODALITY_CATEGORY_VIEW) {
#line 892 "SlingshotView.c"
						SlingshotWidgetsCategoryView* _tmp24_;
#line 353 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
						_tmp24_ = self->priv->category_view;
#line 353 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
						slingshot_widgets_category_view_page_down (_tmp24_);
#line 898 "SlingshotView.c"
					}
				}
#line 355 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				break;
#line 903 "SlingshotView.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label11) ? _tmp19_label11 : (_tmp19_label11 = g_quark_from_static_string ("BackSpace")))) {
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		switch (0) {
#line 909 "SlingshotView.c"
			default:
			{
				GtkSearchEntry* _tmp25_;
				gboolean _tmp26_;
				gboolean _tmp27_;
#line 358 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				_tmp25_ = self->search_entry;
#line 358 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				g_object_get ((GtkWidget*) _tmp25_, "has-focus", &_tmp26_, NULL);
#line 358 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				_tmp27_ = _tmp26_;
#line 358 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				if (!_tmp27_) {
#line 923 "SlingshotView.c"
					GtkSearchEntry* _tmp28_;
					GtkSearchEntry* _tmp29_;
#line 359 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					_tmp28_ = self->search_entry;
#line 359 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					gtk_widget_grab_focus ((GtkWidget*) _tmp28_);
#line 360 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					_tmp29_ = self->search_entry;
#line 360 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					g_signal_emit_by_name ((GtkEntry*) _tmp29_, "move-cursor", GTK_MOVEMENT_BUFFER_ENDS, 0, FALSE);
#line 934 "SlingshotView.c"
				}
#line 362 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				result = GDK_EVENT_PROPAGATE;
#line 362 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				_g_free0 (key);
#line 362 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				return result;
#line 942 "SlingshotView.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label12) ? _tmp19_label12 : (_tmp19_label12 = g_quark_from_static_string ("End")))) {
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		switch (0) {
#line 948 "SlingshotView.c"
			default:
			{
#line 364 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				if (self->priv->modality == SLINGSHOT_SLINGSHOT_VIEW_MODALITY_NORMAL_VIEW) {
#line 953 "SlingshotView.c"
					SlingshotWidgetsGrid* _tmp30_;
#line 365 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					_tmp30_ = self->priv->grid_view;
#line 365 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					slingshot_widgets_grid_go_to_last (_tmp30_);
#line 959 "SlingshotView.c"
				}
#line 368 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				result = GDK_EVENT_PROPAGATE;
#line 368 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				_g_free0 (key);
#line 368 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				return result;
#line 967 "SlingshotView.c"
			}
		}
	} else {
#line 329 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		switch (0) {
#line 973 "SlingshotView.c"
			default:
			{
				gboolean _tmp31_ = FALSE;
				GtkSearchEntry* _tmp32_;
				gboolean _tmp33_;
				gboolean _tmp34_;
#line 370 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				_tmp32_ = self->search_entry;
#line 370 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				g_object_get ((GtkWidget*) _tmp32_, "has-focus", &_tmp33_, NULL);
#line 370 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				_tmp34_ = _tmp33_;
#line 370 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				if (!_tmp34_) {
#line 370 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					_tmp31_ = event->is_modifier != ((guint) 1);
#line 990 "SlingshotView.c"
				} else {
#line 370 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					_tmp31_ = FALSE;
#line 994 "SlingshotView.c"
				}
#line 370 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				if (_tmp31_) {
#line 998 "SlingshotView.c"
					GtkSearchEntry* _tmp35_;
					GtkSearchEntry* _tmp36_;
#line 371 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					_tmp35_ = self->search_entry;
#line 371 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					gtk_widget_grab_focus ((GtkWidget*) _tmp35_);
#line 372 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					_tmp36_ = self->search_entry;
#line 372 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
					g_signal_emit_by_name ((GtkEntry*) _tmp36_, "move-cursor", GTK_MOVEMENT_BUFFER_ENDS, 0, FALSE);
#line 1009 "SlingshotView.c"
				}
#line 375 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				result = GDK_EVENT_PROPAGATE;
#line 375 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				_g_free0 (key);
#line 375 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				return result;
#line 1017 "SlingshotView.c"
			}
		}
	}
#line 379 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	result = GDK_EVENT_STOP;
#line 379 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_free0 (key);
#line 379 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	return result;
#line 1027 "SlingshotView.c"
}

void
slingshot_slingshot_view_show_slingshot (SlingshotSlingshotView* self)
{
	GtkSearchEntry* _tmp0_;
	GtkSearchEntry* _tmp1_;
	GtkRevealer* _tmp2_;
	GtkStack* _tmp3_;
	GraniteWidgetsModeButton* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GtkRevealer* _tmp7_;
	AppMenuPowerStrip* _tmp8_;
	GSettings* _tmp9_;
	GSettings* _tmp10_;
	GtkStack* _tmp11_;
#line 382 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_return_if_fail (self != NULL);
#line 383 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp0_ = self->search_entry;
#line 383 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_entry_set_text ((GtkEntry*) _tmp0_, "");
#line 389 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp1_ = self->search_entry;
#line 389 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp1_);
#line 391 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp2_ = self->priv->view_selector_revealer;
#line 391 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_revealer_set_transition_type (_tmp2_, GTK_REVEALER_TRANSITION_TYPE_NONE);
#line 392 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp3_ = self->stack;
#line 392 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_stack_set_transition_type (_tmp3_, GTK_STACK_TRANSITION_TYPE_NONE);
#line 393 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp4_ = self->view_selector;
#line 393 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp5_ = granite_widgets_mode_button_get_selected (_tmp4_);
#line 393 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp6_ = _tmp5_;
#line 393 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	slingshot_slingshot_view_set_modality (self, (SlingshotSlingshotViewModality) _tmp6_);
#line 394 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp7_ = self->priv->view_selector_revealer;
#line 394 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_revealer_set_transition_type (_tmp7_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT);
#line 395 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp8_ = self->priv->powerstrip;
#line 395 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp9_ = slingshot_slingshot_view_get_settings ();
#line 395 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp10_ = _tmp9_;
#line 395 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp8_, g_settings_get_boolean (_tmp10_, "enable-powerstrip"));
#line 396 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp11_ = self->stack;
#line 396 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_stack_set_transition_type (_tmp11_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
#line 1087 "SlingshotView.c"
}

static void
slingshot_slingshot_view_set_modality (SlingshotSlingshotView* self,
                                       SlingshotSlingshotViewModality new_modality)
{
#line 399 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_return_if_fail (self != NULL);
#line 400 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	self->priv->modality = new_modality;
#line 402 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	switch (self->priv->modality) {
#line 402 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		case SLINGSHOT_SLINGSHOT_VIEW_MODALITY_NORMAL_VIEW:
#line 1102 "SlingshotView.c"
		{
			GSettings* _tmp0_;
			GSettings* _tmp1_;
			GtkRevealer* _tmp4_;
			GtkStack* _tmp5_;
			GtkSearchEntry* _tmp6_;
#line 404 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			_tmp0_ = slingshot_slingshot_view_get_settings ();
#line 404 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			_tmp1_ = _tmp0_;
#line 404 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			if (g_settings_get_boolean (_tmp1_, "use-category")) {
#line 1115 "SlingshotView.c"
				GSettings* _tmp2_;
				GSettings* _tmp3_;
#line 405 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				_tmp2_ = slingshot_slingshot_view_get_settings ();
#line 405 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				_tmp3_ = _tmp2_;
#line 405 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				g_settings_set_boolean (_tmp3_, "use-category", FALSE);
#line 1124 "SlingshotView.c"
			}
#line 408 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			_tmp4_ = self->priv->view_selector_revealer;
#line 408 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			gtk_revealer_set_reveal_child (_tmp4_, TRUE);
#line 409 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			_tmp5_ = self->stack;
#line 409 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			gtk_stack_set_visible_child_name (_tmp5_, "normal");
#line 411 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			_tmp6_ = self->search_entry;
#line 411 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			gtk_widget_grab_focus ((GtkWidget*) _tmp6_);
#line 412 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			break;
#line 1140 "SlingshotView.c"
		}
#line 402 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		case SLINGSHOT_SLINGSHOT_VIEW_MODALITY_CATEGORY_VIEW:
#line 1144 "SlingshotView.c"
		{
			GSettings* _tmp7_;
			GSettings* _tmp8_;
			GtkRevealer* _tmp11_;
			GtkStack* _tmp12_;
			GtkSearchEntry* _tmp13_;
#line 415 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			_tmp7_ = slingshot_slingshot_view_get_settings ();
#line 415 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			_tmp8_ = _tmp7_;
#line 415 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			if (!g_settings_get_boolean (_tmp8_, "use-category")) {
#line 1157 "SlingshotView.c"
				GSettings* _tmp9_;
				GSettings* _tmp10_;
#line 416 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				_tmp9_ = slingshot_slingshot_view_get_settings ();
#line 416 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				_tmp10_ = _tmp9_;
#line 416 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				g_settings_set_boolean (_tmp10_, "use-category", TRUE);
#line 1166 "SlingshotView.c"
			}
#line 419 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			_tmp11_ = self->priv->view_selector_revealer;
#line 419 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			gtk_revealer_set_reveal_child (_tmp11_, TRUE);
#line 420 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			_tmp12_ = self->stack;
#line 420 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			gtk_stack_set_visible_child_name (_tmp12_, "category");
#line 422 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			_tmp13_ = self->search_entry;
#line 422 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			gtk_widget_grab_focus ((GtkWidget*) _tmp13_);
#line 423 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			break;
#line 1182 "SlingshotView.c"
		}
#line 402 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		case SLINGSHOT_SLINGSHOT_VIEW_MODALITY_SEARCH_VIEW:
#line 1186 "SlingshotView.c"
		{
			GtkRevealer* _tmp14_;
			GtkStack* _tmp15_;
#line 426 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			_tmp14_ = self->priv->view_selector_revealer;
#line 426 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			gtk_revealer_set_reveal_child (_tmp14_, FALSE);
#line 427 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			_tmp15_ = self->stack;
#line 427 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			gtk_stack_set_visible_child_name (_tmp15_, "search");
#line 428 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			break;
#line 1200 "SlingshotView.c"
		}
		default:
#line 402 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		break;
#line 1205 "SlingshotView.c"
	}
}

static void
slingshot_slingshot_view_search_data_free (gpointer _data)
{
	SlingshotSlingshotViewSearchData* _data_;
	_data_ = _data;
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (_data_->search_match);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (_data_->target);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_slice_free (SlingshotSlingshotViewSearchData, _data_);
#line 1222 "SlingshotView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	return self ? g_object_ref (self) : NULL;
#line 1230 "SlingshotView.c"
}

static void
slingshot_slingshot_view_search (SlingshotSlingshotView* self,
                                 const gchar* text,
                                 SynapseSearchMatch* search_match,
                                 SynapseMatch* target,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	SlingshotSlingshotViewSearchData* _data_;
	SlingshotSlingshotView* _tmp0_;
	gchar* _tmp1_;
	SynapseSearchMatch* _tmp2_;
	SynapseMatch* _tmp3_;
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_return_if_fail (self != NULL);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_return_if_fail (text != NULL);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_data_ = g_slice_new0 (SlingshotSlingshotViewSearchData);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_task_set_task_data (_data_->_async_result, _data_, slingshot_slingshot_view_search_data_free);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_data_->self = _tmp0_;
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp1_ = g_strdup (text);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_free0 (_data_->text);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_data_->text = _tmp1_;
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp2_ = _g_object_ref0 (search_match);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (_data_->search_match);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_data_->search_match = _tmp2_;
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp3_ = _g_object_ref0 (target);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (_data_->target);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_data_->target = _tmp3_;
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	slingshot_slingshot_view_search_co (_data_);
#line 1280 "SlingshotView.c"
}

static void
slingshot_slingshot_view_search_finish (SlingshotSlingshotView* self,
                                        GAsyncResult* _res_)
{
	SlingshotSlingshotViewSearchData* _data_;
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1290 "SlingshotView.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	return _data1_;
#line 1300 "SlingshotView.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1310 "SlingshotView.c"
		SlingshotSlingshotView* self;
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		self = _data1_->self;
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_g_object_unref0 (_data1_->matches);
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_g_free0 (_data1_->text);
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_g_object_unref0 (self);
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		g_slice_free (Block1Data, _data1_);
#line 1322 "SlingshotView.c"
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 1344 "SlingshotView.c"
}

static gboolean
___lambda75_ (SlingshotSlingshotView* self)
{
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	gboolean result;
#line 446 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp0_ = self->search_entry;
#line 446 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp1_ = gtk_entry_get_text ((GtkEntry*) _tmp0_);
#line 446 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp2_ = _tmp1_;
#line 446 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp3_ = string_strip (_tmp2_);
#line 446 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp4_ = _tmp3_;
#line 446 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp5_ = g_strcmp0 (_tmp4_, "") == 0;
#line 446 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_free0 (_tmp4_);
#line 446 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	if (_tmp5_) {
#line 1373 "SlingshotView.c"
		GraniteWidgetsModeButton* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 447 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp6_ = self->view_selector;
#line 447 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp7_ = granite_widgets_mode_button_get_selected (_tmp6_);
#line 447 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp8_ = _tmp7_;
#line 447 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		slingshot_slingshot_view_set_modality (self, (SlingshotSlingshotViewModality) _tmp8_);
#line 1385 "SlingshotView.c"
	}
#line 448 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	result = FALSE;
#line 448 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	return result;
#line 1391 "SlingshotView.c"
}

static gboolean
____lambda75__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda75_ ((SlingshotSlingshotView*) self);
#line 445 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	return result;
#line 1401 "SlingshotView.c"
}

static void
slingshot_slingshot_view_search_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	SlingshotSlingshotViewSearchData* _data_;
#line 460 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_data_ = _user_data_;
#line 460 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_data_->_source_object_ = source_object;
#line 460 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_data_->_res_ = _res_;
#line 460 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	slingshot_slingshot_view_search_co (_data_);
#line 1418 "SlingshotView.c"
}

static gboolean
__lambda76_ (Block1Data* _data1_)
{
	SlingshotSlingshotView* self;
	SlingshotWidgetsSearchView* _tmp0_;
	GeeList* _tmp1_;
	gboolean result;
#line 465 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	self = _data1_->self;
#line 466 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp0_ = self->priv->search_view;
#line 466 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp1_ = _data1_->matches;
#line 466 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	slingshot_widgets_search_view_set_results (_tmp0_, _tmp1_, _data1_->text);
#line 467 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	result = FALSE;
#line 467 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	return result;
#line 1440 "SlingshotView.c"
}

static gboolean
___lambda76__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda76_ (self);
#line 465 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	return result;
#line 1450 "SlingshotView.c"
}

static gboolean
slingshot_slingshot_view_search_co (SlingshotSlingshotViewSearchData* _data_)
{
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	switch (_data_->_state_) {
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		case 0:
#line 1460 "SlingshotView.c"
		goto _state_0;
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		case 1:
#line 1464 "SlingshotView.c"
		goto _state_1;
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		case 2:
#line 1468 "SlingshotView.c"
		goto _state_2;
		default:
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		g_assert_not_reached ();
#line 1473 "SlingshotView.c"
	}
	_state_0:
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_data_->_data1_ = g_slice_new0 (Block1Data);
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_data_->_data1_->_ref_count_ = 1;
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_data_->_data1_->self = g_object_ref (_data_->self);
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_free0 (_data_->_data1_->text);
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_data_->_data1_->text = _data_->text;
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_data_->_data1_->_async_data_ = _data_;
#line 436 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_data_->_tmp0_ = string_strip (_data_->_data1_->text);
#line 436 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_data_->stripped = _data_->_tmp0_;
#line 438 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_data_->_tmp1_ = _data_->stripped;
#line 438 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	if (g_strcmp0 (_data_->_tmp1_, "") == 0) {
#line 445 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda75__gsource_func, g_object_ref (_data_->self), g_object_unref);
#line 450 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_g_free0 (_data_->stripped);
#line 450 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		block1_data_unref (_data_->_data1_);
#line 450 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_data_->_data1_ = NULL;
#line 450 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 450 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		if (_data_->_state_ != 0) {
#line 450 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 450 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1512 "SlingshotView.c"
			}
		}
#line 450 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		g_object_unref (_data_->_async_result);
#line 450 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		return FALSE;
#line 1519 "SlingshotView.c"
	}
#line 453 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	if (_data_->self->priv->modality != SLINGSHOT_SLINGSHOT_VIEW_MODALITY_SEARCH_VIEW) {
#line 454 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		slingshot_slingshot_view_set_modality (_data_->self, SLINGSHOT_SLINGSHOT_VIEW_MODALITY_SEARCH_VIEW);
#line 1525 "SlingshotView.c"
	}
#line 458 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	if (_data_->search_match != NULL) {
#line 459 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		synapse_search_match_set_search_source (_data_->search_match, _data_->target);
#line 460 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_data_->_tmp2_ = _data_->self->priv->synapse;
#line 460 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_data_->_state_ = 1;
#line 460 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		slingshot_backend_synapse_search_search (_data_->_tmp2_, _data_->_data1_->text, (SynapseSearchProvider*) _data_->search_match, slingshot_slingshot_view_search_ready, _data_);
#line 460 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		return FALSE;
#line 1539 "SlingshotView.c"
		_state_1:
#line 460 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_data_->_tmp3_ = slingshot_backend_synapse_search_search_finish (_data_->_tmp2_, _data_->_res_);
#line 460 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_g_object_unref0 (_data_->_data1_->matches);
#line 460 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_data_->_data1_->matches = _data_->_tmp3_;
#line 1547 "SlingshotView.c"
	} else {
#line 462 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_data_->_tmp4_ = _data_->self->priv->synapse;
#line 462 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_data_->_state_ = 2;
#line 462 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		slingshot_backend_synapse_search_search (_data_->_tmp4_, _data_->_data1_->text, NULL, slingshot_slingshot_view_search_ready, _data_);
#line 462 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		return FALSE;
#line 1557 "SlingshotView.c"
		_state_2:
#line 462 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_data_->_tmp5_ = slingshot_backend_synapse_search_search_finish (_data_->_tmp4_, _data_->_res_);
#line 462 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_g_object_unref0 (_data_->_data1_->matches);
#line 462 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_data_->_data1_->matches = _data_->_tmp5_;
#line 1565 "SlingshotView.c"
	}
#line 465 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda76__gsource_func, block1_data_ref (_data_->_data1_), block1_data_unref);
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_free0 (_data_->stripped);
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	block1_data_unref (_data_->_data1_);
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_data_->_data1_ = NULL;
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	if (_data_->_state_ != 0) {
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1583 "SlingshotView.c"
		}
	}
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_object_unref (_data_->_async_result);
#line 433 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	return FALSE;
#line 1590 "SlingshotView.c"
}

SlingshotSlingshotView*
slingshot_slingshot_view_construct (GType object_type)
{
	SlingshotSlingshotView * self = NULL;
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	self = (SlingshotSlingshotView*) g_object_new (object_type, NULL);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	return self;
#line 1601 "SlingshotView.c"
}

SlingshotSlingshotView*
slingshot_slingshot_view_new (void)
{
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	return slingshot_slingshot_view_construct (SLINGSHOT_TYPE_SLINGSHOT_VIEW);
#line 1609 "SlingshotView.c"
}

static GSettings*
slingshot_slingshot_view_get_settings (void)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 50 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp0_ = slingshot_slingshot_view__settings;
#line 50 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	result = _tmp0_;
#line 50 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	return result;
#line 1623 "SlingshotView.c"
}

static void
slingshot_slingshot_view_set_settings (GSettings* value)
{
	GSettings* _tmp0_;
#line 50 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 50 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (slingshot_slingshot_view__settings);
#line 50 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	slingshot_slingshot_view__settings = _tmp0_;
#line 1636 "SlingshotView.c"
}

static gboolean
_slingshot_slingshot_view___lambda77_ (SlingshotSlingshotView* self)
{
	GtkSearchEntry* _tmp0_;
	gboolean result;
#line 139 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp0_ = self->search_entry;
#line 139 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
#line 140 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	result = GDK_EVENT_PROPAGATE;
#line 140 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	return result;
#line 1652 "SlingshotView.c"
}

static gboolean
__slingshot_slingshot_view___lambda77__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                                  GdkEventFocus* event,
                                                                  gpointer self)
{
	gboolean result;
	result = _slingshot_slingshot_view___lambda77_ ((SlingshotSlingshotView*) self);
#line 138 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	return result;
#line 1664 "SlingshotView.c"
}

static gboolean
_slingshot_slingshot_view_on_event_box_key_press_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                             GdkEventKey* event,
                                                                             gpointer self)
{
	gboolean result;
	result = slingshot_slingshot_view_on_event_box_key_press ((SlingshotSlingshotView*) self, event);
#line 143 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	return result;
#line 1676 "SlingshotView.c"
}

static gboolean
_slingshot_slingshot_view_on_search_view_key_press_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                               GdkEventKey* event,
                                                                               gpointer self)
{
	gboolean result;
	result = slingshot_slingshot_view_on_search_view_key_press ((SlingshotSlingshotView*) self, event);
#line 144 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	return result;
#line 1688 "SlingshotView.c"
}

static void
_slingshot_slingshot_view___lambda78_ (SlingshotSlingshotView* self)
{
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 148 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	if (self->priv->modality != SLINGSHOT_SLINGSHOT_VIEW_MODALITY_SEARCH_VIEW) {
#line 149 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		slingshot_slingshot_view_set_modality (self, SLINGSHOT_SLINGSHOT_VIEW_MODALITY_SEARCH_VIEW);
#line 1701 "SlingshotView.c"
	}
#line 151 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp0_ = self->search_entry;
#line 151 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp1_ = gtk_entry_get_text ((GtkEntry*) _tmp0_);
#line 151 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp2_ = _tmp1_;
#line 151 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	slingshot_slingshot_view_search (self, _tmp2_, NULL, NULL, NULL, NULL);
#line 1711 "SlingshotView.c"
}

static void
__slingshot_slingshot_view___lambda78__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                                        gpointer self)
{
#line 147 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_slingshot_slingshot_view___lambda78_ ((SlingshotSlingshotView*) self);
#line 1720 "SlingshotView.c"
}

static void
_slingshot_slingshot_view_search_entry_activated_gtk_entry_activate (GtkEntry* _sender,
                                                                     gpointer self)
{
#line 155 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	slingshot_slingshot_view_search_entry_activated ((SlingshotSlingshotView*) self);
#line 1729 "SlingshotView.c"
}

static void
_slingshot_slingshot_view___lambda79_ (SlingshotSlingshotView* self)
{
	GtkSearchEntry* _tmp0_;
#line 158 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp0_ = self->search_entry;
#line 158 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
#line 1740 "SlingshotView.c"
}

static void
__slingshot_slingshot_view___lambda79__slingshot_widgets_category_view_search_focus_request (SlingshotWidgetsCategoryView* _sender,
                                                                                             gpointer self)
{
#line 157 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_slingshot_slingshot_view___lambda79_ ((SlingshotSlingshotView*) self);
#line 1749 "SlingshotView.c"
}

static void
_slingshot_slingshot_view___lambda80_ (SlingshotSlingshotView* self)
{
#line 162 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_signal_emit (self, slingshot_slingshot_view_signals[SLINGSHOT_SLINGSHOT_VIEW_CLOSE_INDICATOR_SIGNAL], 0);
#line 1757 "SlingshotView.c"
}

static void
__slingshot_slingshot_view___lambda80__slingshot_widgets_grid_app_launched (SlingshotWidgetsGrid* _sender,
                                                                            gpointer self)
{
#line 161 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_slingshot_slingshot_view___lambda80_ ((SlingshotSlingshotView*) self);
#line 1766 "SlingshotView.c"
}

static void
_slingshot_slingshot_view___lambda81_ (SlingshotSlingshotView* self)
{
#line 166 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_signal_emit (self, slingshot_slingshot_view_signals[SLINGSHOT_SLINGSHOT_VIEW_CLOSE_INDICATOR_SIGNAL], 0);
#line 1774 "SlingshotView.c"
}

static void
__slingshot_slingshot_view___lambda81__slingshot_widgets_search_view_app_launched (SlingshotWidgetsSearchView* _sender,
                                                                                   gpointer self)
{
#line 165 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_slingshot_slingshot_view___lambda81_ ((SlingshotSlingshotView*) self);
#line 1783 "SlingshotView.c"
}

static void
_slingshot_slingshot_view___lambda82_ (SlingshotSlingshotView* self)
{
	GraniteWidgetsModeButton* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 170 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp0_ = self->view_selector;
#line 170 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp1_ = granite_widgets_mode_button_get_selected (_tmp0_);
#line 170 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp2_ = _tmp1_;
#line 170 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	slingshot_slingshot_view_set_modality (self, (SlingshotSlingshotViewModality) _tmp2_);
#line 1800 "SlingshotView.c"
}

static void
__slingshot_slingshot_view___lambda82__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                                                 GtkWidget* widget,
                                                                                 gpointer self)
{
#line 169 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_slingshot_slingshot_view___lambda82_ ((SlingshotSlingshotView*) self);
#line 1810 "SlingshotView.c"
}

static void
_slingshot_slingshot_view___lambda83_ (SlingshotSlingshotView* self)
{
	SlingshotWidgetsGrid* _tmp0_;
	SlingshotBackendAppSystem* _tmp1_;
	SlingshotWidgetsCategoryView* _tmp2_;
#line 175 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp0_ = self->priv->grid_view;
#line 175 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp1_ = self->app_system;
#line 175 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	slingshot_widgets_grid_populate (_tmp0_, _tmp1_);
#line 177 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp2_ = self->priv->category_view;
#line 177 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	slingshot_widgets_category_view_setup_sidebar (_tmp2_);
#line 1829 "SlingshotView.c"
}

static void
__slingshot_slingshot_view___lambda83__slingshot_backend_app_system_changed (SlingshotBackendAppSystem* _sender,
                                                                             gpointer self)
{
#line 174 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_slingshot_slingshot_view___lambda83_ ((SlingshotSlingshotView*) self);
#line 1838 "SlingshotView.c"
}

static void
_slingshot_slingshot_view___lambda84_ (SlingshotSlingshotView* self)
{
	SlingshotWidgetsGrid* _tmp0_;
	SlingshotBackendAppSystem* _tmp1_;
#line 181 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp0_ = self->priv->grid_view;
#line 181 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp1_ = self->app_system;
#line 181 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	slingshot_widgets_grid_populate (_tmp0_, _tmp1_);
#line 1852 "SlingshotView.c"
}

static void
__slingshot_slingshot_view___lambda84__g_settings_changed (GSettings* _sender,
                                                           const gchar* key,
                                                           gpointer self)
{
#line 180 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_slingshot_slingshot_view___lambda84_ ((SlingshotSlingshotView*) self);
#line 1862 "SlingshotView.c"
}

static void
_slingshot_slingshot_view___lambda85_ (SlingshotSlingshotView* self)
{
	SlingshotWidgetsGrid* _tmp0_;
	SlingshotBackendAppSystem* _tmp1_;
#line 185 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp0_ = self->priv->grid_view;
#line 185 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp1_ = self->app_system;
#line 185 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	slingshot_widgets_grid_populate (_tmp0_, _tmp1_);
#line 1876 "SlingshotView.c"
}

static void
__slingshot_slingshot_view___lambda85__g_settings_changed (GSettings* _sender,
                                                           const gchar* key,
                                                           gpointer self)
{
#line 184 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_slingshot_slingshot_view___lambda85_ ((SlingshotSlingshotView*) self);
#line 1886 "SlingshotView.c"
}

static void
_slingshot_slingshot_view___lambda86_ (SlingshotSlingshotView* self)
{
	SlingshotWidgetsGrid* _tmp0_;
	SlingshotBackendAppSystem* _tmp1_;
	SlingshotWidgetsCategoryView* _tmp2_;
#line 189 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp0_ = self->priv->grid_view;
#line 189 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp1_ = self->app_system;
#line 189 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	slingshot_widgets_grid_populate (_tmp0_, _tmp1_);
#line 190 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp2_ = self->priv->category_view;
#line 190 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	slingshot_widgets_category_view_setup_sidebar (_tmp2_);
#line 1905 "SlingshotView.c"
}

static void
__slingshot_slingshot_view___lambda86__g_settings_changed (GSettings* _sender,
                                                           const gchar* key,
                                                           gpointer self)
{
#line 188 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_slingshot_slingshot_view___lambda86_ ((SlingshotSlingshotView*) self);
#line 1915 "SlingshotView.c"
}

static void
_slingshot_slingshot_view___lambda87_ (SlingshotSlingshotView* self)
{
#line 194 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_signal_emit (self, slingshot_slingshot_view_signals[SLINGSHOT_SLINGSHOT_VIEW_CLOSE_INDICATOR_SIGNAL], 0);
#line 1923 "SlingshotView.c"
}

static void
__slingshot_slingshot_view___lambda87__app_menu_power_strip_invoke_action (AppMenuPowerStrip* _sender,
                                                                           gpointer self)
{
#line 193 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_slingshot_slingshot_view___lambda87_ ((SlingshotSlingshotView*) self);
#line 1932 "SlingshotView.c"
}

static GObject *
slingshot_slingshot_view_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SlingshotSlingshotView * self;
	SlingshotBackendAppSystem* _tmp0_;
	SlingshotBackendSynapseSearch* _tmp1_;
	GdkScreen* _tmp2_;
	GdkScreen* _tmp3_;
	GtkImage* grid_image = NULL;
	GtkImage* _tmp4_;
	GtkImage* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GtkImage* category_image = NULL;
	GtkImage* _tmp11_;
	GtkImage* _tmp12_;
	gchar* _tmp13_;
	gchar** _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GraniteWidgetsModeButton* _tmp18_;
	GraniteWidgetsModeButton* _tmp19_;
	GraniteWidgetsModeButton* _tmp20_;
	GtkImage* _tmp21_;
	GraniteWidgetsModeButton* _tmp22_;
	GtkImage* _tmp23_;
	GtkRevealer* _tmp24_;
	GtkRevealer* _tmp25_;
	GtkRevealer* _tmp26_;
	GraniteWidgetsModeButton* _tmp27_;
	GtkSearchEntry* _tmp28_;
	GtkSearchEntry* _tmp29_;
	GtkSearchEntry* _tmp30_;
	GtkSearchEntry* _tmp31_;
	gchar* _tmp32_;
	gchar** _tmp33_;
	gchar** _tmp34_;
	gint _tmp34__length1;
	gchar* _tmp35_;
	gchar* _tmp36_;
	AppMenuPowerStrip* _tmp37_;
	GtkGrid* _tmp38_;
	GtkGrid* _tmp39_;
	GtkGrid* _tmp40_;
	GtkGrid* _tmp41_;
	GtkRevealer* _tmp42_;
	GtkGrid* _tmp43_;
	GtkSearchEntry* _tmp44_;
	GtkGrid* _tmp45_;
	AppMenuPowerStrip* _tmp46_;
	SlingshotWidgetsGrid* _tmp47_;
	SlingshotWidgetsCategoryView* _tmp48_;
	SlingshotWidgetsSearchView* _tmp49_;
	GtkStack* _tmp50_ = NULL;
	GtkStack* _tmp51_;
	SlingshotWidgetsGrid* _tmp52_;
	GtkStack* _tmp53_;
	SlingshotWidgetsCategoryView* _tmp54_;
	GtkStack* _tmp55_;
	SlingshotWidgetsSearchView* _tmp56_;
	GtkGrid* _tmp57_;
	GtkGrid* _tmp58_;
	GtkGrid* _tmp59_;
	GtkGrid* _tmp60_;
	GtkGrid* _tmp61_;
	GtkGrid* _tmp62_;
	GtkStack* _tmp63_;
	SlingshotWidgetsGrid* _tmp64_;
	SlingshotBackendAppSystem* _tmp65_;
	GtkEventBox* event_box = NULL;
	GtkEventBox* _tmp66_;
	GtkEventBox* _tmp67_;
	GtkGrid* _tmp68_;
	GtkEventBox* _tmp69_;
	GSettings* _tmp70_;
	GSettings* _tmp71_;
	GtkEventBox* _tmp74_;
	GtkSearchEntry* _tmp75_;
	GtkSearchEntry* _tmp76_;
	GtkSearchEntry* _tmp77_;
	GtkSearchEntry* _tmp78_;
	SlingshotWidgetsCategoryView* _tmp79_;
	SlingshotWidgetsGrid* _tmp80_;
	SlingshotWidgetsSearchView* _tmp81_;
	GraniteWidgetsModeButton* _tmp82_;
	SlingshotBackendAppSystem* _tmp83_;
	GSettings* _tmp84_;
	GSettings* _tmp85_;
	GSettings* _tmp86_;
	GSettings* _tmp87_;
	GSettings* _tmp88_;
	GSettings* _tmp89_;
	AppMenuPowerStrip* _tmp90_;
	AppMenuPowerStrip* _tmp91_;
	GSettings* _tmp92_;
	GSettings* _tmp93_;
#line 56 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	parent_class = G_OBJECT_CLASS (slingshot_slingshot_view_parent_class);
#line 56 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 56 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SLINGSHOT_TYPE_SLINGSHOT_VIEW, SlingshotSlingshotView);
#line 57 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp0_ = slingshot_backend_app_system_new ();
#line 57 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->app_system);
#line 57 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	self->app_system = _tmp0_;
#line 58 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp1_ = slingshot_backend_synapse_search_new ();
#line 58 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->priv->synapse);
#line 58 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	self->priv->synapse = _tmp1_;
#line 60 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp2_ = gtk_widget_get_screen ((GtkWidget*) self);
#line 60 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 60 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->priv->screen);
#line 60 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	self->priv->screen = _tmp3_;
#line 62 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp4_ = (GtkImage*) gtk_image_new_from_icon_name ("view-grid-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 62 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_object_ref_sink (_tmp4_);
#line 62 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	grid_image = _tmp4_;
#line 64 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp5_ = grid_image;
#line 64 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp6_ = g_strdup ("<Ctrl>1");
#line 64 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp7_ = g_new0 (gchar*, 1 + 1);
#line 64 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp7_[0] = _tmp6_;
#line 64 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp8_ = _tmp7_;
#line 64 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp8__length1 = 1;
#line 64 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp9_ = granite_markup_accel_tooltip (_tmp8_, (gint) 1, _ ("View as Grid"));
#line 64 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp10_ = _tmp9_;
#line 64 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp5_, _tmp10_);
#line 64 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_free0 (_tmp10_);
#line 64 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 66 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp11_ = (GtkImage*) gtk_image_new_from_icon_name ("view-filter-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 66 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_object_ref_sink (_tmp11_);
#line 66 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	category_image = _tmp11_;
#line 68 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp12_ = category_image;
#line 68 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp13_ = g_strdup ("<Ctrl>2");
#line 68 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp14_ = g_new0 (gchar*, 1 + 1);
#line 68 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp14_[0] = _tmp13_;
#line 68 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp15_ = _tmp14_;
#line 68 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp15__length1 = 1;
#line 68 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp16_ = granite_markup_accel_tooltip (_tmp15_, (gint) 1, _ ("View by Category"));
#line 68 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp17_ = _tmp16_;
#line 68 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp12_, _tmp17_);
#line 68 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_free0 (_tmp17_);
#line 68 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_free), NULL);
#line 71 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp18_ = granite_widgets_mode_button_new ();
#line 71 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_object_ref_sink (_tmp18_);
#line 71 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->view_selector);
#line 71 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	self->view_selector = _tmp18_;
#line 72 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp19_ = self->view_selector;
#line 72 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp19_, 12);
#line 73 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp20_ = self->view_selector;
#line 73 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp21_ = grid_image;
#line 73 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	granite_widgets_mode_button_append (_tmp20_, (GtkWidget*) _tmp21_);
#line 74 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp22_ = self->view_selector;
#line 74 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp23_ = category_image;
#line 74 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	granite_widgets_mode_button_append (_tmp22_, (GtkWidget*) _tmp23_);
#line 76 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp24_ = (GtkRevealer*) gtk_revealer_new ();
#line 76 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_object_ref_sink (_tmp24_);
#line 76 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->priv->view_selector_revealer);
#line 76 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	self->priv->view_selector_revealer = _tmp24_;
#line 77 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp25_ = self->priv->view_selector_revealer;
#line 77 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_revealer_set_transition_type (_tmp25_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT);
#line 78 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp26_ = self->priv->view_selector_revealer;
#line 78 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp27_ = self->view_selector;
#line 78 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp27_);
#line 80 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp28_ = (GtkSearchEntry*) gtk_search_entry_new ();
#line 80 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_object_ref_sink (_tmp28_);
#line 80 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->search_entry);
#line 80 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	self->search_entry = _tmp28_;
#line 81 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp29_ = self->search_entry;
#line 81 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_entry_set_placeholder_text ((GtkEntry*) _tmp29_, _ ("Search Apps"));
#line 82 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp30_ = self->search_entry;
#line 82 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp30_, TRUE);
#line 84 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp31_ = self->search_entry;
#line 84 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp32_ = g_strdup ("<Ctrl>BackSpace");
#line 84 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp33_ = g_new0 (gchar*, 1 + 1);
#line 84 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp33_[0] = _tmp32_;
#line 84 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp34_ = _tmp33_;
#line 84 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp34__length1 = 1;
#line 84 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp35_ = granite_markup_accel_tooltip (_tmp34_, (gint) 1, _ ("Clear all"));
#line 84 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp36_ = _tmp35_;
#line 84 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_object_set ((GtkEntry*) _tmp31_, "secondary-icon-tooltip-markup", _tmp36_, NULL);
#line 84 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_free0 (_tmp36_);
#line 84 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp34_ = (_vala_array_free (_tmp34_, _tmp34__length1, (GDestroyNotify) g_free), NULL);
#line 89 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp37_ = app_menu_power_strip_new ();
#line 89 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_object_ref_sink (_tmp37_);
#line 89 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->priv->powerstrip);
#line 89 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	self->priv->powerstrip = _tmp37_;
#line 91 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp38_ = (GtkGrid*) gtk_grid_new ();
#line 91 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_object_ref_sink (_tmp38_);
#line 91 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->priv->top);
#line 91 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	self->priv->top = _tmp38_;
#line 92 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp39_ = self->priv->top;
#line 92 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp39_, 12);
#line 93 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp40_ = self->priv->top;
#line 93 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp40_, 12);
#line 94 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp41_ = self->priv->top;
#line 94 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp42_ = self->priv->view_selector_revealer;
#line 94 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_container_add ((GtkContainer*) _tmp41_, (GtkWidget*) _tmp42_);
#line 95 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp43_ = self->priv->top;
#line 95 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp44_ = self->search_entry;
#line 95 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_container_add ((GtkContainer*) _tmp43_, (GtkWidget*) _tmp44_);
#line 96 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp45_ = self->priv->top;
#line 96 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp46_ = self->priv->powerstrip;
#line 96 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_container_add ((GtkContainer*) _tmp45_, (GtkWidget*) _tmp46_);
#line 98 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp47_ = slingshot_widgets_grid_new ();
#line 98 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_object_ref_sink (_tmp47_);
#line 98 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->priv->grid_view);
#line 98 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	self->priv->grid_view = _tmp47_;
#line 100 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp48_ = slingshot_widgets_category_view_new (self);
#line 100 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_object_ref_sink (_tmp48_);
#line 100 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->priv->category_view);
#line 100 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	self->priv->category_view = _tmp48_;
#line 102 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp49_ = slingshot_widgets_search_view_new ();
#line 102 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_object_ref_sink (_tmp49_);
#line 102 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->priv->search_view);
#line 102 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	self->priv->search_view = _tmp49_;
#line 104 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp50_ = (GtkStack*) gtk_stack_new ();
#line 104 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_stack_set_transition_type (_tmp50_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
#line 104 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_object_ref_sink (_tmp50_);
#line 104 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->stack);
#line 104 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	self->stack = _tmp50_;
#line 107 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp51_ = self->stack;
#line 107 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp52_ = self->priv->grid_view;
#line 107 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_stack_add_named (_tmp51_, (GtkWidget*) _tmp52_, "normal");
#line 108 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp53_ = self->stack;
#line 108 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp54_ = self->priv->category_view;
#line 108 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_stack_add_named (_tmp53_, (GtkWidget*) _tmp54_, "category");
#line 109 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp55_ = self->stack;
#line 109 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp56_ = self->priv->search_view;
#line 109 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_stack_add_named (_tmp55_, (GtkWidget*) _tmp56_, "search");
#line 111 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp57_ = (GtkGrid*) gtk_grid_new ();
#line 111 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_object_ref_sink (_tmp57_);
#line 111 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->priv->container);
#line 111 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	self->priv->container = _tmp57_;
#line 112 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp58_ = self->priv->container;
#line 112 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_grid_set_row_spacing (_tmp58_, 12);
#line 113 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp59_ = self->priv->container;
#line 113 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp59_, 12);
#line 114 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp60_ = self->priv->container;
#line 114 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp61_ = self->priv->top;
#line 114 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_grid_attach (_tmp60_, (GtkWidget*) _tmp61_, 0, 1, 1, 1);
#line 115 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp62_ = self->priv->container;
#line 115 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp63_ = self->stack;
#line 115 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_grid_attach (_tmp62_, (GtkWidget*) _tmp63_, 0, 0, 1, 1);
#line 118 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp64_ = self->priv->grid_view;
#line 118 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp65_ = self->app_system;
#line 118 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	slingshot_widgets_grid_populate (_tmp64_, _tmp65_);
#line 120 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp66_ = (GtkEventBox*) gtk_event_box_new ();
#line 120 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_object_ref_sink (_tmp66_);
#line 120 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	event_box = _tmp66_;
#line 121 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp67_ = event_box;
#line 121 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp68_ = self->priv->container;
#line 121 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_container_add ((GtkContainer*) _tmp67_, (GtkWidget*) _tmp68_);
#line 124 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp69_ = event_box;
#line 124 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp69_);
#line 126 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp70_ = slingshot_slingshot_view_get_settings ();
#line 126 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp71_ = _tmp70_;
#line 126 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	if (g_settings_get_boolean (_tmp71_, "use-category")) {
#line 2353 "SlingshotView.c"
		GraniteWidgetsModeButton* _tmp72_;
#line 127 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp72_ = self->view_selector;
#line 127 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		granite_widgets_mode_button_set_selected (_tmp72_, 1);
#line 128 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		slingshot_slingshot_view_set_modality (self, SLINGSHOT_SLINGSHOT_VIEW_MODALITY_CATEGORY_VIEW);
#line 2361 "SlingshotView.c"
	} else {
		GraniteWidgetsModeButton* _tmp73_;
#line 130 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		_tmp73_ = self->view_selector;
#line 130 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		granite_widgets_mode_button_set_selected (_tmp73_, 0);
#line 131 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		slingshot_slingshot_view_set_modality (self, SLINGSHOT_SLINGSHOT_VIEW_MODALITY_NORMAL_VIEW);
#line 2370 "SlingshotView.c"
	}
#line 138 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_signal_connect_object ((GtkWidget*) self, "focus-in-event", (GCallback) __slingshot_slingshot_view___lambda77__gtk_widget_focus_in_event, self, 0);
#line 143 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp74_ = event_box;
#line 143 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_signal_connect_object ((GtkWidget*) _tmp74_, "key-press-event", (GCallback) _slingshot_slingshot_view_on_event_box_key_press_gtk_widget_key_press_event, self, 0);
#line 144 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp75_ = self->search_entry;
#line 144 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_signal_connect_object ((GtkWidget*) _tmp75_, "key-press-event", (GCallback) _slingshot_slingshot_view_on_search_view_key_press_gtk_widget_key_press_event, self, 0);
#line 147 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp76_ = self->search_entry;
#line 147 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_signal_connect_object (_tmp76_, "search-changed", (GCallback) __slingshot_slingshot_view___lambda78__gtk_search_entry_search_changed, self, 0);
#line 154 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp77_ = self->search_entry;
#line 154 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp77_);
#line 155 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp78_ = self->search_entry;
#line 155 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_signal_connect_object ((GtkEntry*) _tmp78_, "activate", (GCallback) _slingshot_slingshot_view_search_entry_activated_gtk_entry_activate, self, 0);
#line 157 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp79_ = self->priv->category_view;
#line 157 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_signal_connect_object (_tmp79_, "search-focus-request", (GCallback) __slingshot_slingshot_view___lambda79__slingshot_widgets_category_view_search_focus_request, self, 0);
#line 161 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp80_ = self->priv->grid_view;
#line 161 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_signal_connect_object (_tmp80_, "app-launched", (GCallback) __slingshot_slingshot_view___lambda80__slingshot_widgets_grid_app_launched, self, 0);
#line 165 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp81_ = self->priv->search_view;
#line 165 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_signal_connect_object (_tmp81_, "app-launched", (GCallback) __slingshot_slingshot_view___lambda81__slingshot_widgets_search_view_app_launched, self, 0);
#line 169 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp82_ = self->view_selector;
#line 169 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_signal_connect_object (_tmp82_, "mode-changed", (GCallback) __slingshot_slingshot_view___lambda82__granite_widgets_mode_button_mode_changed, self, 0);
#line 174 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp83_ = self->app_system;
#line 174 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_signal_connect_object (_tmp83_, "changed", (GCallback) __slingshot_slingshot_view___lambda83__slingshot_backend_app_system_changed, self, 0);
#line 180 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp84_ = slingshot_slingshot_view_get_settings ();
#line 180 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp85_ = _tmp84_;
#line 180 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_signal_connect_object (_tmp85_, "changed::rows", (GCallback) __slingshot_slingshot_view___lambda84__g_settings_changed, self, G_CONNECT_AFTER);
#line 184 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp86_ = slingshot_slingshot_view_get_settings ();
#line 184 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp87_ = _tmp86_;
#line 184 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_signal_connect_object (_tmp87_, "changed::columns", (GCallback) __slingshot_slingshot_view___lambda85__g_settings_changed, self, G_CONNECT_AFTER);
#line 188 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp88_ = slingshot_slingshot_view_get_settings ();
#line 188 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp89_ = _tmp88_;
#line 188 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_signal_connect_object (_tmp89_, "changed::show-terminal-apps", (GCallback) __slingshot_slingshot_view___lambda86__g_settings_changed, self, G_CONNECT_AFTER);
#line 193 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp90_ = self->priv->powerstrip;
#line 193 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_signal_connect_object (_tmp90_, "invoke-action", (GCallback) __slingshot_slingshot_view___lambda87__app_menu_power_strip_invoke_action, self, 0);
#line 196 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp91_ = self->priv->powerstrip;
#line 196 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp92_ = slingshot_slingshot_view_get_settings ();
#line 196 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp93_ = _tmp92_;
#line 196 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp91_, g_settings_get_boolean (_tmp93_, "enable-powerstrip"));
#line 56 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (event_box);
#line 56 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (category_image);
#line 56 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (grid_image);
#line 56 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	return obj;
#line 2452 "SlingshotView.c"
}

static void
slingshot_slingshot_view_class_init (SlingshotSlingshotViewClass * klass,
                                     gpointer klass_data)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	slingshot_slingshot_view_parent_class = g_type_class_peek_parent (klass);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	g_type_class_adjust_private_offset (klass, &SlingshotSlingshotView_private_offset);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_slingshot_slingshot_view_get_property;
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_slingshot_slingshot_view_set_property;
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	G_OBJECT_CLASS (klass)->constructor = slingshot_slingshot_view_constructor;
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	G_OBJECT_CLASS (klass)->finalize = slingshot_slingshot_view_finalize;
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	slingshot_slingshot_view_signals[SLINGSHOT_SLINGSHOT_VIEW_CLOSE_INDICATOR_SIGNAL] = g_signal_new ("close-indicator", SLINGSHOT_TYPE_SLINGSHOT_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 53 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp0_ = g_settings_new ("org.ubuntubudgie.plugins.budgie-appmenu");
#line 53 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_tmp1_ = _tmp0_;
#line 53 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	slingshot_slingshot_view_set_settings (_tmp1_);
#line 53 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (_tmp1_);
#line 2483 "SlingshotView.c"
}

static void
slingshot_slingshot_view_instance_init (SlingshotSlingshotView * self,
                                        gpointer klass)
{
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	self->priv = slingshot_slingshot_view_get_instance_private (self);
#line 2492 "SlingshotView.c"
}

static void
slingshot_slingshot_view_finalize (GObject * obj)
{
	SlingshotSlingshotView * self;
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SLINGSHOT_TYPE_SLINGSHOT_VIEW, SlingshotSlingshotView);
#line 26 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->app_system);
#line 27 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->search_entry);
#line 28 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->priv->powerstrip);
#line 29 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->stack);
#line 30 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->view_selector);
#line 40 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->priv->synapse);
#line 41 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->priv->screen);
#line 42 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->priv->view_selector_revealer);
#line 44 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->priv->grid_view);
#line 45 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->priv->container);
#line 46 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->priv->top);
#line 47 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->priv->search_view);
#line 48 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	_g_object_unref0 (self->priv->category_view);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	G_OBJECT_CLASS (slingshot_slingshot_view_parent_class)->finalize (obj);
#line 2529 "SlingshotView.c"
}

GType
slingshot_slingshot_view_get_type (void)
{
	return slingshot_slingshot_view_type_id;
}

GType
slingshot_slingshot_view_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (SlingshotSlingshotViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) slingshot_slingshot_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SlingshotSlingshotView), 0, (GInstanceInitFunc) slingshot_slingshot_view_instance_init, NULL };
	slingshot_slingshot_view_type_id = g_type_module_register_type (module, gtk_grid_get_type (), "SlingshotSlingshotView", &g_define_type_info, 0);
	SlingshotSlingshotView_private_offset = sizeof (SlingshotSlingshotViewPrivate);
	return slingshot_slingshot_view_type_id;
}

static void
_vala_slingshot_slingshot_view_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	SlingshotSlingshotView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SLINGSHOT_TYPE_SLINGSHOT_VIEW, SlingshotSlingshotView);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	switch (property_id) {
#line 2557 "SlingshotView.c"
		default:
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		break;
#line 2563 "SlingshotView.c"
	}
}

static void
_vala_slingshot_slingshot_view_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	SlingshotSlingshotView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SLINGSHOT_TYPE_SLINGSHOT_VIEW, SlingshotSlingshotView);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
	switch (property_id) {
#line 2577 "SlingshotView.c"
		default:
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../budgie-applications-menu/applications-menu/src/SlingshotView.vala"
		break;
#line 2583 "SlingshotView.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

