/* SearchView.c generated by valac 0.56.18, the Vala compiler
 * generated from SearchView.vala, do not modify */

/*
 * Copyright 2011-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 *              Giulio Collura
 */

#include "slingshot.h"
#include <granite.h>
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

#define SLINGSHOT_WIDGETS_SEARCH_VIEW_MAX_RESULTS 10
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SLINGSHOT_WIDGETS_SEARCH_VIEW_0_PROPERTY,
	SLINGSHOT_WIDGETS_SEARCH_VIEW_NUM_PROPERTIES
};
static GParamSpec* slingshot_widgets_search_view_properties[SLINGSHOT_WIDGETS_SEARCH_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block4Data Block4Data;
enum  {
	SLINGSHOT_WIDGETS_SEARCH_VIEW_APP_LAUNCHED_SIGNAL,
	SLINGSHOT_WIDGETS_SEARCH_VIEW_NUM_SIGNALS
};
static guint slingshot_widgets_search_view_signals[SLINGSHOT_WIDGETS_SEARCH_VIEW_NUM_SIGNALS] = {0};

struct _SlingshotWidgetsSearchViewPrivate {
	GraniteWidgetsAlertView* alert_view;
	SlingshotAppListBox* list_box;
	GeeHashMap* limitator;
};

struct _Block4Data {
	int _ref_count_;
	SlingshotWidgetsSearchView* self;
	GtkListBoxRow* row;
};

static gint SlingshotWidgetsSearchView_private_offset;
static gpointer slingshot_widgets_search_view_parent_class = NULL;
static GType slingshot_widgets_search_view_type_id = 0;

static void slingshot_widgets_search_view_create_item (SlingshotWidgetsSearchView* self,
                                                SlingshotBackendApp* app,
                                                const gchar* search_term,
                                                SlingshotWidgetsSearchItemResultType result_type);
static void __lambda52_ (SlingshotWidgetsSearchView* self,
                  GtkWidget* child);
static void ___lambda52__gfunc (gconstpointer data,
                         gpointer self);
static gint slingshot_widgets_search_view_update_sort (SlingshotWidgetsSearchView* self,
                                                GtkListBoxRow* row1,
                                                GtkListBoxRow* row2);
static void slingshot_widgets_search_view_update_header (SlingshotWidgetsSearchItem* row,
                                                  SlingshotWidgetsSearchItem* before,
                                                  SlingshotWidgetsSearchView* self);
static GObject * slingshot_widgets_search_view_constructor (GType type,
                                                     guint n_construct_properties,
                                                     GObjectConstructParam * construct_properties);
static gint _slingshot_widgets_search_view___lambda53_ (SlingshotWidgetsSearchView* self,
                                                 GtkListBoxRow* row1,
                                                 GtkListBoxRow* row2);
static gint __slingshot_widgets_search_view___lambda53__gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                         GtkListBoxRow* row2,
                                                                         gpointer self);
static void _slingshot_widgets_search_view___lambda54_ (SlingshotWidgetsSearchView* self);
static void __slingshot_widgets_search_view___lambda54__slingshot_app_list_box_close_request (SlingshotAppListBox* _sender,
                                                                                       gpointer self);
static void _slingshot_widgets_search_view___lambda55_ (SlingshotWidgetsSearchView* self,
                                                 GtkListBoxRow* row);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gboolean __lambda56_ (Block4Data* _data4_);
static gboolean ___lambda56__gsource_func (gpointer self);
static void __slingshot_widgets_search_view___lambda55__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                             GtkListBoxRow* row,
                                                                             gpointer self);
static gboolean _slingshot_widgets_search_view___lambda57_ (SlingshotWidgetsSearchView* self,
                                                     GdkEventButton* e);
static gboolean __slingshot_widgets_search_view___lambda57__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                    GdkEventButton* event,
                                                                                    gpointer self);
static gboolean _slingshot_widgets_search_view___lambda58_ (SlingshotWidgetsSearchView* self,
                                                     GdkEventKey* e);
static gboolean __slingshot_widgets_search_view___lambda58__gtk_widget_key_press_event (GtkWidget* _sender,
                                                                                 GdkEventKey* event,
                                                                                 gpointer self);
static void slingshot_widgets_search_view_finalize (GObject * obj);

static inline gpointer
slingshot_widgets_search_view_get_instance_private (SlingshotWidgetsSearchView* self)
{
	return G_STRUCT_MEMBER_P (self, SlingshotWidgetsSearchView_private_offset);
}

void
slingshot_widgets_search_view_set_results (SlingshotWidgetsSearchView* self,
                                           GeeList* matches,
                                           const gchar* search_term)
{
	gint _tmp0_;
	gint _tmp1_;
	GtkListBoxRow* first = NULL;
	SlingshotAppListBox* _tmp42_;
	GtkListBoxRow* _tmp43_;
	GtkListBoxRow* _tmp44_;
#line 101 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_return_if_fail (self != NULL);
#line 101 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_return_if_fail (matches != NULL);
#line 101 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_return_if_fail (search_term != NULL);
#line 102 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	slingshot_widgets_search_view_clear (self);
#line 103 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp0_ = gee_collection_get_size ((GeeCollection*) matches);
#line 103 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp1_ = _tmp0_;
#line 103 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	if (_tmp1_ > 0) {
#line 156 "SearchView.c"
		{
			GeeList* _match_list = NULL;
			gint _match_size = 0;
			GeeList* _tmp2_;
			gint _tmp3_;
			gint _tmp4_;
			gint _match_index = 0;
#line 104 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
			_match_list = matches;
#line 104 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
			_tmp2_ = _match_list;
#line 104 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
			_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 104 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
			_tmp4_ = _tmp3_;
#line 104 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
			_match_size = _tmp4_;
#line 104 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
			_match_index = -1;
#line 104 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
			while (TRUE) {
#line 178 "SearchView.c"
				gint _tmp5_;
				gint _tmp6_;
				SynapseMatch* match = NULL;
				GeeList* _tmp7_;
				gpointer _tmp8_;
				SlingshotBackendApp* app = NULL;
				SynapseMatch* _tmp9_;
				SlingshotBackendApp* _tmp10_;
				SlingshotWidgetsSearchItemResultType result_type = 0;
				SynapseMatch* _tmp11_;
				SynapseMatchType _tmp12_;
				SynapseMatchType _tmp13_;
				gboolean _tmp14_ = FALSE;
				SynapseMatch* _tmp15_;
				SlingshotBackendApp* _tmp38_;
#line 104 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_match_index = _match_index + 1;
#line 104 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_tmp5_ = _match_index;
#line 104 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_tmp6_ = _match_size;
#line 104 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				if (!(_tmp5_ < _tmp6_)) {
#line 104 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
					break;
#line 204 "SearchView.c"
				}
#line 104 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_tmp7_ = _match_list;
#line 104 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_tmp8_ = gee_list_get (_tmp7_, _match_index);
#line 104 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				match = (SynapseMatch*) _tmp8_;
#line 105 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_tmp9_ = match;
#line 105 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_tmp10_ = slingshot_backend_app_new_from_synapse_match (_tmp9_, NULL);
#line 105 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				app = _tmp10_;
#line 106 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_tmp11_ = match;
#line 106 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_tmp12_ = synapse_match_get_match_type (_tmp11_);
#line 106 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_tmp13_ = _tmp12_;
#line 106 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				result_type = (SlingshotWidgetsSearchItemResultType) _tmp13_;
#line 107 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_tmp15_ = match;
#line 107 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				if (SYNAPSE_DESKTOP_FILE_PLUGIN_IS_ACTION_MATCH (_tmp15_)) {
#line 107 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
					_tmp14_ = TRUE;
#line 232 "SearchView.c"
				} else {
					SynapseMatch* _tmp16_;
#line 108 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
					_tmp16_ = match;
#line 108 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
					_tmp14_ = SYNAPSE_CONTROL_PANEL_PLUGIN_IS_ACTION_MATCH (_tmp16_);
#line 239 "SearchView.c"
				}
#line 107 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				if (_tmp14_) {
#line 109 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
					result_type = SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_APP_ACTIONS;
#line 245 "SearchView.c"
				} else {
					SynapseMatch* _tmp17_;
#line 110 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
					_tmp17_ = match;
#line 110 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
					if (SYNAPSE_LINK_PLUGIN_IS_RESULT (_tmp17_)) {
#line 111 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
						result_type = SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_INTERNET;
#line 254 "SearchView.c"
					} else {
						SynapseMatch* _tmp18_;
#line 112 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
						_tmp18_ = match;
#line 112 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
						if (SYNAPSE_FILE_BOOKMARK_PLUGIN_IS_RESULT (_tmp18_)) {
#line 113 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							result_type = SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_BOOKMARK;
#line 263 "SearchView.c"
						}
					}
				}
#line 116 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				if (result_type == SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_UNKNOWN) {
#line 269 "SearchView.c"
					GeeList* actions = NULL;
					SynapseMatch* _tmp19_;
					GeeList* _tmp20_;
#line 117 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
					_tmp19_ = match;
#line 117 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
					_tmp20_ = slingshot_backend_synapse_search_find_actions_for_match (_tmp19_);
#line 117 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
					actions = _tmp20_;
#line 279 "SearchView.c"
					{
						GeeList* _action_list = NULL;
						GeeList* _tmp21_;
						gint _action_size = 0;
						GeeList* _tmp22_;
						gint _tmp23_;
						gint _tmp24_;
						gint _action_index = 0;
#line 118 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
						_tmp21_ = actions;
#line 118 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
						_action_list = _tmp21_;
#line 118 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
						_tmp22_ = _action_list;
#line 118 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
						_tmp23_ = gee_collection_get_size ((GeeCollection*) _tmp22_);
#line 118 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
						_tmp24_ = _tmp23_;
#line 118 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
						_action_size = _tmp24_;
#line 118 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
						_action_index = -1;
#line 118 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
						while (TRUE) {
#line 304 "SearchView.c"
							gint _tmp25_;
							gint _tmp26_;
							SynapseMatch* action = NULL;
							GeeList* _tmp27_;
							gpointer _tmp28_;
							SynapseMatch* _tmp29_;
							SynapseMatch* _tmp30_;
							SlingshotBackendApp* _tmp31_;
							SlingshotBackendApp* _tmp32_;
							SlingshotBackendApp* _tmp33_;
							SynapseMatch* _tmp34_;
							SynapseMatch* _tmp35_;
							SynapseMatchType _tmp36_;
							SynapseMatchType _tmp37_;
#line 118 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							_action_index = _action_index + 1;
#line 118 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							_tmp25_ = _action_index;
#line 118 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							_tmp26_ = _action_size;
#line 118 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							if (!(_tmp25_ < _tmp26_)) {
#line 118 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
								break;
#line 329 "SearchView.c"
							}
#line 118 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							_tmp27_ = _action_list;
#line 118 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							_tmp28_ = gee_list_get (_tmp27_, _action_index);
#line 118 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							action = (SynapseMatch*) _tmp28_;
#line 119 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							_tmp29_ = action;
#line 119 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							_tmp30_ = match;
#line 119 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							_tmp31_ = slingshot_backend_app_new_from_synapse_match (_tmp29_, _tmp30_);
#line 119 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							_g_object_unref0 (app);
#line 119 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							app = _tmp31_;
#line 120 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							_tmp32_ = app;
#line 120 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							_tmp33_ = app;
#line 120 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							_tmp34_ = slingshot_backend_app_get_match (_tmp33_);
#line 120 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							_tmp35_ = _tmp34_;
#line 120 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							_tmp36_ = synapse_match_get_match_type (_tmp35_);
#line 120 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							_tmp37_ = _tmp36_;
#line 120 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							slingshot_widgets_search_view_create_item (self, _tmp32_, search_term, (SlingshotWidgetsSearchItemResultType) _tmp37_);
#line 118 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
							_g_object_unref0 (action);
#line 363 "SearchView.c"
						}
					}
#line 123 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
					_g_object_unref0 (actions);
#line 123 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
					_g_object_unref0 (app);
#line 123 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
					_g_object_unref0 (match);
#line 123 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
					continue;
#line 374 "SearchView.c"
				}
#line 126 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_tmp38_ = app;
#line 126 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				slingshot_widgets_search_view_create_item (self, _tmp38_, search_term, result_type);
#line 104 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_g_object_unref0 (app);
#line 104 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_g_object_unref0 (match);
#line 384 "SearchView.c"
			}
		}
	} else {
		GraniteWidgetsAlertView* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
#line 130 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp39_ = self->priv->alert_view;
#line 130 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp40_ = g_strdup_printf (_ ("No Results for “%s”"), search_term);
#line 130 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp41_ = _tmp40_;
#line 130 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		granite_widgets_alert_view_set_title (_tmp39_, _tmp41_);
#line 130 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_g_free0 (_tmp41_);
#line 401 "SearchView.c"
	}
#line 134 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp42_ = self->priv->list_box;
#line 134 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp43_ = gtk_list_box_get_row_at_index ((GtkListBox*) _tmp42_, 0);
#line 134 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	first = _tmp43_;
#line 135 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp44_ = first;
#line 135 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	if (_tmp44_ != NULL) {
#line 413 "SearchView.c"
		SlingshotAppListBox* _tmp45_;
		GtkListBoxRow* _tmp46_;
#line 136 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp45_ = self->priv->list_box;
#line 136 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp46_ = first;
#line 136 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		gtk_list_box_select_row ((GtkListBox*) _tmp45_, _tmp46_);
#line 422 "SearchView.c"
	}
}

static void
slingshot_widgets_search_view_create_item (SlingshotWidgetsSearchView* self,
                                           SlingshotBackendApp* app,
                                           const gchar* search_term,
                                           SlingshotWidgetsSearchItemResultType result_type)
{
	GeeHashMap* _tmp0_;
	SlingshotWidgetsSearchItem* search_item = NULL;
	SlingshotWidgetsSearchItem* _tmp5_;
	SlingshotAppListBox* _tmp6_;
	SlingshotWidgetsSearchItem* _tmp7_;
	SlingshotWidgetsSearchItem* _tmp8_;
#line 140 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_return_if_fail (self != NULL);
#line 140 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_return_if_fail (app != NULL);
#line 140 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_return_if_fail (search_term != NULL);
#line 141 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp0_ = self->priv->limitator;
#line 141 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) result_type))) {
#line 448 "SearchView.c"
		guint amount = 0U;
		GeeHashMap* _tmp1_;
		gpointer _tmp2_;
#line 142 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp1_ = self->priv->limitator;
#line 142 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, (gpointer) ((gintptr) result_type));
#line 142 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		amount = (guint) ((guintptr) _tmp2_);
#line 143 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		if (amount >= ((guint) SLINGSHOT_WIDGETS_SEARCH_VIEW_MAX_RESULTS)) {
#line 144 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
			return;
#line 462 "SearchView.c"
		} else {
			GeeHashMap* _tmp3_;
#line 146 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
			_tmp3_ = self->priv->limitator;
#line 146 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) result_type), (gpointer) ((guintptr) (amount + 1)));
#line 469 "SearchView.c"
		}
	} else {
		GeeHashMap* _tmp4_;
#line 149 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp4_ = self->priv->limitator;
#line 149 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, (gpointer) ((gintptr) result_type), (gpointer) ((guintptr) 1));
#line 477 "SearchView.c"
	}
#line 152 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp5_ = slingshot_widgets_search_item_new (app, search_term, result_type);
#line 152 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_object_ref_sink (_tmp5_);
#line 152 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	search_item = _tmp5_;
#line 155 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp6_ = self->priv->list_box;
#line 155 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp7_ = search_item;
#line 155 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
#line 156 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp8_ = search_item;
#line 156 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp8_);
#line 140 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_g_object_unref0 (search_item);
#line 497 "SearchView.c"
}

static void
__lambda52_ (SlingshotWidgetsSearchView* self,
             GtkWidget* child)
{
#line 161 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_return_if_fail (child != NULL);
#line 162 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	gtk_widget_destroy (child);
#line 508 "SearchView.c"
}

static void
___lambda52__gfunc (gconstpointer data,
                    gpointer self)
{
#line 161 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	__lambda52_ ((SlingshotWidgetsSearchView*) self, (GtkWidget*) data);
#line 517 "SearchView.c"
}

void
slingshot_widgets_search_view_clear (SlingshotWidgetsSearchView* self)
{
	GeeHashMap* _tmp0_;
	SlingshotAppListBox* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
#line 159 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_return_if_fail (self != NULL);
#line 160 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp0_ = self->priv->limitator;
#line 160 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
#line 161 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp1_ = self->priv->list_box;
#line 161 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp2_ = gtk_container_get_children ((GtkContainer*) _tmp1_);
#line 161 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp3_ = _tmp2_;
#line 161 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_list_foreach (_tmp3_, ___lambda52__gfunc, self);
#line 161 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	(_tmp3_ == NULL) ? NULL : (_tmp3_ = (g_list_free (_tmp3_), NULL));
#line 543 "SearchView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 167 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	return self ? g_object_ref (self) : NULL;
#line 551 "SearchView.c"
}

void
slingshot_widgets_search_view_activate_selection (SlingshotWidgetsSearchView* self)
{
	GtkListBoxRow* selection = NULL;
	SlingshotAppListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	GtkListBoxRow* _tmp2_;
	GtkListBoxRow* _tmp3_;
#line 166 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_return_if_fail (self != NULL);
#line 167 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp0_ = self->priv->list_box;
#line 167 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp1_ = gtk_list_box_get_selected_row ((GtkListBox*) _tmp0_);
#line 167 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 167 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	selection = _tmp2_;
#line 168 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp3_ = selection;
#line 168 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	if (_tmp3_ != NULL) {
#line 576 "SearchView.c"
		SlingshotAppListBox* _tmp4_;
		GtkListBoxRow* _tmp5_;
#line 169 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp4_ = self->priv->list_box;
#line 169 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp5_ = selection;
#line 169 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		g_signal_emit_by_name ((GtkListBox*) _tmp4_, "row-activated", _tmp5_);
#line 585 "SearchView.c"
	}
#line 166 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_g_object_unref0 (selection);
#line 589 "SearchView.c"
}

static gint
slingshot_widgets_search_view_update_sort (SlingshotWidgetsSearchView* self,
                                           GtkListBoxRow* row1,
                                           GtkListBoxRow* row2)
{
	SlingshotWidgetsSearchItem* item1 = NULL;
	SlingshotWidgetsSearchItem* _tmp0_;
	SlingshotWidgetsSearchItem* item2 = NULL;
	SlingshotWidgetsSearchItem* _tmp1_;
	SlingshotWidgetsSearchItem* _tmp2_;
	SlingshotWidgetsSearchItemResultType _tmp3_;
	SlingshotWidgetsSearchItemResultType _tmp4_;
	SlingshotWidgetsSearchItem* _tmp5_;
	SlingshotWidgetsSearchItemResultType _tmp6_;
	SlingshotWidgetsSearchItemResultType _tmp7_;
	gint result;
#line 173 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 173 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_return_val_if_fail (row1 != NULL, 0);
#line 173 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_return_val_if_fail (row2 != NULL, 0);
#line 174 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp0_ = _g_object_ref0 (SLINGSHOT_WIDGETS_IS_SEARCH_ITEM (row1) ? ((SlingshotWidgetsSearchItem*) row1) : NULL);
#line 174 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	item1 = _tmp0_;
#line 175 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp1_ = _g_object_ref0 (SLINGSHOT_WIDGETS_IS_SEARCH_ITEM (row2) ? ((SlingshotWidgetsSearchItem*) row2) : NULL);
#line 175 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	item2 = _tmp1_;
#line 176 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp2_ = item1;
#line 176 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp3_ = slingshot_widgets_search_item_get_result_type (_tmp2_);
#line 176 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp4_ = _tmp3_;
#line 176 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp5_ = item2;
#line 176 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp6_ = slingshot_widgets_search_item_get_result_type (_tmp5_);
#line 176 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp7_ = _tmp6_;
#line 176 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	if (_tmp4_ != _tmp7_) {
#line 636 "SearchView.c"
		SlingshotWidgetsSearchItem* _tmp8_;
		SlingshotWidgetsSearchItemResultType _tmp9_;
		SlingshotWidgetsSearchItemResultType _tmp10_;
		SlingshotWidgetsSearchItem* _tmp11_;
		SlingshotWidgetsSearchItemResultType _tmp12_;
		SlingshotWidgetsSearchItemResultType _tmp13_;
#line 177 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp8_ = item1;
#line 177 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp9_ = slingshot_widgets_search_item_get_result_type (_tmp8_);
#line 177 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp10_ = _tmp9_;
#line 177 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp11_ = item2;
#line 177 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp12_ = slingshot_widgets_search_item_get_result_type (_tmp11_);
#line 177 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp13_ = _tmp12_;
#line 177 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		result = (gint) (_tmp10_ - _tmp13_);
#line 177 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_g_object_unref0 (item2);
#line 177 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_g_object_unref0 (item1);
#line 177 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		return result;
#line 663 "SearchView.c"
	}
#line 180 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	result = 0;
#line 180 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_g_object_unref0 (item2);
#line 180 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_g_object_unref0 (item1);
#line 180 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	return result;
#line 673 "SearchView.c"
}

static void
slingshot_widgets_search_view_update_header (SlingshotWidgetsSearchItem* row,
                                             SlingshotWidgetsSearchItem* before,
                                             SlingshotWidgetsSearchView* self)
{
	gboolean _tmp0_ = FALSE;
	GraniteHeaderLabel* header = NULL;
	SlingshotWidgetsSearchItemResultType _tmp5_;
	SlingshotWidgetsSearchItemResultType _tmp6_;
	const gchar* _tmp7_;
	GraniteHeaderLabel* _tmp8_;
	GraniteHeaderLabel* _tmp9_;
#line 184 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_return_if_fail (self != NULL);
#line 184 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_return_if_fail (row != NULL);
#line 185 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	if (before != NULL) {
#line 694 "SearchView.c"
		SlingshotWidgetsSearchItemResultType _tmp1_;
		SlingshotWidgetsSearchItemResultType _tmp2_;
		SlingshotWidgetsSearchItemResultType _tmp3_;
		SlingshotWidgetsSearchItemResultType _tmp4_;
#line 185 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp1_ = slingshot_widgets_search_item_get_result_type (before);
#line 185 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp2_ = _tmp1_;
#line 185 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp3_ = slingshot_widgets_search_item_get_result_type (row);
#line 185 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp4_ = _tmp3_;
#line 185 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp0_ = _tmp2_ == _tmp4_;
#line 709 "SearchView.c"
	} else {
#line 185 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp0_ = FALSE;
#line 713 "SearchView.c"
	}
#line 185 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	if (_tmp0_) {
#line 186 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		gtk_list_box_row_set_header ((GtkListBoxRow*) row, NULL);
#line 187 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		return;
#line 721 "SearchView.c"
	}
#line 190 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp5_ = slingshot_widgets_search_item_get_result_type (row);
#line 190 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp6_ = _tmp5_;
#line 190 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp7_ = slingshot_widgets_search_item_result_type_to_string (_tmp6_);
#line 190 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp8_ = granite_header_label_new (_tmp7_);
#line 190 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_object_ref_sink (_tmp8_);
#line 190 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	header = _tmp8_;
#line 192 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp9_ = header;
#line 192 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	gtk_list_box_row_set_header ((GtkListBoxRow*) row, (GtkWidget*) _tmp9_);
#line 184 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_g_object_unref0 (header);
#line 741 "SearchView.c"
}

SlingshotWidgetsSearchView*
slingshot_widgets_search_view_construct (GType object_type)
{
	SlingshotWidgetsSearchView * self = NULL;
#line 23 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	self = (SlingshotWidgetsSearchView*) g_object_new (object_type, NULL);
#line 23 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	return self;
#line 752 "SearchView.c"
}

SlingshotWidgetsSearchView*
slingshot_widgets_search_view_new (void)
{
#line 23 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	return slingshot_widgets_search_view_construct (SLINGSHOT_WIDGETS_TYPE_SEARCH_VIEW);
#line 760 "SearchView.c"
}

static gint
_slingshot_widgets_search_view___lambda53_ (SlingshotWidgetsSearchView* self,
                                            GtkListBoxRow* row1,
                                            GtkListBoxRow* row2)
{
	gint result;
#line 43 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_return_val_if_fail (row1 != NULL, 0);
#line 43 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_return_val_if_fail (row2 != NULL, 0);
#line 43 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	result = slingshot_widgets_search_view_update_sort (self, row1, row2);
#line 43 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	return result;
#line 777 "SearchView.c"
}

static gint
__slingshot_widgets_search_view___lambda53__gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                    GtkListBoxRow* row2,
                                                                    gpointer self)
{
	gint result;
	result = _slingshot_widgets_search_view___lambda53_ ((SlingshotWidgetsSearchView*) self, row1, row2);
#line 43 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	return result;
#line 789 "SearchView.c"
}

static void
_slingshot_widgets_search_view___lambda54_ (SlingshotWidgetsSearchView* self)
{
#line 48 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_signal_emit (self, slingshot_widgets_search_view_signals[SLINGSHOT_WIDGETS_SEARCH_VIEW_APP_LAUNCHED_SIGNAL], 0);
#line 797 "SearchView.c"
}

static void
__slingshot_widgets_search_view___lambda54__slingshot_app_list_box_close_request (SlingshotAppListBox* _sender,
                                                                                  gpointer self)
{
#line 47 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_slingshot_widgets_search_view___lambda54_ ((SlingshotWidgetsSearchView*) self);
#line 806 "SearchView.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 51 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 51 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	return _data4_;
#line 816 "SearchView.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 51 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 826 "SearchView.c"
		SlingshotWidgetsSearchView* self;
#line 51 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		self = _data4_->self;
#line 51 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_g_object_unref0 (_data4_->row);
#line 51 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_g_object_unref0 (self);
#line 51 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		g_slice_free (Block4Data, _data4_);
#line 836 "SearchView.c"
	}
}

static gboolean
__lambda56_ (Block4Data* _data4_)
{
	SlingshotWidgetsSearchView* self;
	SlingshotWidgetsSearchItem* search_item = NULL;
	SlingshotWidgetsSearchItem* _tmp0_;
	SlingshotAppListBox* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 52 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	self = _data4_->self;
#line 53 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp0_ = _g_object_ref0 (SLINGSHOT_WIDGETS_IS_SEARCH_ITEM (_data4_->row) ? ((SlingshotWidgetsSearchItem*) _data4_->row) : NULL);
#line 53 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	search_item = _tmp0_;
#line 54 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp1_ = self->priv->list_box;
#line 54 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp2_ = slingshot_app_list_box_get_dragging (_tmp1_);
#line 54 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp3_ = _tmp2_;
#line 54 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	if (!_tmp3_) {
#line 864 "SearchView.c"
		SlingshotWidgetsSearchItem* _tmp4_;
		SlingshotWidgetsSearchItemResultType _tmp5_;
		SlingshotWidgetsSearchItemResultType _tmp6_;
#line 55 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp4_ = search_item;
#line 55 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp5_ = slingshot_widgets_search_item_get_result_type (_tmp4_);
#line 55 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp6_ = _tmp5_;
#line 55 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		switch (_tmp6_) {
#line 55 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
			case SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_APP_ACTIONS:
#line 55 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
			case SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_LINK:
#line 55 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
			case SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_SETTINGS:
#line 55 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
			case SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_BOOKMARK:
#line 884 "SearchView.c"
			{
				SlingshotWidgetsSearchItem* _tmp7_;
				SlingshotBackendApp* _tmp8_;
				SlingshotBackendApp* _tmp9_;
				SynapseMatch* _tmp10_;
				SynapseMatch* _tmp11_;
#line 60 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_tmp7_ = search_item;
#line 60 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_tmp8_ = slingshot_widgets_search_item_get_app (_tmp7_);
#line 60 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_tmp9_ = _tmp8_;
#line 60 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_tmp10_ = slingshot_backend_app_get_match (_tmp9_);
#line 60 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_tmp11_ = _tmp10_;
#line 60 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				synapse_match_execute (_tmp11_, NULL);
#line 61 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				break;
#line 905 "SearchView.c"
			}
			default:
			{
				SlingshotWidgetsSearchItem* _tmp12_;
				SlingshotBackendApp* _tmp13_;
				SlingshotBackendApp* _tmp14_;
#line 63 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_tmp12_ = search_item;
#line 63 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_tmp13_ = slingshot_widgets_search_item_get_app (_tmp12_);
#line 63 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				_tmp14_ = _tmp13_;
#line 63 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				slingshot_backend_app_launch (_tmp14_);
#line 64 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
				break;
#line 922 "SearchView.c"
			}
		}
#line 67 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		g_signal_emit (self, slingshot_widgets_search_view_signals[SLINGSHOT_WIDGETS_SEARCH_VIEW_APP_LAUNCHED_SIGNAL], 0);
#line 927 "SearchView.c"
	}
#line 70 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	result = FALSE;
#line 70 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_g_object_unref0 (search_item);
#line 70 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	return result;
#line 935 "SearchView.c"
}

static gboolean
___lambda56__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda56_ (self);
#line 52 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	return result;
#line 945 "SearchView.c"
}

static void
_slingshot_widgets_search_view___lambda55_ (SlingshotWidgetsSearchView* self,
                                            GtkListBoxRow* row)
{
	Block4Data* _data4_;
	GtkListBoxRow* _tmp0_;
#line 51 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_return_if_fail (row != NULL);
#line 51 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 51 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_data4_->_ref_count_ = 1;
#line 51 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_data4_->self = g_object_ref (self);
#line 51 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp0_ = _g_object_ref0 (row);
#line 51 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_g_object_unref0 (_data4_->row);
#line 51 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_data4_->row = _tmp0_;
#line 52 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda56__gsource_func, block4_data_ref (_data4_), block4_data_unref);
#line 51 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	block4_data_unref (_data4_);
#line 51 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_data4_ = NULL;
#line 974 "SearchView.c"
}

static void
__slingshot_widgets_search_view___lambda55__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                        GtkListBoxRow* row,
                                                                        gpointer self)
{
#line 51 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_slingshot_widgets_search_view___lambda55_ ((SlingshotWidgetsSearchView*) self, row);
#line 984 "SearchView.c"
}

static gboolean
_slingshot_widgets_search_view___lambda57_ (SlingshotWidgetsSearchView* self,
                                            GdkEventButton* e)
{
	GtkListBoxRow* row = NULL;
	SlingshotAppListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	GtkListBoxRow* _tmp2_;
	SlingshotWidgetsSearchItem* search_item = NULL;
	GtkListBoxRow* _tmp3_;
	SlingshotWidgetsSearchItem* _tmp4_;
	SlingshotWidgetsSearchItem* _tmp5_;
	gboolean result;
#line 74 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 76 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp0_ = self->priv->list_box;
#line 76 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp1_ = gtk_list_box_get_row_at_y ((GtkListBox*) _tmp0_, (gint) e->y);
#line 76 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 76 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	row = _tmp2_;
#line 77 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp3_ = row;
#line 77 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp4_ = _g_object_ref0 (SLINGSHOT_WIDGETS_IS_SEARCH_ITEM (_tmp3_) ? ((SlingshotWidgetsSearchItem*) _tmp3_) : NULL);
#line 77 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	search_item = _tmp4_;
#line 79 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	if (e->button != ((guint) GDK_BUTTON_SECONDARY)) {
#line 80 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		result = GDK_EVENT_PROPAGATE;
#line 80 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_g_object_unref0 (search_item);
#line 80 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_g_object_unref0 (row);
#line 80 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		return result;
#line 1026 "SearchView.c"
	}
#line 83 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp5_ = search_item;
#line 83 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	result = slingshot_widgets_search_item_create_context_menu (_tmp5_, (GdkEvent*) e);
#line 83 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_g_object_unref0 (search_item);
#line 83 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_g_object_unref0 (row);
#line 83 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	return result;
#line 1038 "SearchView.c"
}

static gboolean
__slingshot_widgets_search_view___lambda57__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                           GdkEventButton* event,
                                                                           gpointer self)
{
	gboolean result;
	result = _slingshot_widgets_search_view___lambda57_ ((SlingshotWidgetsSearchView*) self, event);
#line 74 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	return result;
#line 1050 "SearchView.c"
}

static gboolean
_slingshot_widgets_search_view___lambda58_ (SlingshotWidgetsSearchView* self,
                                            GdkEventKey* e)
{
	GtkListBoxRow* row = NULL;
	SlingshotAppListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	GtkListBoxRow* _tmp2_;
	SlingshotWidgetsSearchItem* search_item = NULL;
	GtkListBoxRow* _tmp3_;
	SlingshotWidgetsSearchItem* _tmp4_;
	gboolean result;
#line 86 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 88 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp0_ = self->priv->list_box;
#line 88 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp1_ = gtk_list_box_get_selected_row ((GtkListBox*) _tmp0_);
#line 88 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 88 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	row = _tmp2_;
#line 89 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp3_ = row;
#line 89 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp4_ = _g_object_ref0 (SLINGSHOT_WIDGETS_IS_SEARCH_ITEM (_tmp3_) ? ((SlingshotWidgetsSearchItem*) _tmp3_) : NULL);
#line 89 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	search_item = _tmp4_;
#line 91 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	if (e->keyval == GDK_KEY_Menu) {
#line 1083 "SearchView.c"
		SlingshotWidgetsSearchItem* _tmp5_;
#line 92 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_tmp5_ = search_item;
#line 92 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		result = slingshot_widgets_search_item_create_context_menu (_tmp5_, (GdkEvent*) e);
#line 92 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_g_object_unref0 (search_item);
#line 92 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		_g_object_unref0 (row);
#line 92 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
		return result;
#line 1095 "SearchView.c"
	}
#line 95 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	result = GDK_EVENT_PROPAGATE;
#line 95 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_g_object_unref0 (search_item);
#line 95 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_g_object_unref0 (row);
#line 95 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	return result;
#line 1105 "SearchView.c"
}

static gboolean
__slingshot_widgets_search_view___lambda58__gtk_widget_key_press_event (GtkWidget* _sender,
                                                                        GdkEventKey* event,
                                                                        gpointer self)
{
	gboolean result;
	result = _slingshot_widgets_search_view___lambda58_ ((SlingshotWidgetsSearchView*) self, event);
#line 86 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	return result;
#line 1117 "SearchView.c"
}

static GObject *
slingshot_widgets_search_view_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SlingshotWidgetsSearchView * self;
	GraniteWidgetsAlertView* _tmp0_;
	GraniteWidgetsAlertView* _tmp1_;
	GeeHashMap* _tmp2_;
	SlingshotAppListBox* _tmp3_;
	SlingshotAppListBox* _tmp4_;
	SlingshotAppListBox* _tmp5_;
	SlingshotAppListBox* _tmp6_;
	SlingshotAppListBox* _tmp7_;
	GraniteWidgetsAlertView* _tmp8_;
	SlingshotAppListBox* _tmp9_;
	SlingshotAppListBox* _tmp10_;
	SlingshotAppListBox* _tmp11_;
	SlingshotAppListBox* _tmp12_;
	SlingshotAppListBox* _tmp13_;
#line 33 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	parent_class = G_OBJECT_CLASS (slingshot_widgets_search_view_parent_class);
#line 33 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 33 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SLINGSHOT_WIDGETS_TYPE_SEARCH_VIEW, SlingshotWidgetsSearchView);
#line 34 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_object_set ((GtkScrolledWindow*) self, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 36 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp0_ = granite_widgets_alert_view_new ("", _ ("Try changing search terms."), "edit-find-symbolic");
#line 36 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_object_ref_sink (_tmp0_);
#line 36 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_g_object_unref0 (self->priv->alert_view);
#line 36 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	self->priv->alert_view = _tmp0_;
#line 37 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp1_ = self->priv->alert_view;
#line 37 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp1_);
#line 40 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp2_ = gee_hash_map_new (SLINGSHOT_WIDGETS_SEARCH_ITEM_TYPE_RESULT_TYPE, NULL, NULL, G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 40 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_g_object_unref0 (self->priv->limitator);
#line 40 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	self->priv->limitator = _tmp2_;
#line 41 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp3_ = slingshot_app_list_box_new ();
#line 41 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_object_ref_sink (_tmp3_);
#line 41 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_g_object_unref0 (self->priv->list_box);
#line 41 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	self->priv->list_box = _tmp3_;
#line 42 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp4_ = self->priv->list_box;
#line 42 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	gtk_list_box_set_activate_on_single_click ((GtkListBox*) _tmp4_, TRUE);
#line 43 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp5_ = self->priv->list_box;
#line 43 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	gtk_list_box_set_sort_func ((GtkListBox*) _tmp5_, __slingshot_widgets_search_view___lambda53__gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
#line 44 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp6_ = self->priv->list_box;
#line 44 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	gtk_list_box_set_header_func ((GtkListBox*) _tmp6_, (GtkListBoxUpdateHeaderFunc) slingshot_widgets_search_view_update_header, g_object_ref (self), g_object_unref);
#line 45 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp7_ = self->priv->list_box;
#line 45 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp8_ = self->priv->alert_view;
#line 45 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	gtk_list_box_set_placeholder ((GtkListBox*) _tmp7_, (GtkWidget*) _tmp8_);
#line 47 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp9_ = self->priv->list_box;
#line 47 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_signal_connect_object (_tmp9_, "close-request", (GCallback) __slingshot_widgets_search_view___lambda54__slingshot_app_list_box_close_request, self, 0);
#line 51 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp10_ = self->priv->list_box;
#line 51 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_signal_connect_object ((GtkListBox*) _tmp10_, "row-activated", (GCallback) __slingshot_widgets_search_view___lambda55__gtk_list_box_row_activated, self, 0);
#line 74 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp11_ = self->priv->list_box;
#line 74 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_signal_connect_object ((GtkWidget*) _tmp11_, "button-press-event", (GCallback) __slingshot_widgets_search_view___lambda57__gtk_widget_button_press_event, self, 0);
#line 86 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp12_ = self->priv->list_box;
#line 86 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_signal_connect_object ((GtkWidget*) _tmp12_, "key-press-event", (GCallback) __slingshot_widgets_search_view___lambda58__gtk_widget_key_press_event, self, 0);
#line 98 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_tmp13_ = self->priv->list_box;
#line 98 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp13_);
#line 33 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	return obj;
#line 1216 "SearchView.c"
}

static void
slingshot_widgets_search_view_class_init (SlingshotWidgetsSearchViewClass * klass,
                                          gpointer klass_data)
{
#line 23 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	slingshot_widgets_search_view_parent_class = g_type_class_peek_parent (klass);
#line 23 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	g_type_class_adjust_private_offset (klass, &SlingshotWidgetsSearchView_private_offset);
#line 23 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	G_OBJECT_CLASS (klass)->constructor = slingshot_widgets_search_view_constructor;
#line 23 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	G_OBJECT_CLASS (klass)->finalize = slingshot_widgets_search_view_finalize;
#line 23 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	slingshot_widgets_search_view_signals[SLINGSHOT_WIDGETS_SEARCH_VIEW_APP_LAUNCHED_SIGNAL] = g_signal_new ("app-launched", SLINGSHOT_WIDGETS_TYPE_SEARCH_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1233 "SearchView.c"
}

static void
slingshot_widgets_search_view_instance_init (SlingshotWidgetsSearchView * self,
                                             gpointer klass)
{
#line 23 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	self->priv = slingshot_widgets_search_view_get_instance_private (self);
#line 1242 "SearchView.c"
}

static void
slingshot_widgets_search_view_finalize (GObject * obj)
{
	SlingshotWidgetsSearchView * self;
#line 23 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SLINGSHOT_WIDGETS_TYPE_SEARCH_VIEW, SlingshotWidgetsSearchView);
#line 29 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_g_object_unref0 (self->priv->alert_view);
#line 30 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_g_object_unref0 (self->priv->list_box);
#line 31 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	_g_object_unref0 (self->priv->limitator);
#line 23 "../budgie-applications-menu/applications-menu/src/Views/SearchView.vala"
	G_OBJECT_CLASS (slingshot_widgets_search_view_parent_class)->finalize (obj);
#line 1259 "SearchView.c"
}

GType
slingshot_widgets_search_view_get_type (void)
{
	return slingshot_widgets_search_view_type_id;
}

GType
slingshot_widgets_search_view_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (SlingshotWidgetsSearchViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) slingshot_widgets_search_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SlingshotWidgetsSearchView), 0, (GInstanceInitFunc) slingshot_widgets_search_view_instance_init, NULL };
	slingshot_widgets_search_view_type_id = g_type_module_register_type (module, gtk_scrolled_window_get_type (), "SlingshotWidgetsSearchView", &g_define_type_info, 0);
	SlingshotWidgetsSearchView_private_offset = sizeof (SlingshotWidgetsSearchViewPrivate);
	return slingshot_widgets_search_view_type_id;
}

