/* AppContextMenu.c generated by valac 0.56.18, the Vala compiler
 * generated from AppContextMenu.vala, do not modify */

/*
 * Copyright 2019 elementary, Inc. (https://elementary.io)
 * Copyright 2020-2021 Justin Haygood
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include "slingshot.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gdesktopappinfo.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SLINGSHOT_APP_CONTEXT_MENU_0_PROPERTY,
	SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_ID_PROPERTY,
	SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_PATH_PROPERTY,
	SLINGSHOT_APP_CONTEXT_MENU_NUM_PROPERTIES
};
static GParamSpec* slingshot_app_context_menu_properties[SLINGSHOT_APP_CONTEXT_MENU_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block6Data Block6Data;
typedef struct _Block7Data Block7Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	SLINGSHOT_APP_CONTEXT_MENU_APP_LAUNCHED_SIGNAL,
	SLINGSHOT_APP_CONTEXT_MENU_NUM_SIGNALS
};
static guint slingshot_app_context_menu_signals[SLINGSHOT_APP_CONTEXT_MENU_NUM_SIGNALS] = {0};

struct _SlingshotAppContextMenuPrivate {
	gchar* _desktop_id;
	gchar* _desktop_path;
	GDesktopAppInfo* app_info;
	gboolean has_system_item;
	SlingshotBackendSwitcherooControl* switcheroo_control;
};

struct _Block6Data {
	int _ref_count_;
	SlingshotAppContextMenu* self;
	gchar* action;
};

struct _Block7Data {
	int _ref_count_;
	SlingshotAppContextMenu* self;
	gboolean prefers_non_default_gpu;
};

static gint SlingshotAppContextMenu_private_offset;
static gpointer slingshot_app_context_menu_parent_class = NULL;
static GType slingshot_app_context_menu_type_id = 0;

static GObject * slingshot_app_context_menu_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void _slingshot_app_context_menu_____lambda34_ (Block6Data* _data6_);
static void __slingshot_app_context_menu_____lambda34__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                        gpointer self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void _slingshot_app_context_menu____lambda35_ (Block7Data* _data7_);
static void __slingshot_app_context_menu____lambda35__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                       gpointer self);
static void slingshot_app_context_menu_finalize (GObject * obj);
static void _vala_slingshot_app_context_menu_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_slingshot_app_context_menu_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static gssize _vala_array_length (gpointer array);

static inline gpointer
slingshot_app_context_menu_get_instance_private (SlingshotAppContextMenu* self)
{
	return G_STRUCT_MEMBER_P (self, SlingshotAppContextMenu_private_offset);
}

SlingshotAppContextMenu*
slingshot_app_context_menu_construct (GType object_type,
                                      const gchar* desktop_id,
                                      const gchar* desktop_path)
{
	SlingshotAppContextMenu * self = NULL;
#line 43 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	g_return_val_if_fail (desktop_id != NULL, NULL);
#line 43 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	g_return_val_if_fail (desktop_path != NULL, NULL);
#line 44 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	self = (SlingshotAppContextMenu*) g_object_new (object_type, "desktop-id", desktop_id, "desktop-path", desktop_path, NULL);
#line 43 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	return self;
#line 128 "AppContextMenu.c"
}

SlingshotAppContextMenu*
slingshot_app_context_menu_new (const gchar* desktop_id,
                                const gchar* desktop_path)
{
#line 43 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	return slingshot_app_context_menu_construct (SLINGSHOT_TYPE_APP_CONTEXT_MENU, desktop_id, desktop_path);
#line 137 "AppContextMenu.c"
}

const gchar*
slingshot_app_context_menu_get_desktop_id (SlingshotAppContextMenu* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_tmp0_ = self->priv->_desktop_id;
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	result = _tmp0_;
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	return result;
#line 153 "AppContextMenu.c"
}

static void
slingshot_app_context_menu_set_desktop_id (SlingshotAppContextMenu* self,
                                           const gchar* value)
{
	gchar* old_value;
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	g_return_if_fail (self != NULL);
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	old_value = slingshot_app_context_menu_get_desktop_id (self);
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 167 "AppContextMenu.c"
		gchar* _tmp0_;
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp0_ = g_strdup (value);
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_g_free0 (self->priv->_desktop_id);
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		self->priv->_desktop_id = _tmp0_;
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_app_context_menu_properties[SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_ID_PROPERTY]);
#line 177 "AppContextMenu.c"
	}
}

const gchar*
slingshot_app_context_menu_get_desktop_path (SlingshotAppContextMenu* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_tmp0_ = self->priv->_desktop_path;
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	result = _tmp0_;
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	return result;
#line 194 "AppContextMenu.c"
}

static void
slingshot_app_context_menu_set_desktop_path (SlingshotAppContextMenu* self,
                                             const gchar* value)
{
	gchar* old_value;
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	g_return_if_fail (self != NULL);
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	old_value = slingshot_app_context_menu_get_desktop_path (self);
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 208 "AppContextMenu.c"
		gchar* _tmp0_;
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp0_ = g_strdup (value);
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_g_free0 (self->priv->_desktop_path);
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		self->priv->_desktop_path = _tmp0_;
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_app_context_menu_properties[SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_PATH_PROPERTY]);
#line 218 "AppContextMenu.c"
	}
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	return _data6_;
#line 229 "AppContextMenu.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 239 "AppContextMenu.c"
		SlingshotAppContextMenu* self;
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		self = _data6_->self;
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_g_free0 (_data6_->action);
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_g_object_unref0 (self);
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		g_slice_free (Block6Data, _data6_);
#line 249 "AppContextMenu.c"
	}
}

static void
_slingshot_app_context_menu_____lambda34_ (Block6Data* _data6_)
{
	SlingshotAppContextMenu* self;
	GDesktopAppInfo* _tmp0_;
	const gchar* _tmp1_;
	GAppLaunchContext* _tmp2_;
	GAppLaunchContext* _tmp3_;
#line 67 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	self = _data6_->self;
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_tmp0_ = self->priv->app_info;
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_tmp1_ = _data6_->action;
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_tmp2_ = g_app_launch_context_new ();
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_tmp3_ = _tmp2_;
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	g_desktop_app_info_launch_action (_tmp0_, _tmp1_, _tmp3_);
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_g_object_unref0 (_tmp3_);
#line 69 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	g_signal_emit (self, slingshot_app_context_menu_signals[SLINGSHOT_APP_CONTEXT_MENU_APP_LAUNCHED_SIGNAL], 0);
#line 277 "AppContextMenu.c"
}

static void
__slingshot_app_context_menu_____lambda34__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self)
{
#line 67 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_slingshot_app_context_menu_____lambda34_ (self);
#line 286 "AppContextMenu.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	return _data7_;
#line 296 "AppContextMenu.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 306 "AppContextMenu.c"
		SlingshotAppContextMenu* self;
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		self = _data7_->self;
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_g_object_unref0 (self);
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		g_slice_free (Block7Data, _data7_);
#line 314 "AppContextMenu.c"
	}
}

static void
_slingshot_app_context_menu____lambda35_ (Block7Data* _data7_)
{
	SlingshotAppContextMenu* self;
	GError* _inner_error0_ = NULL;
#line 84 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	self = _data7_->self;
#line 325 "AppContextMenu.c"
	{
		GAppLaunchContext* context = NULL;
		GAppLaunchContext* _tmp0_;
		SlingshotBackendSwitcherooControl* _tmp1_;
		GAppLaunchContext* _tmp2_;
		GDesktopAppInfo* _tmp3_;
		GAppLaunchContext* _tmp4_;
#line 86 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp0_ = g_app_launch_context_new ();
#line 86 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		context = _tmp0_;
#line 87 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp1_ = self->priv->switcheroo_control;
#line 87 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp2_ = context;
#line 87 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		slingshot_backend_switcheroo_control_apply_gpu_environment (_tmp1_, _tmp2_, _data7_->prefers_non_default_gpu);
#line 88 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp3_ = self->priv->app_info;
#line 88 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp4_ = context;
#line 88 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		g_app_info_launch ((GAppInfo*) _tmp3_, NULL, _tmp4_, &_inner_error0_);
#line 88 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 88 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
			_g_object_unref0 (context);
#line 353 "AppContextMenu.c"
			goto __catch0_g_error;
		}
#line 89 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		g_signal_emit (self, slingshot_app_context_menu_signals[SLINGSHOT_APP_CONTEXT_MENU_APP_LAUNCHED_SIGNAL], 0);
#line 85 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_g_object_unref0 (context);
#line 360 "AppContextMenu.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 85 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		e = _inner_error0_;
#line 85 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_inner_error0_ = NULL;
#line 91 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp5_ = gtk_widget_get_name ((GtkWidget*) self);
#line 91 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp6_ = _tmp5_;
#line 91 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp7_ = e;
#line 91 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp8_ = _tmp7_->message;
#line 91 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		g_warning ("AppContextMenu.vala:91: Failed to launch %s: %s", _tmp6_, _tmp8_);
#line 85 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_g_error_free0 (e);
#line 386 "AppContextMenu.c"
	}
	__finally0:
#line 85 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 85 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		g_clear_error (&_inner_error0_);
#line 85 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		return;
#line 397 "AppContextMenu.c"
	}
}

static void
__slingshot_app_context_menu____lambda35__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                  gpointer self)
{
#line 84 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_slingshot_app_context_menu____lambda35_ (self);
#line 407 "AppContextMenu.c"
}

static GObject *
slingshot_app_context_menu_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SlingshotAppContextMenu * self;
	SlingshotBackendSwitcherooControl* _tmp0_;
	const gchar* _tmp1_;
	GDesktopAppInfo* _tmp2_;
	GDesktopAppInfo* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gboolean _tmp16_ = FALSE;
	SlingshotBackendSwitcherooControl* _tmp17_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gboolean _tmp32_;
#line 57 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	parent_class = G_OBJECT_CLASS (slingshot_app_context_menu_parent_class);
#line 57 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 57 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SLINGSHOT_TYPE_APP_CONTEXT_MENU, SlingshotAppContextMenu);
#line 58 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_tmp0_ = slingshot_backend_switcheroo_control_new ();
#line 58 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_g_object_unref0 (self->priv->switcheroo_control);
#line 58 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	self->priv->switcheroo_control = _tmp0_;
#line 60 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_tmp1_ = self->priv->_desktop_id;
#line 60 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_tmp2_ = g_desktop_app_info_new (_tmp1_);
#line 60 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_g_object_unref0 (self->priv->app_info);
#line 60 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	self->priv->app_info = _tmp2_;
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_tmp3_ = self->priv->app_info;
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_tmp5_ = _tmp4_ = g_desktop_app_info_list_actions (_tmp3_);
#line 453 "AppContextMenu.c"
	{
		gchar** _action_collection = NULL;
		gint _action_collection_length1 = 0;
		gint __action_collection_size_ = 0;
		gint _action_it = 0;
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_action_collection = _tmp5_;
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_action_collection_length1 = _vala_array_length (_tmp4_);
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		for (_action_it = 0; _action_it < _action_collection_length1; _action_it = _action_it + 1) {
#line 465 "AppContextMenu.c"
			const gchar* _action = NULL;
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
			_action = _action_collection[_action_it];
#line 469 "AppContextMenu.c"
			{
				Block6Data* _data6_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				GtkMenuItem* menuitem = NULL;
				GDesktopAppInfo* _tmp8_;
				const gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				GtkMenuItem* _tmp12_;
				GtkMenuItem* _tmp13_;
				GtkMenuItem* _tmp14_;
				GtkMenuItem* _tmp15_;
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				_data6_ = g_slice_new0 (Block6Data);
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				_data6_->_ref_count_ = 1;
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				_data6_->self = g_object_ref (self);
#line 63 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				_tmp6_ = _action;
#line 63 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				_tmp7_ = g_strdup (_tmp6_);
#line 63 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				_data6_->action = _tmp7_;
#line 64 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				_tmp8_ = self->priv->app_info;
#line 64 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				_tmp9_ = _data6_->action;
#line 64 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				_tmp10_ = g_desktop_app_info_get_action_name (_tmp8_, _tmp9_);
#line 64 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				_tmp11_ = _tmp10_;
#line 64 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				_tmp12_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_tmp11_);
#line 64 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				g_object_ref_sink (_tmp12_);
#line 64 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				_tmp13_ = _tmp12_;
#line 64 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				_g_free0 (_tmp11_);
#line 64 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				menuitem = _tmp13_;
#line 65 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				_tmp14_ = menuitem;
#line 65 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp14_);
#line 67 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				_tmp15_ = menuitem;
#line 67 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				g_signal_connect_data (_tmp15_, "activate", (GCallback) __slingshot_app_context_menu_____lambda34__gtk_menu_item_activate, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				_g_object_unref0 (menuitem);
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				block6_data_unref (_data6_);
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
				_data6_ = NULL;
#line 527 "AppContextMenu.c"
			}
		}
	}
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_tmp17_ = self->priv->switcheroo_control;
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	if (_tmp17_ != NULL) {
#line 535 "AppContextMenu.c"
		SlingshotBackendSwitcherooControl* _tmp18_;
		gboolean _tmp19_;
		gboolean _tmp20_;
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp18_ = self->priv->switcheroo_control;
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp19_ = slingshot_backend_switcheroo_control_get_has_dual_gpu (_tmp18_);
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp20_ = _tmp19_;
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp16_ = _tmp20_;
#line 547 "AppContextMenu.c"
	} else {
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp16_ = FALSE;
#line 551 "AppContextMenu.c"
	}
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	if (_tmp16_) {
#line 555 "AppContextMenu.c"
		Block7Data* _data7_;
		GDesktopAppInfo* _tmp21_;
		gchar* gpu_name = NULL;
		SlingshotBackendSwitcherooControl* _tmp22_;
		gchar* _tmp23_;
		gchar* label = NULL;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		GtkMenuItem* menu_item = NULL;
		const gchar* _tmp26_;
		GtkMenuItem* _tmp27_;
		GtkMenuItem* _tmp28_;
		GtkMenuItem* _tmp29_;
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_data7_ = g_slice_new0 (Block7Data);
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_data7_->_ref_count_ = 1;
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_data7_->self = g_object_ref (self);
#line 74 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp21_ = self->priv->app_info;
#line 74 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_data7_->prefers_non_default_gpu = g_desktop_app_info_get_boolean (_tmp21_, "PrefersNonDefaultGPU");
#line 76 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp22_ = self->priv->switcheroo_control;
#line 76 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp23_ = slingshot_backend_switcheroo_control_get_gpu_name (_tmp22_, _data7_->prefers_non_default_gpu);
#line 76 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		gpu_name = _tmp23_;
#line 79 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp24_ = gpu_name;
#line 79 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp25_ = g_strdup_printf (_ ("Open with %s Graphics"), _tmp24_);
#line 79 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		label = _tmp25_;
#line 81 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp26_ = label;
#line 81 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp27_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_tmp26_);
#line 81 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		g_object_ref_sink (_tmp27_);
#line 81 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		menu_item = _tmp27_;
#line 82 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp28_ = menu_item;
#line 82 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp28_);
#line 84 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_tmp29_ = menu_item;
#line 84 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		g_signal_connect_data (_tmp29_, "activate", (GCallback) __slingshot_app_context_menu____lambda35__gtk_menu_item_activate, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_g_object_unref0 (menu_item);
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_g_free0 (label);
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_g_free0 (gpu_name);
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		block7_data_unref (_data7_);
#line 73 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		_data7_ = NULL;
#line 617 "AppContextMenu.c"
	}
#line 121 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_tmp30_ = g_find_program_in_path ("io.elementary.appcenter");
#line 121 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_tmp31_ = _tmp30_;
#line 121 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_tmp32_ = _tmp31_ != NULL;
#line 121 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_g_free0 (_tmp31_);
#line 121 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	if (_tmp32_) {
#line 629 "AppContextMenu.c"
		gboolean _tmp33_ = FALSE;
#line 122 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		if (!self->priv->has_system_item) {
#line 633 "AppContextMenu.c"
			GList* _tmp34_;
			GList* _tmp35_;
#line 122 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
			_tmp34_ = gtk_container_get_children ((GtkContainer*) self);
#line 122 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
			_tmp35_ = _tmp34_;
#line 122 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
			_tmp33_ = g_list_length (_tmp35_) > ((guint) 0);
#line 122 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
			(_tmp35_ == NULL) ? NULL : (_tmp35_ = (g_list_free (_tmp35_), NULL));
#line 644 "AppContextMenu.c"
		} else {
#line 122 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
			_tmp33_ = FALSE;
#line 648 "AppContextMenu.c"
		}
#line 122 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		if (_tmp33_) {
#line 652 "AppContextMenu.c"
			GtkSeparatorMenuItem* _tmp36_;
			GtkSeparatorMenuItem* _tmp37_;
#line 123 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
			_tmp36_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 123 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
			g_object_ref_sink (_tmp36_);
#line 123 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
			_tmp37_ = _tmp36_;
#line 123 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
			gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp37_);
#line 123 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
			_g_object_unref0 (_tmp37_);
#line 665 "AppContextMenu.c"
		}
	}
#line 131 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 57 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	return obj;
#line 672 "AppContextMenu.c"
}

static void
slingshot_app_context_menu_class_init (SlingshotAppContextMenuClass * klass,
                                       gpointer klass_data)
{
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	slingshot_app_context_menu_parent_class = g_type_class_peek_parent (klass);
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	g_type_class_adjust_private_offset (klass, &SlingshotAppContextMenu_private_offset);
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_slingshot_app_context_menu_get_property;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_slingshot_app_context_menu_set_property;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	G_OBJECT_CLASS (klass)->constructor = slingshot_app_context_menu_constructor;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	G_OBJECT_CLASS (klass)->finalize = slingshot_app_context_menu_finalize;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_ID_PROPERTY, slingshot_app_context_menu_properties[SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_ID_PROPERTY] = g_param_spec_string ("desktop-id", "desktop-id", "desktop-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_PATH_PROPERTY, slingshot_app_context_menu_properties[SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_PATH_PROPERTY] = g_param_spec_string ("desktop-path", "desktop-path", "desktop-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	slingshot_app_context_menu_signals[SLINGSHOT_APP_CONTEXT_MENU_APP_LAUNCHED_SIGNAL] = g_signal_new ("app-launched", SLINGSHOT_TYPE_APP_CONTEXT_MENU, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 697 "AppContextMenu.c"
}

static void
slingshot_app_context_menu_instance_init (SlingshotAppContextMenu * self,
                                          gpointer klass)
{
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	self->priv = slingshot_app_context_menu_get_instance_private (self);
#line 26 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	self->priv->has_system_item = FALSE;
#line 708 "AppContextMenu.c"
}

static void
slingshot_app_context_menu_finalize (GObject * obj)
{
	SlingshotAppContextMenu * self;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SLINGSHOT_TYPE_APP_CONTEXT_MENU, SlingshotAppContextMenu);
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_g_free0 (self->priv->_desktop_id);
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_g_free0 (self->priv->_desktop_path);
#line 24 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_g_object_unref0 (self->priv->app_info);
#line 29 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	_g_object_unref0 (self->priv->switcheroo_control);
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	G_OBJECT_CLASS (slingshot_app_context_menu_parent_class)->finalize (obj);
#line 727 "AppContextMenu.c"
}

GType
slingshot_app_context_menu_get_type (void)
{
	return slingshot_app_context_menu_type_id;
}

GType
slingshot_app_context_menu_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (SlingshotAppContextMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) slingshot_app_context_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SlingshotAppContextMenu), 0, (GInstanceInitFunc) slingshot_app_context_menu_instance_init, NULL };
	slingshot_app_context_menu_type_id = g_type_module_register_type (module, gtk_menu_get_type (), "SlingshotAppContextMenu", &g_define_type_info, 0);
	SlingshotAppContextMenu_private_offset = sizeof (SlingshotAppContextMenuPrivate);
	return slingshot_app_context_menu_type_id;
}

static void
_vala_slingshot_app_context_menu_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	SlingshotAppContextMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SLINGSHOT_TYPE_APP_CONTEXT_MENU, SlingshotAppContextMenu);
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	switch (property_id) {
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		case SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_ID_PROPERTY:
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		g_value_set_string (value, slingshot_app_context_menu_get_desktop_id (self));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		break;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		case SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_PATH_PROPERTY:
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		g_value_set_string (value, slingshot_app_context_menu_get_desktop_path (self));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		break;
#line 767 "AppContextMenu.c"
		default:
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		break;
#line 773 "AppContextMenu.c"
	}
}

static void
_vala_slingshot_app_context_menu_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	SlingshotAppContextMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SLINGSHOT_TYPE_APP_CONTEXT_MENU, SlingshotAppContextMenu);
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
	switch (property_id) {
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		case SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_ID_PROPERTY:
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		slingshot_app_context_menu_set_desktop_id (self, g_value_get_string (value));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		break;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		case SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_PATH_PROPERTY:
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		slingshot_app_context_menu_set_desktop_path (self, g_value_get_string (value));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		break;
#line 799 "AppContextMenu.c"
		default:
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/AppContextMenu.vala"
		break;
#line 805 "AppContextMenu.c"
	}
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

