/* AppListRow.c generated by valac 0.56.18, the Vala compiler
 * generated from AppListRow.vala, do not modify */

/*
 * Copyright 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "slingshot.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gdesktopappinfo.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	APP_LIST_ROW_0_PROPERTY,
	APP_LIST_ROW_APP_ID_PROPERTY,
	APP_LIST_ROW_DESKTOP_PATH_PROPERTY,
	APP_LIST_ROW_APP_INFO_PROPERTY,
	APP_LIST_ROW_NUM_PROPERTIES
};
static GParamSpec* app_list_row_properties[APP_LIST_ROW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _AppListRowPrivate {
	gchar* _app_id;
	gchar* _desktop_path;
	GDesktopAppInfo* _app_info;
};

static gint AppListRow_private_offset;
static gpointer app_list_row_parent_class = NULL;
static GType app_list_row_type_id = 0;

static void ____lambda59_ (AppListRow* self,
                    GPid pid,
                    gint status);
static void _____lambda59__gchild_watch_func (GPid pid,
                                       gint wait_status,
                                       gpointer self);
static void app_list_row_set_app_info (AppListRow* self,
                                GDesktopAppInfo* value);
static GObject * app_list_row_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void app_list_row_finalize (GObject * obj);
static void _vala_app_list_row_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_app_list_row_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
app_list_row_get_instance_private (AppListRow* self)
{
	return G_STRUCT_MEMBER_P (self, AppListRow_private_offset);
}

AppListRow*
app_list_row_construct (GType object_type,
                        const gchar* app_id,
                        const gchar* desktop_path)
{
	AppListRow * self = NULL;
#line 25 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	g_return_val_if_fail (app_id != NULL, NULL);
#line 25 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	g_return_val_if_fail (desktop_path != NULL, NULL);
#line 26 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	self = (AppListRow*) g_object_new (object_type, "app-id", app_id, "desktop-path", desktop_path, NULL);
#line 25 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	return self;
#line 115 "AppListRow.c"
}

AppListRow*
app_list_row_new (const gchar* app_id,
                  const gchar* desktop_path)
{
#line 25 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	return app_list_row_construct (TYPE_APP_LIST_ROW, app_id, desktop_path);
#line 124 "AppListRow.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 143 "AppListRow.c"
}

static void
____lambda59_ (AppListRow* self,
               GPid pid,
               gint status)
{
#line 83 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	g_spawn_close_pid (pid);
#line 153 "AppListRow.c"
}

static void
_____lambda59__gchild_watch_func (GPid pid,
                                  gint wait_status,
                                  gpointer self)
{
#line 82 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	____lambda59_ ((AppListRow*) self, pid, wait_status);
#line 163 "AppListRow.c"
}

void
app_list_row_launch (AppListRow* self)
{
	GError* _inner_error0_ = NULL;
#line 61 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	g_return_if_fail (self != NULL);
#line 172 "AppListRow.c"
	{
		gchar* commandline = NULL;
		GDesktopAppInfo* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar** spawn_args = NULL;
		gchar** _tmp3_;
		gint spawn_args_length1;
		gint _spawn_args_size_;
#line 70 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		static const char checkstr[] = "pkexec";
#line 184 "AppListRow.c"
		const gchar* _tmp4_;
		gboolean _tmp8_ = FALSE;
		gchar** _tmp9_;
		gint _tmp9__length1;
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_tmp0_ = self->priv->_app_info;
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_tmp1_ = g_app_info_get_commandline ((GAppInfo*) _tmp0_);
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		commandline = _tmp2_;
#line 69 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_tmp3_ = g_new0 (gchar*, 0 + 1);
#line 69 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		spawn_args = _tmp3_;
#line 69 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		spawn_args_length1 = 0;
#line 69 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_spawn_args_size_ = spawn_args_length1;
#line 71 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_tmp4_ = commandline;
#line 71 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		if (string_contains (_tmp4_, checkstr)) {
#line 209 "AppListRow.c"
			const gchar* _tmp5_;
			gchar** _tmp6_;
			gchar** _tmp7_;
#line 72 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			_tmp5_ = commandline;
#line 72 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, " ", 0);
#line 72 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 72 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			spawn_args = _tmp7_;
#line 72 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			spawn_args_length1 = _vala_array_length (_tmp6_);
#line 72 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			_spawn_args_size_ = spawn_args_length1;
#line 225 "AppListRow.c"
		}
#line 74 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_tmp9_ = spawn_args;
#line 74 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_tmp9__length1 = spawn_args_length1;
#line 74 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		if (_tmp9__length1 >= 2) {
#line 233 "AppListRow.c"
			gchar** _tmp10_;
			gint _tmp10__length1;
			const gchar* _tmp11_;
#line 74 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			_tmp10_ = spawn_args;
#line 74 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			_tmp10__length1 = spawn_args_length1;
#line 74 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			_tmp11_ = _tmp10_[0];
#line 74 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			_tmp8_ = g_strcmp0 (_tmp11_, checkstr) == 0;
#line 245 "AppListRow.c"
		} else {
#line 74 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			_tmp8_ = FALSE;
#line 249 "AppListRow.c"
		}
#line 74 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		if (_tmp8_) {
#line 253 "AppListRow.c"
			gchar** spawn_env = NULL;
			gchar** _tmp12_;
			gchar** _tmp13_;
			gint spawn_env_length1;
			gint _spawn_env_size_;
			GPid child_pid = 0;
			gchar** _tmp14_;
			gint _tmp14__length1;
			gchar** _tmp15_;
			gint _tmp15__length1;
			GPid _tmp16_ = 0;
#line 75 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			_tmp13_ = _tmp12_ = g_get_environ ();
#line 75 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			spawn_env = _tmp13_;
#line 75 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			spawn_env_length1 = _vala_array_length (_tmp12_);
#line 75 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			_spawn_env_size_ = spawn_env_length1;
#line 77 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			_tmp14_ = spawn_args;
#line 77 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			_tmp14__length1 = spawn_args_length1;
#line 77 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			_tmp15_ = spawn_env;
#line 77 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			_tmp15__length1 = spawn_env_length1;
#line 77 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			g_spawn_async ("/", _tmp14_, _tmp15_, G_SPAWN_SEARCH_PATH | G_SPAWN_DO_NOT_REAP_CHILD, NULL, NULL, &_tmp16_, &_inner_error0_);
#line 77 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			child_pid = _tmp16_;
#line 77 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
				spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
#line 77 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
				spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 77 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
				_g_free0 (commandline);
#line 293 "AppListRow.c"
				goto __catch0_g_error;
			}
#line 82 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			g_child_watch_add_full (G_PRIORITY_DEFAULT_IDLE, child_pid, _____lambda59__gchild_watch_func, g_object_ref (self), g_object_unref);
#line 74 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
#line 300 "AppListRow.c"
		} else {
			GDesktopAppInfo* _tmp17_;
#line 87 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			_tmp17_ = self->priv->_app_info;
#line 87 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			g_app_info_launch ((GAppInfo*) _tmp17_, NULL, NULL, &_inner_error0_);
#line 87 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 87 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
				spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 87 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
				_g_free0 (commandline);
#line 313 "AppListRow.c"
				goto __catch0_g_error;
			}
		}
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_g_free0 (commandline);
#line 321 "AppListRow.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_error_ = _inner_error0_;
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_inner_error0_ = NULL;
#line 90 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_tmp18_ = _error_;
#line 90 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_tmp19_ = _tmp18_->message;
#line 90 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		g_critical ("AppListRow.vala:90: %s", _tmp19_);
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_g_error_free0 (_error_);
#line 341 "AppListRow.c"
	}
	__finally0:
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		g_clear_error (&_inner_error0_);
#line 62 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		return;
#line 352 "AppListRow.c"
	}
}

const gchar*
app_list_row_get_app_id (AppListRow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 21 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp0_ = self->priv->_app_id;
#line 21 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	result = _tmp0_;
#line 21 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	return result;
#line 369 "AppListRow.c"
}

static void
app_list_row_set_app_id (AppListRow* self,
                         const gchar* value)
{
	gchar* old_value;
#line 21 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	g_return_if_fail (self != NULL);
#line 21 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	old_value = app_list_row_get_app_id (self);
#line 21 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 383 "AppListRow.c"
		gchar* _tmp0_;
#line 21 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_tmp0_ = g_strdup (value);
#line 21 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_g_free0 (self->priv->_app_id);
#line 21 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		self->priv->_app_id = _tmp0_;
#line 21 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		g_object_notify_by_pspec ((GObject *) self, app_list_row_properties[APP_LIST_ROW_APP_ID_PROPERTY]);
#line 393 "AppListRow.c"
	}
}

const gchar*
app_list_row_get_desktop_path (AppListRow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp0_ = self->priv->_desktop_path;
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	result = _tmp0_;
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	return result;
#line 410 "AppListRow.c"
}

static void
app_list_row_set_desktop_path (AppListRow* self,
                               const gchar* value)
{
	gchar* old_value;
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	g_return_if_fail (self != NULL);
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	old_value = app_list_row_get_desktop_path (self);
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 424 "AppListRow.c"
		gchar* _tmp0_;
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_tmp0_ = g_strdup (value);
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_g_free0 (self->priv->_desktop_path);
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		self->priv->_desktop_path = _tmp0_;
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		g_object_notify_by_pspec ((GObject *) self, app_list_row_properties[APP_LIST_ROW_DESKTOP_PATH_PROPERTY]);
#line 434 "AppListRow.c"
	}
}

GDesktopAppInfo*
app_list_row_get_app_info (AppListRow* self)
{
	GDesktopAppInfo* result;
	GDesktopAppInfo* _tmp0_;
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp0_ = self->priv->_app_info;
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	result = _tmp0_;
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	return result;
#line 451 "AppListRow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	return self ? g_object_ref (self) : NULL;
#line 459 "AppListRow.c"
}

static void
app_list_row_set_app_info (AppListRow* self,
                           GDesktopAppInfo* value)
{
	GDesktopAppInfo* old_value;
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	g_return_if_fail (self != NULL);
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	old_value = app_list_row_get_app_info (self);
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	if (old_value != value) {
#line 473 "AppListRow.c"
		GDesktopAppInfo* _tmp0_;
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_g_object_unref0 (self->priv->_app_info);
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		self->priv->_app_info = _tmp0_;
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		g_object_notify_by_pspec ((GObject *) self, app_list_row_properties[APP_LIST_ROW_APP_INFO_PROPERTY]);
#line 483 "AppListRow.c"
	}
}

static GObject *
app_list_row_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AppListRow * self;
	const gchar* _tmp0_;
	GDesktopAppInfo* _tmp1_;
	GDesktopAppInfo* _tmp2_;
	GIcon* icon = NULL;
	GDesktopAppInfo* _tmp3_;
	GIcon* _tmp4_;
	GIcon* _tmp5_;
	GtkIconTheme* theme = NULL;
	GtkIconTheme* _tmp6_;
	gboolean _tmp7_ = FALSE;
	GIcon* _tmp8_;
	GtkImage* image = NULL;
	GtkImage* _tmp14_;
	GtkImage* _tmp15_;
	GIcon* _tmp16_;
	GtkImage* _tmp17_;
	GtkLabel* name_label = NULL;
	GDesktopAppInfo* _tmp18_;
	const gchar* _tmp19_;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* _tmp22_;
	GDesktopAppInfo* _tmp23_;
	const gchar* _tmp24_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp25_;
	GtkGrid* _tmp26_;
	GtkGrid* _tmp27_;
	GtkImage* _tmp28_;
	GtkGrid* _tmp29_;
	GtkLabel* _tmp30_;
	GtkGrid* _tmp31_;
	GtkGrid* _tmp32_;
	GtkGrid* _tmp33_;
#line 32 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	parent_class = G_OBJECT_CLASS (app_list_row_parent_class);
#line 32 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 32 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APP_LIST_ROW, AppListRow);
#line 33 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp0_ = self->priv->_app_id;
#line 33 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp1_ = g_desktop_app_info_new (_tmp0_);
#line 33 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp2_ = _tmp1_;
#line 33 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	app_list_row_set_app_info (self, _tmp2_);
#line 33 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_g_object_unref0 (_tmp2_);
#line 35 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp3_ = self->priv->_app_info;
#line 35 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp4_ = g_app_info_get_icon ((GAppInfo*) _tmp3_);
#line 35 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 35 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	icon = _tmp5_;
#line 36 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp6_ = gtk_icon_theme_get_default ();
#line 36 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	theme = _tmp6_;
#line 37 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp8_ = icon;
#line 37 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	if (_tmp8_ == NULL) {
#line 37 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_tmp7_ = TRUE;
#line 563 "AppListRow.c"
	} else {
		GtkIconTheme* _tmp9_;
		GIcon* _tmp10_;
		GtkIconInfo* _tmp11_;
		GtkIconInfo* _tmp12_;
#line 37 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_tmp9_ = theme;
#line 37 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_tmp10_ = icon;
#line 37 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_tmp11_ = gtk_icon_theme_lookup_by_gicon (_tmp9_, _tmp10_, 32, GTK_ICON_LOOKUP_USE_BUILTIN);
#line 37 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_tmp12_ = _tmp11_;
#line 37 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_tmp7_ = _tmp12_ == NULL;
#line 37 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_g_object_unref0 (_tmp12_);
#line 581 "AppListRow.c"
	}
#line 37 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	if (_tmp7_) {
#line 585 "AppListRow.c"
		GThemedIcon* _tmp13_;
#line 38 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_tmp13_ = (GThemedIcon*) g_themed_icon_new ("application-default-icon");
#line 38 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		_g_object_unref0 (icon);
#line 38 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		icon = (GIcon*) _tmp13_;
#line 593 "AppListRow.c"
	}
#line 41 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp14_ = (GtkImage*) gtk_image_new ();
#line 41 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	g_object_ref_sink (_tmp14_);
#line 41 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	image = _tmp14_;
#line 42 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp15_ = image;
#line 42 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp16_ = icon;
#line 42 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	g_object_set (_tmp15_, "gicon", _tmp16_, NULL);
#line 43 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp17_ = image;
#line 43 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	gtk_image_set_pixel_size (_tmp17_, 32);
#line 45 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp18_ = self->priv->_app_info;
#line 45 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp19_ = g_app_info_get_display_name ((GAppInfo*) _tmp18_);
#line 45 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp20_ = (GtkLabel*) gtk_label_new (_tmp19_);
#line 45 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	g_object_ref_sink (_tmp20_);
#line 45 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	name_label = _tmp20_;
#line 46 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp21_ = name_label;
#line 46 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	gtk_label_set_ellipsize (_tmp21_, PANGO_ELLIPSIZE_END);
#line 47 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp22_ = name_label;
#line 47 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	gtk_label_set_xalign (_tmp22_, (gfloat) 0);
#line 49 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp23_ = self->priv->_app_info;
#line 49 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp24_ = g_app_info_get_description ((GAppInfo*) _tmp23_);
#line 49 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp24_);
#line 51 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp25_ = (GtkGrid*) gtk_grid_new ();
#line 51 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	g_object_ref_sink (_tmp25_);
#line 51 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	grid = _tmp25_;
#line 52 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp26_ = grid;
#line 52 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	gtk_grid_set_column_spacing (_tmp26_, 12);
#line 53 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp27_ = grid;
#line 53 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp28_ = image;
#line 53 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
#line 54 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp29_ = grid;
#line 54 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp30_ = name_label;
#line 54 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	gtk_container_add ((GtkContainer*) _tmp29_, (GtkWidget*) _tmp30_);
#line 55 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp31_ = grid;
#line 55 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	g_object_set ((GtkWidget*) _tmp31_, "margin", 6, NULL);
#line 56 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp32_ = grid;
#line 56 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp32_, 18);
#line 58 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_tmp33_ = grid;
#line 58 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp33_);
#line 32 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_g_object_unref0 (grid);
#line 32 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_g_object_unref0 (name_label);
#line 32 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_g_object_unref0 (image);
#line 32 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_g_object_unref0 (icon);
#line 32 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	return obj;
#line 679 "AppListRow.c"
}

static void
app_list_row_class_init (AppListRowClass * klass,
                         gpointer klass_data)
{
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	app_list_row_parent_class = g_type_class_peek_parent (klass);
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	g_type_class_adjust_private_offset (klass, &AppListRow_private_offset);
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_app_list_row_get_property;
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_app_list_row_set_property;
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	G_OBJECT_CLASS (klass)->constructor = app_list_row_constructor;
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	G_OBJECT_CLASS (klass)->finalize = app_list_row_finalize;
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_LIST_ROW_APP_ID_PROPERTY, app_list_row_properties[APP_LIST_ROW_APP_ID_PROPERTY] = g_param_spec_string ("app-id", "app-id", "app-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_LIST_ROW_DESKTOP_PATH_PROPERTY, app_list_row_properties[APP_LIST_ROW_DESKTOP_PATH_PROPERTY] = g_param_spec_string ("desktop-path", "desktop-path", "desktop-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_LIST_ROW_APP_INFO_PROPERTY, app_list_row_properties[APP_LIST_ROW_APP_INFO_PROPERTY] = g_param_spec_object ("app-info", "app-info", "app-info", G_TYPE_DESKTOP_APP_INFO, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 704 "AppListRow.c"
}

static void
app_list_row_instance_init (AppListRow * self,
                            gpointer klass)
{
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	self->priv = app_list_row_get_instance_private (self);
#line 713 "AppListRow.c"
}

static void
app_list_row_finalize (GObject * obj)
{
	AppListRow * self;
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APP_LIST_ROW, AppListRow);
#line 21 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_g_free0 (self->priv->_app_id);
#line 22 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_g_free0 (self->priv->_desktop_path);
#line 23 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	_g_object_unref0 (self->priv->_app_info);
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	G_OBJECT_CLASS (app_list_row_parent_class)->finalize (obj);
#line 730 "AppListRow.c"
}

GType
app_list_row_get_type (void)
{
	return app_list_row_type_id;
}

GType
app_list_row_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (AppListRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_list_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppListRow), 0, (GInstanceInitFunc) app_list_row_instance_init, NULL };
	app_list_row_type_id = g_type_module_register_type (module, gtk_list_box_row_get_type (), "AppListRow", &g_define_type_info, 0);
	AppListRow_private_offset = sizeof (AppListRowPrivate);
	return app_list_row_type_id;
}

static void
_vala_app_list_row_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	AppListRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_APP_LIST_ROW, AppListRow);
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	switch (property_id) {
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		case APP_LIST_ROW_APP_ID_PROPERTY:
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		g_value_set_string (value, app_list_row_get_app_id (self));
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		break;
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		case APP_LIST_ROW_DESKTOP_PATH_PROPERTY:
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		g_value_set_string (value, app_list_row_get_desktop_path (self));
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		break;
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		case APP_LIST_ROW_APP_INFO_PROPERTY:
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		g_value_set_object (value, app_list_row_get_app_info (self));
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		break;
#line 776 "AppListRow.c"
		default:
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		break;
#line 782 "AppListRow.c"
	}
}

static void
_vala_app_list_row_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	AppListRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_APP_LIST_ROW, AppListRow);
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
	switch (property_id) {
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		case APP_LIST_ROW_APP_ID_PROPERTY:
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		app_list_row_set_app_id (self, g_value_get_string (value));
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		break;
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		case APP_LIST_ROW_DESKTOP_PATH_PROPERTY:
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		app_list_row_set_desktop_path (self, g_value_get_string (value));
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		break;
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		case APP_LIST_ROW_APP_INFO_PROPERTY:
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		app_list_row_set_app_info (self, g_value_get_object (value));
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		break;
#line 814 "AppListRow.c"
		default:
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../budgie-applications-menu/applications-menu/src/Widgets/AppListRow.vala"
		break;
#line 820 "AppListRow.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

