/* SearchItem.c generated by valac 0.56.18, the Vala compiler
 * generated from SearchItem.vala, do not modify */

/*
 * Copyright 2019 elementary, Inc. (https://elementary.io)
 *           2011-2012 Giulio Collura
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include "slingshot.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <gee.h>
#include <gdk/gdk.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define SLINGSHOT_WIDGETS_SEARCH_ITEM_ICON_SIZE 32
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SLINGSHOT_WIDGETS_SEARCH_ITEM_0_PROPERTY,
	SLINGSHOT_WIDGETS_SEARCH_ITEM_APP_PROPERTY,
	SLINGSHOT_WIDGETS_SEARCH_ITEM_SEARCH_TERM_PROPERTY,
	SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_PROPERTY,
	SLINGSHOT_WIDGETS_SEARCH_ITEM_ICON_PROPERTY,
	SLINGSHOT_WIDGETS_SEARCH_ITEM_APP_URI_PROPERTY,
	SLINGSHOT_WIDGETS_SEARCH_ITEM_NUM_PROPERTIES
};
static GParamSpec* slingshot_widgets_search_item_properties[SLINGSHOT_WIDGETS_SEARCH_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
enum  {
	SLINGSHOT_WIDGETS_SEARCH_ITEM_LAUNCH_APP_SIGNAL,
	SLINGSHOT_WIDGETS_SEARCH_ITEM_NUM_SIGNALS
};
static guint slingshot_widgets_search_item_signals[SLINGSHOT_WIDGETS_SEARCH_ITEM_NUM_SIGNALS] = {0};

struct _SlingshotWidgetsSearchItemPrivate {
	SlingshotBackendApp* _app;
	gchar* _search_term;
	SlingshotWidgetsSearchItemResultType _result_type;
	GtkImage* _icon;
	gchar* _app_uri;
	SlingshotAppContextMenu* menu;
	GtkLabel* name_label;
	GCancellable* cancellable;
};

static gint SlingshotWidgetsSearchItem_private_offset;
static gpointer slingshot_widgets_search_item_parent_class = NULL;
static GType slingshot_widgets_search_item_type_id = 0;

static gchar* slingshot_widgets_search_item_markup_string_with_search (const gchar* text,
                                                                const gchar* pattern);
static void slingshot_widgets_search_item_real_destroy (GtkWidget* base);
static void slingshot_widgets_search_item_set_icon (SlingshotWidgetsSearchItem* self,
                                             GtkImage* value);
static void slingshot_widgets_search_item_set_app_uri (SlingshotWidgetsSearchItem* self,
                                                const gchar* value);
static void g_cclosure_user_marshal_BOOLEAN__VOID (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static GObject * slingshot_widgets_search_item_constructor (GType type,
                                                     guint n_construct_properties,
                                                     GObjectConstructParam * construct_properties);
static gboolean _slingshot_backend_app_launch_slingshot_widgets_search_item_launch_app (SlingshotWidgetsSearchItem* _sender,
                                                                                 gpointer self);
static void slingshot_widgets_search_item_finalize (GObject * obj);
static void _vala_slingshot_widgets_search_item_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_slingshot_widgets_search_item_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec);

static inline gpointer
slingshot_widgets_search_item_get_instance_private (SlingshotWidgetsSearchItem* self)
{
	return G_STRUCT_MEMBER_P (self, SlingshotWidgetsSearchItem_private_offset);
}

const gchar*
slingshot_widgets_search_item_result_type_to_string (SlingshotWidgetsSearchItemResultType self)
{
	const gchar* result;
#line 35 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	switch (self) {
#line 35 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_TEXT:
#line 125 "SearchItem.c"
		{
#line 37 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			result = _ ("Text");
#line 37 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			return result;
#line 131 "SearchItem.c"
		}
#line 35 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_APPLICATION:
#line 135 "SearchItem.c"
		{
#line 39 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			result = _ ("Applications");
#line 39 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			return result;
#line 141 "SearchItem.c"
		}
#line 35 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_GENERIC_URI:
#line 145 "SearchItem.c"
		{
#line 41 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			result = _ ("Files");
#line 41 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			return result;
#line 151 "SearchItem.c"
		}
#line 35 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_LINK:
#line 35 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_ACTION:
#line 157 "SearchItem.c"
		{
#line 44 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			result = _ ("Actions");
#line 44 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			return result;
#line 163 "SearchItem.c"
		}
#line 35 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_SEARCH:
#line 167 "SearchItem.c"
		{
#line 46 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			result = _ ("Search");
#line 46 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			return result;
#line 173 "SearchItem.c"
		}
#line 35 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_CONTACT:
#line 177 "SearchItem.c"
		{
#line 48 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			result = _ ("Contacts");
#line 48 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			return result;
#line 183 "SearchItem.c"
		}
#line 35 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_INTERNET:
#line 187 "SearchItem.c"
		{
#line 50 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			result = _ ("Internet");
#line 50 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			return result;
#line 193 "SearchItem.c"
		}
#line 35 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_SETTINGS:
#line 197 "SearchItem.c"
		{
#line 52 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			result = _ ("Settings");
#line 52 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			return result;
#line 203 "SearchItem.c"
		}
#line 35 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_APP_ACTIONS:
#line 207 "SearchItem.c"
		{
#line 54 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			result = _ ("Application Actions");
#line 54 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			return result;
#line 213 "SearchItem.c"
		}
#line 35 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_BOOKMARK:
#line 217 "SearchItem.c"
		{
#line 56 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			result = _ ("Bookmarks");
#line 56 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			return result;
#line 223 "SearchItem.c"
		}
		default:
		{
#line 58 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			result = _ ("Other");
#line 58 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			return result;
#line 231 "SearchItem.c"
		}
	}
}

static GType
slingshot_widgets_search_item_result_type_get_type_once (void)
{
	static const GEnumValue values[] = {{SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_UNKNOWN, "SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_UNKNOWN", "unknown"}, {SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_TEXT, "SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_TEXT", "text"}, {SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_APPLICATION, "SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_APPLICATION", "application"}, {SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_BOOKMARK, "SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_BOOKMARK", "bookmark"}, {SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_APP_ACTIONS, "SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_APP_ACTIONS", "app-actions"}, {SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_ACTION, "SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_ACTION", "action"}, {SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_GENERIC_URI, "SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_GENERIC_URI", "generic-uri"}, {SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_SEARCH, "SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_SEARCH", "search"}, {SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_CONTACT, "SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_CONTACT", "contact"}, {SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_INTERNET, "SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_INTERNET", "internet"}, {SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_SETTINGS, "SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_SETTINGS", "settings"}, {SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_LINK, "SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_LINK", "link"}, {0, NULL, NULL}};
	GType slingshot_widgets_search_item_result_type_type_id;
	slingshot_widgets_search_item_result_type_type_id = g_enum_register_static ("SlingshotWidgetsSearchItemResultType", values);
	return slingshot_widgets_search_item_result_type_type_id;
}

GType
slingshot_widgets_search_item_result_type_get_type (void)
{
	static volatile gsize slingshot_widgets_search_item_result_type_type_id__once = 0;
	if (g_once_init_enter (&slingshot_widgets_search_item_result_type_type_id__once)) {
		GType slingshot_widgets_search_item_result_type_type_id;
		slingshot_widgets_search_item_result_type_type_id = slingshot_widgets_search_item_result_type_get_type_once ();
		g_once_init_leave (&slingshot_widgets_search_item_result_type_type_id__once, slingshot_widgets_search_item_result_type_type_id);
	}
	return slingshot_widgets_search_item_result_type_type_id__once;
}

SlingshotWidgetsSearchItem*
slingshot_widgets_search_item_construct (GType object_type,
                                         SlingshotBackendApp* app,
                                         const gchar* search_term,
                                         SlingshotWidgetsSearchItemResultType result_type)
{
	SlingshotWidgetsSearchItem * self = NULL;
#line 79 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 79 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_return_val_if_fail (search_term != NULL, NULL);
#line 80 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	self = (SlingshotWidgetsSearchItem*) g_object_new (object_type, "app", app, "search-term", search_term, "result-type", result_type, NULL);
#line 79 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	return self;
#line 272 "SearchItem.c"
}

SlingshotWidgetsSearchItem*
slingshot_widgets_search_item_new (SlingshotBackendApp* app,
                                   const gchar* search_term,
                                   SlingshotWidgetsSearchItemResultType result_type)
{
#line 79 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	return slingshot_widgets_search_item_construct (SLINGSHOT_WIDGETS_TYPE_SEARCH_ITEM, app, search_term, result_type);
#line 282 "SearchItem.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 305 "SearchItem.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 314 "SearchItem.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 333 "SearchItem.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 337 "SearchItem.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 343 "SearchItem.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 353 "SearchItem.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 361 "SearchItem.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 365 "SearchItem.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 371 "SearchItem.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 381 "SearchItem.c"
}

static gchar*
slingshot_widgets_search_item_markup_string_with_search (const gchar* text,
                                                         const gchar* pattern)
{
#line 136 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	static const char MARKUP[] = "%s";
#line 390 "SearchItem.c"
	GeeList* matchers = NULL;
	GeeList* _tmp8_;
	gchar* highlighted = NULL;
	const gchar* _tmp49_;
	gchar* result;
#line 135 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 135 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_return_val_if_fail (pattern != NULL, NULL);
#line 138 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	if (g_strcmp0 (pattern, "") == 0) {
#line 402 "SearchItem.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 139 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp0_ = g_markup_escape_text (text, (gssize) -1);
#line 139 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp1_ = _tmp0_;
#line 139 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp2_ = g_strdup_printf (MARKUP, _tmp1_);
#line 139 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp3_ = _tmp2_;
#line 139 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_g_free0 (_tmp1_);
#line 139 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		result = _tmp3_;
#line 139 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		return result;
#line 421 "SearchItem.c"
	}
#line 143 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	if (g_strcmp0 (text, "") == 0) {
#line 425 "SearchItem.c"
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 144 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp4_ = g_markup_escape_text (pattern, (gssize) -1);
#line 144 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp5_ = _tmp4_;
#line 144 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp6_ = g_strdup_printf (MARKUP, _tmp5_);
#line 144 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp7_ = _tmp6_;
#line 144 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_g_free0 (_tmp5_);
#line 144 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		result = _tmp7_;
#line 144 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		return result;
#line 444 "SearchItem.c"
	}
#line 147 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp8_ = synapse_query_get_matchers_for_query (pattern, 0, G_REGEX_OPTIMIZE | G_REGEX_CASELESS);
#line 147 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	matchers = _tmp8_;
#line 153 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	highlighted = NULL;
#line 452 "SearchItem.c"
	{
		GeeList* _matcher_list = NULL;
		GeeList* _tmp9_;
		gint _matcher_size = 0;
		GeeList* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _matcher_index = 0;
#line 154 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp9_ = matchers;
#line 154 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_matcher_list = _tmp9_;
#line 154 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp10_ = _matcher_list;
#line 154 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp11_ = gee_collection_get_size ((GeeCollection*) _tmp10_);
#line 154 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp12_ = _tmp11_;
#line 154 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_matcher_size = _tmp12_;
#line 154 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_matcher_index = -1;
#line 154 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		while (TRUE) {
#line 477 "SearchItem.c"
			gint _tmp13_;
			gint _tmp14_;
			GeeMapEntry* matcher = NULL;
			GeeList* _tmp15_;
			gpointer _tmp16_;
			GMatchInfo* mi = NULL;
			GeeMapEntry* _tmp17_;
			gconstpointer _tmp18_;
			gconstpointer _tmp19_;
			GMatchInfo* _tmp20_ = NULL;
			gboolean _tmp21_;
#line 154 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_matcher_index = _matcher_index + 1;
#line 154 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp13_ = _matcher_index;
#line 154 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp14_ = _matcher_size;
#line 154 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			if (!(_tmp13_ < _tmp14_)) {
#line 154 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
				break;
#line 499 "SearchItem.c"
			}
#line 154 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp15_ = _matcher_list;
#line 154 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp16_ = gee_list_get (_tmp15_, _matcher_index);
#line 154 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			matcher = (GeeMapEntry*) _tmp16_;
#line 156 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp17_ = matcher;
#line 156 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp18_ = gee_map_entry_get_key (_tmp17_);
#line 156 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp19_ = _tmp18_;
#line 156 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp21_ = g_regex_match ((GRegex*) _tmp19_, text, 0, &_tmp20_);
#line 156 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_g_match_info_unref0 (mi);
#line 156 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			mi = _tmp20_;
#line 156 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			if (_tmp21_) {
#line 521 "SearchItem.c"
				gint start_pos = 0;
				gint end_pos = 0;
				gint last_pos = 0;
				gint cnt = 0;
				GMatchInfo* _tmp22_;
				GString* res = NULL;
				GString* _tmp23_;
				GString* _tmp46_;
				const gchar* _tmp47_;
				gchar* _tmp48_;
#line 159 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
				last_pos = 0;
#line 160 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
				_tmp22_ = mi;
#line 160 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
				cnt = g_match_info_get_match_count (_tmp22_);
#line 161 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
				_tmp23_ = g_string_new ("");
#line 161 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
				res = _tmp23_;
#line 542 "SearchItem.c"
				{
					gint i = 0;
#line 162 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
					i = 1;
#line 547 "SearchItem.c"
					{
						gboolean _tmp24_ = FALSE;
#line 162 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
						_tmp24_ = TRUE;
#line 162 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
						while (TRUE) {
#line 554 "SearchItem.c"
							GMatchInfo* _tmp26_;
							gint _tmp27_ = 0;
							gint _tmp28_ = 0;
							gboolean _tmp29_ = FALSE;
							GString* _tmp30_;
							gchar* _tmp31_;
							gchar* _tmp32_;
							gchar* _tmp33_;
							gchar* _tmp34_;
							GString* _tmp35_;
							GMatchInfo* _tmp36_;
							gchar* _tmp37_;
							gchar* _tmp38_;
							gchar* _tmp39_;
							gchar* _tmp40_;
#line 162 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							if (!_tmp24_) {
#line 572 "SearchItem.c"
								gint _tmp25_;
#line 162 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
								_tmp25_ = i;
#line 162 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
								i = _tmp25_ + 1;
#line 578 "SearchItem.c"
							}
#line 162 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							_tmp24_ = FALSE;
#line 162 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							if (!(i < cnt)) {
#line 162 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
								break;
#line 586 "SearchItem.c"
							}
#line 163 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							_tmp26_ = mi;
#line 163 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							g_match_info_fetch_pos (_tmp26_, i, &_tmp27_, &_tmp28_);
#line 163 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							start_pos = _tmp27_;
#line 163 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							end_pos = _tmp28_;
#line 164 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							if (start_pos >= 0) {
#line 164 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
								_tmp29_ = end_pos >= 0;
#line 600 "SearchItem.c"
							} else {
#line 164 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
								_tmp29_ = FALSE;
#line 604 "SearchItem.c"
							}
#line 164 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							g_warn_if_fail (_tmp29_);
#line 165 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							_tmp30_ = res;
#line 165 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							_tmp31_ = string_substring (text, (glong) last_pos, (glong) (start_pos - last_pos));
#line 165 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							_tmp32_ = _tmp31_;
#line 165 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							_tmp33_ = g_markup_escape_text (_tmp32_, (gssize) -1);
#line 165 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							_tmp34_ = _tmp33_;
#line 165 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							g_string_append (_tmp30_, _tmp34_);
#line 165 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							_g_free0 (_tmp34_);
#line 165 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							_g_free0 (_tmp32_);
#line 166 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							last_pos = end_pos;
#line 167 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							_tmp35_ = res;
#line 167 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							_tmp36_ = mi;
#line 167 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							_tmp37_ = g_match_info_fetch (_tmp36_, i);
#line 167 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							_tmp38_ = _tmp37_;
#line 167 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							_tmp39_ = g_markup_printf_escaped ("<b>%s</b>", _tmp38_);
#line 167 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							_tmp40_ = _tmp39_;
#line 167 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							g_string_append (_tmp35_, _tmp40_);
#line 167 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							_g_free0 (_tmp40_);
#line 167 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							_g_free0 (_tmp38_);
#line 168 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
							if (i == (cnt - 1)) {
#line 646 "SearchItem.c"
								GString* _tmp41_;
								gchar* _tmp42_;
								gchar* _tmp43_;
								gchar* _tmp44_;
								gchar* _tmp45_;
#line 169 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
								_tmp41_ = res;
#line 169 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
								_tmp42_ = string_substring (text, (glong) last_pos, (glong) -1);
#line 169 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
								_tmp43_ = _tmp42_;
#line 169 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
								_tmp44_ = g_markup_escape_text (_tmp43_, (gssize) -1);
#line 169 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
								_tmp45_ = _tmp44_;
#line 169 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
								g_string_append (_tmp41_, _tmp45_);
#line 169 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
								_g_free0 (_tmp45_);
#line 169 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
								_g_free0 (_tmp43_);
#line 668 "SearchItem.c"
							}
						}
					}
				}
#line 172 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
				_tmp46_ = res;
#line 172 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
				_tmp47_ = _tmp46_->str;
#line 172 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
				_tmp48_ = g_strdup (_tmp47_);
#line 172 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
				_g_free0 (highlighted);
#line 172 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
				highlighted = _tmp48_;
#line 173 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
				_g_string_free0 (res);
#line 173 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
				_g_match_info_unref0 (mi);
#line 173 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
				_g_object_unref0 (matcher);
#line 173 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
				break;
#line 691 "SearchItem.c"
			}
#line 154 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_g_match_info_unref0 (mi);
#line 154 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_g_object_unref0 (matcher);
#line 697 "SearchItem.c"
		}
	}
#line 177 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp49_ = highlighted;
#line 177 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	if (_tmp49_ != NULL) {
#line 704 "SearchItem.c"
		const gchar* _tmp50_;
		gchar* _tmp51_;
#line 178 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp50_ = highlighted;
#line 178 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp51_ = g_strdup_printf (MARKUP, _tmp50_);
#line 178 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		result = _tmp51_;
#line 178 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_g_free0 (highlighted);
#line 178 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_g_object_unref0 (matchers);
#line 178 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		return result;
#line 719 "SearchItem.c"
	} else {
		gchar* _tmp52_;
		gchar* _tmp53_;
		gchar* _tmp54_;
		gchar* _tmp55_;
#line 180 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp52_ = g_markup_escape_text (text, (gssize) -1);
#line 180 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp53_ = _tmp52_;
#line 180 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp54_ = g_strdup_printf (MARKUP, _tmp53_);
#line 180 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp55_ = _tmp54_;
#line 180 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_g_free0 (_tmp53_);
#line 180 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		result = _tmp55_;
#line 180 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_g_free0 (highlighted);
#line 180 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_g_object_unref0 (matchers);
#line 180 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		return result;
#line 743 "SearchItem.c"
	}
}

static void
slingshot_widgets_search_item_real_destroy (GtkWidget* base)
{
	SlingshotWidgetsSearchItem * self;
	GCancellable* _tmp0_;
#line 184 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	self = (SlingshotWidgetsSearchItem*) base;
#line 185 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	GTK_WIDGET_CLASS (slingshot_widgets_search_item_parent_class)->destroy ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_list_box_row_get_type (), GtkListBoxRow));
#line 186 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp0_ = self->priv->cancellable;
#line 186 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	if (_tmp0_ != NULL) {
#line 760 "SearchItem.c"
		GCancellable* _tmp1_;
#line 187 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp1_ = self->priv->cancellable;
#line 187 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		g_cancellable_cancel (_tmp1_);
#line 766 "SearchItem.c"
	}
}

gboolean
slingshot_widgets_search_item_create_context_menu (SlingshotWidgetsSearchItem* self,
                                                   GdkEvent* e)
{
	SlingshotWidgetsSearchItemResultType _tmp0_;
	SlingshotBackendApp* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	SlingshotBackendApp* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	SlingshotAppContextMenu* _tmp7_;
	SlingshotAppContextMenu* _tmp8_;
	GList* _tmp9_;
	GList* _tmp10_;
	gboolean _tmp11_;
	gboolean result;
#line 190 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 190 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 192 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp0_ = self->priv->_result_type;
#line 192 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	if (_tmp0_ != SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_APPLICATION) {
#line 193 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		result = GDK_EVENT_PROPAGATE;
#line 193 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		return result;
#line 799 "SearchItem.c"
	}
#line 196 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp1_ = self->priv->_app;
#line 196 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp2_ = slingshot_backend_app_get_desktop_id (_tmp1_);
#line 196 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp3_ = _tmp2_;
#line 196 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp4_ = self->priv->_app;
#line 196 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp5_ = slingshot_backend_app_get_desktop_path (_tmp4_);
#line 196 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp6_ = _tmp5_;
#line 196 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp7_ = slingshot_app_context_menu_new (_tmp3_, _tmp6_);
#line 196 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_object_ref_sink (_tmp7_);
#line 196 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_g_object_unref0 (self->priv->menu);
#line 196 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	self->priv->menu = _tmp7_;
#line 198 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp8_ = self->priv->menu;
#line 198 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp9_ = gtk_container_get_children ((GtkContainer*) _tmp8_);
#line 198 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp10_ = _tmp9_;
#line 198 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp11_ = _tmp10_ != NULL;
#line 198 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	(_tmp10_ == NULL) ? NULL : (_tmp10_ = (g_list_free (_tmp10_), NULL));
#line 198 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	if (_tmp11_) {
#line 199 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		if (e->type == GDK_KEY_PRESS) {
#line 835 "SearchItem.c"
			SlingshotAppContextMenu* _tmp12_;
#line 200 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp12_ = self->priv->menu;
#line 200 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			gtk_menu_popup_at_widget ((GtkMenu*) _tmp12_, (GtkWidget*) self, GDK_GRAVITY_EAST, GDK_GRAVITY_CENTER, e);
#line 201 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			result = GDK_EVENT_STOP;
#line 201 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			return result;
#line 845 "SearchItem.c"
		} else {
#line 202 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			if (e->type == GDK_BUTTON_PRESS) {
#line 849 "SearchItem.c"
				SlingshotAppContextMenu* _tmp13_;
#line 203 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
				_tmp13_ = self->priv->menu;
#line 203 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
				gtk_menu_popup_at_pointer ((GtkMenu*) _tmp13_, e);
#line 204 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
				result = GDK_EVENT_STOP;
#line 204 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
				return result;
#line 859 "SearchItem.c"
			}
		}
	}
#line 208 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	result = GDK_EVENT_PROPAGATE;
#line 208 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	return result;
#line 867 "SearchItem.c"
}

SlingshotBackendApp*
slingshot_widgets_search_item_get_app (SlingshotWidgetsSearchItem* self)
{
	SlingshotBackendApp* result;
	SlingshotBackendApp* _tmp0_;
#line 67 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp0_ = self->priv->_app;
#line 67 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	result = _tmp0_;
#line 67 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	return result;
#line 883 "SearchItem.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 67 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 891 "SearchItem.c"
}

static void
slingshot_widgets_search_item_set_app (SlingshotWidgetsSearchItem* self,
                                       SlingshotBackendApp* value)
{
	SlingshotBackendApp* old_value;
#line 67 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_return_if_fail (self != NULL);
#line 67 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	old_value = slingshot_widgets_search_item_get_app (self);
#line 67 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	if (old_value != value) {
#line 905 "SearchItem.c"
		SlingshotBackendApp* _tmp0_;
#line 67 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 67 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_g_object_unref0 (self->priv->_app);
#line 67 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		self->priv->_app = _tmp0_;
#line 67 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_widgets_search_item_properties[SLINGSHOT_WIDGETS_SEARCH_ITEM_APP_PROPERTY]);
#line 915 "SearchItem.c"
	}
}

const gchar*
slingshot_widgets_search_item_get_search_term (SlingshotWidgetsSearchItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp0_ = self->priv->_search_term;
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	result = _tmp0_;
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	return result;
#line 932 "SearchItem.c"
}

static void
slingshot_widgets_search_item_set_search_term (SlingshotWidgetsSearchItem* self,
                                               const gchar* value)
{
	gchar* old_value;
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_return_if_fail (self != NULL);
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	old_value = slingshot_widgets_search_item_get_search_term (self);
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 946 "SearchItem.c"
		gchar* _tmp0_;
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp0_ = g_strdup (value);
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_g_free0 (self->priv->_search_term);
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		self->priv->_search_term = _tmp0_;
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_widgets_search_item_properties[SLINGSHOT_WIDGETS_SEARCH_ITEM_SEARCH_TERM_PROPERTY]);
#line 956 "SearchItem.c"
	}
}

SlingshotWidgetsSearchItemResultType
slingshot_widgets_search_item_get_result_type (SlingshotWidgetsSearchItem* self)
{
	SlingshotWidgetsSearchItemResultType result;
#line 69 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 69 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	result = self->priv->_result_type;
#line 69 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	return result;
#line 970 "SearchItem.c"
}

static void
slingshot_widgets_search_item_set_result_type (SlingshotWidgetsSearchItem* self,
                                               SlingshotWidgetsSearchItemResultType value)
{
	SlingshotWidgetsSearchItemResultType old_value;
#line 69 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_return_if_fail (self != NULL);
#line 69 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	old_value = slingshot_widgets_search_item_get_result_type (self);
#line 69 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	if (old_value != value) {
#line 69 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		self->priv->_result_type = value;
#line 69 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_widgets_search_item_properties[SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_PROPERTY]);
#line 988 "SearchItem.c"
	}
}

GtkImage*
slingshot_widgets_search_item_get_icon (SlingshotWidgetsSearchItem* self)
{
	GtkImage* result;
	GtkImage* _tmp0_;
#line 71 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp0_ = self->priv->_icon;
#line 71 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	result = _tmp0_;
#line 71 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	return result;
#line 1005 "SearchItem.c"
}

static void
slingshot_widgets_search_item_set_icon (SlingshotWidgetsSearchItem* self,
                                        GtkImage* value)
{
	GtkImage* old_value;
#line 71 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_return_if_fail (self != NULL);
#line 71 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	old_value = slingshot_widgets_search_item_get_icon (self);
#line 71 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	if (old_value != value) {
#line 1019 "SearchItem.c"
		GtkImage* _tmp0_;
#line 71 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 71 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_g_object_unref0 (self->priv->_icon);
#line 71 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		self->priv->_icon = _tmp0_;
#line 71 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_widgets_search_item_properties[SLINGSHOT_WIDGETS_SEARCH_ITEM_ICON_PROPERTY]);
#line 1029 "SearchItem.c"
	}
}

const gchar*
slingshot_widgets_search_item_get_app_uri (SlingshotWidgetsSearchItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 72 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp0_ = self->priv->_app_uri;
#line 72 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	result = _tmp0_;
#line 72 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	return result;
#line 1046 "SearchItem.c"
}

static void
slingshot_widgets_search_item_set_app_uri (SlingshotWidgetsSearchItem* self,
                                           const gchar* value)
{
	gchar* old_value;
#line 72 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_return_if_fail (self != NULL);
#line 72 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	old_value = slingshot_widgets_search_item_get_app_uri (self);
#line 72 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1060 "SearchItem.c"
		gchar* _tmp0_;
#line 72 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp0_ = g_strdup (value);
#line 72 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_g_free0 (self->priv->_app_uri);
#line 72 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		self->priv->_app_uri = _tmp0_;
#line 72 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		g_object_notify_by_pspec ((GObject *) self, slingshot_widgets_search_item_properties[SLINGSHOT_WIDGETS_SEARCH_ITEM_APP_URI_PROPERTY]);
#line 1070 "SearchItem.c"
	}
}

static void
g_cclosure_user_marshal_BOOLEAN__VOID (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__VOID) (gpointer data1, gpointer data2);
	register GMarshalFunc_BOOLEAN__VOID callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_return_if_fail (return_value != NULL);
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_return_if_fail (n_param_values == 1);
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		data1 = closure->data;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		data2 = param_values->data[0].v_pointer;
#line 1099 "SearchItem.c"
	} else {
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		data1 = param_values->data[0].v_pointer;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		data2 = closure->data;
#line 1105 "SearchItem.c"
	}
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	callback = (GMarshalFunc_BOOLEAN__VOID) (marshal_data ? marshal_data : cc->callback);
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	v_return = callback (data1, data2);
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_value_set_boolean (return_value, v_return);
#line 1113 "SearchItem.c"
}

static gboolean
_slingshot_backend_app_launch_slingshot_widgets_search_item_launch_app (SlingshotWidgetsSearchItem* _sender,
                                                                        gpointer self)
{
	gboolean result;
	result = slingshot_backend_app_launch ((SlingshotBackendApp*) self);
#line 125 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	return result;
#line 1124 "SearchItem.c"
}

static GObject *
slingshot_widgets_search_item_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SlingshotWidgetsSearchItem * self;
	gchar* markup = NULL;
	SlingshotWidgetsSearchItemResultType _tmp0_;
	const gchar* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
	GtkLabel* _tmp24_;
	GtkImage* _tmp25_;
	GtkImage* _tmp26_;
	GtkImage* _tmp27_;
	SlingshotBackendApp* _tmp28_;
	GIcon* _tmp29_;
	GIcon* _tmp30_;
	GtkImage* _tmp31_;
	SlingshotBackendApp* _tmp32_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	gboolean _tmp35_ = FALSE;
	SlingshotBackendApp* _tmp36_;
	SynapseMatch* _tmp37_;
	SynapseMatch* _tmp38_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp51_;
	GtkGrid* _tmp52_;
	GtkGrid* _tmp53_;
	GtkImage* _tmp54_;
	GtkGrid* _tmp55_;
	GtkLabel* _tmp56_;
	GtkGrid* _tmp57_;
	GtkGrid* _tmp58_;
	GtkGrid* _tmp59_;
	SlingshotWidgetsSearchItemResultType _tmp60_;
	SynapseApplicationMatch* app_match = NULL;
	SlingshotBackendApp* _tmp62_;
	SynapseMatch* _tmp63_;
	SynapseMatch* _tmp64_;
	SynapseApplicationMatch* _tmp65_;
	gboolean _tmp66_ = FALSE;
	SynapseApplicationMatch* _tmp67_;
#line 87 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	parent_class = G_OBJECT_CLASS (slingshot_widgets_search_item_parent_class);
#line 87 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 87 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SLINGSHOT_WIDGETS_TYPE_SEARCH_ITEM, SlingshotWidgetsSearchItem);
#line 89 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp0_ = self->priv->_result_type;
#line 89 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	if (_tmp0_ == SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_TEXT) {
#line 1184 "SearchItem.c"
		SlingshotBackendApp* _tmp1_;
		SynapseMatch* _tmp2_;
		SynapseMatch* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 90 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp1_ = self->priv->_app;
#line 90 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp2_ = slingshot_backend_app_get_match (_tmp1_);
#line 90 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp3_ = _tmp2_;
#line 90 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp4_ = synapse_match_get_title (_tmp3_);
#line 90 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp5_ = _tmp4_;
#line 90 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 90 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_g_free0 (markup);
#line 90 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		markup = _tmp6_;
#line 1207 "SearchItem.c"
	} else {
		SlingshotWidgetsSearchItemResultType _tmp7_;
#line 91 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp7_ = self->priv->_result_type;
#line 91 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		if (_tmp7_ == SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_APP_ACTIONS) {
#line 1214 "SearchItem.c"
			SlingshotBackendApp* _tmp8_;
			SynapseMatch* _tmp9_;
			SynapseMatch* _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
#line 92 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp8_ = self->priv->_app;
#line 92 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp9_ = slingshot_backend_app_get_match (_tmp8_);
#line 92 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp10_ = _tmp9_;
#line 92 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp11_ = synapse_match_get_title (_tmp10_);
#line 92 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp12_ = _tmp11_;
#line 92 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp13_ = self->priv->_search_term;
#line 92 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp14_ = slingshot_widgets_search_item_markup_string_with_search (_tmp12_, _tmp13_);
#line 92 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_g_free0 (markup);
#line 92 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			markup = _tmp14_;
#line 1240 "SearchItem.c"
		} else {
			SlingshotBackendApp* _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
#line 94 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp15_ = self->priv->_app;
#line 94 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp16_ = slingshot_backend_app_get_name (_tmp15_);
#line 94 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp17_ = _tmp16_;
#line 94 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp18_ = self->priv->_search_term;
#line 94 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp19_ = slingshot_widgets_search_item_markup_string_with_search (_tmp17_, _tmp18_);
#line 94 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_g_free0 (markup);
#line 94 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			markup = _tmp19_;
#line 1261 "SearchItem.c"
		}
	}
#line 97 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp20_ = markup;
#line 97 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp21_ = (GtkLabel*) gtk_label_new (_tmp20_);
#line 97 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_object_ref_sink (_tmp21_);
#line 97 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_g_object_unref0 (self->priv->name_label);
#line 97 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	self->priv->name_label = _tmp21_;
#line 98 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp22_ = self->priv->name_label;
#line 98 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	gtk_label_set_ellipsize (_tmp22_, PANGO_ELLIPSIZE_END);
#line 99 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp23_ = self->priv->name_label;
#line 99 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	gtk_label_set_use_markup (_tmp23_, TRUE);
#line 100 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp24_ = self->priv->name_label;
#line 100 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	gtk_label_set_xalign (_tmp24_, (gfloat) 0);
#line 102 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp25_ = (GtkImage*) gtk_image_new ();
#line 102 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_object_ref_sink (_tmp25_);
#line 102 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp26_ = _tmp25_;
#line 102 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	slingshot_widgets_search_item_set_icon (self, _tmp26_);
#line 102 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_g_object_unref0 (_tmp26_);
#line 103 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp27_ = self->priv->_icon;
#line 103 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp28_ = self->priv->_app;
#line 103 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp29_ = slingshot_backend_app_get_icon (_tmp28_);
#line 103 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp30_ = _tmp29_;
#line 103 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_object_set (_tmp27_, "gicon", _tmp30_, NULL);
#line 104 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp31_ = self->priv->_icon;
#line 104 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	gtk_image_set_pixel_size (_tmp31_, SLINGSHOT_WIDGETS_SEARCH_ITEM_ICON_SIZE);
#line 106 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp32_ = self->priv->_app;
#line 106 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp33_ = slingshot_backend_app_get_description (_tmp32_);
#line 106 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp34_ = _tmp33_;
#line 106 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) self, _tmp34_);
#line 108 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp36_ = self->priv->_app;
#line 108 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp37_ = slingshot_backend_app_get_match (_tmp36_);
#line 108 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp38_ = _tmp37_;
#line 108 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	if (_tmp38_ != NULL) {
#line 1326 "SearchItem.c"
		SlingshotBackendApp* _tmp39_;
		SynapseMatch* _tmp40_;
		SynapseMatch* _tmp41_;
		const gchar* _tmp42_;
		const gchar* _tmp43_;
#line 108 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp39_ = self->priv->_app;
#line 108 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp40_ = slingshot_backend_app_get_match (_tmp39_);
#line 108 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp41_ = _tmp40_;
#line 108 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp42_ = synapse_match_get_icon_name (_tmp41_);
#line 108 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp43_ = _tmp42_;
#line 108 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp35_ = g_str_has_prefix (_tmp43_, G_DIR_SEPARATOR_S);
#line 1344 "SearchItem.c"
	} else {
#line 108 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp35_ = FALSE;
#line 1348 "SearchItem.c"
	}
#line 108 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	if (_tmp35_) {
#line 1352 "SearchItem.c"
		GdkPixbuf* pixbuf = NULL;
		SlingshotBackendApp* _tmp44_;
		SynapseMatch* _tmp45_;
		SynapseMatch* _tmp46_;
		GdkPixbuf* _tmp47_;
		GdkPixbuf* _tmp48_;
#line 109 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp44_ = self->priv->_app;
#line 109 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp45_ = slingshot_backend_app_get_match (_tmp44_);
#line 109 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp46_ = _tmp45_;
#line 109 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp47_ = slingshot_backend_synapse_search_get_pathicon_for_match (_tmp46_, SLINGSHOT_WIDGETS_SEARCH_ITEM_ICON_SIZE);
#line 109 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		pixbuf = _tmp47_;
#line 110 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp48_ = pixbuf;
#line 110 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		if (_tmp48_ != NULL) {
#line 1373 "SearchItem.c"
			GtkImage* _tmp49_;
			GdkPixbuf* _tmp50_;
#line 111 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp49_ = self->priv->_icon;
#line 111 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			_tmp50_ = pixbuf;
#line 111 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
			gtk_image_set_from_pixbuf (_tmp49_, _tmp50_);
#line 1382 "SearchItem.c"
		}
#line 108 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_g_object_unref0 (pixbuf);
#line 1386 "SearchItem.c"
	}
#line 115 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp51_ = (GtkGrid*) gtk_grid_new ();
#line 115 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_object_ref_sink (_tmp51_);
#line 115 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	grid = _tmp51_;
#line 116 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp52_ = grid;
#line 116 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	gtk_grid_set_column_spacing (_tmp52_, 12);
#line 117 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp53_ = grid;
#line 117 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp54_ = self->priv->_icon;
#line 117 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	gtk_container_add ((GtkContainer*) _tmp53_, (GtkWidget*) _tmp54_);
#line 118 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp55_ = grid;
#line 118 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp56_ = self->priv->name_label;
#line 118 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	gtk_container_add ((GtkContainer*) _tmp55_, (GtkWidget*) _tmp56_);
#line 119 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp57_ = grid;
#line 119 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_object_set ((GtkWidget*) _tmp57_, "margin", 6, NULL);
#line 120 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp58_ = grid;
#line 120 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp58_, 18);
#line 122 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp59_ = grid;
#line 122 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp59_);
#line 124 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp60_ = self->priv->_result_type;
#line 124 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	if (_tmp60_ != SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_APP_ACTIONS) {
#line 1426 "SearchItem.c"
		SlingshotBackendApp* _tmp61_;
#line 125 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp61_ = self->priv->_app;
#line 125 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		g_signal_connect_object (self, "launch-app", (GCallback) _slingshot_backend_app_launch_slingshot_widgets_search_item_launch_app, _tmp61_, 0);
#line 1432 "SearchItem.c"
	}
#line 128 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	slingshot_widgets_search_item_set_app_uri (self, NULL);
#line 129 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp62_ = self->priv->_app;
#line 129 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp63_ = slingshot_backend_app_get_match (_tmp62_);
#line 129 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp64_ = _tmp63_;
#line 129 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp65_ = _g_object_ref0 (SYNAPSE_IS_APPLICATION_MATCH (_tmp64_) ? ((SynapseApplicationMatch*) _tmp64_) : NULL);
#line 129 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	app_match = _tmp65_;
#line 130 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_tmp67_ = app_match;
#line 130 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	if (_tmp67_ != NULL) {
#line 1450 "SearchItem.c"
		SynapseApplicationMatch* _tmp68_;
		const gchar* _tmp69_;
		const gchar* _tmp70_;
#line 130 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp68_ = app_match;
#line 130 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp69_ = synapse_application_match_get_filename (_tmp68_);
#line 130 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp70_ = _tmp69_;
#line 130 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp66_ = _tmp70_ != NULL;
#line 1462 "SearchItem.c"
	} else {
#line 130 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp66_ = FALSE;
#line 1466 "SearchItem.c"
	}
#line 130 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	if (_tmp66_) {
#line 1470 "SearchItem.c"
		SynapseApplicationMatch* _tmp71_;
		const gchar* _tmp72_;
		const gchar* _tmp73_;
		GFile* _tmp74_;
		GFile* _tmp75_;
		gchar* _tmp76_;
		gchar* _tmp77_;
#line 131 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp71_ = app_match;
#line 131 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp72_ = synapse_application_match_get_filename (_tmp71_);
#line 131 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp73_ = _tmp72_;
#line 131 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp74_ = g_file_new_for_path (_tmp73_);
#line 131 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp75_ = _tmp74_;
#line 131 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp76_ = g_file_get_uri (_tmp75_);
#line 131 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_tmp77_ = _tmp76_;
#line 131 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		slingshot_widgets_search_item_set_app_uri (self, _tmp77_);
#line 131 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_g_free0 (_tmp77_);
#line 131 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		_g_object_unref0 (_tmp75_);
#line 1498 "SearchItem.c"
	}
#line 87 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_g_object_unref0 (app_match);
#line 87 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_g_object_unref0 (grid);
#line 87 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_g_free0 (markup);
#line 87 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	return obj;
#line 1508 "SearchItem.c"
}

static void
slingshot_widgets_search_item_class_init (SlingshotWidgetsSearchItemClass * klass,
                                          gpointer klass_data)
{
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	slingshot_widgets_search_item_parent_class = g_type_class_peek_parent (klass);
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_type_class_adjust_private_offset (klass, &SlingshotWidgetsSearchItem_private_offset);
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	((GtkWidgetClass *) klass)->destroy = (void (*) (GtkWidget*)) slingshot_widgets_search_item_real_destroy;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_slingshot_widgets_search_item_get_property;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_slingshot_widgets_search_item_set_property;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	G_OBJECT_CLASS (klass)->constructor = slingshot_widgets_search_item_constructor;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	G_OBJECT_CLASS (klass)->finalize = slingshot_widgets_search_item_finalize;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_WIDGETS_SEARCH_ITEM_APP_PROPERTY, slingshot_widgets_search_item_properties[SLINGSHOT_WIDGETS_SEARCH_ITEM_APP_PROPERTY] = g_param_spec_object ("app", "app", "app", SLINGSHOT_BACKEND_TYPE_APP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_WIDGETS_SEARCH_ITEM_SEARCH_TERM_PROPERTY, slingshot_widgets_search_item_properties[SLINGSHOT_WIDGETS_SEARCH_ITEM_SEARCH_TERM_PROPERTY] = g_param_spec_string ("search-term", "search-term", "search-term", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_PROPERTY, slingshot_widgets_search_item_properties[SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_PROPERTY] = g_param_spec_enum ("result-type", "result-type", "result-type", SLINGSHOT_WIDGETS_SEARCH_ITEM_TYPE_RESULT_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_WIDGETS_SEARCH_ITEM_ICON_PROPERTY, slingshot_widgets_search_item_properties[SLINGSHOT_WIDGETS_SEARCH_ITEM_ICON_PROPERTY] = g_param_spec_object ("icon", "icon", "icon", gtk_image_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_WIDGETS_SEARCH_ITEM_APP_URI_PROPERTY, slingshot_widgets_search_item_properties[SLINGSHOT_WIDGETS_SEARCH_ITEM_APP_URI_PROPERTY] = g_param_spec_string ("app-uri", "app-uri", "app-uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	slingshot_widgets_search_item_signals[SLINGSHOT_WIDGETS_SEARCH_ITEM_LAUNCH_APP_SIGNAL] = g_signal_new ("launch-app", SLINGSHOT_WIDGETS_TYPE_SEARCH_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__VOID, G_TYPE_BOOLEAN, 0);
#line 1541 "SearchItem.c"
}

static void
slingshot_widgets_search_item_instance_init (SlingshotWidgetsSearchItem * self,
                                             gpointer klass)
{
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	self->priv = slingshot_widgets_search_item_get_instance_private (self);
#line 77 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	self->priv->cancellable = NULL;
#line 1552 "SearchItem.c"
}

static void
slingshot_widgets_search_item_finalize (GObject * obj)
{
	SlingshotWidgetsSearchItem * self;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SLINGSHOT_WIDGETS_TYPE_SEARCH_ITEM, SlingshotWidgetsSearchItem);
#line 67 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_g_object_unref0 (self->priv->_app);
#line 68 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_g_free0 (self->priv->_search_term);
#line 71 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_g_object_unref0 (self->priv->_icon);
#line 72 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_g_free0 (self->priv->_app_uri);
#line 74 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_g_object_unref0 (self->priv->menu);
#line 76 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_g_object_unref0 (self->priv->name_label);
#line 77 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	G_OBJECT_CLASS (slingshot_widgets_search_item_parent_class)->finalize (obj);
#line 1577 "SearchItem.c"
}

GType
slingshot_widgets_search_item_get_type (void)
{
	return slingshot_widgets_search_item_type_id;
}

GType
slingshot_widgets_search_item_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (SlingshotWidgetsSearchItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) slingshot_widgets_search_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SlingshotWidgetsSearchItem), 0, (GInstanceInitFunc) slingshot_widgets_search_item_instance_init, NULL };
	slingshot_widgets_search_item_type_id = g_type_module_register_type (module, gtk_list_box_row_get_type (), "SlingshotWidgetsSearchItem", &g_define_type_info, 0);
	SlingshotWidgetsSearchItem_private_offset = sizeof (SlingshotWidgetsSearchItemPrivate);
	return slingshot_widgets_search_item_type_id;
}

static void
_vala_slingshot_widgets_search_item_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	SlingshotWidgetsSearchItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SLINGSHOT_WIDGETS_TYPE_SEARCH_ITEM, SlingshotWidgetsSearchItem);
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	switch (property_id) {
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_APP_PROPERTY:
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		g_value_set_object (value, slingshot_widgets_search_item_get_app (self));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		break;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_SEARCH_TERM_PROPERTY:
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		g_value_set_string (value, slingshot_widgets_search_item_get_search_term (self));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		break;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_PROPERTY:
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		g_value_set_enum (value, slingshot_widgets_search_item_get_result_type (self));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		break;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_ICON_PROPERTY:
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		g_value_set_object (value, slingshot_widgets_search_item_get_icon (self));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		break;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_APP_URI_PROPERTY:
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		g_value_set_string (value, slingshot_widgets_search_item_get_app_uri (self));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		break;
#line 1635 "SearchItem.c"
		default:
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		break;
#line 1641 "SearchItem.c"
	}
}

static void
_vala_slingshot_widgets_search_item_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec)
{
	SlingshotWidgetsSearchItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SLINGSHOT_WIDGETS_TYPE_SEARCH_ITEM, SlingshotWidgetsSearchItem);
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
	switch (property_id) {
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_APP_PROPERTY:
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		slingshot_widgets_search_item_set_app (self, g_value_get_object (value));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		break;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_SEARCH_TERM_PROPERTY:
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		slingshot_widgets_search_item_set_search_term (self, g_value_get_string (value));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		break;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_RESULT_TYPE_PROPERTY:
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		slingshot_widgets_search_item_set_result_type (self, g_value_get_enum (value));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		break;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_ICON_PROPERTY:
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		slingshot_widgets_search_item_set_icon (self, g_value_get_object (value));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		break;
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		case SLINGSHOT_WIDGETS_SEARCH_ITEM_APP_URI_PROPERTY:
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		slingshot_widgets_search_item_set_app_uri (self, g_value_get_string (value));
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		break;
#line 1685 "SearchItem.c"
		default:
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../budgie-applications-menu/applications-menu/src/Widgets/SearchItem.vala"
		break;
#line 1691 "SearchItem.c"
	}
}

