/* desktop-file-service.c generated by valac 0.56.18, the Vala compiler
 * generated from desktop-file-service.vala, do not modify */

/*
* Copyright (c) 2010 Michal Hruby <michal.mhr@gmail.com>
*               2017-2021 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Michal Hruby <michal.mhr@gmail.com>
*/

#include <glib.h>
#include <glib-object.h>
#include "slingshot.h"
#include <stdlib.h>
#include <string.h>
#include <gio/gdesktopappinfo.h>
#include <gio/gio.h>
#include <gee.h>

#define SYNAPSE_DESKTOP_FILE_SERVICE_DEFAULT_TIMEOUT_SECONDS 3
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define SYNAPSE_TYPE_DESKTOP_FILE_ERROR (synapse_desktop_file_error_get_type ())
enum  {
	SYNAPSE_DESKTOP_FILE_INFO_0_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_DESKTOP_ID_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_NAME_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_GENERIC_NAME_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_COMMENT_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_ICON_NAME_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_GETTEXT_DOMAIN_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_NEEDS_TERMINAL_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_FILENAME_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_EXEC_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_IS_HIDDEN_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_IS_VALID_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_IS_CONTROL_PANEL_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_SHOW_IN_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_NUM_PROPERTIES
};
static GParamSpec* synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	SYNAPSE_DESKTOP_FILE_SERVICE_0_PROPERTY,
	SYNAPSE_DESKTOP_FILE_SERVICE_NUM_PROPERTIES
};
static GParamSpec* synapse_desktop_file_service_properties[SYNAPSE_DESKTOP_FILE_SERVICE_NUM_PROPERTIES];
#define _synapse_utils_async_once_unref0(var) ((var == NULL) ? NULL : (var = (synapse_utils_async_once_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _SynapseDesktopFileServiceInitializeData SynapseDesktopFileServiceInitializeData;
enum  {
	SYNAPSE_DESKTOP_FILE_SERVICE_RELOAD_STARTED_SIGNAL,
	SYNAPSE_DESKTOP_FILE_SERVICE_RELOAD_DONE_SIGNAL,
	SYNAPSE_DESKTOP_FILE_SERVICE_NUM_SIGNALS
};
static guint synapse_desktop_file_service_signals[SYNAPSE_DESKTOP_FILE_SERVICE_NUM_SIGNALS] = {0};

typedef enum  {
	SYNAPSE_DESKTOP_FILE_ERROR_UNINTERESTING_ENTRY
} SynapseDesktopFileError;
#define SYNAPSE_DESKTOP_FILE_ERROR synapse_desktop_file_error_quark ()

struct _SynapseDesktopFileInfoPrivate {
	gchar* _desktop_id;
	gchar* _name;
	gchar* _generic_name;
	gchar* _comment;
	gchar* _icon_name;
	gchar* _gettext_domain;
	gboolean _needs_terminal;
	gchar* _filename;
	gchar* _exec;
	gboolean _is_hidden;
	gboolean _is_valid;
	gboolean _is_control_panel;
	gchar* name_folded;
	SynapseDesktopFileInfoEnvironmentType _show_in;
};

struct _SynapseDesktopFileServicePrivate {
	SynapseUtilsAsyncOnce* init_once;
	GAppInfoMonitor* app_info_monitor;
	GeeList* non_hidden_desktop_files;
	GeeMap* exec_map;
	GeeMap* desktop_id_map;
	guint queued_update_id;
	GRegex* exec_regex;
};

struct _SynapseDesktopFileServiceInitializeData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SynapseDesktopFileService* self;
	SynapseUtilsAsyncOnce* _tmp0_;
	gboolean is_locked;
	SynapseUtilsAsyncOnce* _tmp1_;
	GAppInfoMonitor* _tmp2_;
	GAppInfoMonitor* _tmp3_;
	SynapseUtilsAsyncOnce* _tmp4_;
};

static gint SynapseDesktopFileInfo_private_offset;
static gpointer synapse_desktop_file_info_parent_class = NULL;
static GType synapse_desktop_file_info_type_id = 0;
static gint SynapseDesktopFileService_private_offset;
static gpointer synapse_desktop_file_service_parent_class = NULL;
static SynapseDesktopFileService* synapse_desktop_file_service_instance;
static SynapseDesktopFileService* synapse_desktop_file_service_instance = NULL;
static GType synapse_desktop_file_service_type_id = 0;

VALA_EXTERN GQuark synapse_desktop_file_error_quark (void);
VALA_EXTERN GType synapse_desktop_file_error_get_type (void) G_GNUC_CONST ;
static void synapse_desktop_file_info_init_from_desktop_app_info (SynapseDesktopFileInfo* self,
                                                           GDesktopAppInfo* app_info);
static SynapseDesktopFileInfoEnvironmentType synapse_desktop_file_info_parse_environments (SynapseDesktopFileInfo* self,
                                                                                    gchar** environments,
                                                                                    gint environments_length1);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void synapse_desktop_file_info_set_is_hidden (SynapseDesktopFileInfo* self,
                                              gboolean value);
static void synapse_desktop_file_info_set_is_control_panel (SynapseDesktopFileInfo* self,
                                                     gboolean value);
static void synapse_desktop_file_info_set_is_valid (SynapseDesktopFileInfo* self,
                                             gboolean value);
static void synapse_desktop_file_info_finalize (GObject * obj);
static void _vala_synapse_desktop_file_info_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_synapse_desktop_file_info_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
static SynapseDesktopFileService* synapse_desktop_file_service_new (void);
static SynapseDesktopFileService* synapse_desktop_file_service_construct (GType object_type);
static void synapse_desktop_file_service_initialize_data_free (gpointer _data);
static gboolean synapse_desktop_file_service_initialize_co (SynapseDesktopFileServiceInitializeData* _data_);
static void synapse_desktop_file_service_initialize_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
static void synapse_desktop_file_service_load_all_desktop_files (SynapseDesktopFileService* self);
static void synapse_desktop_file_service_queue_cache_update (SynapseDesktopFileService* self);
static void _synapse_desktop_file_service_queue_cache_update_g_app_info_monitor_changed (GAppInfoMonitor* _sender,
                                                                                  gpointer self);
static gboolean __lambda18_ (SynapseDesktopFileService* self);
static gboolean ___lambda18__gsource_func (gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static GObject * synapse_desktop_file_service_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties);
static void synapse_desktop_file_service_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const gchar* SYNAPSE_DESKTOP_FILE_INFO_SUPPORTED_GETTEXT_DOMAINS_KEYS[2] = {"X-Ubuntu-Gettext-Domain", "X-GNOME-Gettext-Domain"};

GQuark
synapse_desktop_file_error_quark (void)
{
#line 298 "../budgie-applications-menu/applications-menu/src/synapse-core/data-sink.vala"
	return g_quark_from_static_string ("synapse-desktop-file-error-quark");
#line 196 "desktop-file-service.c"
}

static GType
synapse_desktop_file_error_get_type_once (void)
{
	static const GEnumValue values[] = {{SYNAPSE_DESKTOP_FILE_ERROR_UNINTERESTING_ENTRY, "SYNAPSE_DESKTOP_FILE_ERROR_UNINTERESTING_ENTRY", "uninteresting-entry"}, {0, NULL, NULL}};
	GType synapse_desktop_file_error_type_id;
	synapse_desktop_file_error_type_id = g_enum_register_static ("SynapseDesktopFileError", values);
	return synapse_desktop_file_error_type_id;
}

GType
synapse_desktop_file_error_get_type (void)
{
	static volatile gsize synapse_desktop_file_error_type_id__once = 0;
	if (g_once_init_enter (&synapse_desktop_file_error_type_id__once)) {
		GType synapse_desktop_file_error_type_id;
		synapse_desktop_file_error_type_id = synapse_desktop_file_error_get_type_once ();
		g_once_init_leave (&synapse_desktop_file_error_type_id__once, synapse_desktop_file_error_type_id);
	}
	return synapse_desktop_file_error_type_id__once;
}

static inline gpointer
synapse_desktop_file_info_get_instance_private (SynapseDesktopFileInfo* self)
{
	return G_STRUCT_MEMBER_P (self, SynapseDesktopFileInfo_private_offset);
}

static GType
synapse_desktop_file_info_environment_type_get_type_once (void)
{
	static const GFlagsValue values[] = {{SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_GNOME, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_GNOME", "gnome"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_KDE, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_KDE", "kde"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_LXDE, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_LXDE", "lxde"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_LXQT, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_LXQT", "lxqt"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_MATE, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_MATE", "mate"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_RAZOR, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_RAZOR", "razor"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_ROX, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_ROX", "rox"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_TDE, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_TDE", "tde"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_UNITY, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_UNITY", "unity"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_XFCE, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_XFCE", "xfce"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_PANTHEON, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_PANTHEON", "pantheon"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_OLD, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_OLD", "old"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_ALL, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_ALL", "all"}, {0, NULL, NULL}};
	GType synapse_desktop_file_info_environment_type_type_id;
	synapse_desktop_file_info_environment_type_type_id = g_flags_register_static ("SynapseDesktopFileInfoEnvironmentType", values);
	return synapse_desktop_file_info_environment_type_type_id;
}

GType
synapse_desktop_file_info_environment_type_get_type (void)
{
	static volatile gsize synapse_desktop_file_info_environment_type_type_id__once = 0;
	if (g_once_init_enter (&synapse_desktop_file_info_environment_type_type_id__once)) {
		GType synapse_desktop_file_info_environment_type_type_id;
		synapse_desktop_file_info_environment_type_type_id = synapse_desktop_file_info_environment_type_get_type_once ();
		g_once_init_leave (&synapse_desktop_file_info_environment_type_type_id__once, synapse_desktop_file_info_environment_type_type_id);
	}
	return synapse_desktop_file_info_environment_type_type_id__once;
}

const gchar*
synapse_desktop_file_info_get_name_folded (SynapseDesktopFileInfo* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp3_;
	const gchar* result;
#line 66 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->name_folded;
#line 67 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (_tmp0_ == NULL) {
#line 259 "desktop-file-service.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 68 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp1_ = self->priv->_name;
#line 68 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp2_ = g_utf8_casefold (_tmp1_, (gssize) -1);
#line 68 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_free0 (self->priv->name_folded);
#line 68 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		self->priv->name_folded = _tmp2_;
#line 270 "desktop-file-service.c"
	}
#line 71 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp3_ = self->priv->name_folded;
#line 71 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	result = _tmp3_;
#line 71 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 278 "desktop-file-service.c"
}

SynapseDesktopFileInfo*
synapse_desktop_file_info_construct_for_desktop_app_info (GType object_type,
                                                          GDesktopAppInfo* app_info)
{
	SynapseDesktopFileInfo * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 78 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (app_info != NULL, NULL);
#line 79 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp0_ = g_app_info_get_id ((GAppInfo*) app_info);
#line 79 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp1_ = g_desktop_app_info_get_filename (app_info);
#line 79 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp2_ = _tmp1_;
#line 79 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self = (SynapseDesktopFileInfo*) g_object_new (object_type, "desktop-id", _tmp0_, "filename", _tmp2_, NULL);
#line 81 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_info_init_from_desktop_app_info (self, app_info);
#line 78 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return self;
#line 303 "desktop-file-service.c"
}

SynapseDesktopFileInfo*
synapse_desktop_file_info_new_for_desktop_app_info (GDesktopAppInfo* app_info)
{
#line 78 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return synapse_desktop_file_info_construct_for_desktop_app_info (SYNAPSE_TYPE_DESKTOP_FILE_INFO, app_info);
#line 311 "desktop-file-service.c"
}

static SynapseDesktopFileInfoEnvironmentType
synapse_desktop_file_info_parse_environments (SynapseDesktopFileInfo* self,
                                              gchar** environments,
                                              gint environments_length1)
{
	SynapseDesktopFileInfoEnvironmentType _result_ = 0U;
	SynapseDesktopFileInfoEnvironmentType result;
#line 84 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 85 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_result_ = 0;
#line 325 "desktop-file-service.c"
	{
		gchar** env_collection = NULL;
		gint env_collection_length1 = 0;
		gint _env_collection_size_ = 0;
		gint env_it = 0;
#line 86 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		env_collection = environments;
#line 86 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		env_collection_length1 = environments_length1;
#line 86 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		for (env_it = 0; env_it < env_collection_length1; env_it = env_it + 1) {
#line 337 "desktop-file-service.c"
			const gchar* env = NULL;
#line 86 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			env = env_collection[env_it];
#line 341 "desktop-file-service.c"
			{
				gchar* env_up = NULL;
				const gchar* _tmp0_;
				gchar* _tmp1_;
				const gchar* _tmp2_;
				const gchar* _tmp3_;
				GQuark _tmp5_ = 0U;
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label0 = 0;
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label1 = 0;
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label2 = 0;
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label3 = 0;
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label4 = 0;
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label5 = 0;
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label6 = 0;
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label7 = 0;
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label8 = 0;
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label9 = 0;
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label10 = 0;
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label11 = 0;
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label12 = 0;
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label13 = 0;
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label14 = 0;
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label15 = 0;
#line 87 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				_tmp0_ = env;
#line 87 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				_tmp1_ = g_utf8_strup (_tmp0_, (gssize) -1);
#line 87 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				env_up = _tmp1_;
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				_tmp2_ = env_up;
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				_tmp3_ = _tmp2_;
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				if ((((_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("BUDGIE")))) || (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("GNOME"))))) || (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("X-CINNAMON"))))) || (_tmp5_ == ((0 != _tmp4_label3) ? _tmp4_label3 : (_tmp4_label3 = g_quark_from_static_string ("UBUNTU"))))) {
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 397 "desktop-file-service.c"
						default:
						{
#line 93 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_GNOME;
#line 94 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							break;
#line 404 "desktop-file-service.c"
						}
					}
				} else if (_tmp5_ == ((0 != _tmp4_label4) ? _tmp4_label4 : (_tmp4_label4 = g_quark_from_static_string ("PANTHEON")))) {
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 410 "desktop-file-service.c"
						default:
						{
#line 96 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_PANTHEON;
#line 97 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							break;
#line 417 "desktop-file-service.c"
						}
					}
				} else if (_tmp5_ == ((0 != _tmp4_label5) ? _tmp4_label5 : (_tmp4_label5 = g_quark_from_static_string ("KDE")))) {
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 423 "desktop-file-service.c"
						default:
						{
#line 99 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_KDE;
#line 100 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							break;
#line 430 "desktop-file-service.c"
						}
					}
				} else if (_tmp5_ == ((0 != _tmp4_label6) ? _tmp4_label6 : (_tmp4_label6 = g_quark_from_static_string ("LXDE")))) {
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 436 "desktop-file-service.c"
						default:
						{
#line 102 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_LXDE;
#line 103 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							break;
#line 443 "desktop-file-service.c"
						}
					}
				} else if (_tmp5_ == ((0 != _tmp4_label7) ? _tmp4_label7 : (_tmp4_label7 = g_quark_from_static_string ("LXQT")))) {
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 449 "desktop-file-service.c"
						default:
						{
#line 105 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_LXQT;
#line 106 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							break;
#line 456 "desktop-file-service.c"
						}
					}
				} else if (_tmp5_ == ((0 != _tmp4_label8) ? _tmp4_label8 : (_tmp4_label8 = g_quark_from_static_string ("MATE")))) {
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 462 "desktop-file-service.c"
						default:
						{
#line 108 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_MATE;
#line 109 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							break;
#line 469 "desktop-file-service.c"
						}
					}
				} else if (_tmp5_ == ((0 != _tmp4_label9) ? _tmp4_label9 : (_tmp4_label9 = g_quark_from_static_string ("RAZOR")))) {
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 475 "desktop-file-service.c"
						default:
						{
#line 111 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_RAZOR;
#line 112 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							break;
#line 482 "desktop-file-service.c"
						}
					}
				} else if (_tmp5_ == ((0 != _tmp4_label10) ? _tmp4_label10 : (_tmp4_label10 = g_quark_from_static_string ("ROX")))) {
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 488 "desktop-file-service.c"
						default:
						{
#line 113 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_ROX;
#line 113 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							break;
#line 495 "desktop-file-service.c"
						}
					}
				} else if (_tmp5_ == ((0 != _tmp4_label11) ? _tmp4_label11 : (_tmp4_label11 = g_quark_from_static_string ("TDE")))) {
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 501 "desktop-file-service.c"
						default:
						{
#line 114 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_TDE;
#line 114 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							break;
#line 508 "desktop-file-service.c"
						}
					}
				} else if ((_tmp5_ == ((0 != _tmp4_label12) ? _tmp4_label12 : (_tmp4_label12 = g_quark_from_static_string ("UNITY")))) || (_tmp5_ == ((0 != _tmp4_label13) ? _tmp4_label13 : (_tmp4_label13 = g_quark_from_static_string ("UNITY7"))))) {
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 514 "desktop-file-service.c"
						default:
						{
#line 117 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_UNITY;
#line 118 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							break;
#line 521 "desktop-file-service.c"
						}
					}
				} else if (_tmp5_ == ((0 != _tmp4_label14) ? _tmp4_label14 : (_tmp4_label14 = g_quark_from_static_string ("XFCE")))) {
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 527 "desktop-file-service.c"
						default:
						{
#line 119 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_XFCE;
#line 119 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							break;
#line 534 "desktop-file-service.c"
						}
					}
				} else if (_tmp5_ == ((0 != _tmp4_label15) ? _tmp4_label15 : (_tmp4_label15 = g_quark_from_static_string ("OLD")))) {
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 540 "desktop-file-service.c"
						default:
						{
#line 120 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_OLD;
#line 120 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							break;
#line 547 "desktop-file-service.c"
						}
					}
				} else {
#line 88 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 553 "desktop-file-service.c"
						default:
						{
#line 122 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							break;
#line 558 "desktop-file-service.c"
						}
					}
				}
#line 86 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				_g_free0 (env_up);
#line 564 "desktop-file-service.c"
			}
		}
	}
#line 125 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	result = _result_;
#line 125 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 572 "desktop-file-service.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 136 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	for (i = 0; i < stack_length; i++) {
#line 136 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 136 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			return TRUE;
#line 587 "desktop-file-service.c"
		}
	}
#line 136 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return FALSE;
#line 592 "desktop-file-service.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 611 "desktop-file-service.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 168 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return self ? g_object_ref (self) : NULL;
#line 619 "desktop-file-service.c"
}

static void
synapse_desktop_file_info_init_from_desktop_app_info (SynapseDesktopFileInfo* self,
                                                      GDesktopAppInfo* app_info)
{
	GError* _inner_error0_ = NULL;
#line 128 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 128 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (app_info != NULL);
#line 631 "desktop-file-service.c"
	{
		gchar* _tmp0_;
		gchar* _tmp1_;
		gboolean _tmp2_;
		const gchar* _tmp12_;
		const gchar* _tmp13_ = NULL;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar* control_center = NULL;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gboolean _tmp25_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		const gchar* _tmp29_ = NULL;
		const gchar* _tmp30_;
		GIcon* _tmp31_ = NULL;
		GIcon* _tmp32_;
		GIcon* _tmp33_;
		GIcon* icon = NULL;
		GIcon* _tmp35_;
		GIcon* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
#line 130 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp0_ = g_desktop_app_info_get_string (app_info, G_KEY_FILE_DESKTOP_KEY_TYPE);
#line 130 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp1_ = _tmp0_;
#line 130 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp2_ = g_strcmp0 (_tmp1_, G_KEY_FILE_DESKTOP_TYPE_APPLICATION) != 0;
#line 130 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_free0 (_tmp1_);
#line 130 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		if (_tmp2_) {
#line 668 "desktop-file-service.c"
			GError* _tmp3_;
#line 131 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp3_ = g_error_new_literal (SYNAPSE_DESKTOP_FILE_ERROR, SYNAPSE_DESKTOP_FILE_ERROR_UNINTERESTING_ENTRY, "Not Application-type desktop entry");
#line 131 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_inner_error0_ = _tmp3_;
#line 674 "desktop-file-service.c"
			goto __catch0_g_error;
		}
#line 134 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		if (g_desktop_app_info_has_key (app_info, G_KEY_FILE_DESKTOP_KEY_CATEGORIES)) {
#line 679 "desktop-file-service.c"
			gchar** categories = NULL;
			gsize _tmp4_ = 0;
			gchar** _tmp5_;
			gint categories_length1;
			gint _categories_size_;
			gchar** _tmp6_;
			gint _tmp6__length1;
#line 135 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp5_ = g_desktop_app_info_get_string_list (app_info, G_KEY_FILE_DESKTOP_KEY_CATEGORIES, &_tmp4_);
#line 135 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			categories = _tmp5_;
#line 135 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			categories_length1 = _tmp4_;
#line 135 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_categories_size_ = categories_length1;
#line 136 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp6_ = categories;
#line 136 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp6__length1 = categories_length1;
#line 136 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			if (_vala_string_array_contains (_tmp6_, _tmp6__length1, "Screensaver")) {
#line 701 "desktop-file-service.c"
				GError* _tmp7_;
#line 137 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				_tmp7_ = g_error_new_literal (SYNAPSE_DESKTOP_FILE_ERROR, SYNAPSE_DESKTOP_FILE_ERROR_UNINTERESTING_ENTRY, "Screensaver desktop entry");
#line 137 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				_inner_error0_ = _tmp7_;
#line 137 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				categories = (_vala_array_free (categories, categories_length1, (GDestroyNotify) g_free), NULL);
#line 709 "desktop-file-service.c"
				goto __catch0_g_error;
			}
#line 134 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			categories = (_vala_array_free (categories, categories_length1, (GDestroyNotify) g_free), NULL);
#line 714 "desktop-file-service.c"
		}
		{
			const gchar** domain_key_collection = NULL;
			gint domain_key_collection_length1 = 0;
			gint _domain_key_collection_size_ = 0;
			gint domain_key_it = 0;
#line 141 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			domain_key_collection = SYNAPSE_DESKTOP_FILE_INFO_SUPPORTED_GETTEXT_DOMAINS_KEYS;
#line 141 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			domain_key_collection_length1 = G_N_ELEMENTS (SYNAPSE_DESKTOP_FILE_INFO_SUPPORTED_GETTEXT_DOMAINS_KEYS);
#line 141 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			for (domain_key_it = 0; domain_key_it < domain_key_collection_length1; domain_key_it = domain_key_it + 1) {
#line 727 "desktop-file-service.c"
				const gchar* domain_key = NULL;
#line 141 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				domain_key = domain_key_collection[domain_key_it];
#line 731 "desktop-file-service.c"
				{
					const gchar* _tmp8_;
#line 142 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp8_ = domain_key;
#line 142 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					if (g_desktop_app_info_has_key (app_info, _tmp8_)) {
#line 738 "desktop-file-service.c"
						const gchar* _tmp9_;
						gchar* _tmp10_;
						gchar* _tmp11_;
#line 143 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
						_tmp9_ = domain_key;
#line 143 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
						_tmp10_ = g_desktop_app_info_get_string (app_info, _tmp9_);
#line 143 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
						_tmp11_ = _tmp10_;
#line 143 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
						synapse_desktop_file_info_set_gettext_domain (self, _tmp11_);
#line 143 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
						_g_free0 (_tmp11_);
#line 144 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
						break;
#line 754 "desktop-file-service.c"
					}
				}
			}
		}
#line 148 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp12_ = g_app_info_get_name ((GAppInfo*) app_info);
#line 148 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_name (self, _tmp12_);
#line 149 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp14_ = g_desktop_app_info_get_generic_name (app_info);
#line 149 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp13_ = _tmp14_;
#line 149 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		if (_tmp13_ == NULL) {
#line 149 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp13_ = "";
#line 771 "desktop-file-service.c"
		}
#line 149 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_generic_name (self, _tmp13_);
#line 150 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp15_ = g_app_info_get_commandline ((GAppInfo*) app_info);
#line 150 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_exec (self, _tmp15_);
#line 152 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp16_ = self->priv->_exec;
#line 152 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		if (_tmp16_ == NULL) {
#line 783 "desktop-file-service.c"
			const gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			GError* _tmp20_;
			GError* _tmp21_;
#line 153 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp17_ = self->priv->_name;
#line 153 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp18_ = g_strdup_printf ("Unable to get exec for %s", _tmp17_);
#line 153 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp19_ = _tmp18_;
#line 153 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp20_ = g_error_new_literal (SYNAPSE_DESKTOP_FILE_ERROR, SYNAPSE_DESKTOP_FILE_ERROR_UNINTERESTING_ENTRY, _tmp19_);
#line 153 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp21_ = _tmp20_;
#line 153 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_g_free0 (_tmp19_);
#line 153 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_inner_error0_ = _tmp21_;
#line 803 "desktop-file-service.c"
			goto __catch0_g_error;
		}
#line 156 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_is_hidden (self, !g_app_info_should_show ((GAppInfo*) app_info));
#line 158 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp22_ = g_strdup ("gnome-control-center");
#line 158 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		control_center = _tmp22_;
#line 159 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp23_ = g_find_program_in_path ("budgie-control-center");
#line 159 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp24_ = _tmp23_;
#line 159 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp25_ = _tmp24_ != NULL;
#line 159 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_free0 (_tmp24_);
#line 159 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		if (_tmp25_) {
#line 822 "desktop-file-service.c"
			gchar* _tmp26_;
#line 160 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp26_ = g_strdup ("budgie-control-center");
#line 160 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_g_free0 (control_center);
#line 160 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			control_center = _tmp26_;
#line 830 "desktop-file-service.c"
		}
#line 162 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp27_ = self->priv->_exec;
#line 162 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp28_ = control_center;
#line 162 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		if (string_contains (_tmp27_, _tmp28_)) {
#line 163 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			synapse_desktop_file_info_set_is_hidden (self, TRUE);
#line 164 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			synapse_desktop_file_info_set_is_control_panel (self, TRUE);
#line 842 "desktop-file-service.c"
		}
#line 166 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp30_ = g_app_info_get_description ((GAppInfo*) app_info);
#line 166 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp29_ = _tmp30_;
#line 166 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		if (_tmp29_ == NULL) {
#line 166 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp29_ = "";
#line 852 "desktop-file-service.c"
		}
#line 166 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_comment (self, _tmp29_);
#line 168 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp32_ = g_app_info_get_icon ((GAppInfo*) app_info);
#line 168 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp33_ = _g_object_ref0 (_tmp32_);
#line 168 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp31_ = _tmp33_;
#line 168 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		if (_tmp31_ == NULL) {
#line 864 "desktop-file-service.c"
			GThemedIcon* _tmp34_;
#line 169 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp34_ = (GThemedIcon*) g_themed_icon_new ("application-default-icon");
#line 169 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_g_object_unref0 (_tmp31_);
#line 169 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp31_ = (GIcon*) _tmp34_;
#line 872 "desktop-file-service.c"
		}
#line 168 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp35_ = _tmp31_;
#line 168 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp31_ = NULL;
#line 168 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		icon = _tmp35_;
#line 170 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp36_ = icon;
#line 170 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp37_ = g_icon_to_string (_tmp36_);
#line 170 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp38_ = _tmp37_;
#line 170 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_icon_name (self, _tmp38_);
#line 170 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_free0 (_tmp38_);
#line 172 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		if (g_desktop_app_info_has_key (app_info, G_KEY_FILE_DESKTOP_KEY_TERMINAL)) {
#line 173 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			synapse_desktop_file_info_set_needs_terminal (self, g_desktop_app_info_get_boolean (app_info, G_KEY_FILE_DESKTOP_KEY_TERMINAL));
#line 894 "desktop-file-service.c"
		}
#line 175 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		if (g_desktop_app_info_has_key (app_info, G_KEY_FILE_DESKTOP_KEY_ONLY_SHOW_IN)) {
#line 898 "desktop-file-service.c"
			gsize _tmp39_ = 0;
			gchar** _tmp40_;
			gchar** _tmp41_;
			gint _tmp41__length1;
#line 176 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp40_ = g_desktop_app_info_get_string_list (app_info, G_KEY_FILE_DESKTOP_KEY_ONLY_SHOW_IN, &_tmp39_);
#line 176 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp41_ = _tmp40_;
#line 176 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp41__length1 = _tmp39_;
#line 176 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			synapse_desktop_file_info_set_show_in (self, synapse_desktop_file_info_parse_environments (self, _tmp41_, (gint) _tmp39_));
#line 176 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp41_ = (_vala_array_free (_tmp41_, _tmp41__length1, (GDestroyNotify) g_free), NULL);
#line 913 "desktop-file-service.c"
		} else {
#line 177 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			if (g_desktop_app_info_has_key (app_info, G_KEY_FILE_DESKTOP_KEY_NOT_SHOW_IN)) {
#line 917 "desktop-file-service.c"
				SynapseDesktopFileInfoEnvironmentType not_show = 0U;
				gsize _tmp42_ = 0;
				gchar** _tmp43_;
				gchar** _tmp44_;
				gint _tmp44__length1;
				SynapseDesktopFileInfoEnvironmentType _tmp45_;
#line 178 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				_tmp43_ = g_desktop_app_info_get_string_list (app_info, G_KEY_FILE_DESKTOP_KEY_NOT_SHOW_IN, &_tmp42_);
#line 178 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				_tmp44_ = _tmp43_;
#line 178 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				_tmp44__length1 = _tmp42_;
#line 178 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				_tmp45_ = synapse_desktop_file_info_parse_environments (self, _tmp44_, (gint) _tmp42_);
#line 178 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				_tmp44_ = (_vala_array_free (_tmp44_, _tmp44__length1, (GDestroyNotify) g_free), NULL);
#line 178 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				not_show = _tmp45_;
#line 179 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				synapse_desktop_file_info_set_show_in (self, SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_ALL ^ not_show);
#line 938 "desktop-file-service.c"
			}
		}
#line 129 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_object_unref0 (icon);
#line 129 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_object_unref0 (_tmp31_);
#line 129 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_free0 (control_center);
#line 947 "desktop-file-service.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* name = NULL;
		gchar* _tmp46_;
		GError* _tmp48_;
#line 129 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		err = _inner_error0_;
#line 129 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_inner_error0_ = NULL;
#line 182 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp46_ = g_strdup ("Unidentified");
#line 182 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		name = _tmp46_;
#line 184 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		if (g_desktop_app_info_has_key (app_info, G_KEY_FILE_DESKTOP_KEY_NAME)) {
#line 966 "desktop-file-service.c"
			gchar* _tmp47_;
#line 185 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp47_ = g_desktop_app_info_get_string (app_info, G_KEY_FILE_DESKTOP_KEY_NAME);
#line 185 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_g_free0 (name);
#line 185 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			name = _tmp47_;
#line 974 "desktop-file-service.c"
		}
#line 188 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp48_ = err;
#line 188 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		if (g_error_matches (_tmp48_, SYNAPSE_DESKTOP_FILE_ERROR, SYNAPSE_DESKTOP_FILE_ERROR_UNINTERESTING_ENTRY)) {
#line 980 "desktop-file-service.c"
			const gchar* _tmp49_;
			GError* _tmp50_;
			const gchar* _tmp51_;
#line 189 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp49_ = name;
#line 189 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp50_ = err;
#line 189 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp51_ = _tmp50_->message;
#line 189 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			g_debug ("desktop-file-service.vala:189: Ignoring DesktopFileInfo %s - %s", _tmp49_, _tmp51_);
#line 992 "desktop-file-service.c"
		} else {
			GError* _tmp52_;
			const gchar* _tmp53_;
#line 191 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp52_ = err;
#line 191 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			_tmp53_ = _tmp52_->message;
#line 191 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			g_warning ("desktop-file-service.vala:191: Error initializing DesktopFileInfo from" \
" DesktopAppInfo - %s", _tmp53_);
#line 1002 "desktop-file-service.c"
		}
#line 197 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_is_valid (self, FALSE);
#line 129 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_free0 (name);
#line 129 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_error_free0 (err);
#line 1010 "desktop-file-service.c"
	}
	__finally0:
#line 129 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 129 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 129 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_clear_error (&_inner_error0_);
#line 129 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		return;
#line 1021 "desktop-file-service.c"
	}
}

SynapseDesktopFileInfo*
synapse_desktop_file_info_construct (GType object_type)
{
	SynapseDesktopFileInfo * self = NULL;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self = (SynapseDesktopFileInfo*) g_object_new (object_type, NULL);
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return self;
#line 1033 "desktop-file-service.c"
}

SynapseDesktopFileInfo*
synapse_desktop_file_info_new (void)
{
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return synapse_desktop_file_info_construct (SYNAPSE_TYPE_DESKTOP_FILE_INFO);
#line 1041 "desktop-file-service.c"
}

const gchar*
synapse_desktop_file_info_get_desktop_id (SynapseDesktopFileInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 49 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->_desktop_id;
#line 49 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	result = _tmp0_;
#line 49 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 1057 "desktop-file-service.c"
}

void
synapse_desktop_file_info_set_desktop_id (SynapseDesktopFileInfo* self,
                                          const gchar* value)
{
	gchar* old_value;
#line 49 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 49 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_desktop_id (self);
#line 49 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1071 "desktop-file-service.c"
		gchar* _tmp0_;
#line 49 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp0_ = g_strdup (value);
#line 49 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_free0 (self->priv->_desktop_id);
#line 49 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		self->priv->_desktop_id = _tmp0_;
#line 49 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_DESKTOP_ID_PROPERTY]);
#line 1081 "desktop-file-service.c"
	}
}

const gchar*
synapse_desktop_file_info_get_name (SynapseDesktopFileInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 50 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->_name;
#line 50 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	result = _tmp0_;
#line 50 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 1098 "desktop-file-service.c"
}

void
synapse_desktop_file_info_set_name (SynapseDesktopFileInfo* self,
                                    const gchar* value)
{
	gchar* old_value;
#line 50 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 50 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_name (self);
#line 50 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1112 "desktop-file-service.c"
		gchar* _tmp0_;
#line 50 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp0_ = g_strdup (value);
#line 50 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_free0 (self->priv->_name);
#line 50 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		self->priv->_name = _tmp0_;
#line 50 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_NAME_PROPERTY]);
#line 1122 "desktop-file-service.c"
	}
}

const gchar*
synapse_desktop_file_info_get_generic_name (SynapseDesktopFileInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 51 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->_generic_name;
#line 51 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	result = _tmp0_;
#line 51 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 1139 "desktop-file-service.c"
}

void
synapse_desktop_file_info_set_generic_name (SynapseDesktopFileInfo* self,
                                            const gchar* value)
{
	gchar* old_value;
#line 51 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 51 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_generic_name (self);
#line 51 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1153 "desktop-file-service.c"
		gchar* _tmp0_;
#line 51 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp0_ = g_strdup (value);
#line 51 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_free0 (self->priv->_generic_name);
#line 51 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		self->priv->_generic_name = _tmp0_;
#line 51 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_GENERIC_NAME_PROPERTY]);
#line 1163 "desktop-file-service.c"
	}
}

const gchar*
synapse_desktop_file_info_get_comment (SynapseDesktopFileInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 52 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->_comment;
#line 52 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	result = _tmp0_;
#line 52 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 1180 "desktop-file-service.c"
}

void
synapse_desktop_file_info_set_comment (SynapseDesktopFileInfo* self,
                                       const gchar* value)
{
	gchar* old_value;
#line 52 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 52 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_comment (self);
#line 52 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1194 "desktop-file-service.c"
		gchar* _tmp0_;
#line 52 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp0_ = g_strdup (value);
#line 52 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_free0 (self->priv->_comment);
#line 52 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		self->priv->_comment = _tmp0_;
#line 52 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_COMMENT_PROPERTY]);
#line 1204 "desktop-file-service.c"
	}
}

const gchar*
synapse_desktop_file_info_get_icon_name (SynapseDesktopFileInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 53 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->_icon_name;
#line 53 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	result = _tmp0_;
#line 53 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 1221 "desktop-file-service.c"
}

void
synapse_desktop_file_info_set_icon_name (SynapseDesktopFileInfo* self,
                                         const gchar* value)
{
	gchar* old_value;
#line 53 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 53 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_icon_name (self);
#line 53 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1235 "desktop-file-service.c"
		gchar* _tmp0_;
#line 53 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp0_ = g_strdup (value);
#line 53 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_free0 (self->priv->_icon_name);
#line 53 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		self->priv->_icon_name = _tmp0_;
#line 53 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_ICON_NAME_PROPERTY]);
#line 1245 "desktop-file-service.c"
	}
}

const gchar*
synapse_desktop_file_info_get_gettext_domain (SynapseDesktopFileInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 54 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->_gettext_domain;
#line 54 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	result = _tmp0_;
#line 54 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 1262 "desktop-file-service.c"
}

void
synapse_desktop_file_info_set_gettext_domain (SynapseDesktopFileInfo* self,
                                              const gchar* value)
{
	gchar* old_value;
#line 54 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 54 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_gettext_domain (self);
#line 54 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1276 "desktop-file-service.c"
		gchar* _tmp0_;
#line 54 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp0_ = g_strdup (value);
#line 54 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_free0 (self->priv->_gettext_domain);
#line 54 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		self->priv->_gettext_domain = _tmp0_;
#line 54 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_GETTEXT_DOMAIN_PROPERTY]);
#line 1286 "desktop-file-service.c"
	}
}

gboolean
synapse_desktop_file_info_get_needs_terminal (SynapseDesktopFileInfo* self)
{
	gboolean result;
#line 56 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	result = self->priv->_needs_terminal;
#line 56 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 1300 "desktop-file-service.c"
}

void
synapse_desktop_file_info_set_needs_terminal (SynapseDesktopFileInfo* self,
                                              gboolean value)
{
	gboolean old_value;
#line 56 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 56 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_needs_terminal (self);
#line 56 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (old_value != value) {
#line 56 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		self->priv->_needs_terminal = value;
#line 56 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_NEEDS_TERMINAL_PROPERTY]);
#line 1318 "desktop-file-service.c"
	}
}

const gchar*
synapse_desktop_file_info_get_filename (SynapseDesktopFileInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 57 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 57 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->_filename;
#line 57 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	result = _tmp0_;
#line 57 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 1335 "desktop-file-service.c"
}

void
synapse_desktop_file_info_set_filename (SynapseDesktopFileInfo* self,
                                        const gchar* value)
{
	gchar* old_value;
#line 57 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 57 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_filename (self);
#line 57 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1349 "desktop-file-service.c"
		gchar* _tmp0_;
#line 57 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp0_ = g_strdup (value);
#line 57 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_free0 (self->priv->_filename);
#line 57 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		self->priv->_filename = _tmp0_;
#line 57 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_FILENAME_PROPERTY]);
#line 1359 "desktop-file-service.c"
	}
}

const gchar*
synapse_desktop_file_info_get_exec (SynapseDesktopFileInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 59 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->_exec;
#line 59 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	result = _tmp0_;
#line 59 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 1376 "desktop-file-service.c"
}

void
synapse_desktop_file_info_set_exec (SynapseDesktopFileInfo* self,
                                    const gchar* value)
{
	gchar* old_value;
#line 59 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 59 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_exec (self);
#line 59 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1390 "desktop-file-service.c"
		gchar* _tmp0_;
#line 59 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp0_ = g_strdup (value);
#line 59 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_free0 (self->priv->_exec);
#line 59 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		self->priv->_exec = _tmp0_;
#line 59 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_EXEC_PROPERTY]);
#line 1400 "desktop-file-service.c"
	}
}

gboolean
synapse_desktop_file_info_get_is_hidden (SynapseDesktopFileInfo* self)
{
	gboolean result;
#line 61 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 61 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	result = self->priv->_is_hidden;
#line 61 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 1414 "desktop-file-service.c"
}

static void
synapse_desktop_file_info_set_is_hidden (SynapseDesktopFileInfo* self,
                                         gboolean value)
{
	gboolean old_value;
#line 61 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 61 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_is_hidden (self);
#line 61 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (old_value != value) {
#line 61 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		self->priv->_is_hidden = value;
#line 61 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_IS_HIDDEN_PROPERTY]);
#line 1432 "desktop-file-service.c"
	}
}

gboolean
synapse_desktop_file_info_get_is_valid (SynapseDesktopFileInfo* self)
{
	gboolean result;
#line 62 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 62 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	result = self->priv->_is_valid;
#line 62 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 1446 "desktop-file-service.c"
}

static void
synapse_desktop_file_info_set_is_valid (SynapseDesktopFileInfo* self,
                                        gboolean value)
{
	gboolean old_value;
#line 62 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 62 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_is_valid (self);
#line 62 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (old_value != value) {
#line 62 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		self->priv->_is_valid = value;
#line 62 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_IS_VALID_PROPERTY]);
#line 1464 "desktop-file-service.c"
	}
}

gboolean
synapse_desktop_file_info_get_is_control_panel (SynapseDesktopFileInfo* self)
{
	gboolean result;
#line 63 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 63 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	result = self->priv->_is_control_panel;
#line 63 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 1478 "desktop-file-service.c"
}

static void
synapse_desktop_file_info_set_is_control_panel (SynapseDesktopFileInfo* self,
                                                gboolean value)
{
	gboolean old_value;
#line 63 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 63 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_is_control_panel (self);
#line 63 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (old_value != value) {
#line 63 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		self->priv->_is_control_panel = value;
#line 63 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_IS_CONTROL_PANEL_PROPERTY]);
#line 1496 "desktop-file-service.c"
	}
}

SynapseDesktopFileInfoEnvironmentType
synapse_desktop_file_info_get_show_in (SynapseDesktopFileInfo* self)
{
	SynapseDesktopFileInfoEnvironmentType result;
#line 74 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 74 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	result = self->priv->_show_in;
#line 74 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 1510 "desktop-file-service.c"
}

void
synapse_desktop_file_info_set_show_in (SynapseDesktopFileInfo* self,
                                       SynapseDesktopFileInfoEnvironmentType value)
{
	SynapseDesktopFileInfoEnvironmentType old_value;
#line 74 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 74 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_show_in (self);
#line 74 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (old_value != value) {
#line 74 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		self->priv->_show_in = value;
#line 74 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_SHOW_IN_PROPERTY]);
#line 1528 "desktop-file-service.c"
	}
}

static void
synapse_desktop_file_info_class_init (SynapseDesktopFileInfoClass * klass,
                                      gpointer klass_data)
{
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_info_parent_class = g_type_class_peek_parent (klass);
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_type_class_adjust_private_offset (klass, &SynapseDesktopFileInfo_private_offset);
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_synapse_desktop_file_info_get_property;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_synapse_desktop_file_info_set_property;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	G_OBJECT_CLASS (klass)->finalize = synapse_desktop_file_info_finalize;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_DESKTOP_ID_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_DESKTOP_ID_PROPERTY] = g_param_spec_string ("desktop-id", "desktop-id", "desktop-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_NAME_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_GENERIC_NAME_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_GENERIC_NAME_PROPERTY] = g_param_spec_string ("generic-name", "generic-name", "generic-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_COMMENT_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_COMMENT_PROPERTY] = g_param_spec_string ("comment", "comment", "comment", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_ICON_NAME_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_GETTEXT_DOMAIN_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_GETTEXT_DOMAIN_PROPERTY] = g_param_spec_string ("gettext-domain", "gettext-domain", "gettext-domain", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_NEEDS_TERMINAL_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_NEEDS_TERMINAL_PROPERTY] = g_param_spec_boolean ("needs-terminal", "needs-terminal", "needs-terminal", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_FILENAME_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_FILENAME_PROPERTY] = g_param_spec_string ("filename", "filename", "filename", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_EXEC_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_EXEC_PROPERTY] = g_param_spec_string ("exec", "exec", "exec", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_IS_HIDDEN_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_IS_HIDDEN_PROPERTY] = g_param_spec_boolean ("is-hidden", "is-hidden", "is-hidden", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_IS_VALID_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_IS_VALID_PROPERTY] = g_param_spec_boolean ("is-valid", "is-valid", "is-valid", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_IS_CONTROL_PANEL_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_IS_CONTROL_PANEL_PROPERTY] = g_param_spec_boolean ("is-control-panel", "is-control-panel", "is-control-panel", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_SHOW_IN_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_SHOW_IN_PROPERTY] = g_param_spec_flags ("show-in", "show-in", "show-in", SYNAPSE_DESKTOP_FILE_INFO_TYPE_ENVIRONMENT_TYPE, SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_ALL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1572 "desktop-file-service.c"
}

static void
synapse_desktop_file_info_instance_init (SynapseDesktopFileInfo * self,
                                         gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self->priv = synapse_desktop_file_info_get_instance_private (self);
#line 52 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp0_ = g_strdup ("");
#line 52 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self->priv->_comment = _tmp0_;
#line 53 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp1_ = g_strdup ("");
#line 53 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self->priv->_icon_name = _tmp1_;
#line 56 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self->priv->_needs_terminal = FALSE;
#line 61 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self->priv->_is_hidden = FALSE;
#line 62 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self->priv->_is_valid = TRUE;
#line 63 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self->priv->_is_control_panel = FALSE;
#line 65 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self->priv->name_folded = NULL;
#line 74 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self->priv->_show_in = SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_ALL;
#line 1603 "desktop-file-service.c"
}

static void
synapse_desktop_file_info_finalize (GObject * obj)
{
	SynapseDesktopFileInfo * self;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SYNAPSE_TYPE_DESKTOP_FILE_INFO, SynapseDesktopFileInfo);
#line 49 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_free0 (self->priv->_desktop_id);
#line 50 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_free0 (self->priv->_name);
#line 51 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_free0 (self->priv->_generic_name);
#line 52 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_free0 (self->priv->_comment);
#line 53 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_free0 (self->priv->_icon_name);
#line 54 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_free0 (self->priv->_gettext_domain);
#line 57 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_free0 (self->priv->_filename);
#line 59 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_free0 (self->priv->_exec);
#line 65 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_free0 (self->priv->name_folded);
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	G_OBJECT_CLASS (synapse_desktop_file_info_parent_class)->finalize (obj);
#line 1632 "desktop-file-service.c"
}

GType
synapse_desktop_file_info_get_type (void)
{
	return synapse_desktop_file_info_type_id;
}

GType
synapse_desktop_file_info_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (SynapseDesktopFileInfoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) synapse_desktop_file_info_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SynapseDesktopFileInfo), 0, (GInstanceInitFunc) synapse_desktop_file_info_instance_init, NULL };
	synapse_desktop_file_info_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "SynapseDesktopFileInfo", &g_define_type_info, 0);
	SynapseDesktopFileInfo_private_offset = sizeof (SynapseDesktopFileInfoPrivate);
	return synapse_desktop_file_info_type_id;
}

static void
_vala_synapse_desktop_file_info_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	SynapseDesktopFileInfo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SYNAPSE_TYPE_DESKTOP_FILE_INFO, SynapseDesktopFileInfo);
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	switch (property_id) {
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_DESKTOP_ID_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_value_set_string (value, synapse_desktop_file_info_get_desktop_id (self));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_NAME_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_value_set_string (value, synapse_desktop_file_info_get_name (self));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_GENERIC_NAME_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_value_set_string (value, synapse_desktop_file_info_get_generic_name (self));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_COMMENT_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_value_set_string (value, synapse_desktop_file_info_get_comment (self));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_ICON_NAME_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_value_set_string (value, synapse_desktop_file_info_get_icon_name (self));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_GETTEXT_DOMAIN_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_value_set_string (value, synapse_desktop_file_info_get_gettext_domain (self));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_NEEDS_TERMINAL_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_value_set_boolean (value, synapse_desktop_file_info_get_needs_terminal (self));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_FILENAME_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_value_set_string (value, synapse_desktop_file_info_get_filename (self));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_EXEC_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_value_set_string (value, synapse_desktop_file_info_get_exec (self));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_IS_HIDDEN_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_value_set_boolean (value, synapse_desktop_file_info_get_is_hidden (self));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_IS_VALID_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_value_set_boolean (value, synapse_desktop_file_info_get_is_valid (self));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_IS_CONTROL_PANEL_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_value_set_boolean (value, synapse_desktop_file_info_get_is_control_panel (self));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_SHOW_IN_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_value_set_flags (value, synapse_desktop_file_info_get_show_in (self));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 1738 "desktop-file-service.c"
		default:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 1744 "desktop-file-service.c"
	}
}

static void
_vala_synapse_desktop_file_info_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	SynapseDesktopFileInfo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SYNAPSE_TYPE_DESKTOP_FILE_INFO, SynapseDesktopFileInfo);
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	switch (property_id) {
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_DESKTOP_ID_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_desktop_id (self, g_value_get_string (value));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_NAME_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_name (self, g_value_get_string (value));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_GENERIC_NAME_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_generic_name (self, g_value_get_string (value));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_COMMENT_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_comment (self, g_value_get_string (value));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_ICON_NAME_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_icon_name (self, g_value_get_string (value));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_GETTEXT_DOMAIN_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_gettext_domain (self, g_value_get_string (value));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_NEEDS_TERMINAL_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_needs_terminal (self, g_value_get_boolean (value));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_FILENAME_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_filename (self, g_value_get_string (value));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_EXEC_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_exec (self, g_value_get_string (value));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_IS_HIDDEN_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_is_hidden (self, g_value_get_boolean (value));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_IS_VALID_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_is_valid (self, g_value_get_boolean (value));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_IS_CONTROL_PANEL_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_is_control_panel (self, g_value_get_boolean (value));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_SHOW_IN_PROPERTY:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_show_in (self, g_value_get_flags (value));
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 1836 "desktop-file-service.c"
		default:
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		break;
#line 1842 "desktop-file-service.c"
	}
}

static inline gpointer
synapse_desktop_file_service_get_instance_private (SynapseDesktopFileService* self)
{
	return G_STRUCT_MEMBER_P (self, SynapseDesktopFileService_private_offset);
}

SynapseDesktopFileService*
synapse_desktop_file_service_get_default (void)
{
	SynapseDesktopFileService* _tmp0_ = NULL;
	SynapseDesktopFileService* _tmp1_;
	SynapseDesktopFileService* _tmp2_;
	SynapseDesktopFileService* _tmp4_;
	SynapseDesktopFileService* result;
#line 208 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp1_ = synapse_desktop_file_service_instance;
#line 208 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 208 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp0_ = _tmp2_;
#line 208 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (_tmp0_ == NULL) {
#line 1868 "desktop-file-service.c"
		SynapseDesktopFileService* _tmp3_;
#line 208 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp3_ = synapse_desktop_file_service_new ();
#line 208 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_object_unref0 (_tmp0_);
#line 208 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp0_ = _tmp3_;
#line 1876 "desktop-file-service.c"
	}
#line 208 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp4_ = _tmp0_;
#line 208 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp0_ = NULL;
#line 208 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	result = _tmp4_;
#line 208 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (_tmp0_);
#line 208 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 1888 "desktop-file-service.c"
}

static SynapseDesktopFileService*
synapse_desktop_file_service_construct (GType object_type)
{
	SynapseDesktopFileService * self = NULL;
#line 213 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self = (SynapseDesktopFileService*) g_object_new (object_type, NULL);
#line 213 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return self;
#line 1899 "desktop-file-service.c"
}

static SynapseDesktopFileService*
synapse_desktop_file_service_new (void)
{
#line 213 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return synapse_desktop_file_service_construct (SYNAPSE_TYPE_DESKTOP_FILE_SERVICE);
#line 1907 "desktop-file-service.c"
}

static void
synapse_desktop_file_service_initialize_data_free (gpointer _data)
{
	SynapseDesktopFileServiceInitializeData* _data_;
	_data_ = _data;
#line 202 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (_data_->self);
#line 202 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_slice_free (SynapseDesktopFileServiceInitializeData, _data_);
#line 1919 "desktop-file-service.c"
}

void
synapse_desktop_file_service_initialize (SynapseDesktopFileService* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	SynapseDesktopFileServiceInitializeData* _data_;
	SynapseDesktopFileService* _tmp0_;
#line 202 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 202 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_data_ = g_slice_new0 (SynapseDesktopFileServiceInitializeData);
#line 202 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 202 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, synapse_desktop_file_service_initialize_data_free);
#line 202 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 202 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_data_->self = _tmp0_;
#line 202 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_initialize_co (_data_);
#line 1943 "desktop-file-service.c"
}

void
synapse_desktop_file_service_initialize_finish (SynapseDesktopFileService* self,
                                                GAsyncResult* _res_)
{
	SynapseDesktopFileServiceInitializeData* _data_;
#line 202 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1953 "desktop-file-service.c"
}

static void
synapse_desktop_file_service_initialize_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	SynapseDesktopFileServiceInitializeData* _data_;
#line 252 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_data_ = _user_data_;
#line 252 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_data_->_source_object_ = source_object;
#line 252 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_data_->_res_ = _res_;
#line 252 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_initialize_co (_data_);
#line 1970 "desktop-file-service.c"
}

static void
_synapse_desktop_file_service_queue_cache_update_g_app_info_monitor_changed (GAppInfoMonitor* _sender,
                                                                             gpointer self)
{
#line 260 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_queue_cache_update ((SynapseDesktopFileService*) self);
#line 1979 "desktop-file-service.c"
}

static gboolean
synapse_desktop_file_service_initialize_co (SynapseDesktopFileServiceInitializeData* _data_)
{
#line 248 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	switch (_data_->_state_) {
#line 248 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case 0:
#line 1989 "desktop-file-service.c"
		goto _state_0;
#line 248 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		case 1:
#line 1993 "desktop-file-service.c"
		goto _state_1;
		default:
#line 248 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_assert_not_reached ();
#line 1998 "desktop-file-service.c"
	}
	_state_0:
#line 249 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_data_->_tmp0_ = _data_->self->priv->init_once;
#line 249 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (synapse_utils_async_once_is_initialized (_data_->_tmp0_)) {
#line 250 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 250 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		if (_data_->_state_ != 0) {
#line 250 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 250 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2013 "desktop-file-service.c"
			}
		}
#line 250 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_object_unref (_data_->_async_result);
#line 250 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		return FALSE;
#line 2020 "desktop-file-service.c"
	}
#line 252 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_data_->_tmp1_ = _data_->self->priv->init_once;
#line 252 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_data_->_state_ = 1;
#line 252 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	synapse_utils_async_once_enter (_data_->_tmp1_, synapse_desktop_file_service_initialize_ready, _data_);
#line 252 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return FALSE;
#line 2030 "desktop-file-service.c"
	_state_1:
#line 252 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_data_->is_locked = synapse_utils_async_once_enter_finish (_data_->_tmp1_, _data_->_res_);
#line 253 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (!_data_->is_locked) {
#line 254 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 254 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		if (_data_->_state_ != 0) {
#line 254 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 254 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2044 "desktop-file-service.c"
			}
		}
#line 254 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_object_unref (_data_->_async_result);
#line 254 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		return FALSE;
#line 2051 "desktop-file-service.c"
	}
#line 257 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_load_all_desktop_files (_data_->self);
#line 259 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_data_->_tmp2_ = g_app_info_monitor_get ();
#line 259 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (_data_->self->priv->app_info_monitor);
#line 259 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_data_->self->priv->app_info_monitor = _data_->_tmp2_;
#line 260 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_data_->_tmp3_ = _data_->self->priv->app_info_monitor;
#line 260 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_signal_connect_object (_data_->_tmp3_, "changed", (GCallback) _synapse_desktop_file_service_queue_cache_update_g_app_info_monitor_changed, _data_->self, 0);
#line 262 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_data_->_tmp4_ = _data_->self->priv->init_once;
#line 262 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	synapse_utils_async_once_leave (_data_->_tmp4_, (gpointer) ((gintptr) TRUE));
#line 248 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 248 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (_data_->_state_ != 0) {
#line 248 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 248 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2077 "desktop-file-service.c"
		}
	}
#line 248 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_object_unref (_data_->_async_result);
#line 248 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return FALSE;
#line 2084 "desktop-file-service.c"
}

static gboolean
__lambda18_ (SynapseDesktopFileService* self)
{
	gboolean result;
#line 273 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_load_all_desktop_files (self);
#line 274 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_signal_emit (self, synapse_desktop_file_service_signals[SYNAPSE_DESKTOP_FILE_SERVICE_RELOAD_DONE_SIGNAL], 0);
#line 276 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self->priv->queued_update_id = (guint) 0;
#line 278 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	result = G_SOURCE_REMOVE;
#line 278 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 2101 "desktop-file-service.c"
}

static gboolean
___lambda18__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda18_ ((SynapseDesktopFileService*) self);
#line 272 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 2111 "desktop-file-service.c"
}

static void
synapse_desktop_file_service_queue_cache_update (SynapseDesktopFileService* self)
{
#line 265 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 266 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_signal_emit (self, synapse_desktop_file_service_signals[SYNAPSE_DESKTOP_FILE_SERVICE_RELOAD_STARTED_SIGNAL], 0);
#line 268 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (self->priv->queued_update_id != ((guint) 0)) {
#line 269 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_source_remove (self->priv->queued_update_id);
#line 2125 "desktop-file-service.c"
	}
#line 272 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self->priv->queued_update_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) SYNAPSE_DESKTOP_FILE_SERVICE_DEFAULT_TIMEOUT_SECONDS, ___lambda18__gsource_func, g_object_ref (self), g_object_unref);
#line 2129 "desktop-file-service.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 300 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2137 "desktop-file-service.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 300 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 2145 "desktop-file-service.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 2166 "desktop-file-service.c"
}

static void
synapse_desktop_file_service_load_all_desktop_files (SynapseDesktopFileService* self)
{
	GeeList* _tmp0_;
	GeeMap* _tmp1_;
	GeeMap* _tmp2_;
	GList* app_infos = NULL;
	GList* _tmp3_;
	GList* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 283 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 284 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->non_hidden_desktop_files;
#line 284 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	gee_collection_clear ((GeeCollection*) _tmp0_);
#line 285 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp1_ = self->priv->exec_map;
#line 285 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	gee_map_clear (_tmp1_);
#line 286 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp2_ = self->priv->desktop_id_map;
#line 286 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	gee_map_clear (_tmp2_);
#line 288 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp3_ = g_app_info_get_all ();
#line 288 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	app_infos = _tmp3_;
#line 289 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp4_ = app_infos;
#line 2199 "desktop-file-service.c"
	{
		GList* app_collection = NULL;
		GList* app_it = NULL;
#line 289 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		app_collection = _tmp4_;
#line 289 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		for (app_it = app_collection; app_it != NULL; app_it = app_it->next) {
#line 2207 "desktop-file-service.c"
			GAppInfo* app = NULL;
#line 289 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
			app = (GAppInfo*) app_it->data;
#line 2211 "desktop-file-service.c"
			{
				GAppInfo* _tmp5_;
#line 290 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				_tmp5_ = app;
#line 290 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
				if (g_app_info_should_show (_tmp5_)) {
#line 2218 "desktop-file-service.c"
					GDesktopAppInfo* app_info = NULL;
					GAppInfo* _tmp6_;
					SynapseDesktopFileInfo* dfi = NULL;
					GDesktopAppInfo* _tmp7_;
					SynapseDesktopFileInfo* _tmp8_;
					GeeList* _tmp9_;
					SynapseDesktopFileInfo* _tmp10_;
					GeeMap* _tmp11_;
					SynapseDesktopFileInfo* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					SynapseDesktopFileInfo* _tmp15_;
					gchar* exec = NULL;
					SynapseDesktopFileInfo* _tmp16_;
					const gchar* _tmp17_;
					const gchar* _tmp18_;
					gchar* _tmp19_;
					GRegex* _tmp20_;
					GeeList* exec_list = NULL;
					GeeMap* _tmp32_;
					const gchar* _tmp33_;
					gpointer _tmp34_;
					GeeList* _tmp35_;
					GeeList* _tmp40_;
					SynapseDesktopFileInfo* _tmp41_;
#line 291 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp6_ = app;
#line 291 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					app_info = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, G_TYPE_DESKTOP_APP_INFO, GDesktopAppInfo);
#line 292 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp7_ = app_info;
#line 292 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp8_ = synapse_desktop_file_info_new_for_desktop_app_info (_tmp7_);
#line 292 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					dfi = _tmp8_;
#line 294 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp9_ = self->priv->non_hidden_desktop_files;
#line 294 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp10_ = dfi;
#line 294 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					gee_collection_add ((GeeCollection*) _tmp9_, _tmp10_);
#line 295 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp11_ = self->priv->desktop_id_map;
#line 295 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp12_ = dfi;
#line 295 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp13_ = synapse_desktop_file_info_get_desktop_id (_tmp12_);
#line 295 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp14_ = _tmp13_;
#line 295 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp15_ = dfi;
#line 295 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					gee_map_set (_tmp11_, _tmp14_, _tmp15_);
#line 297 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp16_ = dfi;
#line 297 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp17_ = synapse_desktop_file_info_get_exec (_tmp16_);
#line 297 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp18_ = _tmp17_;
#line 297 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp19_ = g_strdup (_tmp18_);
#line 297 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					exec = _tmp19_;
#line 298 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp20_ = self->priv->exec_regex;
#line 298 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					if (_tmp20_ != NULL) {
#line 2286 "desktop-file-service.c"
						{
							gchar* _tmp21_ = NULL;
							GRegex* _tmp22_;
							SynapseDesktopFileInfo* _tmp23_;
							const gchar* _tmp24_;
							const gchar* _tmp25_;
							gchar* _tmp26_;
							gchar* _tmp27_;
							const gchar* _tmp28_;
							gchar* _tmp29_;
#line 300 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_tmp22_ = self->priv->exec_regex;
#line 300 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_tmp23_ = dfi;
#line 300 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_tmp24_ = synapse_desktop_file_info_get_exec (_tmp23_);
#line 300 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_tmp25_ = _tmp24_;
#line 300 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_tmp26_ = g_regex_replace_literal (_tmp22_, _tmp25_, (gssize) -1, 0, "", 0, &_inner_error0_);
#line 300 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_tmp21_ = _tmp26_;
#line 300 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 300 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
								if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2313 "desktop-file-service.c"
									goto __catch0_g_regex_error;
								}
#line 300 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
								_g_free0 (exec);
#line 300 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
								_g_object_unref0 (dfi);
#line 300 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
								(app_infos == NULL) ? NULL : (app_infos = (_g_list_free__g_object_unref0_ (app_infos), NULL));
#line 300 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
								g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 300 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
								g_clear_error (&_inner_error0_);
#line 300 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
								return;
#line 2328 "desktop-file-service.c"
							}
#line 300 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_tmp27_ = _tmp21_;
#line 300 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_tmp21_ = NULL;
#line 300 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_g_free0 (exec);
#line 300 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							exec = _tmp27_;
#line 301 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_tmp28_ = exec;
#line 301 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_tmp29_ = string_strip (_tmp28_);
#line 301 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_g_free0 (exec);
#line 301 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							exec = _tmp29_;
#line 299 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_g_free0 (_tmp21_);
#line 2348 "desktop-file-service.c"
						}
						goto __finally0;
						__catch0_g_regex_error:
						{
							GError* err = NULL;
							GError* _tmp30_;
							const gchar* _tmp31_;
#line 299 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							err = _inner_error0_;
#line 299 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_inner_error0_ = NULL;
#line 303 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_tmp30_ = err;
#line 303 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_tmp31_ = _tmp30_->message;
#line 303 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							g_critical ("desktop-file-service.vala:303: %s", _tmp31_);
#line 299 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_g_error_free0 (err);
#line 2368 "desktop-file-service.c"
						}
						__finally0:
#line 299 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 299 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_g_free0 (exec);
#line 299 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							_g_object_unref0 (dfi);
#line 299 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							(app_infos == NULL) ? NULL : (app_infos = (_g_list_free__g_object_unref0_ (app_infos), NULL));
#line 299 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 299 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							g_clear_error (&_inner_error0_);
#line 299 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
							return;
#line 2385 "desktop-file-service.c"
						}
					}
#line 308 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp32_ = self->priv->exec_map;
#line 308 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp33_ = exec;
#line 308 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp34_ = gee_map_get (_tmp32_, _tmp33_);
#line 308 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					exec_list = (GeeList*) _tmp34_;
#line 309 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp35_ = exec_list;
#line 309 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					if (_tmp35_ == NULL) {
#line 2400 "desktop-file-service.c"
						GeeArrayList* _tmp36_;
						GeeMap* _tmp37_;
						const gchar* _tmp38_;
						GeeList* _tmp39_;
#line 310 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
						_tmp36_ = gee_array_list_new (SYNAPSE_TYPE_DESKTOP_FILE_INFO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 310 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
						_g_object_unref0 (exec_list);
#line 310 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
						exec_list = (GeeList*) _tmp36_;
#line 311 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
						_tmp37_ = self->priv->exec_map;
#line 311 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
						_tmp38_ = exec;
#line 311 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
						_tmp39_ = exec_list;
#line 311 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
						gee_map_set (_tmp37_, _tmp38_, _tmp39_);
#line 2419 "desktop-file-service.c"
					}
#line 313 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp40_ = exec_list;
#line 313 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_tmp41_ = dfi;
#line 313 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					gee_collection_add ((GeeCollection*) _tmp40_, _tmp41_);
#line 290 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_g_object_unref0 (exec_list);
#line 290 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_g_free0 (exec);
#line 290 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
					_g_object_unref0 (dfi);
#line 2433 "desktop-file-service.c"
				}
			}
		}
	}
#line 283 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	(app_infos == NULL) ? NULL : (app_infos = (_g_list_free__g_object_unref0_ (app_infos), NULL));
#line 2440 "desktop-file-service.c"
}

GeeList*
synapse_desktop_file_service_get_desktop_files (SynapseDesktopFileService* self)
{
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
	GeeList* result;
#line 319 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 320 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->non_hidden_desktop_files;
#line 320 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp1_ = gee_list_get_read_only_view (_tmp0_);
#line 320 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp2_ = _tmp1_;
#line 320 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	result = _tmp2_;
#line 320 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 2462 "desktop-file-service.c"
}

GeeList*
synapse_desktop_file_service_get_desktop_files_for_exec (SynapseDesktopFileService* self,
                                                         const gchar* exec)
{
	GeeList* _tmp0_ = NULL;
	GeeMap* _tmp1_;
	gpointer _tmp2_;
	GeeList* _tmp4_;
	GeeList* result;
#line 323 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 323 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (exec != NULL, NULL);
#line 324 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp1_ = self->priv->exec_map;
#line 324 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp2_ = gee_map_get (_tmp1_, exec);
#line 324 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp0_ = (GeeList*) _tmp2_;
#line 324 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (_tmp0_ == NULL) {
#line 2486 "desktop-file-service.c"
		GeeArrayList* _tmp3_;
#line 324 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp3_ = gee_array_list_new (SYNAPSE_TYPE_DESKTOP_FILE_INFO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 324 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_object_unref0 (_tmp0_);
#line 324 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp0_ = (GeeList*) _tmp3_;
#line 2494 "desktop-file-service.c"
	}
#line 324 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp4_ = _tmp0_;
#line 324 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp0_ = NULL;
#line 324 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	result = _tmp4_;
#line 324 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (_tmp0_);
#line 324 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 2506 "desktop-file-service.c"
}

SynapseDesktopFileInfo*
synapse_desktop_file_service_get_desktop_file_for_id (SynapseDesktopFileService* self,
                                                      const gchar* desktop_id)
{
	GeeMap* _tmp0_;
	gpointer _tmp1_;
	SynapseDesktopFileInfo* result;
#line 327 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 327 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (desktop_id != NULL, NULL);
#line 328 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->desktop_id_map;
#line 328 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp1_ = gee_map_get (_tmp0_, desktop_id);
#line 328 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	result = (SynapseDesktopFileInfo*) _tmp1_;
#line 328 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return result;
#line 2528 "desktop-file-service.c"
}

static GObject *
synapse_desktop_file_service_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SynapseDesktopFileService * self;
	GeeArrayList* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	SynapseUtilsAsyncOnce* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 226 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	parent_class = G_OBJECT_CLASS (synapse_desktop_file_service_parent_class);
#line 226 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 226 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SYNAPSE_TYPE_DESKTOP_FILE_SERVICE, SynapseDesktopFileService);
#line 227 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_instance = self;
#line 229 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp0_ = gee_array_list_new (SYNAPSE_TYPE_DESKTOP_FILE_INFO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 229 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (self->priv->non_hidden_desktop_files);
#line 229 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self->priv->non_hidden_desktop_files = (GeeList*) _tmp0_;
#line 230 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 230 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (self->priv->exec_map);
#line 230 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self->priv->exec_map = (GeeMap*) _tmp1_;
#line 231 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SYNAPSE_TYPE_DESKTOP_FILE_INFO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 231 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (self->priv->desktop_id_map);
#line 231 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self->priv->desktop_id_map = (GeeMap*) _tmp2_;
#line 233 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_tmp3_ = synapse_utils_async_once_new (G_TYPE_BOOLEAN, NULL, NULL);
#line 233 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_synapse_utils_async_once_unref0 (self->priv->init_once);
#line 233 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self->priv->init_once = _tmp3_;
#line 2576 "desktop-file-service.c"
	{
		GRegex* _tmp4_ = NULL;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
#line 236 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp5_ = g_regex_new ("%[fFuU]", 0, 0, &_inner_error0_);
#line 236 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp4_ = _tmp5_;
#line 236 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2587 "desktop-file-service.c"
			goto __catch0_g_error;
		}
#line 236 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp6_ = _tmp4_;
#line 236 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp4_ = NULL;
#line 236 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_regex_unref0 (self->priv->exec_regex);
#line 236 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		self->priv->exec_regex = _tmp6_;
#line 235 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_regex_unref0 (_tmp4_);
#line 2600 "desktop-file-service.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 235 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		err = _inner_error0_;
#line 235 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_inner_error0_ = NULL;
#line 238 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp7_ = err;
#line 238 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_tmp8_ = _tmp7_->message;
#line 238 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_warning ("desktop-file-service.vala:238: Unable to construct exec regex: %s", _tmp8_);
#line 235 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		_g_error_free0 (err);
#line 2620 "desktop-file-service.c"
	}
	__finally0:
#line 235 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 235 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 235 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
		g_clear_error (&_inner_error0_);
#line 2629 "desktop-file-service.c"
	}
#line 241 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_initialize (self, NULL, NULL);
#line 226 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	return obj;
#line 2635 "desktop-file-service.c"
}

static void
synapse_desktop_file_service_class_init (SynapseDesktopFileServiceClass * klass,
                                         gpointer klass_data)
{
#line 202 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_parent_class = g_type_class_peek_parent (klass);
#line 202 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	g_type_class_adjust_private_offset (klass, &SynapseDesktopFileService_private_offset);
#line 202 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	G_OBJECT_CLASS (klass)->constructor = synapse_desktop_file_service_constructor;
#line 202 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	G_OBJECT_CLASS (klass)->finalize = synapse_desktop_file_service_finalize;
#line 202 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_signals[SYNAPSE_DESKTOP_FILE_SERVICE_RELOAD_STARTED_SIGNAL] = g_signal_new ("reload-started", SYNAPSE_TYPE_DESKTOP_FILE_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 202 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_signals[SYNAPSE_DESKTOP_FILE_SERVICE_RELOAD_DONE_SIGNAL] = g_signal_new ("reload-done", SYNAPSE_TYPE_DESKTOP_FILE_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2654 "desktop-file-service.c"
}

static void
synapse_desktop_file_service_instance_init (SynapseDesktopFileService * self,
                                            gpointer klass)
{
#line 202 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self->priv = synapse_desktop_file_service_get_instance_private (self);
#line 223 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self->priv->queued_update_id = (guint) 0;
#line 2665 "desktop-file-service.c"
}

static void
synapse_desktop_file_service_finalize (GObject * obj)
{
	SynapseDesktopFileService * self;
#line 202 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SYNAPSE_TYPE_DESKTOP_FILE_SERVICE, SynapseDesktopFileService);
#line 245 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_instance = NULL;
#line 204 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_synapse_utils_async_once_unref0 (self->priv->init_once);
#line 215 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (self->priv->app_info_monitor);
#line 216 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (self->priv->non_hidden_desktop_files);
#line 217 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (self->priv->exec_map);
#line 218 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (self->priv->desktop_id_map);
#line 224 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	_g_regex_unref0 (self->priv->exec_regex);
#line 202 "../budgie-applications-menu/applications-menu/src/synapse-core/desktop-file-service.vala"
	G_OBJECT_CLASS (synapse_desktop_file_service_parent_class)->finalize (obj);
#line 2690 "desktop-file-service.c"
}

GType
synapse_desktop_file_service_get_type (void)
{
	return synapse_desktop_file_service_type_id;
}

GType
synapse_desktop_file_service_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (SynapseDesktopFileServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) synapse_desktop_file_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SynapseDesktopFileService), 0, (GInstanceInitFunc) synapse_desktop_file_service_instance_init, NULL };
	synapse_desktop_file_service_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "SynapseDesktopFileService", &g_define_type_info, 0);
	SynapseDesktopFileService_private_offset = sizeof (SynapseDesktopFileServicePrivate);
	return synapse_desktop_file_service_type_id;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 298 "../budgie-applications-menu/applications-menu/src/synapse-core/data-sink.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 2715 "desktop-file-service.c"
		gssize i;
#line 298 "../budgie-applications-menu/applications-menu/src/synapse-core/data-sink.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 298 "../budgie-applications-menu/applications-menu/src/synapse-core/data-sink.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 298 "../budgie-applications-menu/applications-menu/src/synapse-core/data-sink.vala"
				destroy_func (((gpointer*) array)[i]);
#line 2723 "desktop-file-service.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 298 "../budgie-applications-menu/applications-menu/src/synapse-core/data-sink.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 298 "../budgie-applications-menu/applications-menu/src/synapse-core/data-sink.vala"
	g_free (array);
#line 2738 "desktop-file-service.c"
}

