/* layouts.c generated by valac 0.56.18, the Vala compiler
 * generated from layouts.vala, do not modify */

/*
* Layouts
* Author: David Mohammed
* Copyright © 2020 Ubuntu Budgie Developers
* Website=https://ubuntubudgie.org
* This program is free software: you can redistribute it and/or modify it
* under the terms of the GNU General Public License as published by the Free
* Software Foundation, either version 3 of the License, or any later version.
* This program is distributed in the hope that it will be useful, but WITHOUT
* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
* FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
* more details. You should have received a copy of the GNU General Public
* License along with this program.  If not, see
* <https://www.gnu.org/licenses/>.
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gstdio.h>
#include <gio/gio.h>

#define LAYOUTS_plank_schema "net.launchpad.plank"
#define LAYOUTS_plank_settings_schema "net.launchpad.plank.dock.settings"
#define LAYOUTS_plank_path "/net/launchpad/plank/docks/xyz/"
#define LAYOUTS_panel_schema "com.solus-project.budgie-panel"
#define LAYOUTS_plank_global_path "/usr/share/applications/plank.desktop"
#define LAYOUTS_appmenu_budgie_schema "org.ubuntubudgie.plugins.budgie-appmenu"
#define LAYOUTS_budgiewm_schema "com.solus-project.budgie-wm"
#define LAYOUTS_nemo_window_schema "org.nemo.window-state"
#define LAYOUTS_nemo_preferences_schema "org.nemo.preferences"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define LAYOUTS_TYPE_LAYOUTS_MANAGER (layouts_layouts_manager_get_type ())
#define LAYOUTS_LAYOUTS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LAYOUTS_TYPE_LAYOUTS_MANAGER, LayoutsLayoutsManager))
#define LAYOUTS_LAYOUTS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LAYOUTS_TYPE_LAYOUTS_MANAGER, LayoutsLayoutsManagerClass))
#define LAYOUTS_IS_LAYOUTS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LAYOUTS_TYPE_LAYOUTS_MANAGER))
#define LAYOUTS_IS_LAYOUTS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LAYOUTS_TYPE_LAYOUTS_MANAGER))
#define LAYOUTS_LAYOUTS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LAYOUTS_TYPE_LAYOUTS_MANAGER, LayoutsLayoutsManagerClass))

typedef struct _LayoutsLayoutsManager LayoutsLayoutsManager;
typedef struct _LayoutsLayoutsManagerClass LayoutsLayoutsManagerClass;
typedef struct _LayoutsLayoutsManagerPrivate LayoutsLayoutsManagerPrivate;
enum  {
	LAYOUTS_LAYOUTS_MANAGER_0_PROPERTY,
	LAYOUTS_LAYOUTS_MANAGER_NUM_PROPERTIES
};
static GParamSpec* layouts_layouts_manager_properties[LAYOUTS_LAYOUTS_MANAGER_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _LayoutsLayoutsManager {
	GObject parent_instance;
	LayoutsLayoutsManagerPrivate * priv;
};

struct _LayoutsLayoutsManagerClass {
	GObjectClass parent_class;
};

struct _Block1Data {
	int _ref_count_;
	LayoutsLayoutsManager* self;
	GSettings* preference_settings;
	gboolean show_menu;
};

static gpointer layouts_layouts_manager_parent_class = NULL;

VALA_EXTERN GType layouts_layouts_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LayoutsLayoutsManager, g_object_unref)
static void layouts_layouts_manager_run_cmd (LayoutsLayoutsManager* self,
                                      const gchar* commandline,
                                      gboolean async);
static void layouts_layouts_manager_stop_plank (LayoutsLayoutsManager* self);
static void layouts_layouts_manager_show_nemo_menu (LayoutsLayoutsManager* self,
                                             gboolean show_menu);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda4_ (Block1Data* _data1_);
static gboolean ___lambda4__gsource_func (gpointer self);
static void layouts_layouts_manager_start_plank (LayoutsLayoutsManager* self,
                                          gboolean centered);
static void layouts_layouts_manager_appmenu_powerstrip (LayoutsLayoutsManager* self,
                                                 gboolean enable);
static void layouts_layouts_manager_appmenu_categoryview (LayoutsLayoutsManager* self,
                                                   gboolean show_category);
static void layouts_layouts_manager_leftside_buttons (LayoutsLayoutsManager* self,
                                               gboolean leftside);
static void layouts_layouts_manager_reset_panel (LayoutsLayoutsManager* self);
VALA_EXTERN void layouts_layouts_manager_reset (LayoutsLayoutsManager* self,
                                    const gchar* layout_name);
static gboolean __lambda5_ (LayoutsLayoutsManager* self);
static gboolean ___lambda5__gsource_func (gpointer self);
VALA_EXTERN LayoutsLayoutsManager* layouts_layouts_manager_new (void);
VALA_EXTERN LayoutsLayoutsManager* layouts_layouts_manager_construct (GType object_type);
static GType layouts_layouts_manager_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static void
layouts_layouts_manager_run_cmd (LayoutsLayoutsManager* self,
                                 const gchar* commandline,
                                 gboolean async)
{
	GError* _inner_error0_ = NULL;
#line 31 "../budgie-extras-daemon/src/layouts.vala"
	g_return_if_fail (self != NULL);
#line 31 "../budgie-extras-daemon/src/layouts.vala"
	g_return_if_fail (commandline != NULL);
#line 141 "layouts.c"
	{
#line 33 "../budgie-extras-daemon/src/layouts.vala"
		if (async) {
#line 34 "../budgie-extras-daemon/src/layouts.vala"
			g_spawn_command_line_async (commandline, &_inner_error0_);
#line 34 "../budgie-extras-daemon/src/layouts.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 34 "../budgie-extras-daemon/src/layouts.vala"
				if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 151 "layouts.c"
					goto __catch0_g_spawn_error;
				}
#line 34 "../budgie-extras-daemon/src/layouts.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 34 "../budgie-extras-daemon/src/layouts.vala"
				g_clear_error (&_inner_error0_);
#line 34 "../budgie-extras-daemon/src/layouts.vala"
				return;
#line 160 "layouts.c"
			}
		} else {
#line 37 "../budgie-extras-daemon/src/layouts.vala"
			g_spawn_command_line_sync (commandline, NULL, NULL, NULL, &_inner_error0_);
#line 37 "../budgie-extras-daemon/src/layouts.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 37 "../budgie-extras-daemon/src/layouts.vala"
				if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 169 "layouts.c"
					goto __catch0_g_spawn_error;
				}
#line 37 "../budgie-extras-daemon/src/layouts.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 37 "../budgie-extras-daemon/src/layouts.vala"
				g_clear_error (&_inner_error0_);
#line 37 "../budgie-extras-daemon/src/layouts.vala"
				return;
#line 178 "layouts.c"
			}
		}
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 32 "../budgie-extras-daemon/src/layouts.vala"
		e = _inner_error0_;
#line 32 "../budgie-extras-daemon/src/layouts.vala"
		_inner_error0_ = NULL;
#line 41 "../budgie-extras-daemon/src/layouts.vala"
		_tmp0_ = e;
#line 41 "../budgie-extras-daemon/src/layouts.vala"
		_tmp1_ = _tmp0_->message;
#line 41 "../budgie-extras-daemon/src/layouts.vala"
		g_warning ("layouts.vala:41: Issue when executing %s", _tmp1_);
#line 32 "../budgie-extras-daemon/src/layouts.vala"
		_g_error_free0 (e);
#line 200 "layouts.c"
	}
	__finally0:
#line 32 "../budgie-extras-daemon/src/layouts.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 32 "../budgie-extras-daemon/src/layouts.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 32 "../budgie-extras-daemon/src/layouts.vala"
		g_clear_error (&_inner_error0_);
#line 32 "../budgie-extras-daemon/src/layouts.vala"
		return;
#line 211 "layouts.c"
	}
}

static void
layouts_layouts_manager_stop_plank (LayoutsLayoutsManager* self)
{
	gchar* autostart_file = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 46 "../budgie-extras-daemon/src/layouts.vala"
	g_return_if_fail (self != NULL);
#line 47 "../budgie-extras-daemon/src/layouts.vala"
	layouts_layouts_manager_run_cmd (self, "killall plank", FALSE);
#line 49 "../budgie-extras-daemon/src/layouts.vala"
	_tmp0_ = g_get_home_dir ();
#line 49 "../budgie-extras-daemon/src/layouts.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/.config/autostart/plank.desktop", NULL);
#line 49 "../budgie-extras-daemon/src/layouts.vala"
	autostart_file = _tmp1_;
#line 52 "../budgie-extras-daemon/src/layouts.vala"
	_tmp2_ = autostart_file;
#line 52 "../budgie-extras-daemon/src/layouts.vala"
	if (!g_file_test (_tmp2_, G_FILE_TEST_EXISTS)) {
#line 237 "layouts.c"
		const gchar* _tmp3_;
#line 53 "../budgie-extras-daemon/src/layouts.vala"
		_tmp3_ = autostart_file;
#line 53 "../budgie-extras-daemon/src/layouts.vala"
		g_debug ("layouts.vala:53: does not exist %s", _tmp3_);
#line 54 "../budgie-extras-daemon/src/layouts.vala"
		_g_free0 (autostart_file);
#line 54 "../budgie-extras-daemon/src/layouts.vala"
		return;
#line 247 "layouts.c"
	}
	{
		GFile* file = NULL;
		const gchar* _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
#line 58 "../budgie-extras-daemon/src/layouts.vala"
		_tmp4_ = autostart_file;
#line 58 "../budgie-extras-daemon/src/layouts.vala"
		_tmp5_ = g_file_new_for_path (_tmp4_);
#line 58 "../budgie-extras-daemon/src/layouts.vala"
		file = _tmp5_;
#line 59 "../budgie-extras-daemon/src/layouts.vala"
		_tmp6_ = file;
#line 59 "../budgie-extras-daemon/src/layouts.vala"
		g_file_delete (_tmp6_, NULL, &_inner_error0_);
#line 59 "../budgie-extras-daemon/src/layouts.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 59 "../budgie-extras-daemon/src/layouts.vala"
			_g_object_unref0 (file);
#line 268 "layouts.c"
			goto __catch0_g_error;
		}
#line 57 "../budgie-extras-daemon/src/layouts.vala"
		_g_object_unref0 (file);
#line 273 "layouts.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 57 "../budgie-extras-daemon/src/layouts.vala"
		e = _inner_error0_;
#line 57 "../budgie-extras-daemon/src/layouts.vala"
		_inner_error0_ = NULL;
#line 62 "../budgie-extras-daemon/src/layouts.vala"
		_tmp7_ = e;
#line 62 "../budgie-extras-daemon/src/layouts.vala"
		_tmp8_ = _tmp7_->message;
#line 62 "../budgie-extras-daemon/src/layouts.vala"
		g_warning ("layouts.vala:62: Cannot delete: %s", _tmp8_);
#line 57 "../budgie-extras-daemon/src/layouts.vala"
		_g_error_free0 (e);
#line 293 "layouts.c"
	}
	__finally0:
#line 57 "../budgie-extras-daemon/src/layouts.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 57 "../budgie-extras-daemon/src/layouts.vala"
		_g_free0 (autostart_file);
#line 57 "../budgie-extras-daemon/src/layouts.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 57 "../budgie-extras-daemon/src/layouts.vala"
		g_clear_error (&_inner_error0_);
#line 57 "../budgie-extras-daemon/src/layouts.vala"
		return;
#line 306 "layouts.c"
	}
#line 46 "../budgie-extras-daemon/src/layouts.vala"
	_g_free0 (autostart_file);
#line 310 "layouts.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 66 "../budgie-extras-daemon/src/layouts.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 66 "../budgie-extras-daemon/src/layouts.vala"
	return _data1_;
#line 320 "layouts.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 66 "../budgie-extras-daemon/src/layouts.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 330 "layouts.c"
		LayoutsLayoutsManager* self;
#line 66 "../budgie-extras-daemon/src/layouts.vala"
		self = _data1_->self;
#line 66 "../budgie-extras-daemon/src/layouts.vala"
		_g_object_unref0 (_data1_->preference_settings);
#line 66 "../budgie-extras-daemon/src/layouts.vala"
		_g_object_unref0 (self);
#line 66 "../budgie-extras-daemon/src/layouts.vala"
		g_slice_free (Block1Data, _data1_);
#line 340 "layouts.c"
	}
}

static gboolean
__lambda4_ (Block1Data* _data1_)
{
	LayoutsLayoutsManager* self;
	GSettings* window_settings = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	gboolean result;
#line 72 "../budgie-extras-daemon/src/layouts.vala"
	self = _data1_->self;
#line 74 "../budgie-extras-daemon/src/layouts.vala"
	_tmp0_ = g_settings_new (LAYOUTS_nemo_window_schema);
#line 74 "../budgie-extras-daemon/src/layouts.vala"
	window_settings = _tmp0_;
#line 75 "../budgie-extras-daemon/src/layouts.vala"
	g_settings_set_boolean (window_settings, "start-with-menu-bar", _data1_->show_menu);
#line 76 "../budgie-extras-daemon/src/layouts.vala"
	_tmp1_ = _data1_->preference_settings;
#line 76 "../budgie-extras-daemon/src/layouts.vala"
	g_settings_set_boolean (_tmp1_, "disable-menu-warning", FALSE);
#line 77 "../budgie-extras-daemon/src/layouts.vala"
	result = FALSE;
#line 77 "../budgie-extras-daemon/src/layouts.vala"
	_g_object_unref0 (window_settings);
#line 77 "../budgie-extras-daemon/src/layouts.vala"
	return result;
#line 370 "layouts.c"
}

static gboolean
___lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda4_ (self);
#line 72 "../budgie-extras-daemon/src/layouts.vala"
	return result;
#line 380 "layouts.c"
}

static void
layouts_layouts_manager_show_nemo_menu (LayoutsLayoutsManager* self,
                                        gboolean show_menu)
{
	Block1Data* _data1_;
	GSettingsSchema* schema = NULL;
	GSettingsSchemaSource* _tmp0_;
	GSettingsSchema* _tmp1_;
	GSettingsSchema* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
#line 66 "../budgie-extras-daemon/src/layouts.vala"
	g_return_if_fail (self != NULL);
#line 66 "../budgie-extras-daemon/src/layouts.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 66 "../budgie-extras-daemon/src/layouts.vala"
	_data1_->_ref_count_ = 1;
#line 66 "../budgie-extras-daemon/src/layouts.vala"
	_data1_->self = g_object_ref (self);
#line 66 "../budgie-extras-daemon/src/layouts.vala"
	_data1_->show_menu = show_menu;
#line 67 "../budgie-extras-daemon/src/layouts.vala"
	_tmp0_ = g_settings_schema_source_get_default ();
#line 67 "../budgie-extras-daemon/src/layouts.vala"
	_tmp1_ = g_settings_schema_source_lookup (_tmp0_, LAYOUTS_nemo_window_schema, TRUE);
#line 67 "../budgie-extras-daemon/src/layouts.vala"
	schema = _tmp1_;
#line 68 "../budgie-extras-daemon/src/layouts.vala"
	_tmp2_ = schema;
#line 68 "../budgie-extras-daemon/src/layouts.vala"
	if (_tmp2_ == NULL) {
#line 69 "../budgie-extras-daemon/src/layouts.vala"
		_g_settings_schema_unref0 (schema);
#line 69 "../budgie-extras-daemon/src/layouts.vala"
		block1_data_unref (_data1_);
#line 69 "../budgie-extras-daemon/src/layouts.vala"
		_data1_ = NULL;
#line 69 "../budgie-extras-daemon/src/layouts.vala"
		return;
#line 422 "layouts.c"
	}
#line 70 "../budgie-extras-daemon/src/layouts.vala"
	_tmp3_ = g_settings_new (LAYOUTS_nemo_preferences_schema);
#line 70 "../budgie-extras-daemon/src/layouts.vala"
	_data1_->preference_settings = _tmp3_;
#line 71 "../budgie-extras-daemon/src/layouts.vala"
	_tmp4_ = _data1_->preference_settings;
#line 71 "../budgie-extras-daemon/src/layouts.vala"
	g_settings_set_boolean (_tmp4_, "disable-menu-warning", TRUE);
#line 72 "../budgie-extras-daemon/src/layouts.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, ___lambda4__gsource_func, block1_data_ref (_data1_), block1_data_unref);
#line 66 "../budgie-extras-daemon/src/layouts.vala"
	_g_settings_schema_unref0 (schema);
#line 66 "../budgie-extras-daemon/src/layouts.vala"
	block1_data_unref (_data1_);
#line 66 "../budgie-extras-daemon/src/layouts.vala"
	_data1_ = NULL;
#line 440 "layouts.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 462 "layouts.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 466 "layouts.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 472 "layouts.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 476 "layouts.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 480 "layouts.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 488 "layouts.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 516 "layouts.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 525 "layouts.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 539 "layouts.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 548 "layouts.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 562 "layouts.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 571 "layouts.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 580 "layouts.c"
}

static void
layouts_layouts_manager_start_plank (LayoutsLayoutsManager* self,
                                     gboolean centered)
{
	GError* _inner_error0_ = NULL;
#line 81 "../budgie-extras-daemon/src/layouts.vala"
	g_return_if_fail (self != NULL);
#line 82 "../budgie-extras-daemon/src/layouts.vala"
	layouts_layouts_manager_stop_plank (self);
#line 84 "../budgie-extras-daemon/src/layouts.vala"
	if (!g_file_test (LAYOUTS_plank_global_path, G_FILE_TEST_EXISTS)) {
#line 85 "../budgie-extras-daemon/src/layouts.vala"
		g_debug ("layouts.vala:85: does not exist %s", LAYOUTS_plank_global_path);
#line 86 "../budgie-extras-daemon/src/layouts.vala"
		return;
#line 598 "layouts.c"
	}
#line 89 "../budgie-extras-daemon/src/layouts.vala"
	if (centered) {
#line 602 "layouts.c"
		GSettings* plank_settings = NULL;
		GSettings* _tmp0_;
		gchar** docks = NULL;
		GSettings* _tmp1_;
		gchar** _tmp2_;
		gchar** _tmp3_;
		gint docks_length1;
		gint _docks_size_;
		gchar** _tmp4_;
		gint _tmp4__length1;
#line 90 "../budgie-extras-daemon/src/layouts.vala"
		_tmp0_ = g_settings_new (LAYOUTS_plank_schema);
#line 90 "../budgie-extras-daemon/src/layouts.vala"
		plank_settings = _tmp0_;
#line 91 "../budgie-extras-daemon/src/layouts.vala"
		_tmp1_ = plank_settings;
#line 91 "../budgie-extras-daemon/src/layouts.vala"
		_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "enabled-docks");
#line 91 "../budgie-extras-daemon/src/layouts.vala"
		docks = _tmp3_;
#line 91 "../budgie-extras-daemon/src/layouts.vala"
		docks_length1 = _vala_array_length (_tmp2_);
#line 91 "../budgie-extras-daemon/src/layouts.vala"
		_docks_size_ = docks_length1;
#line 93 "../budgie-extras-daemon/src/layouts.vala"
		_tmp4_ = docks;
#line 93 "../budgie-extras-daemon/src/layouts.vala"
		_tmp4__length1 = docks_length1;
#line 631 "layouts.c"
		{
			gchar** dock_collection = NULL;
			gint dock_collection_length1 = 0;
			gint _dock_collection_size_ = 0;
			gint dock_it = 0;
#line 93 "../budgie-extras-daemon/src/layouts.vala"
			dock_collection = _tmp4_;
#line 93 "../budgie-extras-daemon/src/layouts.vala"
			dock_collection_length1 = _tmp4__length1;
#line 93 "../budgie-extras-daemon/src/layouts.vala"
			for (dock_it = 0; dock_it < dock_collection_length1; dock_it = dock_it + 1) {
#line 643 "layouts.c"
				gchar* _tmp5_;
				gchar* dock = NULL;
#line 93 "../budgie-extras-daemon/src/layouts.vala"
				_tmp5_ = g_strdup (dock_collection[dock_it]);
#line 93 "../budgie-extras-daemon/src/layouts.vala"
				dock = _tmp5_;
#line 650 "layouts.c"
				{
					gchar* path = NULL;
					const gchar* _tmp6_;
					gchar* _tmp7_;
					GSettings* settings = NULL;
					const gchar* _tmp8_;
					GSettings* _tmp9_;
					GSettings* _tmp10_;
					GSettings* _tmp11_;
					GSettings* _tmp12_;
					GSettings* _tmp13_;
					GSettings* _tmp14_;
					GSettings* _tmp15_;
#line 94 "../budgie-extras-daemon/src/layouts.vala"
					_tmp6_ = dock;
#line 94 "../budgie-extras-daemon/src/layouts.vala"
					_tmp7_ = string_replace (LAYOUTS_plank_path, "xyz", _tmp6_);
#line 94 "../budgie-extras-daemon/src/layouts.vala"
					path = _tmp7_;
#line 95 "../budgie-extras-daemon/src/layouts.vala"
					_tmp8_ = path;
#line 95 "../budgie-extras-daemon/src/layouts.vala"
					_tmp9_ = g_settings_new_with_path (LAYOUTS_plank_settings_schema, _tmp8_);
#line 95 "../budgie-extras-daemon/src/layouts.vala"
					settings = _tmp9_;
#line 97 "../budgie-extras-daemon/src/layouts.vala"
					_tmp10_ = settings;
#line 97 "../budgie-extras-daemon/src/layouts.vala"
					g_settings_set_string (_tmp10_, "position", "bottom");
#line 98 "../budgie-extras-daemon/src/layouts.vala"
					_tmp11_ = settings;
#line 98 "../budgie-extras-daemon/src/layouts.vala"
					g_settings_set_string (_tmp11_, "theme", "Transparent");
#line 99 "../budgie-extras-daemon/src/layouts.vala"
					_tmp12_ = settings;
#line 99 "../budgie-extras-daemon/src/layouts.vala"
					g_settings_set_int (_tmp12_, "icon-size", 32);
#line 100 "../budgie-extras-daemon/src/layouts.vala"
					_tmp13_ = settings;
#line 100 "../budgie-extras-daemon/src/layouts.vala"
					g_settings_set_int (_tmp13_, "hide-delay", 500);
#line 101 "../budgie-extras-daemon/src/layouts.vala"
					_tmp14_ = settings;
#line 101 "../budgie-extras-daemon/src/layouts.vala"
					g_settings_set_string (_tmp14_, "hide-mode", "window-dodge");
#line 102 "../budgie-extras-daemon/src/layouts.vala"
					_tmp15_ = settings;
#line 102 "../budgie-extras-daemon/src/layouts.vala"
					g_settings_set_boolean (_tmp15_, "zoom-enabled", TRUE);
#line 103 "../budgie-extras-daemon/src/layouts.vala"
					_g_object_unref0 (settings);
#line 103 "../budgie-extras-daemon/src/layouts.vala"
					_g_free0 (path);
#line 103 "../budgie-extras-daemon/src/layouts.vala"
					_g_free0 (dock);
#line 103 "../budgie-extras-daemon/src/layouts.vala"
					break;
#line 708 "layouts.c"
				}
			}
		}
#line 89 "../budgie-extras-daemon/src/layouts.vala"
		docks = (_vala_array_free (docks, docks_length1, (GDestroyNotify) g_free), NULL);
#line 89 "../budgie-extras-daemon/src/layouts.vala"
		_g_object_unref0 (plank_settings);
#line 716 "layouts.c"
	}
	{
		gchar* autostart_folder = NULL;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		const gchar* _tmp18_;
		GFile* file = NULL;
		GFile* _tmp22_;
		GFile* dest = NULL;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		GFile* _tmp26_;
		GFile* _tmp27_;
		GFile* _tmp28_;
		GFile* _tmp29_;
#line 108 "../budgie-extras-daemon/src/layouts.vala"
		_tmp16_ = g_get_home_dir ();
#line 108 "../budgie-extras-daemon/src/layouts.vala"
		_tmp17_ = g_strconcat (_tmp16_, "/.config/autostart/", NULL);
#line 108 "../budgie-extras-daemon/src/layouts.vala"
		autostart_folder = _tmp17_;
#line 111 "../budgie-extras-daemon/src/layouts.vala"
		_tmp18_ = autostart_folder;
#line 111 "../budgie-extras-daemon/src/layouts.vala"
		if (!g_file_test (_tmp18_, G_FILE_TEST_IS_DIR)) {
#line 743 "layouts.c"
			GFile* folder = NULL;
			const gchar* _tmp19_;
			GFile* _tmp20_;
			GFile* _tmp21_;
#line 112 "../budgie-extras-daemon/src/layouts.vala"
			_tmp19_ = autostart_folder;
#line 112 "../budgie-extras-daemon/src/layouts.vala"
			_tmp20_ = g_file_new_for_path (_tmp19_);
#line 112 "../budgie-extras-daemon/src/layouts.vala"
			folder = _tmp20_;
#line 113 "../budgie-extras-daemon/src/layouts.vala"
			_tmp21_ = folder;
#line 113 "../budgie-extras-daemon/src/layouts.vala"
			g_file_make_directory (_tmp21_, NULL, &_inner_error0_);
#line 113 "../budgie-extras-daemon/src/layouts.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 113 "../budgie-extras-daemon/src/layouts.vala"
				_g_object_unref0 (folder);
#line 113 "../budgie-extras-daemon/src/layouts.vala"
				_g_free0 (autostart_folder);
#line 764 "layouts.c"
				goto __catch0_g_error;
			}
#line 111 "../budgie-extras-daemon/src/layouts.vala"
			_g_object_unref0 (folder);
#line 769 "layouts.c"
		}
#line 116 "../budgie-extras-daemon/src/layouts.vala"
		_tmp22_ = g_file_new_for_path (LAYOUTS_plank_global_path);
#line 116 "../budgie-extras-daemon/src/layouts.vala"
		file = _tmp22_;
#line 117 "../budgie-extras-daemon/src/layouts.vala"
		_tmp23_ = autostart_folder;
#line 117 "../budgie-extras-daemon/src/layouts.vala"
		_tmp24_ = g_strconcat (_tmp23_, "plank.desktop", NULL);
#line 117 "../budgie-extras-daemon/src/layouts.vala"
		_tmp25_ = _tmp24_;
#line 117 "../budgie-extras-daemon/src/layouts.vala"
		_tmp26_ = g_file_new_for_path (_tmp25_);
#line 117 "../budgie-extras-daemon/src/layouts.vala"
		_tmp27_ = _tmp26_;
#line 117 "../budgie-extras-daemon/src/layouts.vala"
		_g_free0 (_tmp25_);
#line 117 "../budgie-extras-daemon/src/layouts.vala"
		dest = _tmp27_;
#line 118 "../budgie-extras-daemon/src/layouts.vala"
		_tmp28_ = file;
#line 118 "../budgie-extras-daemon/src/layouts.vala"
		_tmp29_ = dest;
#line 118 "../budgie-extras-daemon/src/layouts.vala"
		g_file_copy (_tmp28_, _tmp29_, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error0_);
#line 118 "../budgie-extras-daemon/src/layouts.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 118 "../budgie-extras-daemon/src/layouts.vala"
			_g_object_unref0 (dest);
#line 118 "../budgie-extras-daemon/src/layouts.vala"
			_g_object_unref0 (file);
#line 118 "../budgie-extras-daemon/src/layouts.vala"
			_g_free0 (autostart_folder);
#line 803 "layouts.c"
			goto __catch0_g_error;
		}
#line 107 "../budgie-extras-daemon/src/layouts.vala"
		_g_object_unref0 (dest);
#line 107 "../budgie-extras-daemon/src/layouts.vala"
		_g_object_unref0 (file);
#line 107 "../budgie-extras-daemon/src/layouts.vala"
		_g_free0 (autostart_folder);
#line 812 "layouts.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp30_;
		const gchar* _tmp31_;
#line 107 "../budgie-extras-daemon/src/layouts.vala"
		e = _inner_error0_;
#line 107 "../budgie-extras-daemon/src/layouts.vala"
		_inner_error0_ = NULL;
#line 121 "../budgie-extras-daemon/src/layouts.vala"
		_tmp30_ = e;
#line 121 "../budgie-extras-daemon/src/layouts.vala"
		_tmp31_ = _tmp30_->message;
#line 121 "../budgie-extras-daemon/src/layouts.vala"
		g_warning ("layouts.vala:121: Cannot copy: %s", _tmp31_);
#line 107 "../budgie-extras-daemon/src/layouts.vala"
		_g_error_free0 (e);
#line 832 "layouts.c"
	}
	__finally0:
#line 107 "../budgie-extras-daemon/src/layouts.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 107 "../budgie-extras-daemon/src/layouts.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 107 "../budgie-extras-daemon/src/layouts.vala"
		g_clear_error (&_inner_error0_);
#line 107 "../budgie-extras-daemon/src/layouts.vala"
		return;
#line 843 "layouts.c"
	}
#line 124 "../budgie-extras-daemon/src/layouts.vala"
	layouts_layouts_manager_run_cmd (self, "nohup plank &>/dev/null", TRUE);
#line 847 "layouts.c"
}

static void
layouts_layouts_manager_appmenu_powerstrip (LayoutsLayoutsManager* self,
                                            gboolean enable)
{
	GSettingsSchema* schema = NULL;
	GSettingsSchemaSource* _tmp0_;
	GSettingsSchema* _tmp1_;
	GSettingsSchema* _tmp2_;
	GSettings* settings = NULL;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
#line 127 "../budgie-extras-daemon/src/layouts.vala"
	g_return_if_fail (self != NULL);
#line 128 "../budgie-extras-daemon/src/layouts.vala"
	_tmp0_ = g_settings_schema_source_get_default ();
#line 128 "../budgie-extras-daemon/src/layouts.vala"
	_tmp1_ = g_settings_schema_source_lookup (_tmp0_, LAYOUTS_appmenu_budgie_schema, TRUE);
#line 128 "../budgie-extras-daemon/src/layouts.vala"
	schema = _tmp1_;
#line 129 "../budgie-extras-daemon/src/layouts.vala"
	_tmp2_ = schema;
#line 129 "../budgie-extras-daemon/src/layouts.vala"
	if (_tmp2_ == NULL) {
#line 130 "../budgie-extras-daemon/src/layouts.vala"
		_g_settings_schema_unref0 (schema);
#line 130 "../budgie-extras-daemon/src/layouts.vala"
		return;
#line 877 "layouts.c"
	}
#line 131 "../budgie-extras-daemon/src/layouts.vala"
	_tmp3_ = g_settings_new (LAYOUTS_appmenu_budgie_schema);
#line 131 "../budgie-extras-daemon/src/layouts.vala"
	settings = _tmp3_;
#line 132 "../budgie-extras-daemon/src/layouts.vala"
	_tmp4_ = settings;
#line 132 "../budgie-extras-daemon/src/layouts.vala"
	g_settings_set_boolean (_tmp4_, "enable-powerstrip", enable);
#line 127 "../budgie-extras-daemon/src/layouts.vala"
	_g_object_unref0 (settings);
#line 127 "../budgie-extras-daemon/src/layouts.vala"
	_g_settings_schema_unref0 (schema);
#line 891 "layouts.c"
}

static void
layouts_layouts_manager_appmenu_categoryview (LayoutsLayoutsManager* self,
                                              gboolean show_category)
{
	GSettingsSchema* schema = NULL;
	GSettingsSchemaSource* _tmp0_;
	GSettingsSchema* _tmp1_;
	GSettingsSchema* _tmp2_;
	GSettings* settings = NULL;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
#line 135 "../budgie-extras-daemon/src/layouts.vala"
	g_return_if_fail (self != NULL);
#line 136 "../budgie-extras-daemon/src/layouts.vala"
	_tmp0_ = g_settings_schema_source_get_default ();
#line 136 "../budgie-extras-daemon/src/layouts.vala"
	_tmp1_ = g_settings_schema_source_lookup (_tmp0_, LAYOUTS_appmenu_budgie_schema, TRUE);
#line 136 "../budgie-extras-daemon/src/layouts.vala"
	schema = _tmp1_;
#line 137 "../budgie-extras-daemon/src/layouts.vala"
	_tmp2_ = schema;
#line 137 "../budgie-extras-daemon/src/layouts.vala"
	if (_tmp2_ == NULL) {
#line 138 "../budgie-extras-daemon/src/layouts.vala"
		_g_settings_schema_unref0 (schema);
#line 138 "../budgie-extras-daemon/src/layouts.vala"
		return;
#line 921 "layouts.c"
	}
#line 139 "../budgie-extras-daemon/src/layouts.vala"
	_tmp3_ = g_settings_new (LAYOUTS_appmenu_budgie_schema);
#line 139 "../budgie-extras-daemon/src/layouts.vala"
	settings = _tmp3_;
#line 140 "../budgie-extras-daemon/src/layouts.vala"
	_tmp4_ = settings;
#line 140 "../budgie-extras-daemon/src/layouts.vala"
	g_settings_set_boolean (_tmp4_, "use-category", show_category);
#line 135 "../budgie-extras-daemon/src/layouts.vala"
	_g_object_unref0 (settings);
#line 135 "../budgie-extras-daemon/src/layouts.vala"
	_g_settings_schema_unref0 (schema);
#line 935 "layouts.c"
}

static void
layouts_layouts_manager_leftside_buttons (LayoutsLayoutsManager* self,
                                          gboolean leftside)
{
	GSettings* settings = NULL;
	GSettings* _tmp0_;
#line 143 "../budgie-extras-daemon/src/layouts.vala"
	g_return_if_fail (self != NULL);
#line 144 "../budgie-extras-daemon/src/layouts.vala"
	_tmp0_ = g_settings_new (LAYOUTS_budgiewm_schema);
#line 144 "../budgie-extras-daemon/src/layouts.vala"
	settings = _tmp0_;
#line 145 "../budgie-extras-daemon/src/layouts.vala"
	if (leftside) {
#line 952 "layouts.c"
		GSettings* _tmp1_;
#line 146 "../budgie-extras-daemon/src/layouts.vala"
		_tmp1_ = settings;
#line 146 "../budgie-extras-daemon/src/layouts.vala"
		g_settings_set_string (_tmp1_, "button-style", "left");
#line 958 "layouts.c"
	} else {
		GSettings* _tmp2_;
#line 149 "../budgie-extras-daemon/src/layouts.vala"
		_tmp2_ = settings;
#line 149 "../budgie-extras-daemon/src/layouts.vala"
		g_settings_set_string (_tmp2_, "button-style", "traditional");
#line 965 "layouts.c"
	}
#line 143 "../budgie-extras-daemon/src/layouts.vala"
	_g_object_unref0 (settings);
#line 969 "layouts.c"
}

static void
layouts_layouts_manager_reset_panel (LayoutsLayoutsManager* self)
{
#line 153 "../budgie-extras-daemon/src/layouts.vala"
	g_return_if_fail (self != NULL);
#line 154 "../budgie-extras-daemon/src/layouts.vala"
	layouts_layouts_manager_run_cmd (self, "nohup budgie-panel --reset --replace &>/dev/null", TRUE);
#line 979 "layouts.c"
}

static gboolean
__lambda5_ (LayoutsLayoutsManager* self)
{
	gboolean result;
#line 206 "../budgie-extras-daemon/src/layouts.vala"
	layouts_layouts_manager_reset_panel (self);
#line 207 "../budgie-extras-daemon/src/layouts.vala"
	result = FALSE;
#line 207 "../budgie-extras-daemon/src/layouts.vala"
	return result;
#line 992 "layouts.c"
}

static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ ((LayoutsLayoutsManager*) self);
#line 205 "../budgie-extras-daemon/src/layouts.vala"
	return result;
#line 1002 "layouts.c"
}

void
layouts_layouts_manager_reset (LayoutsLayoutsManager* self,
                               const gchar* layout_name)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 165 "../budgie-extras-daemon/src/layouts.vala"
	static GQuark _tmp1_label0 = 0;
#line 165 "../budgie-extras-daemon/src/layouts.vala"
	static GQuark _tmp1_label1 = 0;
#line 165 "../budgie-extras-daemon/src/layouts.vala"
	static GQuark _tmp1_label2 = 0;
#line 165 "../budgie-extras-daemon/src/layouts.vala"
	static GQuark _tmp1_label3 = 0;
#line 165 "../budgie-extras-daemon/src/layouts.vala"
	static GQuark _tmp1_label4 = 0;
#line 165 "../budgie-extras-daemon/src/layouts.vala"
	static GQuark _tmp1_label5 = 0;
#line 165 "../budgie-extras-daemon/src/layouts.vala"
	static GQuark _tmp1_label6 = 0;
#line 1025 "layouts.c"
	GSettings* settings = NULL;
	GSettings* _tmp3_;
#line 157 "../budgie-extras-daemon/src/layouts.vala"
	g_return_if_fail (self != NULL);
#line 157 "../budgie-extras-daemon/src/layouts.vala"
	g_return_if_fail (layout_name != NULL);
#line 159 "../budgie-extras-daemon/src/layouts.vala"
	layouts_layouts_manager_stop_plank (self);
#line 160 "../budgie-extras-daemon/src/layouts.vala"
	layouts_layouts_manager_appmenu_powerstrip (self, FALSE);
#line 161 "../budgie-extras-daemon/src/layouts.vala"
	layouts_layouts_manager_appmenu_categoryview (self, FALSE);
#line 162 "../budgie-extras-daemon/src/layouts.vala"
	layouts_layouts_manager_leftside_buttons (self, FALSE);
#line 163 "../budgie-extras-daemon/src/layouts.vala"
	layouts_layouts_manager_show_nemo_menu (self, FALSE);
#line 165 "../budgie-extras-daemon/src/layouts.vala"
	_tmp0_ = layout_name;
#line 165 "../budgie-extras-daemon/src/layouts.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 165 "../budgie-extras-daemon/src/layouts.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("ubuntubudgie")))) {
#line 165 "../budgie-extras-daemon/src/layouts.vala"
		switch (0) {
#line 1050 "layouts.c"
			default:
			{
				{
#line 168 "../budgie-extras-daemon/src/layouts.vala"
					break;
#line 1056 "layouts.c"
				}
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("classicubuntubudgie")))) {
#line 165 "../budgie-extras-daemon/src/layouts.vala"
		switch (0) {
#line 1063 "layouts.c"
			default:
			{
				{
#line 172 "../budgie-extras-daemon/src/layouts.vala"
					break;
#line 1069 "layouts.c"
				}
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("cupertino")))) {
#line 165 "../budgie-extras-daemon/src/layouts.vala"
		switch (0) {
#line 1076 "layouts.c"
			default:
			{
				{
#line 175 "../budgie-extras-daemon/src/layouts.vala"
					layouts_layouts_manager_appmenu_powerstrip (self, TRUE);
#line 176 "../budgie-extras-daemon/src/layouts.vala"
					layouts_layouts_manager_appmenu_categoryview (self, TRUE);
#line 177 "../budgie-extras-daemon/src/layouts.vala"
					layouts_layouts_manager_leftside_buttons (self, TRUE);
#line 178 "../budgie-extras-daemon/src/layouts.vala"
					layouts_layouts_manager_show_nemo_menu (self, TRUE);
#line 179 "../budgie-extras-daemon/src/layouts.vala"
					break;
#line 1090 "layouts.c"
				}
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("theone")))) {
#line 165 "../budgie-extras-daemon/src/layouts.vala"
		switch (0) {
#line 1097 "layouts.c"
			default:
			{
				{
#line 182 "../budgie-extras-daemon/src/layouts.vala"
					layouts_layouts_manager_leftside_buttons (self, TRUE);
#line 183 "../budgie-extras-daemon/src/layouts.vala"
					layouts_layouts_manager_show_nemo_menu (self, TRUE);
#line 184 "../budgie-extras-daemon/src/layouts.vala"
					break;
#line 1107 "layouts.c"
				}
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("redmond")))) {
#line 165 "../budgie-extras-daemon/src/layouts.vala"
		switch (0) {
#line 1114 "layouts.c"
			default:
			{
				{
#line 187 "../budgie-extras-daemon/src/layouts.vala"
					layouts_layouts_manager_appmenu_powerstrip (self, TRUE);
#line 188 "../budgie-extras-daemon/src/layouts.vala"
					layouts_layouts_manager_appmenu_categoryview (self, TRUE);
#line 189 "../budgie-extras-daemon/src/layouts.vala"
					break;
#line 1124 "layouts.c"
				}
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("eleven")))) {
#line 165 "../budgie-extras-daemon/src/layouts.vala"
		switch (0) {
#line 1131 "layouts.c"
			default:
			{
				{
#line 192 "../budgie-extras-daemon/src/layouts.vala"
					layouts_layouts_manager_appmenu_powerstrip (self, TRUE);
#line 193 "../budgie-extras-daemon/src/layouts.vala"
					break;
#line 1139 "layouts.c"
				}
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label6) ? _tmp1_label6 : (_tmp1_label6 = g_quark_from_static_string ("chrome")))) {
#line 165 "../budgie-extras-daemon/src/layouts.vala"
		switch (0) {
#line 1146 "layouts.c"
			default:
			{
				{
#line 197 "../budgie-extras-daemon/src/layouts.vala"
					break;
#line 1152 "layouts.c"
				}
			}
		}
	} else {
#line 165 "../budgie-extras-daemon/src/layouts.vala"
		switch (0) {
#line 1159 "layouts.c"
			default:
			{
				{
#line 200 "../budgie-extras-daemon/src/layouts.vala"
					break;
#line 1165 "layouts.c"
				}
			}
		}
	}
#line 203 "../budgie-extras-daemon/src/layouts.vala"
	_tmp3_ = g_settings_new (LAYOUTS_panel_schema);
#line 203 "../budgie-extras-daemon/src/layouts.vala"
	settings = _tmp3_;
#line 204 "../budgie-extras-daemon/src/layouts.vala"
	g_settings_set_string (settings, "layout", layout_name);
#line 205 "../budgie-extras-daemon/src/layouts.vala"
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, ___lambda5__gsource_func, g_object_ref (self), g_object_unref);
#line 157 "../budgie-extras-daemon/src/layouts.vala"
	_g_object_unref0 (settings);
#line 1180 "layouts.c"
}

LayoutsLayoutsManager*
layouts_layouts_manager_construct (GType object_type)
{
	LayoutsLayoutsManager * self = NULL;
#line 29 "../budgie-extras-daemon/src/layouts.vala"
	self = (LayoutsLayoutsManager*) g_object_new (object_type, NULL);
#line 29 "../budgie-extras-daemon/src/layouts.vala"
	return self;
#line 1191 "layouts.c"
}

LayoutsLayoutsManager*
layouts_layouts_manager_new (void)
{
#line 29 "../budgie-extras-daemon/src/layouts.vala"
	return layouts_layouts_manager_construct (LAYOUTS_TYPE_LAYOUTS_MANAGER);
#line 1199 "layouts.c"
}

static void
layouts_layouts_manager_class_init (LayoutsLayoutsManagerClass * klass,
                                    gpointer klass_data)
{
#line 29 "../budgie-extras-daemon/src/layouts.vala"
	layouts_layouts_manager_parent_class = g_type_class_peek_parent (klass);
#line 1208 "layouts.c"
}

static void
layouts_layouts_manager_instance_init (LayoutsLayoutsManager * self,
                                       gpointer klass)
{
}

static GType
layouts_layouts_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LayoutsLayoutsManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) layouts_layouts_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LayoutsLayoutsManager), 0, (GInstanceInitFunc) layouts_layouts_manager_instance_init, NULL };
	GType layouts_layouts_manager_type_id;
	layouts_layouts_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "LayoutsLayoutsManager", &g_define_type_info, 0);
	return layouts_layouts_manager_type_id;
}

GType
layouts_layouts_manager_get_type (void)
{
	static volatile gsize layouts_layouts_manager_type_id__once = 0;
	if (g_once_init_enter (&layouts_layouts_manager_type_id__once)) {
		GType layouts_layouts_manager_type_id;
		layouts_layouts_manager_type_id = layouts_layouts_manager_get_type_once ();
		g_once_init_leave (&layouts_layouts_manager_type_id__once, layouts_layouts_manager_type_id);
	}
	return layouts_layouts_manager_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

