/* main.c generated by valac 0.56.18, the Vala compiler
 * generated from main.vala, do not modify */

/*
* BudgieExtrasDaemon
* Author: David Mohammed
* Copyright © 2019 Ubuntu Budgie Developers
* Website=https://ubuntubudgie.org
* This program is free software: you can redistribute it and/or modify it
* under the terms of the GNU General Public License as published by the Free
* Software Foundation, either version 3 of the License, or any later version.
* This program is distributed in the hope that it will be useful, but WITHOUT
* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
* FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
* more details. You should have received a copy of the GNU General Public
* License along with this program.  If not, see
* <https://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define BUDGIE_EXTRAS_TYPE_KEYBINDER_MANAGER (budgie_extras_keybinder_manager_get_type ())
#define BUDGIE_EXTRAS_KEYBINDER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BUDGIE_EXTRAS_TYPE_KEYBINDER_MANAGER, BudgieExtrasKeybinderManager))
#define BUDGIE_EXTRAS_KEYBINDER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BUDGIE_EXTRAS_TYPE_KEYBINDER_MANAGER, BudgieExtrasKeybinderManagerClass))
#define BUDGIE_EXTRAS_IS_KEYBINDER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BUDGIE_EXTRAS_TYPE_KEYBINDER_MANAGER))
#define BUDGIE_EXTRAS_IS_KEYBINDER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BUDGIE_EXTRAS_TYPE_KEYBINDER_MANAGER))
#define BUDGIE_EXTRAS_KEYBINDER_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BUDGIE_EXTRAS_TYPE_KEYBINDER_MANAGER, BudgieExtrasKeybinderManagerClass))

typedef struct _BudgieExtrasKeybinderManager BudgieExtrasKeybinderManager;
typedef struct _BudgieExtrasKeybinderManagerClass BudgieExtrasKeybinderManagerClass;
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

VALA_EXTERN gboolean replace;
gboolean replace = FALSE;
VALA_EXTERN gboolean budgie_extras_setup;
gboolean budgie_extras_setup = FALSE;
VALA_EXTERN gboolean budgie_extras_spammed;
gboolean budgie_extras_spammed = FALSE;

VALA_EXTERN void budgie_extras_DaemonNameLost (GDBusConnection* conn,
                                   const gchar* name);
static gint _vala_main (gchar** args,
                 gint args_length1);
VALA_EXTERN GType budgie_extras_keybinder_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BudgieExtrasKeybinderManager, g_object_unref)
VALA_EXTERN BudgieExtrasKeybinderManager* budgie_extras_keybinder_manager_new (gboolean replace);
VALA_EXTERN BudgieExtrasKeybinderManager* budgie_extras_keybinder_manager_construct (GType object_type,
                                                                         gboolean replace);

const GOptionEntry options[2] = {{"replace", (gchar) 0, (gint) 0, G_OPTION_ARG_NONE, &replace, "Replace currently running daemon"}, {NULL}};

void
budgie_extras_DaemonNameLost (GDBusConnection* conn,
                              const gchar* name)
{
#line 33 "../budgie-extras-daemon/src/main.vala"
	g_return_if_fail (conn != NULL);
#line 33 "../budgie-extras-daemon/src/main.vala"
	g_return_if_fail (name != NULL);
#line 35 "../budgie-extras-daemon/src/main.vala"
	g_warning ("main.vala:35: budgie-extras-daemon lost d-bus name %s", name);
#line 36 "../budgie-extras-daemon/src/main.vala"
	if (!budgie_extras_spammed) {
#line 37 "../budgie-extras-daemon/src/main.vala"
		if (budgie_extras_setup) {
#line 38 "../budgie-extras-daemon/src/main.vala"
			g_message ("main.vala:38: Replaced existing budgie-extras-daemon");
#line 92 "main.c"
		} else {
#line 40 "../budgie-extras-daemon/src/main.vala"
			g_message ("main.vala:40: Another instance of budgie-extras-daemon is running. Use" \
" --replace");
#line 96 "main.c"
		}
#line 42 "../budgie-extras-daemon/src/main.vala"
		budgie_extras_spammed = TRUE;
#line 100 "main.c"
	}
#line 44 "../budgie-extras-daemon/src/main.vala"
	gtk_main_quit ();
#line 104 "main.c"
}

/**
 * Main entry for the daemon
 */
static gint
_vala_main (gchar** args,
            gint args_length1)
{
	GOptionContext* ctx = NULL;
	BudgieExtrasKeybinderManager* manager = NULL;
	GOptionContext* _tmp0_;
	GOptionContext* _tmp1_;
	GOptionContext* _tmp2_;
	GOptionContext* _tmp3_;
	GOptionGroup* _tmp4_;
	BudgieExtrasKeybinderManager* _tmp9_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 52 "../budgie-extras-daemon/src/main.vala"
	gtk_init ((gint*) (&args_length1), &args);
#line 55 "../budgie-extras-daemon/src/main.vala"
	manager = NULL;
#line 57 "../budgie-extras-daemon/src/main.vala"
	_tmp0_ = g_option_context_new ("- Budgie Extras Daemon");
#line 57 "../budgie-extras-daemon/src/main.vala"
	_g_option_context_free0 (ctx);
#line 57 "../budgie-extras-daemon/src/main.vala"
	ctx = _tmp0_;
#line 58 "../budgie-extras-daemon/src/main.vala"
	_tmp1_ = ctx;
#line 58 "../budgie-extras-daemon/src/main.vala"
	g_option_context_set_help_enabled (_tmp1_, TRUE);
#line 59 "../budgie-extras-daemon/src/main.vala"
	_tmp2_ = ctx;
#line 59 "../budgie-extras-daemon/src/main.vala"
	g_option_context_add_main_entries (_tmp2_, options, NULL);
#line 60 "../budgie-extras-daemon/src/main.vala"
	_tmp3_ = ctx;
#line 60 "../budgie-extras-daemon/src/main.vala"
	_tmp4_ = gtk_get_option_group (FALSE);
#line 60 "../budgie-extras-daemon/src/main.vala"
	g_option_context_add_group (_tmp3_, _tmp4_);
#line 148 "main.c"
	{
		GOptionContext* _tmp5_;
#line 63 "../budgie-extras-daemon/src/main.vala"
		_tmp5_ = ctx;
#line 63 "../budgie-extras-daemon/src/main.vala"
		g_option_context_parse (_tmp5_, (gint*) (&args_length1), &args, &_inner_error0_);
#line 63 "../budgie-extras-daemon/src/main.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 157 "main.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 62 "../budgie-extras-daemon/src/main.vala"
		e = _inner_error0_;
#line 62 "../budgie-extras-daemon/src/main.vala"
		_inner_error0_ = NULL;
#line 65 "../budgie-extras-daemon/src/main.vala"
		_tmp6_ = e;
#line 65 "../budgie-extras-daemon/src/main.vala"
		_tmp7_ = _tmp6_->message;
#line 65 "../budgie-extras-daemon/src/main.vala"
		g_message ("main.vala:65: Error: %s\n", _tmp7_);
#line 66 "../budgie-extras-daemon/src/main.vala"
		result = 0;
#line 66 "../budgie-extras-daemon/src/main.vala"
		_g_error_free0 (e);
#line 66 "../budgie-extras-daemon/src/main.vala"
		_g_object_unref0 (manager);
#line 66 "../budgie-extras-daemon/src/main.vala"
		_g_option_context_free0 (ctx);
#line 66 "../budgie-extras-daemon/src/main.vala"
		return result;
#line 187 "main.c"
	}
	__finally0:
#line 62 "../budgie-extras-daemon/src/main.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 192 "main.c"
		gint _tmp8_ = -1;
#line 62 "../budgie-extras-daemon/src/main.vala"
		_g_object_unref0 (manager);
#line 62 "../budgie-extras-daemon/src/main.vala"
		_g_option_context_free0 (ctx);
#line 62 "../budgie-extras-daemon/src/main.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 62 "../budgie-extras-daemon/src/main.vala"
		g_clear_error (&_inner_error0_);
#line 62 "../budgie-extras-daemon/src/main.vala"
		return _tmp8_;
#line 204 "main.c"
	}
#line 69 "../budgie-extras-daemon/src/main.vala"
	_tmp9_ = budgie_extras_keybinder_manager_new (replace);
#line 69 "../budgie-extras-daemon/src/main.vala"
	_g_object_unref0 (manager);
#line 69 "../budgie-extras-daemon/src/main.vala"
	manager = _tmp9_;
#line 72 "../budgie-extras-daemon/src/main.vala"
	gtk_main ();
#line 75 "../budgie-extras-daemon/src/main.vala"
	_g_object_unref0 (manager);
#line 75 "../budgie-extras-daemon/src/main.vala"
	manager = NULL;
#line 77 "../budgie-extras-daemon/src/main.vala"
	result = 0;
#line 77 "../budgie-extras-daemon/src/main.vala"
	_g_object_unref0 (manager);
#line 77 "../budgie-extras-daemon/src/main.vala"
	_g_option_context_free0 (ctx);
#line 77 "../budgie-extras-daemon/src/main.vala"
	return result;
#line 226 "main.c"
}

int
main (int argc,
      char ** argv)
{
#line 51 "../budgie-extras-daemon/src/main.vala"
	return _vala_main (argv, argc);
#line 235 "main.c"
}

