/* Applet.c generated by valac 0.56.18, the Vala compiler
 * generated from Applet.vala, do not modify */

/*
* Copyright (c) 2018-2020 Daniel Pinto (https://github.com/danielpinto8zz6/budgie-network-applet)
* Copyright (c) 2015-2018 elementary LLC (https://elementary.io)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU Library General Public License as published by
* the Free Software Foundation, either version 2.1 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Library General Public License for more details.
*
* You should have received a copy of the GNU Library General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
*/

#include "networkapplet.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <plugin.h>
#include <glib-object.h>
#include <locale.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <libpeas/peas.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	NETWORK_PLUGIN_0_PROPERTY,
	NETWORK_PLUGIN_NUM_PROPERTIES
};
static GParamSpec* network_plugin_properties[NETWORK_PLUGIN_NUM_PROPERTIES];
enum  {
	NETWORK_APPLET_0_PROPERTY,
	NETWORK_APPLET_NUM_PROPERTIES
};
static GParamSpec* network_applet_properties[NETWORK_APPLET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NetworkAppletPrivate {
	BudgiePopover* popover;
	BudgiePopoverManager* manager;
	NetworkWidgetsPopoverWidget* popover_widget;
	NetworkWidgetsDisplayWidget* display_widget;
};

static gpointer network_plugin_parent_class = NULL;
static BudgiePluginIface * network_plugin_budgie_plugin_parent_iface = NULL;
static GType network_plugin_type_id = 0;
static gint NetworkApplet_private_offset;
static gpointer network_applet_parent_class = NULL;
static GType network_applet_type_id = 0;

static BudgieApplet* network_plugin_real_get_panel_widget (BudgiePlugin* base,
                                                    const gchar* uuid);
static void network_applet_on_state_changed (NetworkApplet* self);
static void _network_applet_on_state_changed_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self);
static void __lambda41_ (NetworkApplet* self);
static void ___lambda41__network_widgets_popover_widget_settings_shown (NetworkWidgetsPopoverWidget* _sender,
                                                                 gpointer self);
static gboolean __lambda42_ (NetworkApplet* self,
                      GdkEventButton* e);
static gboolean ___lambda42__gtk_widget_button_press_event (GtkWidget* _sender,
                                                     GdkEventButton* event,
                                                     gpointer self);
static void network_applet_real_update_popovers (BudgieApplet* base,
                                          BudgiePopoverManager* manager);
static void network_applet_finalize (GObject * obj);
GType network_widgets_nm_visualizer_register_type (GTypeModule * module);
GType network_widgets_display_widget_register_type (GTypeModule * module);
GType network_widgets_popover_widget_register_type (GTypeModule * module);
GType network_widgets_separator_register_type (GTypeModule * module);
GType network_widgets_switch_register_type (GTypeModule * module);
GType network_widgets_overlay_icon_register_type (GTypeModule * module);
GType network_widget_nm_interface_register_type (GTypeModule * module);
GType network_abstract_ether_interface_register_type (GTypeModule * module);
GType network_abstract_modem_interface_register_type (GTypeModule * module);
GType network_abstract_vpn_interface_register_type (GTypeModule * module);
GType network_abstract_wifi_interface_register_type (GTypeModule * module);
GType network_abstract_bluetooth_interface_register_type (GTypeModule * module);
GType network_vpn_menu_item_register_type (GTypeModule * module);
GType network_wifi_menu_item_register_type (GTypeModule * module);
GType network_ether_interface_register_type (GTypeModule * module);
GType network_modem_interface_register_type (GTypeModule * module);
GType network_vpn_interface_register_type (GTypeModule * module);
GType network_wifi_interface_register_type (GTypeModule * module);
GType network_bluetooth_interface_register_type (GTypeModule * module);
GType rf_kill_device_register_type (GTypeModule * module);
GType rf_kill_manager_register_type (GTypeModule * module);

static BudgieApplet*
network_plugin_real_get_panel_widget (BudgiePlugin* base,
                                      const gchar* uuid)
{
	NetworkPlugin * self;
	NetworkApplet* _tmp0_;
	BudgieApplet* result;
#line 22 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	self = (NetworkPlugin*) base;
#line 22 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 23 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp0_ = network_applet_new ();
#line 23 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	g_object_ref_sink (_tmp0_);
#line 23 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	result = (BudgieApplet*) _tmp0_;
#line 23 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	return result;
#line 133 "Applet.c"
}

NetworkPlugin*
network_plugin_construct (GType object_type)
{
	NetworkPlugin * self = NULL;
#line 21 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	self = (NetworkPlugin*) g_object_new (object_type, NULL);
#line 21 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	return self;
#line 144 "Applet.c"
}

NetworkPlugin*
network_plugin_new (void)
{
#line 21 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	return network_plugin_construct (NETWORK_TYPE_PLUGIN);
#line 152 "Applet.c"
}

static void
network_plugin_class_init (NetworkPluginClass * klass,
                           gpointer klass_data)
{
#line 21 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_plugin_parent_class = g_type_class_peek_parent (klass);
#line 161 "Applet.c"
}

static void
network_plugin_budgie_plugin_interface_init (BudgiePluginIface * iface,
                                             gpointer iface_data)
{
#line 21 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_plugin_budgie_plugin_parent_iface = g_type_interface_peek_parent (iface);
#line 21 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	iface->get_panel_widget = (BudgieApplet* (*) (BudgiePlugin*, const gchar*)) network_plugin_real_get_panel_widget;
#line 172 "Applet.c"
}

static void
network_plugin_instance_init (NetworkPlugin * self,
                              gpointer klass)
{
}

GType
network_plugin_get_type (void)
{
	return network_plugin_type_id;
}

GType
network_plugin_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkPluginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_plugin_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkPlugin), 0, (GInstanceInitFunc) network_plugin_instance_init, NULL };
	static const GInterfaceInfo budgie_plugin_info = { (GInterfaceInitFunc) network_plugin_budgie_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	network_plugin_type_id = g_type_module_register_type (module, peas_extension_base_get_type (), "NetworkPlugin", &g_define_type_info, 0);
	g_type_module_add_interface (module, network_plugin_type_id, budgie_plugin_get_type (), &budgie_plugin_info);
	return network_plugin_type_id;
}

static inline gpointer
network_applet_get_instance_private (NetworkApplet* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkApplet_private_offset);
}

static void
_network_applet_on_state_changed_g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self)
{
#line 57 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_applet_on_state_changed ((NetworkApplet*) self);
#line 210 "Applet.c"
}

static void
__lambda41_ (NetworkApplet* self)
{
	BudgiePopover* _tmp0_;
#line 60 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp0_ = self->priv->popover;
#line 60 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 221 "Applet.c"
}

static void
___lambda41__network_widgets_popover_widget_settings_shown (NetworkWidgetsPopoverWidget* _sender,
                                                            gpointer self)
{
#line 60 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	__lambda41_ ((NetworkApplet*) self);
#line 230 "Applet.c"
}

static gboolean
__lambda42_ (NetworkApplet* self,
             GdkEventButton* e)
{
	BudgiePopover* _tmp0_;
	gboolean result;
#line 62 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 63 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	if (e->button != ((guint) 1)) {
#line 64 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
		result = GDK_EVENT_PROPAGATE;
#line 64 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
		return result;
#line 247 "Applet.c"
	}
#line 66 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp0_ = self->priv->popover;
#line 66 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	if (gtk_widget_get_visible ((GtkWidget*) _tmp0_)) {
#line 253 "Applet.c"
		BudgiePopover* _tmp1_;
#line 67 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
		_tmp1_ = self->priv->popover;
#line 67 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 259 "Applet.c"
	} else {
		BudgiePopoverManager* _tmp2_;
		GtkEventBox* _tmp3_;
#line 69 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
		_tmp2_ = self->priv->manager;
#line 69 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
		_tmp3_ = self->widget;
#line 69 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
		budgie_popover_manager_show_popover (_tmp2_, (GtkWidget*) _tmp3_);
#line 269 "Applet.c"
	}
#line 71 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	result = GDK_EVENT_STOP;
#line 71 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	return result;
#line 275 "Applet.c"
}

static gboolean
___lambda42__gtk_widget_button_press_event (GtkWidget* _sender,
                                            GdkEventButton* event,
                                            gpointer self)
{
	gboolean result;
	result = __lambda42_ ((NetworkApplet*) self, event);
#line 62 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	return result;
#line 287 "Applet.c"
}

NetworkApplet*
network_applet_construct (GType object_type)
{
	NetworkApplet * self = NULL;
	GtkEventBox* _tmp0_;
	GtkEventBox* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkEventBox* _tmp3_;
	BudgiePopover* _tmp4_;
	NetworkWidgetsDisplayWidget* _tmp5_;
	GtkEventBox* _tmp6_;
	NetworkWidgetsDisplayWidget* _tmp7_;
	NetworkWidgetsPopoverWidget* _tmp8_;
	NetworkWidgetsPopoverWidget* _tmp9_;
	NetworkWidgetsPopoverWidget* _tmp10_;
	BudgiePopover* _tmp11_;
	NetworkWidgetsPopoverWidget* _tmp12_;
	NetworkWidgetsPopoverWidget* _tmp13_;
	NetworkWidgetsPopoverWidget* _tmp14_;
	NetworkWidgetsPopoverWidget* _tmp15_;
	NetworkWidgetsPopoverWidget* _tmp16_;
	GtkEventBox* _tmp17_;
	BudgiePopover* _tmp18_;
	GtkWidget* _tmp19_;
#line 37 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	self = (NetworkApplet*) g_object_new (object_type, NULL);
#line 38 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	setlocale (LC_ALL, "");
#line 39 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	bindtextdomain (CONFIG_GETTEXT_PACKAGE, CONFIG_LOCALE_DIR);
#line 40 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	bind_textdomain_codeset (CONFIG_GETTEXT_PACKAGE, "UTF-8");
#line 41 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	textdomain (CONFIG_GETTEXT_PACKAGE);
#line 43 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp0_ = (GtkEventBox*) gtk_event_box_new ();
#line 43 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	g_object_ref_sink (_tmp0_);
#line 43 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_g_object_unref0 (self->widget);
#line 43 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	self->widget = _tmp0_;
#line 44 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp1_ = self->widget;
#line 44 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp1_);
#line 46 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 46 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	gtk_style_context_add_class (_tmp2_, "budgie-network-applet");
#line 48 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp3_ = self->widget;
#line 48 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp4_ = (BudgiePopover*) budgie_popover_new ((GtkWidget*) _tmp3_);
#line 48 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	g_object_ref_sink (_tmp4_);
#line 48 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_g_object_unref0 (self->priv->popover);
#line 48 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	self->priv->popover = _tmp4_;
#line 50 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp5_ = network_widgets_display_widget_new ();
#line 50 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	g_object_ref_sink (_tmp5_);
#line 50 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_g_object_unref0 (self->priv->display_widget);
#line 50 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	self->priv->display_widget = _tmp5_;
#line 51 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp6_ = self->widget;
#line 51 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp7_ = self->priv->display_widget;
#line 51 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
#line 53 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp8_ = network_widgets_popover_widget_new ();
#line 53 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	g_object_ref_sink (_tmp8_);
#line 53 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_g_object_unref0 (self->priv->popover_widget);
#line 53 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	self->priv->popover_widget = _tmp8_;
#line 54 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp9_ = self->priv->popover_widget;
#line 54 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	g_object_set ((GtkWidget*) _tmp9_, "width-request", 250, NULL);
#line 55 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp10_ = self->priv->popover_widget;
#line 55 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp10_, (guint) 6);
#line 56 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp11_ = self->priv->popover;
#line 56 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp12_ = self->priv->popover_widget;
#line 56 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	gtk_container_add ((GtkContainer*) _tmp11_, (GtkWidget*) _tmp12_);
#line 57 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp13_ = self->priv->popover_widget;
#line 57 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	g_signal_connect_object ((GObject*) _tmp13_, "notify::state", (GCallback) _network_applet_on_state_changed_g_object_notify, self, 0);
#line 58 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp14_ = self->priv->popover_widget;
#line 58 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	g_signal_connect_object ((GObject*) _tmp14_, "notify::secure", (GCallback) _network_applet_on_state_changed_g_object_notify, self, 0);
#line 59 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp15_ = self->priv->popover_widget;
#line 59 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	g_signal_connect_object ((GObject*) _tmp15_, "notify::extra-info", (GCallback) _network_applet_on_state_changed_g_object_notify, self, 0);
#line 60 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp16_ = self->priv->popover_widget;
#line 60 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	g_signal_connect_object (_tmp16_, "settings-shown", (GCallback) ___lambda41__network_widgets_popover_widget_settings_shown, self, 0);
#line 62 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp17_ = self->widget;
#line 62 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	g_signal_connect_object ((GtkWidget*) _tmp17_, "button-press-event", (GCallback) ___lambda42__gtk_widget_button_press_event, self, 0);
#line 74 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp18_ = self->priv->popover;
#line 74 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp19_ = gtk_bin_get_child ((GtkBin*) _tmp18_);
#line 74 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	gtk_widget_show_all (_tmp19_);
#line 76 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 78 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_applet_on_state_changed (self);
#line 37 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	return self;
#line 418 "Applet.c"
}

NetworkApplet*
network_applet_new (void)
{
#line 37 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	return network_applet_construct (NETWORK_TYPE_APPLET);
#line 426 "Applet.c"
}

static void
network_applet_real_update_popovers (BudgieApplet* base,
                                     BudgiePopoverManager* manager)
{
	NetworkApplet * self;
	GtkEventBox* _tmp0_;
	BudgiePopover* _tmp1_;
#line 81 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	self = (NetworkApplet*) base;
#line 82 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	self->priv->manager = manager;
#line 83 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp0_ = self->widget;
#line 83 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp1_ = self->priv->popover;
#line 83 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	budgie_popover_manager_register_popover (manager, (GtkWidget*) _tmp0_, _tmp1_);
#line 446 "Applet.c"
}

static void
network_applet_on_state_changed (NetworkApplet* self)
{
	NetworkWidgetsPopoverWidget* _tmp0_;
	NetworkWidgetsDisplayWidget* _tmp1_;
	NetworkWidgetsDisplayWidget* _tmp2_;
	NetworkWidgetsPopoverWidget* _tmp3_;
	NetworkState _tmp4_;
	NetworkState _tmp5_;
	NetworkWidgetsPopoverWidget* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	NetworkWidgetsPopoverWidget* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
#line 86 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	g_return_if_fail (self != NULL);
#line 87 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp0_ = self->priv->popover_widget;
#line 87 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_vala_assert (_tmp0_ != NULL, "popover_widget != null");
#line 88 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp1_ = self->priv->display_widget;
#line 88 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_vala_assert (_tmp1_ != NULL, "display_widget != null");
#line 90 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp2_ = self->priv->display_widget;
#line 90 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp3_ = self->priv->popover_widget;
#line 90 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp4_ = network_widgets_nm_visualizer_get_state ((NetworkWidgetsNMVisualizer*) _tmp3_);
#line 90 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp5_ = _tmp4_;
#line 90 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp6_ = self->priv->popover_widget;
#line 90 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp7_ = network_widgets_nm_visualizer_get_secure ((NetworkWidgetsNMVisualizer*) _tmp6_);
#line 90 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp8_ = _tmp7_;
#line 90 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp9_ = self->priv->popover_widget;
#line 90 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp10_ = network_widgets_nm_visualizer_get_extra_info ((NetworkWidgetsNMVisualizer*) _tmp9_);
#line 90 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp11_ = _tmp10_;
#line 90 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_widgets_display_widget_update_state (_tmp2_, _tmp5_, _tmp8_, _tmp11_);
#line 496 "Applet.c"
}

static void
network_applet_class_init (NetworkAppletClass * klass,
                           gpointer klass_data)
{
#line 27 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_applet_parent_class = g_type_class_peek_parent (klass);
#line 27 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	g_type_class_adjust_private_offset (klass, &NetworkApplet_private_offset);
#line 27 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	((BudgieAppletClass *) klass)->update_popovers = (void (*) (BudgieApplet*, BudgiePopoverManager*)) network_applet_real_update_popovers;
#line 27 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	G_OBJECT_CLASS (klass)->finalize = network_applet_finalize;
#line 511 "Applet.c"
}

static void
network_applet_instance_init (NetworkApplet * self,
                              gpointer klass)
{
#line 27 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	self->priv = network_applet_get_instance_private (self);
#line 30 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	self->priv->popover = NULL;
#line 32 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	self->priv->manager = NULL;
#line 34 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	self->priv->popover_widget = NULL;
#line 35 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	self->priv->display_widget = NULL;
#line 528 "Applet.c"
}

static void
network_applet_finalize (GObject * obj)
{
	NetworkApplet * self;
#line 27 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_APPLET, NetworkApplet);
#line 28 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_g_object_unref0 (self->widget);
#line 30 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_g_object_unref0 (self->priv->popover);
#line 34 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_g_object_unref0 (self->priv->popover_widget);
#line 35 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_g_object_unref0 (self->priv->display_widget);
#line 27 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	G_OBJECT_CLASS (network_applet_parent_class)->finalize (obj);
#line 547 "Applet.c"
}

GType
network_applet_get_type (void)
{
	return network_applet_type_id;
}

GType
network_applet_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkAppletClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_applet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkApplet), 0, (GInstanceInitFunc) network_applet_instance_init, NULL };
	network_applet_type_id = g_type_module_register_type (module, budgie_applet_get_type (), "NetworkApplet", &g_define_type_info, 0);
	NetworkApplet_private_offset = sizeof (NetworkAppletPrivate);
	return network_applet_type_id;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 98 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	return self ? g_object_ref (self) : NULL;
#line 570 "Applet.c"
}

void
peas_register_types (GTypeModule* module)
{
	PeasObjectModule* objmodule = NULL;
	PeasObjectModule* _tmp0_;
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	g_return_if_fail (module != NULL);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_widgets_nm_visualizer_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_widgets_display_widget_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_widgets_popover_widget_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_widgets_separator_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_widgets_switch_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_widgets_overlay_icon_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_plugin_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_applet_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_widget_nm_interface_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_abstract_ether_interface_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_abstract_modem_interface_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_abstract_vpn_interface_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_abstract_wifi_interface_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_abstract_bluetooth_interface_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_vpn_menu_item_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_wifi_menu_item_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_ether_interface_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_modem_interface_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_vpn_interface_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_wifi_interface_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	network_bluetooth_interface_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	rf_kill_device_register_type (module);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	rf_kill_manager_register_type (module);
#line 98 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (module, peas_object_module_get_type ()) ? ((PeasObjectModule*) module) : NULL);
#line 98 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	objmodule = _tmp0_;
#line 99 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	peas_object_module_register_extension_type (objmodule, budgie_plugin_get_type (), NETWORK_TYPE_PLUGIN);
#line 96 "../budgie-network-manager/budgie-network-applet/src/Applet.vala"
	_g_object_unref0 (objmodule);
#line 634 "Applet.c"
}

