/* VpnMenuItem.c generated by valac 0.56.18, the Vala compiler
 * generated from VpnMenuItem.vala, do not modify */

/*
 * Copyright (c) 2017-2018 elementary LLC (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "networkapplet.h"
#include <glib.h>
#include <NetworkManager.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	NETWORK_VPN_MENU_ITEM_0_PROPERTY,
	NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY,
	NETWORK_VPN_MENU_ITEM_ID_PROPERTY,
	NETWORK_VPN_MENU_ITEM_VPN_STATE_PROPERTY,
	NETWORK_VPN_MENU_ITEM_RADIO_BUTTON_PROPERTY,
	NETWORK_VPN_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
typedef struct _NetworkVpnMenuItemNapData NetworkVpnMenuItemNapData;
typedef struct _NetworkVpnMenuItemCheckVpnConnectivityData NetworkVpnMenuItemCheckVpnConnectivityData;
enum  {
	NETWORK_VPN_MENU_ITEM_USER_ACTION_SIGNAL,
	NETWORK_VPN_MENU_ITEM_NUM_SIGNALS
};
static guint network_vpn_menu_item_signals[NETWORK_VPN_MENU_ITEM_NUM_SIGNALS] = {0};

struct _NetworkVpnMenuItemPrivate {
	gboolean checking_vpn_connectivity;
	NMRemoteConnection* _connection;
	NetworkState _vpn_state;
	GtkRadioButton* _radio_button;
	GtkSpinner* spinner;
	GtkImage* error_img;
};

struct _Block1Data {
	int _ref_count_;
	NetworkVpnMenuItem* self;
	gpointer _async_data_;
};

struct _NetworkVpnMenuItemNapData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	NetworkVpnMenuItem* self;
	guint interval;
	gint priority;
	Block1Data* _data1_;
};

struct _NetworkVpnMenuItemCheckVpnConnectivityData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	NetworkVpnMenuItem* self;
	gint i;
	gboolean _tmp0_;
	gint _tmp1_;
	NetworkState _tmp2_;
	GtkSpinner* _tmp3_;
};

static gint NetworkVpnMenuItem_private_offset;
static gpointer network_vpn_menu_item_parent_class = NULL;
static GtkRadioButton* network_vpn_menu_item_blank_button;
static GtkRadioButton* network_vpn_menu_item_blank_button = NULL;
static GType network_vpn_menu_item_type_id = 0;

static void network_vpn_menu_item_set_connection (NetworkVpnMenuItem* self,
                                           NMRemoteConnection* value);
static void network_vpn_menu_item_update (NetworkVpnMenuItem* self);
static void _network_vpn_menu_item_update_nm_connection_changed (NMConnection* _sender,
                                                          gpointer self);
static void network_vpn_menu_item_set_radio_button (NetworkVpnMenuItem* self,
                                             GtkRadioButton* value);
static gboolean __lambda29_ (NetworkVpnMenuItem* self,
                      GtkWidget* b,
                      GdkEventButton* ev);
static gboolean ___lambda29__gtk_widget_button_release_event (GtkWidget* _sender,
                                                       GdkEventButton* event,
                                                       gpointer self);
static void _network_vpn_menu_item_update_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void network_vpn_menu_item_hide_item (NetworkVpnMenuItem* self,
                                      GtkWidget* w);
static void network_vpn_menu_item_show_item (NetworkVpnMenuItem* self,
                                      GtkWidget* w);
static void network_vpn_menu_item_check_vpn_connectivity (NetworkVpnMenuItem* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static void network_vpn_menu_item_check_vpn_connectivity_finish (NetworkVpnMenuItem* self,
                                                          GAsyncResult* _res_);
static void network_vpn_menu_item_nap_data_free (gpointer _data);
static void network_vpn_menu_item_nap (NetworkVpnMenuItem* self,
                                guint interval,
                                gint priority,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
static void network_vpn_menu_item_nap_finish (NetworkVpnMenuItem* self,
                                       GAsyncResult* _res_);
static gboolean network_vpn_menu_item_nap_co (NetworkVpnMenuItemNapData* _data_);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda28_ (Block1Data* _data1_);
static gboolean ___lambda28__gsource_func (gpointer self);
static void network_vpn_menu_item_check_vpn_connectivity_data_free (gpointer _data);
static gboolean network_vpn_menu_item_check_vpn_connectivity_co (NetworkVpnMenuItemCheckVpnConnectivityData* _data_);
static void network_vpn_menu_item_check_vpn_connectivity_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
static void network_vpn_menu_item_finalize (GObject * obj);
static void _vala_network_vpn_menu_item_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_network_vpn_menu_item_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);

static inline gpointer
network_vpn_menu_item_get_instance_private (NetworkVpnMenuItem* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkVpnMenuItem_private_offset);
}

static void
_network_vpn_menu_item_update_nm_connection_changed (NMConnection* _sender,
                                                     gpointer self)
{
#line 38 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_update ((NetworkVpnMenuItem*) self);
#line 171 "VpnMenuItem.c"
}

static gboolean
__lambda29_ (NetworkVpnMenuItem* self,
             GtkWidget* b,
             GdkEventButton* ev)
{
	gboolean result;
#line 48 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 48 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (ev != NULL, FALSE);
#line 49 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_signal_emit (self, network_vpn_menu_item_signals[NETWORK_VPN_MENU_ITEM_USER_ACTION_SIGNAL], 0);
#line 50 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	result = FALSE;
#line 50 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	return result;
#line 190 "VpnMenuItem.c"
}

static gboolean
___lambda29__gtk_widget_button_release_event (GtkWidget* _sender,
                                              GdkEventButton* event,
                                              gpointer self)
{
	gboolean result;
	result = __lambda29_ ((NetworkVpnMenuItem*) self, _sender, event);
#line 48 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	return result;
#line 202 "VpnMenuItem.c"
}

static void
_network_vpn_menu_item_update_g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
#line 66 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_update ((NetworkVpnMenuItem*) self);
#line 212 "VpnMenuItem.c"
}

NetworkVpnMenuItem*
network_vpn_menu_item_construct (GType object_type,
                                 NMRemoteConnection* _connection)
{
	NetworkVpnMenuItem * self = NULL;
	NMRemoteConnection* _tmp0_;
	GtkBox* main_box = NULL;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkRadioButton* _tmp4_;
	GtkRadioButton* _tmp5_;
	GtkRadioButton* _tmp6_;
	GtkRadioButton* _tmp9_;
	GtkImage* _tmp10_;
	GtkImage* _tmp11_;
	GtkImage* _tmp12_;
	GtkSpinner* _tmp13_;
	GtkSpinner* _tmp14_;
	GtkSpinner* _tmp15_;
	GtkSpinner* _tmp16_;
	GtkSpinner* _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp19_;
	GtkBox* _tmp20_;
	GtkRadioButton* _tmp21_;
	GtkBox* _tmp22_;
	GtkSpinner* _tmp23_;
	GtkBox* _tmp24_;
	GtkImage* _tmp25_;
	GtkRadioButton* _tmp26_;
	GtkBox* _tmp27_;
	GtkStyleContext* _tmp28_;
#line 36 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	self = (NetworkVpnMenuItem*) g_object_new (object_type, NULL);
#line 37 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_set_connection (self, _connection);
#line 38 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_connection;
#line 38 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_signal_connect_object ((NMConnection*) _tmp0_, "changed", (GCallback) _network_vpn_menu_item_update_nm_connection_changed, self, 0);
#line 40 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 40 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_object_ref_sink (_tmp1_);
#line 40 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	main_box = _tmp1_;
#line 41 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp2_ = main_box;
#line 41 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp3_ = main_box;
#line 41 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp3_, 6);
#line 41 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp2_, 6);
#line 43 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp4_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
#line 43 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_object_ref_sink (_tmp4_);
#line 43 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp5_ = _tmp4_;
#line 43 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_set_radio_button (self, _tmp5_);
#line 43 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (_tmp5_);
#line 44 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp6_ = network_vpn_menu_item_blank_button;
#line 44 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	if (_tmp6_ != NULL) {
#line 284 "VpnMenuItem.c"
		GtkRadioButton* _tmp7_;
		GtkRadioButton* _tmp8_;
#line 45 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		_tmp7_ = self->priv->_radio_button;
#line 45 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		_tmp8_ = network_vpn_menu_item_blank_button;
#line 45 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		gtk_radio_button_join_group (_tmp7_, _tmp8_);
#line 293 "VpnMenuItem.c"
	}
#line 48 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp9_ = self->priv->_radio_button;
#line 48 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_signal_connect_object ((GtkWidget*) _tmp9_, "button-release-event", (GCallback) ___lambda29__gtk_widget_button_release_event, self, 0);
#line 53 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp10_ = (GtkImage*) gtk_image_new_from_icon_name ("process-error-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 53 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_object_ref_sink (_tmp10_);
#line 53 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->error_img);
#line 53 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	self->priv->error_img = _tmp10_;
#line 54 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp11_ = self->priv->error_img;
#line 54 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp11_, 6);
#line 55 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp12_ = self->priv->error_img;
#line 55 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp12_, _ ("This Virtual Private Network could not be connected to."));
#line 57 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp13_ = (GtkSpinner*) gtk_spinner_new ();
#line 57 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_object_ref_sink (_tmp13_);
#line 57 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->spinner);
#line 57 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	self->priv->spinner = _tmp13_;
#line 58 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp14_ = self->priv->spinner;
#line 58 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	gtk_spinner_start (_tmp14_);
#line 59 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp15_ = self->priv->spinner;
#line 59 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp15_, FALSE);
#line 60 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp16_ = self->priv->spinner;
#line 60 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp17_ = self->priv->spinner;
#line 60 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp18_ = gtk_widget_get_visible ((GtkWidget*) _tmp17_);
#line 60 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp19_ = _tmp18_;
#line 60 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp16_, !_tmp19_);
#line 62 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp20_ = main_box;
#line 62 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp21_ = self->priv->_radio_button;
#line 62 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	gtk_box_pack_start (_tmp20_, (GtkWidget*) _tmp21_, TRUE, TRUE, (guint) 0);
#line 63 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp22_ = main_box;
#line 63 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp23_ = self->priv->spinner;
#line 63 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	gtk_box_pack_start (_tmp22_, (GtkWidget*) _tmp23_, FALSE, FALSE, (guint) 0);
#line 64 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp24_ = main_box;
#line 64 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp25_ = self->priv->error_img;
#line 64 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	gtk_box_pack_start (_tmp24_, (GtkWidget*) _tmp25_, FALSE, FALSE, (guint) 0);
#line 66 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_signal_connect_object ((GObject*) self, "notify::vpn_state", (GCallback) _network_vpn_menu_item_update_g_object_notify, self, 0);
#line 67 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp26_ = self->priv->_radio_button;
#line 67 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_signal_connect_object ((GObject*) _tmp26_, "notify::active", (GCallback) _network_vpn_menu_item_update_g_object_notify, self, 0);
#line 69 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp27_ = main_box;
#line 69 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp27_);
#line 70 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp28_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 70 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	gtk_style_context_add_class (_tmp28_, "menuitem");
#line 72 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_update (self);
#line 36 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (main_box);
#line 36 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	return self;
#line 379 "VpnMenuItem.c"
}

NetworkVpnMenuItem*
network_vpn_menu_item_new (NMRemoteConnection* _connection)
{
#line 36 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	return network_vpn_menu_item_construct (NETWORK_TYPE_VPN_MENU_ITEM, _connection);
#line 387 "VpnMenuItem.c"
}

/**
    * Only used for an item which is not displayed: hacky way to have no radio button selected.
    **/
NetworkVpnMenuItem*
network_vpn_menu_item_construct_blank (GType object_type)
{
	NetworkVpnMenuItem * self = NULL;
	GtkRadioButton* _tmp0_;
	GtkRadioButton* _tmp1_;
	GtkRadioButton* _tmp2_;
#line 78 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	self = (NetworkVpnMenuItem*) g_object_new (object_type, NULL);
#line 79 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
#line 79 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_object_ref_sink (_tmp0_);
#line 79 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = _tmp0_;
#line 79 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_set_radio_button (self, _tmp1_);
#line 79 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (_tmp1_);
#line 80 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp2_ = self->priv->_radio_button;
#line 80 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_blank_button = _tmp2_;
#line 78 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	return self;
#line 418 "VpnMenuItem.c"
}

NetworkVpnMenuItem*
network_vpn_menu_item_new_blank (void)
{
#line 78 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	return network_vpn_menu_item_construct_blank (NETWORK_TYPE_VPN_MENU_ITEM);
#line 426 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_update (NetworkVpnMenuItem* self)
{
	GtkRadioButton* _tmp0_;
	NMRemoteConnection* _tmp1_;
	const gchar* _tmp2_;
	GtkImage* _tmp3_;
	GtkSpinner* _tmp4_;
	NetworkState _tmp5_;
#line 83 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 84 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_radio_button;
#line 84 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = self->priv->_connection;
#line 84 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp2_ = nm_connection_get_id ((NMConnection*) _tmp1_);
#line 84 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	gtk_button_set_label ((GtkButton*) _tmp0_, _tmp2_);
#line 85 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp3_ = self->priv->error_img;
#line 85 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_hide_item (self, (GtkWidget*) _tmp3_);
#line 86 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp4_ = self->priv->spinner;
#line 86 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_hide_item (self, (GtkWidget*) _tmp4_);
#line 88 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp5_ = self->priv->_vpn_state;
#line 88 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	switch (_tmp5_) {
#line 88 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_STATE_FAILED_VPN:
#line 462 "VpnMenuItem.c"
		{
			GtkImage* _tmp6_;
#line 90 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
			_tmp6_ = self->priv->error_img;
#line 90 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
			network_vpn_menu_item_show_item (self, (GtkWidget*) _tmp6_);
#line 91 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
			break;
#line 471 "VpnMenuItem.c"
		}
#line 88 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_STATE_CONNECTING_VPN:
#line 475 "VpnMenuItem.c"
		{
			GtkSpinner* _tmp7_;
			GtkRadioButton* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 93 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
			_tmp7_ = self->priv->spinner;
#line 93 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
			network_vpn_menu_item_show_item (self, (GtkWidget*) _tmp7_);
#line 94 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
			_tmp8_ = self->priv->_radio_button;
#line 94 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
			_tmp9_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp8_);
#line 94 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
			_tmp10_ = _tmp9_;
#line 94 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
			if (!_tmp10_) {
#line 95 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
				g_critical ("VpnMenuItem.vala:95: An VPN is being connected but not active.");
#line 495 "VpnMenuItem.c"
			}
#line 97 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
			network_vpn_menu_item_check_vpn_connectivity (self, NULL, NULL);
#line 98 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
			break;
#line 501 "VpnMenuItem.c"
		}
		default:
#line 88 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		break;
#line 506 "VpnMenuItem.c"
	}
}

void
network_vpn_menu_item_set_active (NetworkVpnMenuItem* self,
                                  gboolean active)
{
	GtkRadioButton* _tmp0_;
#line 102 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 103 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_radio_button;
#line 103 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, active);
#line 521 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_show_item (NetworkVpnMenuItem* self,
                                 GtkWidget* w)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 106 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 106 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (w != NULL);
#line 107 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_visible (w, TRUE);
#line 108 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = gtk_widget_get_visible (w);
#line 108 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = _tmp0_;
#line 108 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_no_show_all (w, _tmp1_);
#line 542 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_hide_item (NetworkVpnMenuItem* self,
                                 GtkWidget* w)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 111 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 111 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (w != NULL);
#line 112 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_visible (w, FALSE);
#line 113 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = gtk_widget_get_visible (w);
#line 113 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = _tmp0_;
#line 113 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_no_show_all (w, !_tmp1_);
#line 114 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_hide (w);
#line 565 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_nap_data_free (gpointer _data)
{
	NetworkVpnMenuItemNapData* _data_;
	_data_ = _data;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (_data_->self);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_slice_free (NetworkVpnMenuItemNapData, _data_);
#line 577 "VpnMenuItem.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 585 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_nap (NetworkVpnMenuItem* self,
                           guint interval,
                           gint priority,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	NetworkVpnMenuItemNapData* _data_;
	NetworkVpnMenuItem* _tmp0_;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_data_ = g_slice_new0 (NetworkVpnMenuItemNapData);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_task_set_task_data (_data_->_async_result, _data_, network_vpn_menu_item_nap_data_free);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_data_->self = _tmp0_;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_data_->interval = interval;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_data_->priority = priority;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_nap_co (_data_);
#line 615 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_nap_finish (NetworkVpnMenuItem* self,
                                  GAsyncResult* _res_)
{
	NetworkVpnMenuItemNapData* _data_;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 625 "VpnMenuItem.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	return _data1_;
#line 635 "VpnMenuItem.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 645 "VpnMenuItem.c"
		NetworkVpnMenuItem* self;
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		self = _data1_->self;
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		_g_object_unref0 (self);
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		g_slice_free (Block1Data, _data1_);
#line 653 "VpnMenuItem.c"
	}
}

static gboolean
__lambda28_ (Block1Data* _data1_)
{
	NetworkVpnMenuItem* self;
	gboolean result;
#line 118 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	self = _data1_->self;
#line 119 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_nap_co (_data1_->_async_data_);
#line 120 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	result = FALSE;
#line 120 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	return result;
#line 670 "VpnMenuItem.c"
}

static gboolean
___lambda28__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda28_ (self);
#line 118 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	return result;
#line 680 "VpnMenuItem.c"
}

static gboolean
network_vpn_menu_item_nap_co (NetworkVpnMenuItemNapData* _data_)
{
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	switch (_data_->_state_) {
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		case 0:
#line 690 "VpnMenuItem.c"
		goto _state_0;
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		case 1:
#line 694 "VpnMenuItem.c"
		goto _state_1;
		default:
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		g_assert_not_reached ();
#line 699 "VpnMenuItem.c"
	}
	_state_0:
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_data_->_data1_ = g_slice_new0 (Block1Data);
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_data_->_data1_->_ref_count_ = 1;
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_data_->_data1_->self = g_object_ref (_data_->self);
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_data_->_data1_->_async_data_ = _data_;
#line 118 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_timeout_add_full (_data_->priority, _data_->interval, ___lambda28__gsource_func, block1_data_ref (_data_->_data1_), block1_data_unref);
#line 122 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_data_->_state_ = 1;
#line 122 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	return FALSE;
#line 716 "VpnMenuItem.c"
	_state_1:
	;
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	block1_data_unref (_data_->_data1_);
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_data_->_data1_ = NULL;
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	if (_data_->_state_ != 0) {
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 731 "VpnMenuItem.c"
		}
	}
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_object_unref (_data_->_async_result);
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	return FALSE;
#line 738 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_check_vpn_connectivity_data_free (gpointer _data)
{
	NetworkVpnMenuItemCheckVpnConnectivityData* _data_;
	_data_ = _data;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (_data_->self);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_slice_free (NetworkVpnMenuItemCheckVpnConnectivityData, _data_);
#line 750 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_check_vpn_connectivity (NetworkVpnMenuItem* self,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	NetworkVpnMenuItemCheckVpnConnectivityData* _data_;
	NetworkVpnMenuItem* _tmp0_;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_data_ = g_slice_new0 (NetworkVpnMenuItemCheckVpnConnectivityData);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_task_set_task_data (_data_->_async_result, _data_, network_vpn_menu_item_check_vpn_connectivity_data_free);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_data_->self = _tmp0_;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_check_vpn_connectivity_co (_data_);
#line 774 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_check_vpn_connectivity_finish (NetworkVpnMenuItem* self,
                                                     GAsyncResult* _res_)
{
	NetworkVpnMenuItemCheckVpnConnectivityData* _data_;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 784 "VpnMenuItem.c"
}

/**
    * Uses a timeout to check VPN connectivity
    **/
static void
network_vpn_menu_item_check_vpn_connectivity_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	NetworkVpnMenuItemCheckVpnConnectivityData* _data_;
#line 139 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_data_ = _user_data_;
#line 139 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_data_->_source_object_ = source_object;
#line 139 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_data_->_res_ = _res_;
#line 139 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_check_vpn_connectivity_co (_data_);
#line 804 "VpnMenuItem.c"
}

static gboolean
network_vpn_menu_item_check_vpn_connectivity_co (NetworkVpnMenuItemCheckVpnConnectivityData* _data_)
{
#line 128 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	switch (_data_->_state_) {
#line 128 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		case 0:
#line 814 "VpnMenuItem.c"
		goto _state_0;
#line 128 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		case 1:
#line 818 "VpnMenuItem.c"
		goto _state_1;
		default:
#line 128 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		g_assert_not_reached ();
#line 823 "VpnMenuItem.c"
	}
	_state_0:
#line 129 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	if (!_data_->self->priv->checking_vpn_connectivity) {
#line 131 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		_data_->self->priv->checking_vpn_connectivity = TRUE;
#line 830 "VpnMenuItem.c"
		{
#line 133 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
			_data_->i = 0;
#line 834 "VpnMenuItem.c"
			{
#line 133 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
				_data_->_tmp0_ = TRUE;
#line 133 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
				while (TRUE) {
#line 133 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
					if (!_data_->_tmp0_) {
#line 133 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
						_data_->_tmp1_ = _data_->i;
#line 133 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
						_data_->i = _data_->_tmp1_ + 1;
#line 846 "VpnMenuItem.c"
					}
#line 133 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
					_data_->_tmp0_ = FALSE;
#line 133 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
					if (!(_data_->i < 20)) {
#line 133 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
						break;
#line 854 "VpnMenuItem.c"
					}
#line 134 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
					_data_->_tmp2_ = _data_->self->priv->_vpn_state;
#line 134 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
					if (_data_->_tmp2_ == NETWORK_STATE_CONNECTED_VPN) {
#line 135 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
						_data_->_tmp3_ = _data_->self->priv->spinner;
#line 135 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
						network_vpn_menu_item_hide_item (_data_->self, (GtkWidget*) _data_->_tmp3_);
#line 136 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
						_data_->self->priv->checking_vpn_connectivity = FALSE;
#line 137 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
						g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 137 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
						if (_data_->_state_ != 0) {
#line 137 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
							while (!g_task_get_completed (_data_->_async_result)) {
#line 137 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
								g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 874 "VpnMenuItem.c"
							}
						}
#line 137 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
						g_object_unref (_data_->_async_result);
#line 137 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
						return FALSE;
#line 881 "VpnMenuItem.c"
					}
#line 139 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
					_data_->_state_ = 1;
#line 139 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
					network_vpn_menu_item_nap (_data_->self, (guint) 500, G_PRIORITY_DEFAULT, network_vpn_menu_item_check_vpn_connectivity_ready, _data_);
#line 139 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
					return FALSE;
#line 889 "VpnMenuItem.c"
					_state_1:
#line 139 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
					network_vpn_menu_item_nap_finish (_data_->self, _data_->_res_);
#line 893 "VpnMenuItem.c"
				}
			}
		}
	}
#line 128 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 128 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	if (_data_->_state_ != 0) {
#line 128 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 128 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 906 "VpnMenuItem.c"
		}
	}
#line 128 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_object_unref (_data_->_async_result);
#line 128 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	return FALSE;
#line 913 "VpnMenuItem.c"
}

NMRemoteConnection*
network_vpn_menu_item_get_connection (NetworkVpnMenuItem* self)
{
	NMRemoteConnection* result;
	NMRemoteConnection* _tmp0_;
#line 24 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_connection;
#line 24 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	result = _tmp0_;
#line 24 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	return result;
#line 929 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_set_connection (NetworkVpnMenuItem* self,
                                      NMRemoteConnection* value)
{
	NMRemoteConnection* old_value;
#line 24 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 24 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	old_value = network_vpn_menu_item_get_connection (self);
#line 24 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	if (old_value != value) {
#line 943 "VpnMenuItem.c"
		NMRemoteConnection* _tmp0_;
#line 24 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		_g_object_unref0 (self->priv->_connection);
#line 24 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		self->priv->_connection = _tmp0_;
#line 24 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY]);
#line 953 "VpnMenuItem.c"
	}
}

const gchar*
network_vpn_menu_item_get_id (NetworkVpnMenuItem* self)
{
	const gchar* result;
	NMRemoteConnection* _tmp0_;
	const gchar* _tmp1_;
#line 26 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_connection;
#line 27 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = nm_connection_get_id ((NMConnection*) _tmp0_);
#line 27 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	result = _tmp1_;
#line 27 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	return result;
#line 973 "VpnMenuItem.c"
}

NetworkState
network_vpn_menu_item_get_vpn_state (NetworkVpnMenuItem* self)
{
	NetworkState result;
#line 30 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 30 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	result = self->priv->_vpn_state;
#line 30 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	return result;
#line 986 "VpnMenuItem.c"
}

void
network_vpn_menu_item_set_vpn_state (NetworkVpnMenuItem* self,
                                     NetworkState value)
{
	NetworkState old_value;
#line 30 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 30 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	old_value = network_vpn_menu_item_get_vpn_state (self);
#line 30 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	if (old_value != value) {
#line 30 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		self->priv->_vpn_state = value;
#line 30 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_VPN_STATE_PROPERTY]);
#line 1004 "VpnMenuItem.c"
	}
}

GtkRadioButton*
network_vpn_menu_item_get_radio_button (NetworkVpnMenuItem* self)
{
	GtkRadioButton* result;
	GtkRadioButton* _tmp0_;
#line 32 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_radio_button;
#line 32 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	result = _tmp0_;
#line 32 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	return result;
#line 1021 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_set_radio_button (NetworkVpnMenuItem* self,
                                        GtkRadioButton* value)
{
	GtkRadioButton* old_value;
#line 32 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 32 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	old_value = network_vpn_menu_item_get_radio_button (self);
#line 32 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	if (old_value != value) {
#line 1035 "VpnMenuItem.c"
		GtkRadioButton* _tmp0_;
#line 32 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 32 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		_g_object_unref0 (self->priv->_radio_button);
#line 32 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		self->priv->_radio_button = _tmp0_;
#line 32 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_RADIO_BUTTON_PROPERTY]);
#line 1045 "VpnMenuItem.c"
	}
}

static void
network_vpn_menu_item_class_init (NetworkVpnMenuItemClass * klass,
                                  gpointer klass_data)
{
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_parent_class = g_type_class_peek_parent (klass);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_type_class_adjust_private_offset (klass, &NetworkVpnMenuItem_private_offset);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_network_vpn_menu_item_get_property;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_network_vpn_menu_item_set_property;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	G_OBJECT_CLASS (klass)->finalize = network_vpn_menu_item_finalize;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY] = g_param_spec_object ("connection", "connection", "connection", nm_remote_connection_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_MENU_ITEM_ID_PROPERTY, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_MENU_ITEM_VPN_STATE_PROPERTY, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_VPN_STATE_PROPERTY] = g_param_spec_enum ("vpn-state", "vpn-state", "vpn-state", NETWORK_TYPE_STATE, NETWORK_STATE_DISCONNECTED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_MENU_ITEM_RADIO_BUTTON_PROPERTY, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_RADIO_BUTTON_PROPERTY] = g_param_spec_object ("radio-button", "radio-button", "radio-button", gtk_radio_button_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_signals[NETWORK_VPN_MENU_ITEM_USER_ACTION_SIGNAL] = g_signal_new ("user-action", NETWORK_TYPE_VPN_MENU_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1073 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_instance_init (NetworkVpnMenuItem * self,
                                     gpointer klass)
{
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	self->priv = network_vpn_menu_item_get_instance_private (self);
#line 21 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	self->priv->checking_vpn_connectivity = FALSE;
#line 30 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	self->priv->_vpn_state = NETWORK_STATE_DISCONNECTED;
#line 1086 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_finalize (GObject * obj)
{
	NetworkVpnMenuItem * self;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem);
#line 24 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->_connection);
#line 32 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->_radio_button);
#line 33 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->spinner);
#line 34 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->error_img);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	G_OBJECT_CLASS (network_vpn_menu_item_parent_class)->finalize (obj);
#line 1105 "VpnMenuItem.c"
}

GType
network_vpn_menu_item_get_type (void)
{
	return network_vpn_menu_item_type_id;
}

GType
network_vpn_menu_item_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkVpnMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_vpn_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkVpnMenuItem), 0, (GInstanceInitFunc) network_vpn_menu_item_instance_init, NULL };
	network_vpn_menu_item_type_id = g_type_module_register_type (module, gtk_list_box_row_get_type (), "NetworkVpnMenuItem", &g_define_type_info, 0);
	NetworkVpnMenuItem_private_offset = sizeof (NetworkVpnMenuItemPrivate);
	return network_vpn_menu_item_type_id;
}

static void
_vala_network_vpn_menu_item_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	NetworkVpnMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	switch (property_id) {
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY:
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		g_value_set_object (value, network_vpn_menu_item_get_connection (self));
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		break;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_ID_PROPERTY:
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		g_value_set_string (value, network_vpn_menu_item_get_id (self));
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		break;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_VPN_STATE_PROPERTY:
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		g_value_set_enum (value, network_vpn_menu_item_get_vpn_state (self));
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		break;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_RADIO_BUTTON_PROPERTY:
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		g_value_set_object (value, network_vpn_menu_item_get_radio_button (self));
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		break;
#line 1157 "VpnMenuItem.c"
		default:
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		break;
#line 1163 "VpnMenuItem.c"
	}
}

static void
_vala_network_vpn_menu_item_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	NetworkVpnMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
	switch (property_id) {
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY:
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		network_vpn_menu_item_set_connection (self, g_value_get_object (value));
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		break;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_VPN_STATE_PROPERTY:
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		network_vpn_menu_item_set_vpn_state (self, g_value_get_enum (value));
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		break;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_RADIO_BUTTON_PROPERTY:
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		network_vpn_menu_item_set_radio_button (self, g_value_get_object (value));
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		break;
#line 1195 "VpnMenuItem.c"
		default:
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/VpnMenuItem.vala"
		break;
#line 1201 "VpnMenuItem.c"
	}
}

