/* WifiMenuItem.c generated by valac 0.56.18, the Vala compiler
 * generated from WifiMenuItem.vala, do not modify */

/*
 * Copyright (c) 2015-2018 elementary LLC (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "networkapplet.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <NetworkManager.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#define NETWORK_WIFI_MENU_ITEM_BASE_ICON_NAME "network-wireless-signal-"
#define NETWORK_WIFI_MENU_ITEM_SYMBOLIC "-symbolic"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	NETWORK_WIFI_MENU_ITEM_0_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_NUM_PROPERTIES];
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	NETWORK_WIFI_MENU_ITEM_USER_ACTION_SIGNAL,
	NETWORK_WIFI_MENU_ITEM_NUM_SIGNALS
};
static guint network_wifi_menu_item_signals[NETWORK_WIFI_MENU_ITEM_NUM_SIGNALS] = {0};

struct _NetworkWifiMenuItemPrivate {
	NetworkState _state;
	GBytes* _ssid;
	guint8 _strength;
	GeeLinkedList* all_aps;
	GRecMutex __lock_all_aps;
	GtkRadioButton* radio_button;
	GtkImage* img_strength;
	GtkImage* lock_img;
	GtkImage* error_img;
	GtkSpinner* spinner;
	guint refresh_source;
	GRecMutex __lock_refresh_source;
};

static gint NetworkWifiMenuItem_private_offset;
static gpointer network_wifi_menu_item_parent_class = NULL;
static GType network_wifi_menu_item_type_id = 0;

static void network_wifi_menu_item_update (NetworkWifiMenuItem* self);
static void network_wifi_menu_item_start_refresh (NetworkWifiMenuItem* self);
static gboolean ___lambda5_ (NetworkWifiMenuItem* self);
static gboolean ____lambda5__gsource_func (gpointer self);
static void network_wifi_menu_item_stop_refresh (NetworkWifiMenuItem* self);
static void network_wifi_menu_item_hide_item (NetworkWifiMenuItem* self,
                                       GtkWidget* w);
static void network_wifi_menu_item_show_item (NetworkWifiMenuItem* self,
                                       GtkWidget* w);
static void network_wifi_menu_item_set_strength (NetworkWifiMenuItem* self,
                                          guint8 value);
static const gchar* network_wifi_menu_item_get_strength_symbolic_icon (NetworkWifiMenuItem* self);
static GObject * network_wifi_menu_item_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _network_wifi_menu_item_update_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static gboolean _network_wifi_menu_item___lambda6_ (NetworkWifiMenuItem* self);
static gboolean __network_wifi_menu_item___lambda6__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                              GdkEventButton* event,
                                                                              gpointer self);
static void _network_wifi_menu_item___lambda7_ (NetworkWifiMenuItem* self);
static void __network_wifi_menu_item___lambda7__gtk_list_box_row_activate (GtkListBoxRow* _sender,
                                                                    gpointer self);
static void _network_wifi_menu_item___lambda8_ (NetworkWifiMenuItem* self);
static void __network_wifi_menu_item___lambda8__gtk_widget_map (GtkWidget* _sender,
                                                         gpointer self);
static void _network_wifi_menu_item___lambda9_ (NetworkWifiMenuItem* self);
static void __network_wifi_menu_item___lambda9__gtk_widget_unmap (GtkWidget* _sender,
                                                           gpointer self);
static void network_wifi_menu_item_finalize (GObject * obj);
static void _vala_network_wifi_menu_item_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_network_wifi_menu_item_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
network_wifi_menu_item_get_instance_private (NetworkWifiMenuItem* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkWifiMenuItem_private_offset);
}

NetworkWifiMenuItem*
network_wifi_menu_item_construct (GType object_type,
                                  NMAccessPoint* ap,
                                  NetworkWifiMenuItem* previous)
{
	NetworkWifiMenuItem * self = NULL;
	GBytes* _tmp0_;
	GBytes* _tmp1_;
#line 77 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (ap != NULL, NULL);
#line 78 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = nm_access_point_get_ssid (ap);
#line 78 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp1_ = _tmp0_;
#line 78 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	self = (NetworkWifiMenuItem*) g_object_new (object_type, "ssid", _tmp1_, "margin-top", 3, NULL);
#line 79 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_add_ap (self, ap);
#line 81 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	if (previous != NULL) {
#line 147 "WifiMenuItem.c"
		GtkRadioButton* _tmp2_;
		GtkRadioButton* _tmp3_;
		GSList* _tmp4_;
#line 82 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		_tmp2_ = self->priv->radio_button;
#line 82 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		_tmp3_ = previous->priv->radio_button;
#line 82 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		_tmp4_ = gtk_radio_button_get_group (_tmp3_);
#line 82 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		gtk_radio_button_set_group (_tmp2_, _tmp4_);
#line 159 "WifiMenuItem.c"
	}
#line 85 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 77 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	return self;
#line 165 "WifiMenuItem.c"
}

NetworkWifiMenuItem*
network_wifi_menu_item_new (NMAccessPoint* ap,
                            NetworkWifiMenuItem* previous)
{
#line 77 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	return network_wifi_menu_item_construct (NETWORK_TYPE_WIFI_MENU_ITEM, ap, previous);
#line 174 "WifiMenuItem.c"
}

/**
     * Only used for an item which is not displayed: hacky way to have no radio button selected.
     **/
NetworkWifiMenuItem*
network_wifi_menu_item_construct_blank (GType object_type)
{
	NetworkWifiMenuItem * self = NULL;
	GtkWidget* _tmp0_;
#line 91 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	self = (NetworkWifiMenuItem*) g_object_new (object_type, NULL);
#line 92 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) self);
#line 92 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_destroy (_tmp0_);
#line 91 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	return self;
#line 193 "WifiMenuItem.c"
}

NetworkWifiMenuItem*
network_wifi_menu_item_new_blank (void)
{
#line 91 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	return network_wifi_menu_item_construct_blank (NETWORK_TYPE_WIFI_MENU_ITEM);
#line 201 "WifiMenuItem.c"
}

void
network_wifi_menu_item_set_active (NetworkWifiMenuItem* self,
                                   gboolean active)
{
	GtkRadioButton* _tmp0_;
#line 95 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 96 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->radio_button;
#line 96 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, active);
#line 215 "WifiMenuItem.c"
}

void
network_wifi_menu_item_add_ap (NetworkWifiMenuItem* self,
                               NMAccessPoint* ap)
{
	GError* _inner_error0_ = NULL;
#line 99 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 99 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (ap != NULL);
#line 227 "WifiMenuItem.c"
	{
		GeeLinkedList* _tmp0_;
#line 100 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		_tmp0_ = self->priv->all_aps;
#line 100 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		g_rec_mutex_lock (&self->priv->__lock_all_aps);
#line 234 "WifiMenuItem.c"
		{
			GeeLinkedList* _tmp1_;
#line 101 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_tmp1_ = self->priv->all_aps;
#line 101 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, ap);
#line 241 "WifiMenuItem.c"
		}
		__finally0:
		{
			GeeLinkedList* _tmp2_;
#line 100 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_tmp2_ = self->priv->all_aps;
#line 100 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			g_rec_mutex_unlock (&self->priv->__lock_all_aps);
#line 250 "WifiMenuItem.c"
		}
#line 100 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 100 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 100 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			g_clear_error (&_inner_error0_);
#line 100 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			return;
#line 260 "WifiMenuItem.c"
		}
	}
#line 104 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update (self);
#line 265 "WifiMenuItem.c"
}

gboolean
network_wifi_menu_item_remove_ap (NetworkWifiMenuItem* self,
                                  NMAccessPoint* ap)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 107 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 107 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (ap != NULL, FALSE);
#line 278 "WifiMenuItem.c"
	{
		GeeLinkedList* _tmp0_;
		gboolean _tmp7_ = FALSE;
#line 108 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		_tmp0_ = self->priv->all_aps;
#line 108 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		g_rec_mutex_lock (&self->priv->__lock_all_aps);
#line 286 "WifiMenuItem.c"
		{
			GeeLinkedList* _tmp1_;
			GeeLinkedList* _tmp2_;
			gboolean _tmp3_;
			gboolean _tmp4_;
#line 109 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_tmp1_ = self->priv->all_aps;
#line 109 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, ap);
#line 110 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_tmp2_ = self->priv->all_aps;
#line 110 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_tmp3_ = gee_collection_get_is_empty ((GeeCollection*) _tmp2_);
#line 110 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_tmp4_ = _tmp3_;
#line 110 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			result = !_tmp4_;
#line 304 "WifiMenuItem.c"
			{
				GeeLinkedList* _tmp5_;
#line 108 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				_tmp5_ = self->priv->all_aps;
#line 108 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				g_rec_mutex_unlock (&self->priv->__lock_all_aps);
#line 311 "WifiMenuItem.c"
			}
#line 110 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			return result;
#line 315 "WifiMenuItem.c"
		}
		__finally0:
		{
			GeeLinkedList* _tmp6_;
#line 108 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_tmp6_ = self->priv->all_aps;
#line 108 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			g_rec_mutex_unlock (&self->priv->__lock_all_aps);
#line 324 "WifiMenuItem.c"
		}
#line 108 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 108 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		g_clear_error (&_inner_error0_);
#line 108 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		return _tmp7_;
#line 332 "WifiMenuItem.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 119 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 341 "WifiMenuItem.c"
}

NMAccessPoint*
network_wifi_menu_item_get_nearest_ap (NetworkWifiMenuItem* self)
{
	GError* _inner_error0_ = NULL;
	NMAccessPoint* result;
#line 114 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 351 "WifiMenuItem.c"
	{
		GeeLinkedList* _tmp0_;
#line 115 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		_tmp0_ = self->priv->all_aps;
#line 115 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		g_rec_mutex_lock (&self->priv->__lock_all_aps);
#line 358 "WifiMenuItem.c"
		{
			NMAccessPoint* ap = NULL;
			GeeLinkedList* _tmp1_;
			gpointer _tmp2_;
#line 116 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_tmp1_ = self->priv->all_aps;
#line 116 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_tmp2_ = gee_linked_list_first (_tmp1_);
#line 116 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			ap = (NMAccessPoint*) _tmp2_;
#line 369 "WifiMenuItem.c"
			{
				GeeLinkedList* _iter_ap_list = NULL;
				GeeLinkedList* _tmp3_;
				gint _iter_ap_size = 0;
				GeeLinkedList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _iter_ap_index = 0;
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				_tmp3_ = self->priv->all_aps;
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				_iter_ap_list = _tmp3_;
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				_tmp4_ = _iter_ap_list;
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				_tmp6_ = _tmp5_;
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				_iter_ap_size = _tmp6_;
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				_iter_ap_index = -1;
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				while (TRUE) {
#line 394 "WifiMenuItem.c"
					gint _tmp7_;
					gint _tmp8_;
					NMAccessPoint* iter_ap = NULL;
					GeeLinkedList* _tmp9_;
					gpointer _tmp10_;
					NMAccessPoint* _tmp11_;
					guint8 _tmp12_;
					guint8 _tmp13_;
					NMAccessPoint* _tmp14_;
					guint8 _tmp15_;
					guint8 _tmp16_;
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_iter_ap_index = _iter_ap_index + 1;
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp7_ = _iter_ap_index;
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp8_ = _iter_ap_size;
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					if (!(_tmp7_ < _tmp8_)) {
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
						break;
#line 416 "WifiMenuItem.c"
					}
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp9_ = _iter_ap_list;
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _iter_ap_index);
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					iter_ap = (NMAccessPoint*) _tmp10_;
#line 118 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp11_ = ap;
#line 118 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp12_ = nm_access_point_get_strength (_tmp11_);
#line 118 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp13_ = _tmp12_;
#line 118 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp14_ = iter_ap;
#line 118 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp15_ = nm_access_point_get_strength (_tmp14_);
#line 118 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp16_ = _tmp15_;
#line 118 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					if (_tmp13_ < _tmp16_) {
#line 438 "WifiMenuItem.c"
						NMAccessPoint* _tmp17_;
						NMAccessPoint* _tmp18_;
#line 119 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
						_tmp17_ = iter_ap;
#line 119 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
						_tmp18_ = _g_object_ref0 (_tmp17_);
#line 119 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
						_g_object_unref0 (ap);
#line 119 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
						ap = _tmp18_;
#line 449 "WifiMenuItem.c"
					}
#line 117 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_g_object_unref0 (iter_ap);
#line 453 "WifiMenuItem.c"
				}
			}
#line 123 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			result = ap;
#line 458 "WifiMenuItem.c"
			{
				GeeLinkedList* _tmp19_;
#line 115 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				_tmp19_ = self->priv->all_aps;
#line 115 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				g_rec_mutex_unlock (&self->priv->__lock_all_aps);
#line 465 "WifiMenuItem.c"
			}
#line 123 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			return result;
#line 469 "WifiMenuItem.c"
		}
		__finally0:
		{
			GeeLinkedList* _tmp20_;
#line 115 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_tmp20_ = self->priv->all_aps;
#line 115 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			g_rec_mutex_unlock (&self->priv->__lock_all_aps);
#line 478 "WifiMenuItem.c"
		}
#line 115 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 115 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		g_clear_error (&_inner_error0_);
#line 115 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		return NULL;
#line 486 "WifiMenuItem.c"
	}
}

static gboolean
___lambda5_ (NetworkWifiMenuItem* self)
{
	gboolean result;
#line 134 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update (self);
#line 135 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	result = G_SOURCE_CONTINUE;
#line 135 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	return result;
#line 500 "WifiMenuItem.c"
}

static gboolean
____lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda5_ ((NetworkWifiMenuItem*) self);
#line 133 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	return result;
#line 510 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_start_refresh (NetworkWifiMenuItem* self)
{
	GError* _inner_error0_ = NULL;
#line 127 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 519 "WifiMenuItem.c"
	{
#line 128 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		g_rec_mutex_lock (&self->priv->__lock_refresh_source);
#line 523 "WifiMenuItem.c"
		{
#line 129 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			if (self->priv->refresh_source > ((guint) 0)) {
#line 130 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				g_source_remove (self->priv->refresh_source);
#line 529 "WifiMenuItem.c"
			}
#line 133 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			self->priv->refresh_source = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 5, ____lambda5__gsource_func, g_object_ref (self), g_object_unref);
#line 533 "WifiMenuItem.c"
		}
		__finally0:
		{
#line 128 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			g_rec_mutex_unlock (&self->priv->__lock_refresh_source);
#line 539 "WifiMenuItem.c"
		}
#line 128 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 128 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 128 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			g_clear_error (&_inner_error0_);
#line 128 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			return;
#line 549 "WifiMenuItem.c"
		}
	}
}

static void
network_wifi_menu_item_stop_refresh (NetworkWifiMenuItem* self)
{
	GError* _inner_error0_ = NULL;
#line 140 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 560 "WifiMenuItem.c"
	{
#line 141 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		g_rec_mutex_lock (&self->priv->__lock_refresh_source);
#line 564 "WifiMenuItem.c"
		{
#line 142 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			g_source_remove (self->priv->refresh_source);
#line 143 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			self->priv->refresh_source = (guint) 0;
#line 570 "WifiMenuItem.c"
		}
		__finally0:
		{
#line 141 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			g_rec_mutex_unlock (&self->priv->__lock_refresh_source);
#line 576 "WifiMenuItem.c"
		}
#line 141 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 141 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 141 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			g_clear_error (&_inner_error0_);
#line 141 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			return;
#line 586 "WifiMenuItem.c"
		}
	}
}

static void
network_wifi_menu_item_update (NetworkWifiMenuItem* self)
{
	GtkRadioButton* _tmp0_;
	GBytes* _tmp1_;
	gsize _tmp2_ = 0;
	guint8* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	NMAccessPoint* ap = NULL;
	NM80211ApSecurityFlags flags = 0U;
	NMAccessPoint* _tmp10_;
	NM80211ApSecurityFlags _tmp11_;
	NM80211ApSecurityFlags _tmp12_;
	gboolean is_secured = FALSE;
	GtkImage* _tmp17_;
	GtkImage* _tmp18_;
	GtkImage* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
	GtkImage* _tmp22_;
	GtkSpinner* _tmp23_;
	NetworkState _tmp24_;
	guint8 next_strength = 0U;
	GtkImage* _tmp43_;
	const gchar* _tmp44_;
	GError* _inner_error0_ = NULL;
#line 147 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 148 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->radio_button;
#line 148 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp1_ = self->priv->_ssid;
#line 148 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp3_ = g_bytes_get_data (_tmp1_, &_tmp2_);
#line 148 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp4_ = nm_utils_ssid_to_utf8 (_tmp3_, (gsize) _tmp2_);
#line 148 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp5_ = _tmp4_;
#line 148 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_button_set_label ((GtkButton*) _tmp0_, _tmp5_);
#line 148 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_g_free0 (_tmp5_);
#line 150 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	ap = NULL;
#line 636 "WifiMenuItem.c"
	{
		GeeLinkedList* _tmp6_;
#line 151 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		_tmp6_ = self->priv->all_aps;
#line 151 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		g_rec_mutex_lock (&self->priv->__lock_all_aps);
#line 643 "WifiMenuItem.c"
		{
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
#line 152 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_tmp7_ = self->priv->all_aps;
#line 152 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_tmp8_ = gee_linked_list_first (_tmp7_);
#line 152 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_g_object_unref0 (ap);
#line 152 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			ap = (NMAccessPoint*) _tmp8_;
#line 655 "WifiMenuItem.c"
		}
		__finally0:
		{
			GeeLinkedList* _tmp9_;
#line 151 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_tmp9_ = self->priv->all_aps;
#line 151 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			g_rec_mutex_unlock (&self->priv->__lock_all_aps);
#line 664 "WifiMenuItem.c"
		}
#line 151 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 151 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_g_object_unref0 (ap);
#line 151 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 151 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			g_clear_error (&_inner_error0_);
#line 151 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			return;
#line 676 "WifiMenuItem.c"
		}
	}
#line 155 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp10_ = ap;
#line 155 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp11_ = nm_access_point_get_wpa_flags (_tmp10_);
#line 155 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp12_ = _tmp11_;
#line 155 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	flags = _tmp12_;
#line 156 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	is_secured = FALSE;
#line 158 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	if ((flags & NM_802_11_AP_SEC_GROUP_WEP40) == NM_802_11_AP_SEC_GROUP_WEP40) {
#line 159 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		is_secured = TRUE;
#line 160 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("This network uses 40/64-bit WEP encryption"));
#line 695 "WifiMenuItem.c"
	} else {
#line 161 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		if ((flags & NM_802_11_AP_SEC_GROUP_WEP104) == NM_802_11_AP_SEC_GROUP_WEP104) {
#line 162 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			is_secured = TRUE;
#line 163 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("This network uses 104/128-bit WEP encryption"));
#line 703 "WifiMenuItem.c"
		} else {
#line 164 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			if ((flags & NM_802_11_AP_SEC_KEY_MGMT_PSK) == NM_802_11_AP_SEC_KEY_MGMT_PSK) {
#line 165 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				is_secured = TRUE;
#line 166 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("This network uses WPA encryption"));
#line 711 "WifiMenuItem.c"
			} else {
				gboolean _tmp13_ = FALSE;
#line 167 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				if (flags != NM_802_11_AP_SEC_NONE) {
#line 167 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp13_ = TRUE;
#line 718 "WifiMenuItem.c"
				} else {
					NMAccessPoint* _tmp14_;
					NM80211ApSecurityFlags _tmp15_;
					NM80211ApSecurityFlags _tmp16_;
#line 167 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp14_ = ap;
#line 167 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp15_ = nm_access_point_get_rsn_flags (_tmp14_);
#line 167 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp16_ = _tmp15_;
#line 167 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp13_ = _tmp16_ != NM_802_11_AP_SEC_NONE;
#line 731 "WifiMenuItem.c"
				}
#line 167 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				if (_tmp13_) {
#line 168 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					is_secured = TRUE;
#line 169 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("This network uses encryption"));
#line 739 "WifiMenuItem.c"
				} else {
#line 171 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("This network is unsecured"));
#line 743 "WifiMenuItem.c"
				}
			}
		}
	}
#line 174 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp17_ = self->priv->lock_img;
#line 174 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp17_, !is_secured);
#line 175 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp18_ = self->priv->lock_img;
#line 175 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp19_ = self->priv->lock_img;
#line 175 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp20_ = gtk_widget_get_visible ((GtkWidget*) _tmp19_);
#line 175 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp21_ = _tmp20_;
#line 175 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp18_, !_tmp21_);
#line 177 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp22_ = self->priv->error_img;
#line 177 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_hide_item (self, (GtkWidget*) _tmp22_);
#line 178 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp23_ = self->priv->spinner;
#line 178 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_hide_item (self, (GtkWidget*) _tmp23_);
#line 180 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp24_ = self->priv->_state;
#line 180 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	switch (_tmp24_) {
#line 180 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		case NETWORK_STATE_FAILED_WIFI:
#line 776 "WifiMenuItem.c"
		{
			GtkImage* _tmp25_;
#line 182 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_tmp25_ = self->priv->error_img;
#line 182 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			network_wifi_menu_item_show_item (self, (GtkWidget*) _tmp25_);
#line 183 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			break;
#line 785 "WifiMenuItem.c"
		}
#line 180 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		case NETWORK_STATE_CONNECTING_WIFI:
#line 789 "WifiMenuItem.c"
		{
			GtkSpinner* _tmp26_;
			GtkRadioButton* _tmp27_;
			gboolean _tmp28_;
			gboolean _tmp29_;
#line 185 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_tmp26_ = self->priv->spinner;
#line 185 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			network_wifi_menu_item_show_item (self, (GtkWidget*) _tmp26_);
#line 186 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_tmp27_ = self->priv->radio_button;
#line 186 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_tmp28_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp27_);
#line 186 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_tmp29_ = _tmp28_;
#line 186 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			if (!_tmp29_) {
#line 187 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				g_critical ("WifiMenuItem.vala:187: An access point is being connected but not acti" \
"ve.");
#line 809 "WifiMenuItem.c"
			}
#line 189 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			break;
#line 813 "WifiMenuItem.c"
		}
		default:
#line 180 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		break;
#line 818 "WifiMenuItem.c"
	}
#line 193 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	next_strength = (guint8) 0;
#line 822 "WifiMenuItem.c"
	{
		GeeLinkedList* _tmp30_;
#line 194 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		_tmp30_ = self->priv->all_aps;
#line 194 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		g_rec_mutex_lock (&self->priv->__lock_all_aps);
#line 829 "WifiMenuItem.c"
		{
			{
				GeeLinkedList* _iter_ap_list = NULL;
				GeeLinkedList* _tmp31_;
				gint _iter_ap_size = 0;
				GeeLinkedList* _tmp32_;
				gint _tmp33_;
				gint _tmp34_;
				gint _iter_ap_index = 0;
#line 195 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				_tmp31_ = self->priv->all_aps;
#line 195 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				_iter_ap_list = _tmp31_;
#line 195 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				_tmp32_ = _iter_ap_list;
#line 195 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				_tmp33_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp32_);
#line 195 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				_tmp34_ = _tmp33_;
#line 195 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				_iter_ap_size = _tmp34_;
#line 195 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				_iter_ap_index = -1;
#line 195 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				while (TRUE) {
#line 855 "WifiMenuItem.c"
					gint _tmp35_;
					gint _tmp36_;
					NMAccessPoint* iter_ap = NULL;
					GeeLinkedList* _tmp37_;
					gpointer _tmp38_;
					NMAccessPoint* _tmp39_;
					guint8 _tmp40_;
					guint8 _tmp41_;
#line 195 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_iter_ap_index = _iter_ap_index + 1;
#line 195 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp35_ = _iter_ap_index;
#line 195 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp36_ = _iter_ap_size;
#line 195 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					if (!(_tmp35_ < _tmp36_)) {
#line 195 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
						break;
#line 874 "WifiMenuItem.c"
					}
#line 195 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp37_ = _iter_ap_list;
#line 195 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp38_ = gee_abstract_list_get ((GeeAbstractList*) _tmp37_, _iter_ap_index);
#line 195 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					iter_ap = (NMAccessPoint*) _tmp38_;
#line 196 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp39_ = iter_ap;
#line 196 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp40_ = nm_access_point_get_strength (_tmp39_);
#line 196 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_tmp41_ = _tmp40_;
#line 196 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					next_strength = MAX (next_strength, _tmp41_);
#line 195 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
					_g_object_unref0 (iter_ap);
#line 892 "WifiMenuItem.c"
				}
			}
		}
		__finally1:
		{
			GeeLinkedList* _tmp42_;
#line 194 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_tmp42_ = self->priv->all_aps;
#line 194 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			g_rec_mutex_unlock (&self->priv->__lock_all_aps);
#line 903 "WifiMenuItem.c"
		}
#line 194 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 194 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_g_object_unref0 (ap);
#line 194 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 194 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			g_clear_error (&_inner_error0_);
#line 194 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			return;
#line 915 "WifiMenuItem.c"
		}
	}
#line 200 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_set_strength (self, next_strength);
#line 201 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp43_ = self->priv->img_strength;
#line 201 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp44_ = network_wifi_menu_item_get_strength_symbolic_icon (self);
#line 201 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_object_set (_tmp43_, "icon-name", _tmp44_, NULL);
#line 147 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (ap);
#line 928 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_show_item (NetworkWifiMenuItem* self,
                                  GtkWidget* w)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 204 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 204 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (w != NULL);
#line 205 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_visible (w, TRUE);
#line 206 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = gtk_widget_get_visible (w);
#line 206 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp1_ = _tmp0_;
#line 206 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_no_show_all (w, !_tmp1_);
#line 949 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_hide_item (NetworkWifiMenuItem* self,
                                  GtkWidget* w)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 209 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 209 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (w != NULL);
#line 210 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_visible (w, FALSE);
#line 211 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = gtk_widget_get_visible (w);
#line 211 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp1_ = _tmp0_;
#line 211 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_no_show_all (w, !_tmp1_);
#line 212 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_hide (w);
#line 972 "WifiMenuItem.c"
}

static const gchar*
network_wifi_menu_item_get_strength_symbolic_icon (NetworkWifiMenuItem* self)
{
	guint8 _tmp0_;
	const gchar* result;
#line 217 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 218 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->_strength;
#line 218 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	if (((gint) _tmp0_) < 30) {
#line 219 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		result = NETWORK_WIFI_MENU_ITEM_BASE_ICON_NAME "weak" NETWORK_WIFI_MENU_ITEM_SYMBOLIC;
#line 219 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		return result;
#line 990 "WifiMenuItem.c"
	} else {
		guint8 _tmp1_;
#line 220 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		_tmp1_ = self->priv->_strength;
#line 220 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		if (((gint) _tmp1_) < 55) {
#line 221 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			result = NETWORK_WIFI_MENU_ITEM_BASE_ICON_NAME "ok" NETWORK_WIFI_MENU_ITEM_SYMBOLIC;
#line 221 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			return result;
#line 1001 "WifiMenuItem.c"
		} else {
			guint8 _tmp2_;
#line 222 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			_tmp2_ = self->priv->_strength;
#line 222 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
			if (((gint) _tmp2_) < 80) {
#line 223 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				result = NETWORK_WIFI_MENU_ITEM_BASE_ICON_NAME "good" NETWORK_WIFI_MENU_ITEM_SYMBOLIC;
#line 223 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				return result;
#line 1012 "WifiMenuItem.c"
			} else {
#line 225 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				result = NETWORK_WIFI_MENU_ITEM_BASE_ICON_NAME "excellent" NETWORK_WIFI_MENU_ITEM_SYMBOLIC;
#line 225 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
				return result;
#line 1018 "WifiMenuItem.c"
			}
		}
	}
}

NetworkState
network_wifi_menu_item_get_state (NetworkWifiMenuItem* self)
{
	NetworkState result;
#line 20 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 20 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	result = self->priv->_state;
#line 20 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	return result;
#line 1034 "WifiMenuItem.c"
}

void
network_wifi_menu_item_set_state (NetworkWifiMenuItem* self,
                                  NetworkState value)
{
	NetworkState old_value;
#line 20 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 20 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	old_value = network_wifi_menu_item_get_state (self);
#line 20 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	if (old_value != value) {
#line 20 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		self->priv->_state = value;
#line 20 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY]);
#line 1052 "WifiMenuItem.c"
	}
}

GBytes*
network_wifi_menu_item_get_ssid (NetworkWifiMenuItem* self)
{
	GBytes* result;
	GBytes* _tmp0_;
#line 21 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->_ssid;
#line 21 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	result = _tmp0_;
#line 21 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	return result;
#line 1069 "WifiMenuItem.c"
}

static gpointer
_g_bytes_ref0 (gpointer self)
{
#line 21 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	return self ? g_bytes_ref (self) : NULL;
#line 1077 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_set_ssid (NetworkWifiMenuItem* self,
                                 GBytes* value)
{
	GBytes* old_value;
#line 21 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 21 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	old_value = network_wifi_menu_item_get_ssid (self);
#line 21 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	if (old_value != value) {
#line 1091 "WifiMenuItem.c"
		GBytes* _tmp0_;
#line 21 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		_tmp0_ = _g_bytes_ref0 (value);
#line 21 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		_g_bytes_unref0 (self->priv->_ssid);
#line 21 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		self->priv->_ssid = _tmp0_;
#line 21 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY]);
#line 1101 "WifiMenuItem.c"
	}
}

guint8
network_wifi_menu_item_get_strength (NetworkWifiMenuItem* self)
{
	guint8 result;
#line 22 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 22 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	result = self->priv->_strength;
#line 22 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	return result;
#line 1115 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_set_strength (NetworkWifiMenuItem* self,
                                     guint8 value)
{
	guint8 old_value;
#line 22 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 22 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	old_value = network_wifi_menu_item_get_strength (self);
#line 22 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	if (old_value != value) {
#line 22 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		self->priv->_strength = value;
#line 22 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY]);
#line 1133 "WifiMenuItem.c"
	}
}

static void
_network_wifi_menu_item_update_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
#line 66 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update ((NetworkWifiMenuItem*) self);
#line 1144 "WifiMenuItem.c"
}

static gboolean
_network_wifi_menu_item___lambda6_ (NetworkWifiMenuItem* self)
{
#line 68 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_signal_emit_by_name ((GtkListBoxRow*) self, "activate");
#line 1152 "WifiMenuItem.c"
}

static gboolean
__network_wifi_menu_item___lambda6__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                     GdkEventButton* event,
                                                                     gpointer self)
{
	gboolean result;
	result = _network_wifi_menu_item___lambda6_ ((NetworkWifiMenuItem*) self);
#line 68 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	return result;
#line 1164 "WifiMenuItem.c"
}

static void
_network_wifi_menu_item___lambda7_ (NetworkWifiMenuItem* self)
{
#line 70 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_signal_emit (self, network_wifi_menu_item_signals[NETWORK_WIFI_MENU_ITEM_USER_ACTION_SIGNAL], 0);
#line 1172 "WifiMenuItem.c"
}

static void
__network_wifi_menu_item___lambda7__gtk_list_box_row_activate (GtkListBoxRow* _sender,
                                                               gpointer self)
{
#line 69 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_network_wifi_menu_item___lambda7_ ((NetworkWifiMenuItem*) self);
#line 1181 "WifiMenuItem.c"
}

static void
_network_wifi_menu_item___lambda8_ (NetworkWifiMenuItem* self)
{
#line 73 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_start_refresh (self);
#line 1189 "WifiMenuItem.c"
}

static void
__network_wifi_menu_item___lambda8__gtk_widget_map (GtkWidget* _sender,
                                                    gpointer self)
{
#line 73 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_network_wifi_menu_item___lambda8_ ((NetworkWifiMenuItem*) self);
#line 1198 "WifiMenuItem.c"
}

static void
_network_wifi_menu_item___lambda9_ (NetworkWifiMenuItem* self)
{
#line 74 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_stop_refresh (self);
#line 1206 "WifiMenuItem.c"
}

static void
__network_wifi_menu_item___lambda9__gtk_widget_unmap (GtkWidget* _sender,
                                                      gpointer self)
{
#line 74 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_network_wifi_menu_item___lambda9_ ((NetworkWifiMenuItem*) self);
#line 1215 "WifiMenuItem.c"
}

static GObject *
network_wifi_menu_item_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkWifiMenuItem * self;
	GeeLinkedList* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkRadioButton* _tmp2_;
	GtkRadioButton* _tmp3_;
	GtkRadioButton* _tmp4_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* _tmp8_;
	GtkImage* _tmp9_;
	GtkImage* _tmp10_;
	GtkSpinner* _tmp11_;
	GtkSpinner* _tmp12_;
	GtkSpinner* _tmp13_;
	GtkSpinner* _tmp14_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp15_;
	GtkGrid* _tmp16_;
	GtkGrid* _tmp17_;
	GtkRadioButton* _tmp18_;
	GtkGrid* _tmp19_;
	GtkSpinner* _tmp20_;
	GtkGrid* _tmp21_;
	GtkImage* _tmp22_;
	GtkGrid* _tmp23_;
	GtkImage* _tmp24_;
	GtkGrid* _tmp25_;
	GtkImage* _tmp26_;
	GtkGrid* _tmp27_;
	GtkRadioButton* _tmp28_;
#line 33 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	parent_class = G_OBJECT_CLASS (network_wifi_menu_item_parent_class);
#line 33 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 33 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
#line 34 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = gee_linked_list_new (nm_access_point_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 34 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->all_aps);
#line 34 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	self->priv->all_aps = _tmp0_;
#line 35 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 35 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_style_context_add_class (_tmp1_, "menuitem");
#line 37 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp2_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
#line 37 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp2_);
#line 37 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->radio_button);
#line 37 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	self->priv->radio_button = _tmp2_;
#line 38 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp3_ = self->priv->radio_button;
#line 38 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp3_, TRUE);
#line 39 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp4_ = self->priv->radio_button;
#line 39 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp4_, 6);
#line 41 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp5_ = (GtkImage*) gtk_image_new ();
#line 41 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp5_);
#line 41 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->img_strength);
#line 41 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	self->priv->img_strength = _tmp5_;
#line 42 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp6_ = self->priv->img_strength;
#line 42 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_object_set (_tmp6_, "icon-size", (gint) GTK_ICON_SIZE_MENU, NULL);
#line 43 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp7_ = self->priv->img_strength;
#line 43 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp7_, 6);
#line 45 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp8_ = (GtkImage*) gtk_image_new_from_icon_name ("channel-insecure-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 45 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp8_);
#line 45 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->lock_img);
#line 45 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	self->priv->lock_img = _tmp8_;
#line 48 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp9_ = (GtkImage*) gtk_image_new_from_icon_name ("process-error-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 48 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp9_);
#line 48 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->error_img);
#line 48 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	self->priv->error_img = _tmp9_;
#line 49 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp10_ = self->priv->error_img;
#line 49 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp10_, _ ("This wireless network could not be connected to."));
#line 51 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp11_ = (GtkSpinner*) gtk_spinner_new ();
#line 51 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp11_);
#line 51 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->spinner);
#line 51 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	self->priv->spinner = _tmp11_;
#line 52 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp12_ = self->priv->spinner;
#line 52 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_spinner_start (_tmp12_);
#line 53 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp13_ = self->priv->spinner;
#line 53 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp13_, FALSE);
#line 54 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp14_ = self->priv->spinner;
#line 54 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp14_, TRUE);
#line 56 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp15_ = (GtkGrid*) gtk_grid_new ();
#line 56 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp15_);
#line 56 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	grid = _tmp15_;
#line 57 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp16_ = grid;
#line 57 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_grid_set_column_spacing (_tmp16_, 6);
#line 58 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp17_ = grid;
#line 58 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp18_ = self->priv->radio_button;
#line 58 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
#line 59 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp19_ = grid;
#line 59 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp20_ = self->priv->spinner;
#line 59 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
#line 60 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp21_ = grid;
#line 60 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp22_ = self->priv->error_img;
#line 60 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) _tmp21_, (GtkWidget*) _tmp22_);
#line 61 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp23_ = grid;
#line 61 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp24_ = self->priv->lock_img;
#line 61 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
#line 62 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp25_ = grid;
#line 62 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp26_ = self->priv->img_strength;
#line 62 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) _tmp26_);
#line 64 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp27_ = grid;
#line 64 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp27_);
#line 66 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_signal_connect_object ((GObject*) self, "notify::state", (GCallback) _network_wifi_menu_item_update_g_object_notify, self, 0);
#line 67 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_tmp28_ = self->priv->radio_button;
#line 67 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_signal_connect_object ((GObject*) _tmp28_, "notify::active", (GCallback) _network_wifi_menu_item_update_g_object_notify, self, 0);
#line 68 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_signal_connect_object ((GtkWidget*) self, "button-release-event", (GCallback) __network_wifi_menu_item___lambda6__gtk_widget_button_release_event, self, 0);
#line 69 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_signal_connect_object ((GtkListBoxRow*) self, "activate", (GCallback) __network_wifi_menu_item___lambda7__gtk_list_box_row_activate, self, 0);
#line 73 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_signal_connect_object ((GtkWidget*) self, "map", (GCallback) __network_wifi_menu_item___lambda8__gtk_widget_map, self, 0);
#line 74 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_signal_connect_object ((GtkWidget*) self, "unmap", (GCallback) __network_wifi_menu_item___lambda9__gtk_widget_unmap, self, 0);
#line 33 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (grid);
#line 33 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	return obj;
#line 1406 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_class_init (NetworkWifiMenuItemClass * klass,
                                   gpointer klass_data)
{
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_parent_class = g_type_class_peek_parent (klass);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_type_class_adjust_private_offset (klass, &NetworkWifiMenuItem_private_offset);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_network_wifi_menu_item_get_property;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_network_wifi_menu_item_set_property;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (klass)->constructor = network_wifi_menu_item_constructor;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (klass)->finalize = network_wifi_menu_item_finalize;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", NETWORK_TYPE_STATE, NETWORK_STATE_DISCONNECTED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY] = g_param_spec_boxed ("ssid", "ssid", "ssid", G_TYPE_BYTES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY] = g_param_spec_uchar ("strength", "strength", "strength", 0, G_MAXUINT8, (guint8) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_signals[NETWORK_WIFI_MENU_ITEM_USER_ACTION_SIGNAL] = g_signal_new ("user-action", NETWORK_TYPE_WIFI_MENU_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1433 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_instance_init (NetworkWifiMenuItem * self,
                                      gpointer klass)
{
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	self->priv = network_wifi_menu_item_get_instance_private (self);
#line 20 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	self->priv->_state = NETWORK_STATE_DISCONNECTED;
#line 22 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	self->priv->_strength = (guint8) 0;
#line 24 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_rec_mutex_init (&self->priv->__lock_all_aps);
#line 31 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_rec_mutex_init (&self->priv->__lock_refresh_source);
#line 31 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	self->priv->refresh_source = (guint) 0;
#line 1452 "WifiMenuItem.c"
}

static void
network_wifi_menu_item_finalize (GObject * obj)
{
	NetworkWifiMenuItem * self;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
#line 21 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_g_bytes_unref0 (self->priv->_ssid);
#line 24 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_rec_mutex_clear (&self->priv->__lock_all_aps);
#line 24 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->all_aps);
#line 26 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->radio_button);
#line 27 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->img_strength);
#line 28 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->lock_img);
#line 29 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->error_img);
#line 30 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->spinner);
#line 31 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	g_rec_mutex_clear (&self->priv->__lock_refresh_source);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (network_wifi_menu_item_parent_class)->finalize (obj);
#line 1481 "WifiMenuItem.c"
}

GType
network_wifi_menu_item_get_type (void)
{
	return network_wifi_menu_item_type_id;
}

GType
network_wifi_menu_item_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkWifiMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_wifi_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWifiMenuItem), 0, (GInstanceInitFunc) network_wifi_menu_item_instance_init, NULL };
	network_wifi_menu_item_type_id = g_type_module_register_type (module, gtk_list_box_row_get_type (), "NetworkWifiMenuItem", &g_define_type_info, 0);
	NetworkWifiMenuItem_private_offset = sizeof (NetworkWifiMenuItemPrivate);
	return network_wifi_menu_item_type_id;
}

static void
_vala_network_wifi_menu_item_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	switch (property_id) {
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY:
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		g_value_set_enum (value, network_wifi_menu_item_get_state (self));
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		break;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY:
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		g_value_set_boxed (value, network_wifi_menu_item_get_ssid (self));
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		break;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY:
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		g_value_set_uchar (value, network_wifi_menu_item_get_strength (self));
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		break;
#line 1527 "WifiMenuItem.c"
		default:
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		break;
#line 1533 "WifiMenuItem.c"
	}
}

static void
_vala_network_wifi_menu_item_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
	switch (property_id) {
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY:
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		network_wifi_menu_item_set_state (self, g_value_get_enum (value));
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		break;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY:
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		network_wifi_menu_item_set_ssid (self, g_value_get_boxed (value));
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		break;
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY:
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		network_wifi_menu_item_set_strength (self, g_value_get_uchar (value));
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		break;
#line 1565 "WifiMenuItem.c"
		default:
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../budgie-network-manager/budgie-network-applet/src/common/Widgets/WifiMenuItem.vala"
		break;
#line 1571 "WifiMenuItem.c"
	}
}

