/* FuzzyClockApplet.c generated by valac 0.56.18, the Vala compiler
 * generated from FuzzyClockApplet.vala, do not modify */

/*
 * This file is part of budgie-extras
 *
 * Copyright © 2019 Ubuntu Budgie Developers
 * Author: Adam Dyess
 * Website=https://ubuntubudgie.org
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or any later version.
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details. You should have received a copy of the GNU General Public
 * License along with this program.  If not, see
 * <https://www.gnu.org/licenses/>.
 */

#include "fuzzyclock.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <plugin.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <locale.h>
#include <config.h>
#include <gio/gdesktopappinfo.h>
#include <libpeas/peas.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FUZZY_CLOCK_PLUGIN_0_PROPERTY,
	FUZZY_CLOCK_PLUGIN_NUM_PROPERTIES
};
static GParamSpec* fuzzy_clock_plugin_properties[FUZZY_CLOCK_PLUGIN_NUM_PROPERTIES];
typedef enum  {
	CLOCK_FORMAT_TWENTYFOUR = 0,
	CLOCK_FORMAT_TWELVE = 1
} ClockFormat;

#define TYPE_CLOCK_FORMAT (clock_format_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _ParamSpecFuzzyClockRule ParamSpecFuzzyClockRule;
enum  {
	FUZZY_CLOCK_APPLET_0_PROPERTY,
	FUZZY_CLOCK_APPLET_UUID_PROPERTY,
	FUZZY_CLOCK_APPLET_NUM_PROPERTIES
};
static GParamSpec* fuzzy_clock_applet_properties[FUZZY_CLOCK_APPLET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _ParamSpecFuzzyClockRule {
	GParamSpec parent_instance;
};

struct _FuzzyClockAppletPrivate {
	gchar* _uuid;
	GSettings* panel_settings;
	GSettings* currpanelsubject_settings;
	gboolean fuzzy_onpanel;
	gchar* general_path;
	gchar* date_format;
	GDateTime* time;
	BudgiePopover* popover;
	GAppInfo* calprov;
	GtkButton* cal_button;
	GtkCheckButton* clock_format;
	GtkCheckButton* check_date;
	gulong check_id;
	GtkOrientation orient;
	BudgiePopoverManager* manager;
};

struct _Block1Data {
	int _ref_count_;
	FuzzyClockApplet* self;
	gchar** applets;
	gint applets_length1;
	gint _applets_size_;
	gchar* uuid;
};

struct _Block2Data {
	int _ref_count_;
	FuzzyClockApplet* self;
	GtkStack* stack;
	gchar* uuid;
};

static gpointer fuzzy_clock_plugin_parent_class = NULL;
static BudgiePluginIface * fuzzy_clock_plugin_budgie_plugin_parent_iface = NULL;
static GType fuzzy_clock_plugin_type_id = 0;
static gpointer fuzzy_clock_rule_parent_class = NULL;
static GType fuzzy_clock_rule_type_id = 0;
static gint FuzzyClockApplet_private_offset;
static gpointer fuzzy_clock_applet_parent_class = NULL;
static GType fuzzy_clock_applet_type_id = 0;

static BudgieApplet* fuzzy_clock_plugin_real_get_panel_widget (BudgiePlugin* base,
                                                        const gchar* uuid);
VALA_EXTERN GType clock_format_get_type (void) G_GNUC_CONST ;
static void fuzzy_clock_rule_finalize (FuzzyClockRule * obj);
static gboolean fuzzy_clock_applet_find_applet (FuzzyClockApplet* self,
                                         const gchar* uuid,
                                         gchar** applets,
                                         gint applets_length1);
static void fuzzy_clock_applet_watchapplet (FuzzyClockApplet* self,
                                     const gchar* uuid);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void _____lambda4_ (Block1Data* _data1_);
static void ______lambda4__g_settings_changed (GSettings* _sender,
                                        const gchar* key,
                                        gpointer self);
static GtkButton* fuzzy_clock_applet_new_directional_button (FuzzyClockApplet* self,
                                                      const gchar* label_str,
                                                      GtkPositionType arrow_direction);
static GtkButton* fuzzy_clock_applet_new_plain_button (FuzzyClockApplet* self,
                                                const gchar* label_str);
static void fuzzy_clock_applet_real_panel_position_changed (BudgieApplet* base,
                                                     BudgiePanelPosition position);
static gint fuzzy_clock_applet_get_containingindex (FuzzyClockApplet* self,
                                             gchar** arr,
                                             gint arr_length1,
                                             const gchar* lookfor);
static gchar* fuzzy_clock_applet_read_dateformat (FuzzyClockApplet* self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean __lambda5_ (Block2Data* _data2_);
static gboolean ___lambda5__gsource_func (gpointer self);
static void fuzzy_clock_applet_on_date_activate (FuzzyClockApplet* self);
static void _fuzzy_clock_applet_on_date_activate_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void fuzzy_clock_applet_on_cal_activate (FuzzyClockApplet* self);
static void _fuzzy_clock_applet_on_cal_activate_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void __lambda6_ (Block2Data* _data2_);
static void ___lambda6__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void __lambda7_ (FuzzyClockApplet* self);
static void ___lambda7__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self);
static void __lambda8_ (Block2Data* _data2_);
static void ___lambda8__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void __lambda9_ (Block2Data* _data2_);
static void ___lambda9__budgie_popover_closed (BudgiePopover* _sender,
                                        gpointer self);
static gboolean __lambda10_ (FuzzyClockApplet* self,
                      GdkEventButton* e);
static gboolean ___lambda10__gtk_widget_button_press_event (GtkWidget* _sender,
                                                     GdkEventButton* event,
                                                     gpointer self);
static gboolean _fuzzy_clock_applet_update_clock_gsource_func (gpointer self);
static void _fuzzy_clock_applet_on_settings_change_g_settings_changed (GSettings* _sender,
                                                                const gchar* key,
                                                                gpointer self);
static void fuzzy_clock_applet_update_cal (FuzzyClockApplet* self);
static void _fuzzy_clock_applet_update_cal_g_app_info_monitor_changed (GAppInfoMonitor* _sender,
                                                                gpointer self);
static void fuzzy_clock_applet_real_update_popovers (BudgieApplet* base,
                                              BudgiePopoverManager* manager);
static void fuzzy_clock_applet_finalize (GObject * obj);
static void _vala_fuzzy_clock_applet_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_fuzzy_clock_applet_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static BudgieApplet*
fuzzy_clock_plugin_real_get_panel_widget (BudgiePlugin* base,
                                          const gchar* uuid)
{
	FuzzyClockPlugin * self;
	FuzzyClockApplet* _tmp0_;
	BudgieApplet* result;
#line 20 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self = (FuzzyClockPlugin*) base;
#line 20 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 22 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = fuzzy_clock_applet_new (uuid);
#line 22 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_ref_sink (_tmp0_);
#line 22 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	result = (BudgieApplet*) _tmp0_;
#line 22 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return result;
#line 223 "FuzzyClockApplet.c"
}

FuzzyClockPlugin*
fuzzy_clock_plugin_construct (GType object_type)
{
	FuzzyClockPlugin * self = NULL;
#line 18 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self = (FuzzyClockPlugin*) g_object_new (object_type, NULL);
#line 18 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return self;
#line 234 "FuzzyClockApplet.c"
}

FuzzyClockPlugin*
fuzzy_clock_plugin_new (void)
{
#line 18 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return fuzzy_clock_plugin_construct (TYPE_FUZZY_CLOCK_PLUGIN);
#line 242 "FuzzyClockApplet.c"
}

static void
fuzzy_clock_plugin_class_init (FuzzyClockPluginClass * klass,
                               gpointer klass_data)
{
#line 18 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	fuzzy_clock_plugin_parent_class = g_type_class_peek_parent (klass);
#line 251 "FuzzyClockApplet.c"
}

static void
fuzzy_clock_plugin_budgie_plugin_interface_init (BudgiePluginIface * iface,
                                                 gpointer iface_data)
{
#line 18 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	fuzzy_clock_plugin_budgie_plugin_parent_iface = g_type_interface_peek_parent (iface);
#line 18 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	iface->get_panel_widget = (BudgieApplet* (*) (BudgiePlugin*, const gchar*)) fuzzy_clock_plugin_real_get_panel_widget;
#line 262 "FuzzyClockApplet.c"
}

static void
fuzzy_clock_plugin_instance_init (FuzzyClockPlugin * self,
                                  gpointer klass)
{
}

GType
fuzzy_clock_plugin_get_type (void)
{
	return fuzzy_clock_plugin_type_id;
}

GType
fuzzy_clock_plugin_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (FuzzyClockPluginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) fuzzy_clock_plugin_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FuzzyClockPlugin), 0, (GInstanceInitFunc) fuzzy_clock_plugin_instance_init, NULL };
	static const GInterfaceInfo budgie_plugin_info = { (GInterfaceInitFunc) fuzzy_clock_plugin_budgie_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	fuzzy_clock_plugin_type_id = g_type_module_register_type (module, peas_extension_base_get_type (), "FuzzyClockPlugin", &g_define_type_info, 0);
	g_type_module_add_interface (module, fuzzy_clock_plugin_type_id, budgie_plugin_get_type (), &budgie_plugin_info);
	return fuzzy_clock_plugin_type_id;
}

static GType
clock_format_get_type_once (void)
{
	static const GEnumValue values[] = {{CLOCK_FORMAT_TWENTYFOUR, "CLOCK_FORMAT_TWENTYFOUR", "twentyfour"}, {CLOCK_FORMAT_TWELVE, "CLOCK_FORMAT_TWELVE", "twelve"}, {0, NULL, NULL}};
	GType clock_format_type_id;
	clock_format_type_id = g_enum_register_static ("ClockFormat", values);
	return clock_format_type_id;
}

GType
clock_format_get_type (void)
{
	static volatile gsize clock_format_type_id__once = 0;
	if (g_once_init_enter (&clock_format_type_id__once)) {
		GType clock_format_type_id;
		clock_format_type_id = clock_format_get_type_once ();
		g_once_init_leave (&clock_format_type_id__once, clock_format_type_id);
	}
	return clock_format_type_id__once;
}

/**
     * Format string rules
     *      one for each of 12 text formats
     */
static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 331 "FuzzyClockApplet.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 335 "FuzzyClockApplet.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 341 "FuzzyClockApplet.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 345 "FuzzyClockApplet.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 349 "FuzzyClockApplet.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 357 "FuzzyClockApplet.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 385 "FuzzyClockApplet.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 394 "FuzzyClockApplet.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 408 "FuzzyClockApplet.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 417 "FuzzyClockApplet.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 431 "FuzzyClockApplet.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 440 "FuzzyClockApplet.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 449 "FuzzyClockApplet.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 468 "FuzzyClockApplet.c"
}

FuzzyClockRule*
fuzzy_clock_rule_construct (GType object_type,
                            const gchar* rule_text,
                            gint hour_offset)
{
	FuzzyClockRule* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 43 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_val_if_fail (rule_text != NULL, NULL);
#line 43 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self = (FuzzyClockRule*) g_type_create_instance (object_type);
#line 45 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = string_replace (rule_text, FUZZY_CLOCK_RULE_fwd_hour, "");
#line 45 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp1_ = _tmp0_;
#line 45 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp2_ = string_replace (_tmp1_, FUZZY_CLOCK_RULE_back_hour, "");
#line 45 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_free0 (self->format);
#line 45 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->format = _tmp2_;
#line 45 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_free0 (_tmp1_);
#line 46 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->hour_offset = hour_offset;
#line 47 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (string_contains (rule_text, FUZZY_CLOCK_RULE_fwd_hour)) {
#line 48 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		self->hour_offset = hour_offset + 1;
#line 502 "FuzzyClockApplet.c"
	} else {
#line 50 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		if (string_contains (rule_text, FUZZY_CLOCK_RULE_back_hour)) {
#line 51 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			self->hour_offset = hour_offset - 1;
#line 508 "FuzzyClockApplet.c"
		}
	}
#line 43 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return self;
#line 513 "FuzzyClockApplet.c"
}

FuzzyClockRule*
fuzzy_clock_rule_new (const gchar* rule_text,
                      gint hour_offset)
{
#line 43 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return fuzzy_clock_rule_construct (TYPE_FUZZY_CLOCK_RULE, rule_text, hour_offset);
#line 522 "FuzzyClockApplet.c"
}

static void
value_fuzzy_clock_rule_init (GValue* value)
{
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	value->data[0].v_pointer = NULL;
#line 530 "FuzzyClockApplet.c"
}

static void
value_fuzzy_clock_rule_free_value (GValue* value)
{
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (value->data[0].v_pointer) {
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		fuzzy_clock_rule_unref (value->data[0].v_pointer);
#line 540 "FuzzyClockApplet.c"
	}
}

static void
value_fuzzy_clock_rule_copy_value (const GValue* src_value,
                                   GValue* dest_value)
{
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (src_value->data[0].v_pointer) {
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		dest_value->data[0].v_pointer = fuzzy_clock_rule_ref (src_value->data[0].v_pointer);
#line 552 "FuzzyClockApplet.c"
	} else {
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		dest_value->data[0].v_pointer = NULL;
#line 556 "FuzzyClockApplet.c"
	}
}

static gpointer
value_fuzzy_clock_rule_peek_pointer (const GValue* value)
{
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return value->data[0].v_pointer;
#line 565 "FuzzyClockApplet.c"
}

static gchar*
value_fuzzy_clock_rule_collect_value (GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (collect_values[0].v_pointer) {
#line 576 "FuzzyClockApplet.c"
		FuzzyClockRule * object;
		object = collect_values[0].v_pointer;
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		if (object->parent_instance.g_class == NULL) {
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 583 "FuzzyClockApplet.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 587 "FuzzyClockApplet.c"
		}
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		value->data[0].v_pointer = fuzzy_clock_rule_ref (object);
#line 591 "FuzzyClockApplet.c"
	} else {
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		value->data[0].v_pointer = NULL;
#line 595 "FuzzyClockApplet.c"
	}
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return NULL;
#line 599 "FuzzyClockApplet.c"
}

static gchar*
value_fuzzy_clock_rule_lcopy_value (const GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	FuzzyClockRule ** object_p;
	object_p = collect_values[0].v_pointer;
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (!object_p) {
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 614 "FuzzyClockApplet.c"
	}
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (!value->data[0].v_pointer) {
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		*object_p = NULL;
#line 620 "FuzzyClockApplet.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		*object_p = value->data[0].v_pointer;
#line 624 "FuzzyClockApplet.c"
	} else {
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		*object_p = fuzzy_clock_rule_ref (value->data[0].v_pointer);
#line 628 "FuzzyClockApplet.c"
	}
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return NULL;
#line 632 "FuzzyClockApplet.c"
}

GParamSpec*
param_spec_fuzzy_clock_rule (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags)
{
	ParamSpecFuzzyClockRule* spec;
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_FUZZY_CLOCK_RULE), NULL);
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return G_PARAM_SPEC (spec);
#line 651 "FuzzyClockApplet.c"
}

gpointer
value_get_fuzzy_clock_rule (const GValue* value)
{
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FUZZY_CLOCK_RULE), NULL);
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return value->data[0].v_pointer;
#line 661 "FuzzyClockApplet.c"
}

void
value_set_fuzzy_clock_rule (GValue* value,
                            gpointer v_object)
{
	FuzzyClockRule * old;
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FUZZY_CLOCK_RULE));
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	old = value->data[0].v_pointer;
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (v_object) {
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_FUZZY_CLOCK_RULE));
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		value->data[0].v_pointer = v_object;
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		fuzzy_clock_rule_ref (value->data[0].v_pointer);
#line 683 "FuzzyClockApplet.c"
	} else {
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		value->data[0].v_pointer = NULL;
#line 687 "FuzzyClockApplet.c"
	}
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (old) {
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		fuzzy_clock_rule_unref (old);
#line 693 "FuzzyClockApplet.c"
	}
}

void
value_take_fuzzy_clock_rule (GValue* value,
                             gpointer v_object)
{
	FuzzyClockRule * old;
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FUZZY_CLOCK_RULE));
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	old = value->data[0].v_pointer;
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (v_object) {
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_FUZZY_CLOCK_RULE));
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		value->data[0].v_pointer = v_object;
#line 714 "FuzzyClockApplet.c"
	} else {
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		value->data[0].v_pointer = NULL;
#line 718 "FuzzyClockApplet.c"
	}
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (old) {
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		fuzzy_clock_rule_unref (old);
#line 724 "FuzzyClockApplet.c"
	}
}

static void
fuzzy_clock_rule_class_init (FuzzyClockRuleClass * klass,
                             gpointer klass_data)
{
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	fuzzy_clock_rule_parent_class = g_type_class_peek_parent (klass);
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	((FuzzyClockRuleClass *) klass)->finalize = fuzzy_clock_rule_finalize;
#line 736 "FuzzyClockApplet.c"
}

static void
fuzzy_clock_rule_instance_init (FuzzyClockRule * self,
                                gpointer klass)
{
	gchar* _tmp0_;
#line 37 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = g_strdup ("");
#line 37 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->format = _tmp0_;
#line 38 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->hour_offset = 0;
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->ref_count = 1;
#line 752 "FuzzyClockApplet.c"
}

static void
fuzzy_clock_rule_finalize (FuzzyClockRule * obj)
{
	FuzzyClockRule * self;
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FUZZY_CLOCK_RULE, FuzzyClockRule);
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_signal_handlers_destroy (self);
#line 37 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_free0 (self->format);
#line 765 "FuzzyClockApplet.c"
}

GType
fuzzy_clock_rule_get_type (void)
{
	return fuzzy_clock_rule_type_id;
}

GType
fuzzy_clock_rule_register_type (GTypeModule * module)
{
	static const GTypeValueTable g_define_type_value_table = { value_fuzzy_clock_rule_init, value_fuzzy_clock_rule_free_value, value_fuzzy_clock_rule_copy_value, value_fuzzy_clock_rule_peek_pointer, "p", value_fuzzy_clock_rule_collect_value, "p", value_fuzzy_clock_rule_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (FuzzyClockRuleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) fuzzy_clock_rule_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FuzzyClockRule), 0, (GInstanceInitFunc) fuzzy_clock_rule_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	fuzzy_clock_rule_type_id = g_type_register_fundamental (g_type_fundamental_next (), "FuzzyClockRule", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return fuzzy_clock_rule_type_id;
}

gpointer
fuzzy_clock_rule_ref (gpointer instance)
{
	FuzzyClockRule * self;
	self = instance;
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_atomic_int_inc (&self->ref_count);
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return instance;
#line 793 "FuzzyClockApplet.c"
}

void
fuzzy_clock_rule_unref (gpointer instance)
{
	FuzzyClockRule * self;
	self = instance;
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		FUZZY_CLOCK_RULE_GET_CLASS (self)->finalize (self);
#line 33 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 807 "FuzzyClockApplet.c"
	}
}

static inline gpointer
fuzzy_clock_applet_get_instance_private (FuzzyClockApplet* self)
{
	return G_STRUCT_MEMBER_P (self, FuzzyClockApplet_private_offset);
}

static gboolean
fuzzy_clock_applet_find_applet (FuzzyClockApplet* self,
                                const gchar* uuid,
                                gchar** applets,
                                gint applets_length1)
{
	gboolean result;
#line 65 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 65 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_val_if_fail (uuid != NULL, FALSE);
#line 828 "FuzzyClockApplet.c"
	{
		gint i = 0;
#line 66 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		i = 0;
#line 833 "FuzzyClockApplet.c"
		{
			gboolean _tmp0_ = FALSE;
#line 66 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			_tmp0_ = TRUE;
#line 66 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			while (TRUE) {
#line 840 "FuzzyClockApplet.c"
				const gchar* _tmp2_;
#line 66 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				if (!_tmp0_) {
#line 844 "FuzzyClockApplet.c"
					gint _tmp1_;
#line 66 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
					_tmp1_ = i;
#line 66 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
					i = _tmp1_ + 1;
#line 850 "FuzzyClockApplet.c"
				}
#line 66 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp0_ = FALSE;
#line 66 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				if (!(i < applets_length1)) {
#line 66 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
					break;
#line 858 "FuzzyClockApplet.c"
				}
#line 67 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp2_ = applets[i];
#line 67 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				if (g_strcmp0 (_tmp2_, uuid) == 0) {
#line 68 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
					result = TRUE;
#line 68 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
					return result;
#line 868 "FuzzyClockApplet.c"
				}
			}
		}
	}
#line 71 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	result = FALSE;
#line 71 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return result;
#line 877 "FuzzyClockApplet.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 74 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 74 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return _data1_;
#line 887 "FuzzyClockApplet.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 74 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 897 "FuzzyClockApplet.c"
		FuzzyClockApplet* self;
#line 74 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		self = _data1_->self;
#line 74 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_data1_->applets = (_vala_array_free (_data1_->applets, _data1_->applets_length1, (GDestroyNotify) g_free), NULL);
#line 74 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_free0 (_data1_->uuid);
#line 74 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_object_unref0 (self);
#line 74 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		g_slice_free (Block1Data, _data1_);
#line 909 "FuzzyClockApplet.c"
	}
}

static void
_____lambda4_ (Block1Data* _data1_)
{
	FuzzyClockApplet* self;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
#line 87 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self = _data1_->self;
#line 88 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = self->priv->currpanelsubject_settings;
#line 88 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, "applets");
#line 88 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_data1_->applets = (_vala_array_free (_data1_->applets, _data1_->applets_length1, (GDestroyNotify) g_free), NULL);
#line 88 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_data1_->applets = _tmp2_;
#line 88 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_data1_->applets_length1 = _vala_array_length (_tmp1_);
#line 88 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_data1_->_applets_size_ = _data1_->applets_length1;
#line 89 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp3_ = _data1_->applets;
#line 89 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp3__length1 = _data1_->applets_length1;
#line 89 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (!fuzzy_clock_applet_find_applet (self, _data1_->uuid, _tmp3_, (gint) _tmp3__length1)) {
#line 90 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		self->priv->fuzzy_onpanel = FALSE;
#line 944 "FuzzyClockApplet.c"
	}
}

static void
______lambda4__g_settings_changed (GSettings* _sender,
                                   const gchar* key,
                                   gpointer self)
{
#line 87 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_____lambda4_ (self);
#line 955 "FuzzyClockApplet.c"
}

static void
fuzzy_clock_applet_watchapplet (FuzzyClockApplet* self,
                                const gchar* uuid)
{
	Block1Data* _data1_;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GSettings* _tmp2_;
	gchar** allpanels_list = NULL;
	GSettings* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint allpanels_list_length1;
	gint _allpanels_list_size_;
	gchar** _tmp6_;
	gint _tmp6__length1;
#line 74 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 74 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_if_fail (uuid != NULL);
#line 74 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 74 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_data1_->_ref_count_ = 1;
#line 74 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_data1_->self = g_object_ref (self);
#line 74 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = g_strdup (uuid);
#line 74 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_free0 (_data1_->uuid);
#line 74 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_data1_->uuid = _tmp0_;
#line 77 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp1_ = self->priv->general_path;
#line 77 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp2_ = g_settings_new (_tmp1_);
#line 77 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->priv->panel_settings);
#line 77 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->priv->panel_settings = _tmp2_;
#line 78 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp3_ = self->priv->panel_settings;
#line 78 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp5_ = _tmp4_ = g_settings_get_strv (_tmp3_, "panels");
#line 78 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	allpanels_list = _tmp5_;
#line 78 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	allpanels_list_length1 = _vala_array_length (_tmp4_);
#line 78 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_allpanels_list_size_ = allpanels_list_length1;
#line 79 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp6_ = allpanels_list;
#line 79 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp6__length1 = allpanels_list_length1;
#line 1012 "FuzzyClockApplet.c"
	{
		gchar** p_collection = NULL;
		gint p_collection_length1 = 0;
		gint _p_collection_size_ = 0;
		gint p_it = 0;
#line 79 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		p_collection = _tmp6_;
#line 79 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		p_collection_length1 = _tmp6__length1;
#line 79 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		for (p_it = 0; p_it < p_collection_length1; p_it = p_it + 1) {
#line 1024 "FuzzyClockApplet.c"
			gchar* _tmp7_;
			gchar* p = NULL;
#line 79 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			_tmp7_ = g_strdup (p_collection[p_it]);
#line 79 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			p = _tmp7_;
#line 1031 "FuzzyClockApplet.c"
			{
				gchar* panelpath = NULL;
				const gchar* _tmp8_;
				gchar* _tmp9_;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				const gchar* _tmp13_;
				GSettings* _tmp14_;
				GSettings* _tmp15_;
				gchar** _tmp16_;
				gchar** _tmp17_;
				gchar** _tmp18_;
				gint _tmp18__length1;
#line 80 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp8_ = p;
#line 80 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp9_ = g_strconcat ("/com/solus-project/budgie-panel/panels/", "{", _tmp8_, "}/", NULL);
#line 80 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				panelpath = _tmp9_;
#line 81 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp10_ = self->priv->general_path;
#line 81 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp11_ = g_strconcat (_tmp10_, ".panel", NULL);
#line 81 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp12_ = _tmp11_;
#line 81 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp13_ = panelpath;
#line 81 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp14_ = g_settings_new_with_path (_tmp12_, _tmp13_);
#line 81 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_g_object_unref0 (self->priv->currpanelsubject_settings);
#line 81 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				self->priv->currpanelsubject_settings = _tmp14_;
#line 81 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_g_free0 (_tmp12_);
#line 85 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp15_ = self->priv->currpanelsubject_settings;
#line 85 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp17_ = _tmp16_ = g_settings_get_strv (_tmp15_, "applets");
#line 85 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_data1_->applets = (_vala_array_free (_data1_->applets, _data1_->applets_length1, (GDestroyNotify) g_free), NULL);
#line 85 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_data1_->applets = _tmp17_;
#line 85 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_data1_->applets_length1 = _vala_array_length (_tmp16_);
#line 85 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_data1_->_applets_size_ = _data1_->applets_length1;
#line 86 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp18_ = _data1_->applets;
#line 86 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp18__length1 = _data1_->applets_length1;
#line 86 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				if (fuzzy_clock_applet_find_applet (self, _data1_->uuid, _tmp18_, (gint) _tmp18__length1)) {
#line 1086 "FuzzyClockApplet.c"
					GSettings* _tmp19_;
#line 87 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
					_tmp19_ = self->priv->currpanelsubject_settings;
#line 87 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
					g_signal_connect_data (_tmp19_, "changed::applets", (GCallback) ______lambda4__g_settings_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 93 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
					_g_free0 (panelpath);
#line 93 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
					_g_free0 (p);
#line 93 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
					break;
#line 1098 "FuzzyClockApplet.c"
				}
#line 79 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_g_free0 (panelpath);
#line 79 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_g_free0 (p);
#line 1104 "FuzzyClockApplet.c"
			}
		}
	}
#line 74 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	allpanels_list = (_vala_array_free (allpanels_list, allpanels_list_length1, (GDestroyNotify) g_free), NULL);
#line 74 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	block1_data_unref (_data1_);
#line 74 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_data1_ = NULL;
#line 1114 "FuzzyClockApplet.c"
}

/**
     * Helper to create fancy button with a direction indicator
     */
static GtkButton*
fuzzy_clock_applet_new_directional_button (FuzzyClockApplet* self,
                                           const gchar* label_str,
                                           GtkPositionType arrow_direction)
{
	GtkBox* box = NULL;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkLabel* label = NULL;
	GtkLabel* _tmp2_;
	GtkButton* button = NULL;
	GtkButton* _tmp3_;
	GtkImage* image = NULL;
	GtkImage* _tmp4_;
	GtkLabel* _tmp18_;
	GtkLabel* _tmp19_;
	GtkBox* _tmp20_;
	GtkBox* _tmp21_;
	GtkButton* _tmp22_;
	GtkStyleContext* _tmp23_;
	GtkButton* _tmp24_;
	GtkBox* _tmp25_;
	GtkButton* result;
#line 268 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 268 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_val_if_fail (label_str != NULL, NULL);
#line 270 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 270 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_ref_sink (_tmp0_);
#line 270 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	box = _tmp0_;
#line 271 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp1_ = box;
#line 271 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_FILL);
#line 272 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp2_ = (GtkLabel*) gtk_label_new (label_str);
#line 272 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_ref_sink (_tmp2_);
#line 272 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	label = _tmp2_;
#line 273 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp3_ = (GtkButton*) gtk_button_new ();
#line 273 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_ref_sink (_tmp3_);
#line 273 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	button = _tmp3_;
#line 274 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp4_ = (GtkImage*) gtk_image_new ();
#line 274 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_ref_sink (_tmp4_);
#line 274 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	image = _tmp4_;
#line 276 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (arrow_direction == GTK_POS_RIGHT) {
#line 1177 "FuzzyClockApplet.c"
		GtkImage* _tmp5_;
		GtkBox* _tmp6_;
		GtkLabel* _tmp7_;
		GtkBox* _tmp8_;
		GtkImage* _tmp9_;
		GtkImage* _tmp10_;
		GtkLabel* _tmp11_;
#line 277 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp5_ = image;
#line 277 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		gtk_image_set_from_icon_name (_tmp5_, "go-next-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 278 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp6_ = box;
#line 278 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp7_ = label;
#line 278 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		gtk_box_pack_start (_tmp6_, (GtkWidget*) _tmp7_, TRUE, TRUE, (guint) 0);
#line 279 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp8_ = box;
#line 279 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp9_ = image;
#line 279 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		gtk_box_pack_end (_tmp8_, (GtkWidget*) _tmp9_, FALSE, FALSE, (guint) 1);
#line 280 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp10_ = image;
#line 280 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		gtk_widget_set_margin_start ((GtkWidget*) _tmp10_, 6);
#line 281 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp11_ = label;
#line 281 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		gtk_widget_set_margin_start ((GtkWidget*) _tmp11_, 6);
#line 1209 "FuzzyClockApplet.c"
	} else {
		GtkImage* _tmp12_;
		GtkBox* _tmp13_;
		GtkImage* _tmp14_;
		GtkBox* _tmp15_;
		GtkLabel* _tmp16_;
		GtkImage* _tmp17_;
#line 283 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp12_ = image;
#line 283 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		gtk_image_set_from_icon_name (_tmp12_, "go-previous-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 284 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp13_ = box;
#line 284 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp14_ = image;
#line 284 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		gtk_box_pack_start (_tmp13_, (GtkWidget*) _tmp14_, FALSE, FALSE, (guint) 0);
#line 285 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp15_ = box;
#line 285 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp16_ = label;
#line 285 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		gtk_box_pack_start (_tmp15_, (GtkWidget*) _tmp16_, TRUE, TRUE, (guint) 0);
#line 286 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp17_ = image;
#line 286 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		gtk_widget_set_margin_end ((GtkWidget*) _tmp17_, 6);
#line 1237 "FuzzyClockApplet.c"
	}
#line 289 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp18_ = label;
#line 289 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp18_, GTK_ALIGN_START);
#line 290 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp19_ = label;
#line 290 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_set ((GtkWidget*) _tmp19_, "margin", 0, NULL);
#line 291 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp20_ = box;
#line 291 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_set ((GtkWidget*) _tmp20_, "margin", 0, NULL);
#line 292 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp21_ = box;
#line 292 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp21_, (guint) 0);
#line 293 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp22_ = button;
#line 293 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp23_ = gtk_widget_get_style_context ((GtkWidget*) _tmp22_);
#line 293 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_style_context_add_class (_tmp23_, GTK_STYLE_CLASS_FLAT);
#line 294 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp24_ = button;
#line 294 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp25_ = box;
#line 294 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
#line 295 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	result = button;
#line 295 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (image);
#line 295 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (label);
#line 295 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (box);
#line 295 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return result;
#line 1277 "FuzzyClockApplet.c"
}

/**
     * Helper to create new dropdown buttons
     */
static GtkButton*
fuzzy_clock_applet_new_plain_button (FuzzyClockApplet* self,
                                     const gchar* label_str)
{
	GtkButton* ret = NULL;
	GtkButton* _tmp0_;
	GtkWidget* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkButton* result;
#line 301 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 301 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_val_if_fail (label_str != NULL, NULL);
#line 303 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = (GtkButton*) gtk_button_new_with_label (label_str);
#line 303 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_ref_sink (_tmp0_);
#line 303 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	ret = _tmp0_;
#line 304 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp1_ = gtk_bin_get_child ((GtkBin*) ret);
#line 304 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_widget_set_halign (_tmp1_, GTK_ALIGN_START);
#line 305 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) ret);
#line 305 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_style_context_add_class (_tmp2_, GTK_STYLE_CLASS_FLAT);
#line 307 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	result = ret;
#line 307 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return result;
#line 1314 "FuzzyClockApplet.c"
}

/**
     * Updates the orientation if the panel changes positions
     */
static void
fuzzy_clock_applet_real_panel_position_changed (BudgieApplet* base,
                                                BudgiePanelPosition position)
{
	FuzzyClockApplet * self;
	gboolean _tmp0_ = FALSE;
	GtkBox* _tmp7_;
#line 313 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self = (FuzzyClockApplet*) base;
#line 315 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (position == BUDGIE_PANEL_POSITION_LEFT) {
#line 315 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp0_ = TRUE;
#line 1333 "FuzzyClockApplet.c"
	} else {
#line 315 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp0_ = position == BUDGIE_PANEL_POSITION_RIGHT;
#line 1337 "FuzzyClockApplet.c"
	}
#line 315 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (_tmp0_) {
#line 316 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		self->priv->orient = GTK_ORIENTATION_VERTICAL;
#line 317 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		if (position == BUDGIE_PANEL_POSITION_RIGHT) {
#line 1345 "FuzzyClockApplet.c"
			GtkLabel* _tmp1_;
			GtkLabel* _tmp2_;
#line 318 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			_tmp1_ = self->clock;
#line 318 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			gtk_label_set_angle (_tmp1_, (gdouble) 270);
#line 319 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			_tmp2_ = self->date_label;
#line 319 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			gtk_label_set_angle (_tmp2_, (gdouble) 270);
#line 1356 "FuzzyClockApplet.c"
		} else {
			GtkLabel* _tmp3_;
			GtkLabel* _tmp4_;
#line 322 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			_tmp3_ = self->clock;
#line 322 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			gtk_label_set_angle (_tmp3_, (gdouble) 90);
#line 323 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			_tmp4_ = self->date_label;
#line 323 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			gtk_label_set_angle (_tmp4_, (gdouble) 90);
#line 1368 "FuzzyClockApplet.c"
		}
	} else {
		GtkLabel* _tmp5_;
		GtkLabel* _tmp6_;
#line 326 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		self->priv->orient = GTK_ORIENTATION_HORIZONTAL;
#line 327 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp5_ = self->clock;
#line 327 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		gtk_label_set_angle (_tmp5_, (gdouble) 0);
#line 328 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp6_ = self->date_label;
#line 328 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		gtk_label_set_angle (_tmp6_, (gdouble) 0);
#line 1383 "FuzzyClockApplet.c"
	}
#line 330 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp7_ = self->layout;
#line 330 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp7_, self->priv->orient);
#line 331 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	fuzzy_clock_applet_update_clock (self);
#line 1391 "FuzzyClockApplet.c"
}

static gint
fuzzy_clock_applet_get_containingindex (FuzzyClockApplet* self,
                                        gchar** arr,
                                        gint arr_length1,
                                        const gchar* lookfor)
{
	gint result;
#line 335 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 335 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_val_if_fail (lookfor != NULL, 0);
#line 1405 "FuzzyClockApplet.c"
	{
		gint i = 0;
#line 336 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		i = 0;
#line 1410 "FuzzyClockApplet.c"
		{
			gboolean _tmp0_ = FALSE;
#line 336 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			_tmp0_ = TRUE;
#line 336 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			while (TRUE) {
#line 1417 "FuzzyClockApplet.c"
				const gchar* _tmp2_;
#line 336 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				if (!_tmp0_) {
#line 1421 "FuzzyClockApplet.c"
					gint _tmp1_;
#line 336 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
					_tmp1_ = i;
#line 336 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
					i = _tmp1_ + 1;
#line 1427 "FuzzyClockApplet.c"
				}
#line 336 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp0_ = FALSE;
#line 336 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				if (!(i < arr_length1)) {
#line 336 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
					break;
#line 1435 "FuzzyClockApplet.c"
				}
#line 337 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp2_ = arr[i];
#line 337 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				if (string_contains (lookfor, _tmp2_)) {
#line 337 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
					result = i;
#line 337 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
					return result;
#line 1445 "FuzzyClockApplet.c"
				}
			}
		}
	}
#line 339 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	result = -1;
#line 339 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return result;
#line 1454 "FuzzyClockApplet.c"
}

/**
     * Taken from showtime - calculate the locale dateformat
     */
static gchar*
fuzzy_clock_applet_read_dateformat (FuzzyClockApplet* self)
{
	gchar** monthvars = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint monthvars_length1;
	gint _monthvars_size_;
	gchar** daynamevars = NULL;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar** _tmp14_;
	gint daynamevars_length1;
	gint _daynamevars_size_;
	gchar** monthdayvars = NULL;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar** _tmp21_;
	gint monthdayvars_length1;
	gint _monthdayvars_size_;
	gchar* cmd = NULL;
	gchar* _tmp22_;
	gchar* output = NULL;
	gchar* _tmp23_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 345 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 346 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = g_strdup ("%B");
#line 346 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp1_ = g_strdup ("%-b");
#line 346 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp2_ = g_strdup ("%_b");
#line 346 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp3_ = g_strdup ("%h");
#line 346 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp4_ = g_strdup ("%-h");
#line 346 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp5_ = g_strdup ("%_h");
#line 346 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp6_ = g_strdup ("%b");
#line 346 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp7_ = g_new0 (gchar*, 7 + 1);
#line 346 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp7_[0] = _tmp0_;
#line 346 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp7_[1] = _tmp1_;
#line 346 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp7_[2] = _tmp2_;
#line 346 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp7_[3] = _tmp3_;
#line 346 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp7_[4] = _tmp4_;
#line 346 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp7_[5] = _tmp5_;
#line 346 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp7_[6] = _tmp6_;
#line 346 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	monthvars = _tmp7_;
#line 346 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	monthvars_length1 = 7;
#line 346 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_monthvars_size_ = monthvars_length1;
#line 349 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp8_ = g_strdup ("%A");
#line 349 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp9_ = g_strdup ("%a");
#line 349 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp10_ = g_strdup ("%-a");
#line 349 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp11_ = g_strdup ("%-A");
#line 349 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp12_ = g_strdup ("%_a");
#line 349 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp13_ = g_strdup ("%_A");
#line 349 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp14_ = g_new0 (gchar*, 6 + 1);
#line 349 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp14_[0] = _tmp8_;
#line 349 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp14_[1] = _tmp9_;
#line 349 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp14_[2] = _tmp10_;
#line 349 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp14_[3] = _tmp11_;
#line 349 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp14_[4] = _tmp12_;
#line 349 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp14_[5] = _tmp13_;
#line 349 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	daynamevars = _tmp14_;
#line 349 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	daynamevars_length1 = 6;
#line 349 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_daynamevars_size_ = daynamevars_length1;
#line 352 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp15_ = g_strdup ("%e");
#line 352 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp16_ = g_strdup ("%-e");
#line 352 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp17_ = g_strdup ("%_e");
#line 352 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp18_ = g_strdup ("%d");
#line 352 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp19_ = g_strdup ("%-d");
#line 352 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp20_ = g_strdup ("%_d");
#line 352 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp21_ = g_new0 (gchar*, 6 + 1);
#line 352 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp21_[0] = _tmp15_;
#line 352 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp21_[1] = _tmp16_;
#line 352 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp21_[2] = _tmp17_;
#line 352 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp21_[3] = _tmp18_;
#line 352 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp21_[4] = _tmp19_;
#line 352 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp21_[5] = _tmp20_;
#line 352 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	monthdayvars = _tmp21_;
#line 352 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	monthdayvars_length1 = 6;
#line 352 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_monthdayvars_size_ = monthdayvars_length1;
#line 355 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp22_ = g_strdup ("locale date_fmt");
#line 355 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	cmd = _tmp22_;
#line 356 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp23_ = g_strdup ("");
#line 356 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	output = _tmp23_;
#line 1610 "FuzzyClockApplet.c"
	{
		GString* builder = NULL;
		GString* _tmp24_;
		gchar* _tmp25_ = NULL;
		gchar** output_data = NULL;
		const gchar* _tmp26_;
		gchar** _tmp27_;
		gchar** _tmp28_;
		gint output_data_length1;
		gint _output_data_size_;
		gchar** _tmp29_;
		gint _tmp29__length1;
		const gchar* _tmp40_;
		gchar* _tmp41_;
#line 358 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp24_ = g_string_new ("");
#line 358 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		builder = _tmp24_;
#line 359 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		g_spawn_command_line_sync (cmd, &_tmp25_, NULL, NULL, &_inner_error0_);
#line 359 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_free0 (output);
#line 359 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		output = _tmp25_;
#line 359 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 359 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			_g_string_free0 (builder);
#line 1639 "FuzzyClockApplet.c"
			goto __catch0_g_error;
		}
#line 360 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp26_ = output;
#line 360 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp28_ = _tmp27_ = g_strsplit (_tmp26_, " ", 0);
#line 360 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		output_data = _tmp28_;
#line 360 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		output_data_length1 = _vala_array_length (_tmp27_);
#line 360 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_output_data_size_ = output_data_length1;
#line 361 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp29_ = output_data;
#line 361 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp29__length1 = output_data_length1;
#line 1656 "FuzzyClockApplet.c"
		{
			gchar** s_collection = NULL;
			gint s_collection_length1 = 0;
			gint _s_collection_size_ = 0;
			gint s_it = 0;
#line 361 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			s_collection = _tmp29_;
#line 361 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			s_collection_length1 = _tmp29__length1;
#line 361 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
#line 1668 "FuzzyClockApplet.c"
				gchar* _tmp30_;
				gchar* s = NULL;
#line 361 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp30_ = g_strdup (s_collection[s_it]);
#line 361 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				s = _tmp30_;
#line 1675 "FuzzyClockApplet.c"
				{
					const gchar* _tmp31_;
#line 363 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
					_tmp31_ = s;
#line 363 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
					if (fuzzy_clock_applet_get_containingindex (self, monthvars, (gint) monthvars_length1, _tmp31_) != -1) {
#line 1682 "FuzzyClockApplet.c"
						const gchar* _tmp32_;
						GString* _tmp33_;
#line 364 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
						_tmp32_ = monthvars[0];
#line 364 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
						_tmp33_ = g_string_append (builder, _tmp32_);
#line 364 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
						g_string_append (_tmp33_, " ");
#line 1691 "FuzzyClockApplet.c"
					} else {
						const gchar* _tmp34_;
#line 366 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
						_tmp34_ = s;
#line 366 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
						if (fuzzy_clock_applet_get_containingindex (self, daynamevars, (gint) daynamevars_length1, _tmp34_) != -1) {
#line 1698 "FuzzyClockApplet.c"
							const gchar* _tmp35_;
							GString* _tmp36_;
#line 367 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
							_tmp35_ = daynamevars[0];
#line 367 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
							_tmp36_ = g_string_append (builder, _tmp35_);
#line 367 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
							g_string_append (_tmp36_, " ");
#line 1707 "FuzzyClockApplet.c"
						} else {
							const gchar* _tmp37_;
#line 369 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
							_tmp37_ = s;
#line 369 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
							if (fuzzy_clock_applet_get_containingindex (self, monthdayvars, (gint) monthdayvars_length1, _tmp37_) != -1) {
#line 1714 "FuzzyClockApplet.c"
								const gchar* _tmp38_;
								GString* _tmp39_;
#line 370 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
								_tmp38_ = monthdayvars[0];
#line 370 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
								_tmp39_ = g_string_append (builder, _tmp38_);
#line 370 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
								g_string_append (_tmp39_, " ");
#line 1723 "FuzzyClockApplet.c"
							}
						}
					}
#line 361 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
					_g_free0 (s);
#line 1729 "FuzzyClockApplet.c"
				}
			}
		}
#line 373 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp40_ = builder->str;
#line 373 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp41_ = g_strdup (_tmp40_);
#line 373 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		result = _tmp41_;
#line 373 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		output_data = (_vala_array_free (output_data, output_data_length1, (GDestroyNotify) g_free), NULL);
#line 373 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_string_free0 (builder);
#line 373 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_free0 (output);
#line 373 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_free0 (cmd);
#line 373 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		monthdayvars = (_vala_array_free (monthdayvars, monthdayvars_length1, (GDestroyNotify) g_free), NULL);
#line 373 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		daynamevars = (_vala_array_free (daynamevars, daynamevars_length1, (GDestroyNotify) g_free), NULL);
#line 373 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		monthvars = (_vala_array_free (monthvars, monthvars_length1, (GDestroyNotify) g_free), NULL);
#line 373 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		return result;
#line 1755 "FuzzyClockApplet.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		gchar* _tmp42_;
#line 357 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		g_clear_error (&_inner_error0_);
#line 376 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp42_ = g_strdup ("");
#line 376 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		result = _tmp42_;
#line 376 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_free0 (output);
#line 376 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_free0 (cmd);
#line 376 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		monthdayvars = (_vala_array_free (monthdayvars, monthdayvars_length1, (GDestroyNotify) g_free), NULL);
#line 376 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		daynamevars = (_vala_array_free (daynamevars, daynamevars_length1, (GDestroyNotify) g_free), NULL);
#line 376 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		monthvars = (_vala_array_free (monthvars, monthvars_length1, (GDestroyNotify) g_free), NULL);
#line 376 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		return result;
#line 1779 "FuzzyClockApplet.c"
	}
	__finally0:
#line 357 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_free0 (output);
#line 357 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_free0 (cmd);
#line 357 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	monthdayvars = (_vala_array_free (monthdayvars, monthdayvars_length1, (GDestroyNotify) g_free), NULL);
#line 357 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	daynamevars = (_vala_array_free (daynamevars, daynamevars_length1, (GDestroyNotify) g_free), NULL);
#line 357 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	monthvars = (_vala_array_free (monthvars, monthvars_length1, (GDestroyNotify) g_free), NULL);
#line 357 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 357 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_clear_error (&_inner_error0_);
#line 357 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return NULL;
#line 1798 "FuzzyClockApplet.c"
}

/**
     * Main initialization of the Applet
     */
static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return _data2_;
#line 1811 "FuzzyClockApplet.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1821 "FuzzyClockApplet.c"
		FuzzyClockApplet* self;
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		self = _data2_->self;
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_object_unref0 (_data2_->stack);
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_free0 (_data2_->uuid);
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_object_unref0 (self);
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		g_slice_free (Block2Data, _data2_);
#line 1833 "FuzzyClockApplet.c"
	}
}

static gboolean
__lambda5_ (Block2Data* _data2_)
{
	FuzzyClockApplet* self;
	gboolean result;
#line 386 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self = _data2_->self;
#line 387 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	fuzzy_clock_applet_watchapplet (self, _data2_->uuid);
#line 388 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	result = FALSE;
#line 388 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return result;
#line 1850 "FuzzyClockApplet.c"
}

static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ (self);
#line 386 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return result;
#line 1860 "FuzzyClockApplet.c"
}

static void
_fuzzy_clock_applet_on_date_activate_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
#line 436 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	fuzzy_clock_applet_on_date_activate ((FuzzyClockApplet*) self);
#line 1869 "FuzzyClockApplet.c"
}

static void
_fuzzy_clock_applet_on_cal_activate_gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
#line 437 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	fuzzy_clock_applet_on_cal_activate ((FuzzyClockApplet*) self);
#line 1878 "FuzzyClockApplet.c"
}

static void
__lambda6_ (Block2Data* _data2_)
{
	FuzzyClockApplet* self;
#line 445 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self = _data2_->self;
#line 445 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_stack_set_visible_child_name (_data2_->stack, "prefs");
#line 1889 "FuzzyClockApplet.c"
}

static void
___lambda6__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 445 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	__lambda6_ (self);
#line 1898 "FuzzyClockApplet.c"
}

static void
__lambda7_ (FuzzyClockApplet* self)
{
	ClockFormat f = 0;
	GSettings* _tmp0_;
	ClockFormat _tmp1_ = 0;
	ClockFormat newf = 0;
	GSettings* _tmp2_;
#line 466 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = self->settings;
#line 466 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	f = (ClockFormat) g_settings_get_enum (_tmp0_, "clock-format");
#line 467 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (f == CLOCK_FORMAT_TWELVE) {
#line 467 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp1_ = CLOCK_FORMAT_TWENTYFOUR;
#line 1917 "FuzzyClockApplet.c"
	} else {
#line 467 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp1_ = CLOCK_FORMAT_TWELVE;
#line 1921 "FuzzyClockApplet.c"
	}
#line 467 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	newf = _tmp1_;
#line 468 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp2_ = self->settings;
#line 468 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_settings_set_enum (_tmp2_, "clock-format", (gint) newf);
#line 1929 "FuzzyClockApplet.c"
}

static void
___lambda7__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                       gpointer self)
{
#line 465 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	__lambda7_ ((FuzzyClockApplet*) self);
#line 1938 "FuzzyClockApplet.c"
}

static void
__lambda8_ (Block2Data* _data2_)
{
	FuzzyClockApplet* self;
#line 474 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self = _data2_->self;
#line 474 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_stack_set_visible_child_name (_data2_->stack, "root");
#line 1949 "FuzzyClockApplet.c"
}

static void
___lambda8__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 474 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	__lambda8_ (self);
#line 1958 "FuzzyClockApplet.c"
}

static void
__lambda9_ (Block2Data* _data2_)
{
	FuzzyClockApplet* self;
#line 483 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self = _data2_->self;
#line 484 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_stack_set_visible_child_name (_data2_->stack, "root");
#line 1969 "FuzzyClockApplet.c"
}

static void
___lambda9__budgie_popover_closed (BudgiePopover* _sender,
                                   gpointer self)
{
#line 483 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	__lambda9_ (self);
#line 1978 "FuzzyClockApplet.c"
}

static gboolean
__lambda10_ (FuzzyClockApplet* self,
             GdkEventButton* e)
{
	BudgiePopover* _tmp0_;
	gboolean result;
#line 487 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 488 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (e->button != ((guint) 1)) {
#line 489 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		result = GDK_EVENT_PROPAGATE;
#line 489 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		return result;
#line 1995 "FuzzyClockApplet.c"
	}
#line 491 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = self->priv->popover;
#line 491 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (gtk_widget_get_visible ((GtkWidget*) _tmp0_)) {
#line 2001 "FuzzyClockApplet.c"
		BudgiePopover* _tmp1_;
#line 492 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp1_ = self->priv->popover;
#line 492 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 2007 "FuzzyClockApplet.c"
	} else {
		BudgiePopoverManager* _tmp2_;
		GtkEventBox* _tmp3_;
#line 494 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp2_ = self->priv->manager;
#line 494 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp3_ = self->widget;
#line 494 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		budgie_popover_manager_show_popover (_tmp2_, (GtkWidget*) _tmp3_);
#line 2017 "FuzzyClockApplet.c"
	}
#line 496 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	result = GDK_EVENT_STOP;
#line 496 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return result;
#line 2023 "FuzzyClockApplet.c"
}

static gboolean
___lambda10__gtk_widget_button_press_event (GtkWidget* _sender,
                                            GdkEventButton* event,
                                            gpointer self)
{
	gboolean result;
	result = __lambda10_ ((FuzzyClockApplet*) self, event);
#line 487 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return result;
#line 2035 "FuzzyClockApplet.c"
}

static gboolean
_fuzzy_clock_applet_update_clock_gsource_func (gpointer self)
{
	gboolean result;
	result = fuzzy_clock_applet_update_clock ((FuzzyClockApplet*) self);
#line 499 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return result;
#line 2045 "FuzzyClockApplet.c"
}

static void
_fuzzy_clock_applet_on_settings_change_g_settings_changed (GSettings* _sender,
                                                           const gchar* key,
                                                           gpointer self)
{
#line 501 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	fuzzy_clock_applet_on_settings_change ((FuzzyClockApplet*) self, key);
#line 2055 "FuzzyClockApplet.c"
}

static void
_fuzzy_clock_applet_update_cal_g_app_info_monitor_changed (GAppInfoMonitor* _sender,
                                                           gpointer self)
{
#line 506 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	fuzzy_clock_applet_update_cal ((FuzzyClockApplet*) self);
#line 2064 "FuzzyClockApplet.c"
}

FuzzyClockApplet*
fuzzy_clock_applet_construct (GType object_type,
                              const gchar* uuid)
{
	FuzzyClockApplet * self = NULL;
	Block2Data* _data2_;
	gchar* _tmp0_;
	GtkEventBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkLabel* _tmp3_;
	GDateTime* _tmp4_;
	GtkEventBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkLabel* _tmp8_;
	GtkBox* _tmp9_;
	GtkBox* _tmp10_;
	GtkLabel* _tmp11_;
	GtkBox* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	gchar* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GSettings* _tmp19_;
	GtkStyleContext* _tmp20_;
	GtkEventBox* _tmp21_;
	BudgiePopover* _tmp22_;
	GtkStack* _tmp23_;
	GtkStyleContext* _tmp24_;
	BudgiePopover* _tmp25_;
	GtkBox* menu = NULL;
	GtkBox* _tmp26_;
	GtkBox* _tmp27_;
	GtkButton* time_button = NULL;
	GtkButton* _tmp28_;
	GtkButton* _tmp29_;
	GtkButton* _tmp30_;
	GtkBox* _tmp31_;
	GtkBox* _tmp32_;
	GtkButton* _tmp33_;
	GtkButton* sub_button = NULL;
	GtkButton* _tmp34_;
	GtkButton* _tmp35_;
	GtkBox* _tmp36_;
	GtkButton* _tmp37_;
	GtkBox* _tmp38_;
	GtkBox* _tmp39_;
	GtkBox* _tmp40_;
	GtkCheckButton* _tmp41_;
	GtkCheckButton* _tmp42_;
	GtkWidget* _tmp43_;
	GValue _tmp44_ = {0};
	GSettings* _tmp45_;
	GtkCheckButton* _tmp46_;
	GSettings* _tmp47_;
	GtkLabel* _tmp48_;
	GtkCheckButton* _tmp49_;
	GtkCheckButton* _tmp50_;
	GtkWidget* _tmp51_;
	GValue _tmp52_ = {0};
	GtkCheckButton* _tmp53_;
	gulong _tmp54_;
	GtkButton* _tmp55_;
	GtkButton* _tmp56_;
	GtkBox* _tmp57_;
	GtkButton* _tmp58_;
	GtkBox* _tmp59_;
	GtkSeparator* _tmp60_;
	GtkSeparator* _tmp61_;
	GtkBox* _tmp62_;
	GtkCheckButton* _tmp63_;
	GtkBox* _tmp64_;
	GtkCheckButton* _tmp65_;
	GtkBox* _tmp66_;
	BudgiePopover* _tmp67_;
	GtkEventBox* _tmp68_;
	GSettings* _tmp69_;
	GAppInfo* _tmp70_;
	GAppInfoMonitor* monitor = NULL;
	GAppInfoMonitor* _tmp71_;
	GtkButton* _tmp72_;
	GAppInfo* _tmp73_;
	GtkButton* _tmp74_;
	GtkEventBox* _tmp75_;
	BudgiePopover* _tmp76_;
	GtkWidget* _tmp77_;
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_data2_->_ref_count_ = 1;
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = g_strdup (uuid);
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_free0 (_data2_->uuid);
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_data2_->uuid = _tmp0_;
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self = (FuzzyClockApplet*) g_object_new (object_type, NULL);
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_data2_->self = g_object_ref (self);
#line 386 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, ___lambda5__gsource_func, block2_data_ref (_data2_), block2_data_unref);
#line 392 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	fuzzy_clock_applet_initialiseLocaleLanguageSupport (self);
#line 393 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp1_ = (GtkEventBox*) gtk_event_box_new ();
#line 393 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_ref_sink (_tmp1_);
#line 393 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->widget);
#line 393 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->widget = _tmp1_;
#line 394 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 2);
#line 394 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_ref_sink (_tmp2_);
#line 394 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->layout);
#line 394 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->layout = _tmp2_;
#line 396 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp3_ = (GtkLabel*) gtk_label_new ("");
#line 396 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_ref_sink (_tmp3_);
#line 396 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->clock);
#line 396 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->clock = _tmp3_;
#line 397 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp4_ = g_date_time_new_now_local ();
#line 397 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_date_time_unref0 (self->priv->time);
#line 397 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->priv->time = _tmp4_;
#line 398 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp5_ = self->widget;
#line 398 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp6_ = self->layout;
#line 398 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
#line 400 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp7_ = self->layout;
#line 400 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp8_ = self->clock;
#line 400 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_box_pack_start (_tmp7_, (GtkWidget*) _tmp8_, FALSE, FALSE, (guint) 0);
#line 401 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp9_ = self->layout;
#line 401 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_set ((GtkWidget*) _tmp9_, "margin", 0, NULL);
#line 402 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp10_ = self->layout;
#line 402 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp10_, (guint) 0);
#line 404 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp11_ = (GtkLabel*) gtk_label_new ("");
#line 404 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_ref_sink (_tmp11_);
#line 404 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->date_label);
#line 404 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->date_label = _tmp11_;
#line 405 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp12_ = self->layout;
#line 405 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp13_ = self->date_label;
#line 405 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_box_pack_start (_tmp12_, (GtkWidget*) _tmp13_, FALSE, FALSE, (guint) 0);
#line 406 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp14_ = self->date_label;
#line 406 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp14_, TRUE);
#line 407 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp15_ = self->date_label;
#line 407 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_widget_hide ((GtkWidget*) _tmp15_);
#line 409 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp16_ = fuzzy_clock_applet_read_dateformat (self);
#line 409 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_free0 (self->priv->date_format);
#line 409 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->priv->date_format = _tmp16_;
#line 411 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp17_ = self->clock;
#line 411 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp17_, GTK_ALIGN_CENTER);
#line 412 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp18_ = self->date_label;
#line 412 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp18_, GTK_ALIGN_CENTER);
#line 414 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp19_ = g_settings_new ("org.gnome.desktop.interface");
#line 414 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->settings);
#line 414 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->settings = _tmp19_;
#line 416 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp20_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 416 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_style_context_add_class (_tmp20_, "budgie-fuzzy-clock-applet");
#line 419 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp21_ = self->widget;
#line 419 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp22_ = (BudgiePopover*) budgie_popover_new ((GtkWidget*) _tmp21_);
#line 419 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_ref_sink (_tmp22_);
#line 419 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->priv->popover);
#line 419 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->priv->popover = _tmp22_;
#line 421 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp23_ = (GtkStack*) gtk_stack_new ();
#line 421 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_ref_sink (_tmp23_);
#line 421 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_data2_->stack = _tmp23_;
#line 422 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp24_ = gtk_widget_get_style_context ((GtkWidget*) _data2_->stack);
#line 422 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_style_context_add_class (_tmp24_, "fuzzy-clock-applet-stack");
#line 424 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp25_ = self->priv->popover;
#line 424 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) _data2_->stack);
#line 425 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_stack_set_homogeneous (_data2_->stack, TRUE);
#line 426 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_stack_set_transition_type (_data2_->stack, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT);
#line 428 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 1);
#line 428 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_ref_sink (_tmp26_);
#line 428 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	menu = _tmp26_;
#line 429 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp27_ = menu;
#line 429 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp27_, (guint) 6);
#line 432 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp28_ = fuzzy_clock_applet_new_plain_button (self, _ ("Date and Time settings"));
#line 432 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	time_button = _tmp28_;
#line 435 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp29_ = fuzzy_clock_applet_new_plain_button (self, _ ("Calendar"));
#line 435 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->priv->cal_button);
#line 435 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->priv->cal_button = _tmp29_;
#line 436 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_signal_connect_object (time_button, "clicked", (GCallback) _fuzzy_clock_applet_on_date_activate_gtk_button_clicked, self, 0);
#line 437 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp30_ = self->priv->cal_button;
#line 437 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_signal_connect_object (_tmp30_, "clicked", (GCallback) _fuzzy_clock_applet_on_cal_activate_gtk_button_clicked, self, 0);
#line 440 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp31_ = menu;
#line 440 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_box_pack_start (_tmp31_, (GtkWidget*) time_button, FALSE, FALSE, (guint) 0);
#line 441 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp32_ = menu;
#line 441 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp33_ = self->priv->cal_button;
#line 441 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_box_pack_start (_tmp32_, (GtkWidget*) _tmp33_, FALSE, FALSE, (guint) 0);
#line 444 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp34_ = fuzzy_clock_applet_new_directional_button (self, _ ("Preferences"), GTK_POS_RIGHT);
#line 444 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	sub_button = _tmp34_;
#line 445 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp35_ = sub_button;
#line 445 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_signal_connect_data (_tmp35_, "clicked", (GCallback) ___lambda6__gtk_button_clicked, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 446 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp36_ = menu;
#line 446 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp37_ = sub_button;
#line 446 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_box_pack_end (_tmp36_, (GtkWidget*) _tmp37_, FALSE, FALSE, (guint) 2);
#line 448 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp38_ = menu;
#line 448 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_stack_add_named (_data2_->stack, (GtkWidget*) _tmp38_, "root");
#line 451 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp39_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 1);
#line 451 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_ref_sink (_tmp39_);
#line 451 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (menu);
#line 451 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	menu = _tmp39_;
#line 452 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp40_ = menu;
#line 452 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp40_, (guint) 6);
#line 455 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp41_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Show date"));
#line 455 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_ref_sink (_tmp41_);
#line 455 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->priv->check_date);
#line 455 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->priv->check_date = _tmp41_;
#line 456 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp42_ = self->priv->check_date;
#line 456 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp43_ = gtk_bin_get_child ((GtkBin*) _tmp42_);
#line 456 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_value_init (&_tmp44_, G_TYPE_INT);
#line 456 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_value_set_int (&_tmp44_, 8);
#line 456 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_set_property ((GObject*) _tmp43_, "margin-start", &_tmp44_);
#line 456 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	G_IS_VALUE (&_tmp44_) ? (g_value_unset (&_tmp44_), NULL) : NULL;
#line 457 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp45_ = self->settings;
#line 457 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp46_ = self->priv->check_date;
#line 457 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_settings_bind (_tmp45_, "clock-show-date", (GObject*) _tmp46_, "active", G_SETTINGS_BIND_GET | G_SETTINGS_BIND_SET);
#line 458 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp47_ = self->settings;
#line 458 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp48_ = self->date_label;
#line 458 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_settings_bind (_tmp47_, "clock-show-date", (GObject*) _tmp48_, "visible", G_SETTINGS_BIND_DEFAULT);
#line 462 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp49_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Use 24 hour time"));
#line 462 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_ref_sink (_tmp49_);
#line 462 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->priv->clock_format);
#line 462 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->priv->clock_format = _tmp49_;
#line 463 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp50_ = self->priv->clock_format;
#line 463 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp51_ = gtk_bin_get_child ((GtkBin*) _tmp50_);
#line 463 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_value_init (&_tmp52_, G_TYPE_INT);
#line 463 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_value_set_int (&_tmp52_, 8);
#line 463 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_set_property ((GObject*) _tmp51_, "margin-start", &_tmp52_);
#line 463 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	G_IS_VALUE (&_tmp52_) ? (g_value_unset (&_tmp52_), NULL) : NULL;
#line 465 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp53_ = self->priv->clock_format;
#line 465 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp54_ = g_signal_connect_object ((GtkToggleButton*) _tmp53_, "toggled", (GCallback) ___lambda7__gtk_toggle_button_toggled, self, G_CONNECT_AFTER);
#line 465 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->priv->check_id = _tmp54_;
#line 473 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp55_ = fuzzy_clock_applet_new_directional_button (self, _ ("Preferences"), GTK_POS_LEFT);
#line 473 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (sub_button);
#line 473 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	sub_button = _tmp55_;
#line 474 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp56_ = sub_button;
#line 474 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_signal_connect_data (_tmp56_, "clicked", (GCallback) ___lambda8__gtk_button_clicked, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 475 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp57_ = menu;
#line 475 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp58_ = sub_button;
#line 475 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_box_pack_start (_tmp57_, (GtkWidget*) _tmp58_, FALSE, FALSE, (guint) 0);
#line 476 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp59_ = menu;
#line 476 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp60_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 476 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_ref_sink (_tmp60_);
#line 476 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp61_ = _tmp60_;
#line 476 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_box_pack_start (_tmp59_, (GtkWidget*) _tmp61_, FALSE, FALSE, (guint) 2);
#line 476 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (_tmp61_);
#line 477 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp62_ = menu;
#line 477 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp63_ = self->priv->check_date;
#line 477 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_box_pack_start (_tmp62_, (GtkWidget*) _tmp63_, FALSE, FALSE, (guint) 0);
#line 478 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp64_ = menu;
#line 478 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp65_ = self->priv->clock_format;
#line 478 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_box_pack_start (_tmp64_, (GtkWidget*) _tmp65_, FALSE, FALSE, (guint) 0);
#line 479 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp66_ = menu;
#line 479 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_stack_add_named (_data2_->stack, (GtkWidget*) _tmp66_, "prefs");
#line 483 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp67_ = self->priv->popover;
#line 483 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_signal_connect_data (_tmp67_, "closed", (GCallback) ___lambda9__budgie_popover_closed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 487 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp68_ = self->widget;
#line 487 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_signal_connect_object ((GtkWidget*) _tmp68_, "button-press-event", (GCallback) ___lambda10__gtk_widget_button_press_event, self, 0);
#line 499 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_timeout_add_seconds_full (G_PRIORITY_LOW, (guint) 30, _fuzzy_clock_applet_update_clock_gsource_func, g_object_ref (self), g_object_unref);
#line 501 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp69_ = self->settings;
#line 501 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_signal_connect_object (_tmp69_, "changed", (GCallback) _fuzzy_clock_applet_on_settings_change_g_settings_changed, self, 0);
#line 503 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp70_ = g_app_info_get_default_for_type (CALENDAR_MIME, FALSE);
#line 503 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->priv->calprov);
#line 503 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->priv->calprov = _tmp70_;
#line 505 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp71_ = g_app_info_monitor_get ();
#line 505 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	monitor = _tmp71_;
#line 506 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_signal_connect_object (monitor, "changed", (GCallback) _fuzzy_clock_applet_update_cal_g_app_info_monitor_changed, self, 0);
#line 508 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp72_ = self->priv->cal_button;
#line 508 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp73_ = self->priv->calprov;
#line 508 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp72_, _tmp73_ != NULL);
#line 509 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp74_ = self->priv->cal_button;
#line 509 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_signal_connect_object (_tmp74_, "clicked", (GCallback) _fuzzy_clock_applet_on_cal_activate_gtk_button_clicked, self, 0);
#line 511 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	fuzzy_clock_applet_update_cal (self);
#line 513 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	fuzzy_clock_applet_update_clock (self);
#line 514 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp75_ = self->widget;
#line 514 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp75_);
#line 515 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	fuzzy_clock_applet_on_settings_change (self, "clock-format");
#line 516 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp76_ = self->priv->popover;
#line 516 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp77_ = gtk_bin_get_child ((GtkBin*) _tmp76_);
#line 516 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_widget_show_all (_tmp77_);
#line 518 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (monitor);
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (sub_button);
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (time_button);
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (menu);
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	block2_data_unref (_data2_);
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_data2_ = NULL;
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return self;
#line 2535 "FuzzyClockApplet.c"
}

FuzzyClockApplet*
fuzzy_clock_applet_new (const gchar* uuid)
{
#line 383 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return fuzzy_clock_applet_construct (TYPE_FUZZY_CLOCK_APPLET, uuid);
#line 2543 "FuzzyClockApplet.c"
}

/**
     * Ensure translations are displayed correctly
     * according to the locale
     */
void
fuzzy_clock_applet_initialiseLocaleLanguageSupport (FuzzyClockApplet* self)
{
#line 525 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 527 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	setlocale (LC_ALL, "");
#line 528 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALEDIR);
#line 531 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 534 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	textdomain (GETTEXT_PACKAGE);
#line 2563 "FuzzyClockApplet.c"
}

/**
     * This is called to when the calendar app is updated/changed
     */
static void
fuzzy_clock_applet_update_cal (FuzzyClockApplet* self)
{
	GAppInfo* _tmp0_;
	GtkButton* _tmp1_;
	GAppInfo* _tmp2_;
#line 540 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 542 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = g_app_info_get_default_for_type (CALENDAR_MIME, FALSE);
#line 542 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->priv->calprov);
#line 542 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->priv->calprov = _tmp0_;
#line 543 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp1_ = self->priv->cal_button;
#line 543 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp2_ = self->priv->calprov;
#line 543 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, _tmp2_ != NULL);
#line 2589 "FuzzyClockApplet.c"
}

/**
     * This is called to launch Date and Time Settings app
     */
static void
fuzzy_clock_applet_on_date_activate (FuzzyClockApplet* self)
{
	BudgiePopover* _tmp0_;
	GDesktopAppInfo* app_info = NULL;
	GDesktopAppInfo* _tmp1_;
	GDesktopAppInfo* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 549 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 551 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = self->priv->popover;
#line 551 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 552 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp1_ = g_desktop_app_info_new ("gnome-datetime-panel.desktop");
#line 552 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	app_info = _tmp1_;
#line 554 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp2_ = app_info;
#line 554 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (_tmp2_ == NULL) {
#line 555 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_object_unref0 (app_info);
#line 555 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		return;
#line 2621 "FuzzyClockApplet.c"
	}
	{
		GDesktopAppInfo* _tmp3_;
#line 558 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp3_ = app_info;
#line 558 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		g_app_info_launch ((GAppInfo*) _tmp3_, NULL, NULL, &_inner_error0_);
#line 558 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2631 "FuzzyClockApplet.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 557 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		e = _inner_error0_;
#line 557 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_inner_error0_ = NULL;
#line 560 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp4_ = e;
#line 560 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp5_ = _tmp4_->message;
#line 560 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		g_message ("FuzzyClockApplet.vala:560: Unable to launch gnome-datetime-panel.deskt" \
"op: %s", _tmp5_);
#line 557 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_error_free0 (e);
#line 2653 "FuzzyClockApplet.c"
	}
	__finally0:
#line 557 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 557 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_object_unref0 (app_info);
#line 557 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 557 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		g_clear_error (&_inner_error0_);
#line 557 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		return;
#line 2666 "FuzzyClockApplet.c"
	}
#line 549 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (app_info);
#line 2670 "FuzzyClockApplet.c"
}

/**
     * This is called to launch calendar app when user selects from drop-down
     */
static void
fuzzy_clock_applet_on_cal_activate (FuzzyClockApplet* self)
{
	BudgiePopover* _tmp0_;
	GAppInfo* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 567 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 569 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = self->priv->popover;
#line 569 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 571 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp1_ = self->priv->calprov;
#line 571 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (_tmp1_ == NULL) {
#line 572 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		return;
#line 2694 "FuzzyClockApplet.c"
	}
	{
		GAppInfo* _tmp2_;
#line 575 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp2_ = self->priv->calprov;
#line 575 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		g_app_info_launch (_tmp2_, NULL, NULL, &_inner_error0_);
#line 575 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2704 "FuzzyClockApplet.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GAppInfo* _tmp3_;
		const gchar* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 574 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		e = _inner_error0_;
#line 574 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_inner_error0_ = NULL;
#line 577 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp3_ = self->priv->calprov;
#line 577 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp4_ = g_app_info_get_name (_tmp3_);
#line 577 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp5_ = e;
#line 577 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp6_ = _tmp5_->message;
#line 577 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		g_message ("FuzzyClockApplet.vala:577: Unable to launch %s: %s", _tmp4_, _tmp6_);
#line 574 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_error_free0 (e);
#line 2732 "FuzzyClockApplet.c"
	}
	__finally0:
#line 574 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 574 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 574 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		g_clear_error (&_inner_error0_);
#line 574 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		return;
#line 2743 "FuzzyClockApplet.c"
	}
}

static void
fuzzy_clock_applet_real_update_popovers (BudgieApplet* base,
                                         BudgiePopoverManager* manager)
{
	FuzzyClockApplet * self;
	GtkEventBox* _tmp0_;
	BudgiePopover* _tmp1_;
#line 581 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self = (FuzzyClockApplet*) base;
#line 583 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->priv->manager = manager;
#line 584 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = self->widget;
#line 584 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp1_ = self->priv->popover;
#line 584 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	budgie_popover_manager_register_popover (manager, (GtkWidget*) _tmp0_, _tmp1_);
#line 2764 "FuzzyClockApplet.c"
}

/**
     * This is called when any of the preferences are changed
     */
void
fuzzy_clock_applet_on_settings_change (FuzzyClockApplet* self,
                                       const gchar* key)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 592 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	static GQuark _tmp1_label0 = 0;
#line 592 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	static GQuark _tmp1_label1 = 0;
#line 590 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 590 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_if_fail (key != NULL);
#line 592 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = key;
#line 592 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 592 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("clock-format")))) {
#line 592 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		switch (0) {
#line 2792 "FuzzyClockApplet.c"
			default:
			{
				GtkCheckButton* _tmp3_;
				ClockFormat f = 0;
				GSettings* _tmp4_;
				GtkCheckButton* _tmp5_;
				GtkCheckButton* _tmp6_;
#line 594 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp3_ = self->priv->clock_format;
#line 594 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				g_signal_handler_block ((void*) _tmp3_, self->priv->check_id);
#line 595 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp4_ = self->settings;
#line 595 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				f = (ClockFormat) g_settings_get_enum (_tmp4_, key);
#line 596 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				self->ampm = f == CLOCK_FORMAT_TWELVE;
#line 597 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp5_ = self->priv->clock_format;
#line 597 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				gtk_toggle_button_set_active ((GtkToggleButton*) _tmp5_, f == CLOCK_FORMAT_TWENTYFOUR);
#line 598 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				fuzzy_clock_applet_update_clock (self);
#line 599 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp6_ = self->priv->clock_format;
#line 599 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				g_signal_handler_unblock ((void*) _tmp6_, self->priv->check_id);
#line 600 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				break;
#line 2822 "FuzzyClockApplet.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("clock-show-date")))) {
#line 592 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		switch (0) {
#line 2828 "FuzzyClockApplet.c"
			default:
			{
#line 602 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				fuzzy_clock_applet_update_clock (self);
#line 603 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				break;
#line 2835 "FuzzyClockApplet.c"
			}
		}
	}
}

/**
     * Update the date if necessary
     */
void
fuzzy_clock_applet_update_date (FuzzyClockApplet* self)
{
	GtkCheckButton* _tmp0_;
	gchar* ftime = NULL;
	gchar* old = NULL;
	GtkLabel* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	GDateTime* _tmp10_;
	gchar* ctime = NULL;
	GDateTime* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	GtkLabel* _tmp16_;
	const gchar* _tmp17_;
#line 610 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 612 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = self->priv->check_date;
#line 612 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (!gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_)) {
#line 613 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		return;
#line 2870 "FuzzyClockApplet.c"
	}
#line 617 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (self->priv->orient == GTK_ORIENTATION_HORIZONTAL) {
#line 2874 "FuzzyClockApplet.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 618 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp1_ = self->priv->date_format;
#line 618 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 618 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_free0 (ftime);
#line 618 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		ftime = _tmp2_;
#line 2885 "FuzzyClockApplet.c"
	} else {
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 620 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp3_ = self->priv->date_format;
#line 620 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp4_ = g_strconcat ("<small>", _tmp3_, NULL);
#line 620 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp5_ = _tmp4_;
#line 620 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp6_ = g_strconcat (_tmp5_, "</small>", NULL);
#line 620 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_free0 (ftime);
#line 620 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		ftime = _tmp6_;
#line 620 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_free0 (_tmp5_);
#line 2905 "FuzzyClockApplet.c"
	}
#line 624 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp7_ = self->date_label;
#line 624 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp8_ = gtk_label_get_label (_tmp7_);
#line 624 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 624 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	old = _tmp9_;
#line 626 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp10_ = g_date_time_new_now_local ();
#line 626 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_date_time_unref0 (self->priv->time);
#line 626 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->priv->time = _tmp10_;
#line 627 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp11_ = self->priv->time;
#line 627 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp12_ = ftime;
#line 627 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp13_ = g_date_time_format (_tmp11_, _tmp12_);
#line 627 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	ctime = _tmp13_;
#line 629 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp14_ = old;
#line 629 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp15_ = ctime;
#line 629 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (g_strcmp0 (_tmp14_, _tmp15_) == 0) {
#line 630 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_free0 (ctime);
#line 630 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_free0 (old);
#line 630 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_free0 (ftime);
#line 630 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		return;
#line 2943 "FuzzyClockApplet.c"
	}
#line 633 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp16_ = self->date_label;
#line 633 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp17_ = ctime;
#line 633 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_label_set_markup (_tmp16_, _tmp17_);
#line 610 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_free0 (ctime);
#line 610 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_free0 (old);
#line 610 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_free0 (ftime);
#line 2957 "FuzzyClockApplet.c"
}

/**
     * This is called once thirty-seconds, updating the displayed time
     */
gboolean
fuzzy_clock_applet_update_clock (FuzzyClockApplet* self)
{
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	gint hour = 0;
	GDateTime* _tmp1_;
	gint minute = 0;
	GDateTime* _tmp2_;
	gint rule = 0;
	FuzzyClockRule** _tmp3_;
	gint _tmp3__length1;
	FuzzyClockRule* _tmp4_;
	gchar* ftime = NULL;
	gchar* old = NULL;
	GtkLabel* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* ctime = NULL;
	const gchar* _tmp17_;
	gchar** _tmp18_;
	gint _tmp18__length1;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	GtkLabel* _tmp23_;
	const gchar* _tmp24_;
	gboolean result;
#line 639 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 641 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 641 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	now = _tmp0_;
#line 642 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp1_ = now;
#line 642 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	hour = g_date_time_get_hour (_tmp1_);
#line 643 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp2_ = now;
#line 643 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	minute = g_date_time_get_minute (_tmp2_) + 2;
#line 644 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	rule = ((gint) floor ((gdouble) (minute / 5))) % 12;
#line 647 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (minute >= 60) {
#line 648 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		hour += 1;
#line 3012 "FuzzyClockApplet.c"
	}
#line 651 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp3_ = self->rules;
#line 651 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp3__length1 = self->rules_length1;
#line 651 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp4_ = _tmp3_[rule];
#line 651 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	hour += _tmp4_->hour_offset;
#line 653 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (hour < 0) {
#line 654 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		hour += 24;
#line 3026 "FuzzyClockApplet.c"
	} else {
#line 655 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		if (hour >= 24) {
#line 656 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			hour -= 24;
#line 3032 "FuzzyClockApplet.c"
		} else {
			gboolean _tmp5_ = FALSE;
#line 657 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			if (self->ampm) {
#line 657 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp5_ = hour >= 13;
#line 3039 "FuzzyClockApplet.c"
			} else {
#line 657 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				_tmp5_ = FALSE;
#line 3043 "FuzzyClockApplet.c"
			}
#line 657 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			if (_tmp5_) {
#line 658 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
				hour -= 12;
#line 3049 "FuzzyClockApplet.c"
			}
		}
	}
#line 661 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (self->priv->orient == GTK_ORIENTATION_HORIZONTAL) {
#line 3055 "FuzzyClockApplet.c"
		FuzzyClockRule** _tmp6_;
		gint _tmp6__length1;
		FuzzyClockRule* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 662 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp6_ = self->rules;
#line 662 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp6__length1 = self->rules_length1;
#line 662 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp7_ = _tmp6_[rule];
#line 662 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp8_ = _tmp7_->format;
#line 662 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp9_ = g_strdup_printf (" %s ", _tmp8_);
#line 662 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_free0 (ftime);
#line 662 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		ftime = _tmp9_;
#line 3075 "FuzzyClockApplet.c"
	} else {
		FuzzyClockRule** _tmp10_;
		gint _tmp10__length1;
		FuzzyClockRule* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
#line 664 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp10_ = self->rules;
#line 664 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp10__length1 = self->rules_length1;
#line 664 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp11_ = _tmp10_[rule];
#line 664 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp12_ = _tmp11_->format;
#line 664 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp13_ = g_strdup_printf (" <small>%s</small> ", _tmp12_);
#line 664 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_free0 (ftime);
#line 664 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		ftime = _tmp13_;
#line 3096 "FuzzyClockApplet.c"
	}
#line 666 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	fuzzy_clock_applet_update_date (self);
#line 669 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp14_ = self->clock;
#line 669 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp15_ = gtk_label_get_label (_tmp14_);
#line 669 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp16_ = g_strdup (_tmp15_);
#line 669 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	old = _tmp16_;
#line 670 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp17_ = ftime;
#line 670 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp18_ = self->hours;
#line 670 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp18__length1 = self->hours_length1;
#line 670 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp19_ = _tmp18_[hour];
#line 670 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp20_ = g_strdup_printf (_tmp17_, _tmp19_);
#line 670 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	ctime = _tmp20_;
#line 671 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp21_ = old;
#line 671 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp22_ = ctime;
#line 671 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (g_strcmp0 (_tmp21_, _tmp22_) == 0) {
#line 672 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		if (!self->priv->fuzzy_onpanel) {
#line 673 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			result = FALSE;
#line 673 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			_g_free0 (ctime);
#line 673 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			_g_free0 (old);
#line 673 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			_g_free0 (ftime);
#line 673 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			_g_date_time_unref0 (now);
#line 673 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
			return result;
#line 3140 "FuzzyClockApplet.c"
		}
#line 675 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		result = TRUE;
#line 675 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_free0 (ctime);
#line 675 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_free0 (old);
#line 675 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_free0 (ftime);
#line 675 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_date_time_unref0 (now);
#line 675 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		return result;
#line 3154 "FuzzyClockApplet.c"
	}
#line 679 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp23_ = self->clock;
#line 679 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp24_ = ctime;
#line 679 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_label_set_markup (_tmp23_, _tmp24_);
#line 680 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 681 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	result = self->priv->fuzzy_onpanel;
#line 681 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_free0 (ctime);
#line 681 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_free0 (old);
#line 681 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_free0 (ftime);
#line 681 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_date_time_unref0 (now);
#line 681 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return result;
#line 3176 "FuzzyClockApplet.c"
}

const gchar*
fuzzy_clock_applet_get_uuid (FuzzyClockApplet* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 58 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 58 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = self->priv->_uuid;
#line 58 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	result = _tmp0_;
#line 58 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return result;
#line 3192 "FuzzyClockApplet.c"
}

void
fuzzy_clock_applet_set_uuid (FuzzyClockApplet* self,
                             const gchar* value)
{
	gchar* old_value;
#line 58 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_if_fail (self != NULL);
#line 58 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	old_value = fuzzy_clock_applet_get_uuid (self);
#line 58 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3206 "FuzzyClockApplet.c"
		gchar* _tmp0_;
#line 58 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_tmp0_ = g_strdup (value);
#line 58 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		_g_free0 (self->priv->_uuid);
#line 58 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		self->priv->_uuid = _tmp0_;
#line 58 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		g_object_notify_by_pspec ((GObject *) self, fuzzy_clock_applet_properties[FUZZY_CLOCK_APPLET_UUID_PROPERTY]);
#line 3216 "FuzzyClockApplet.c"
	}
}

static void
fuzzy_clock_applet_class_init (FuzzyClockAppletClass * klass,
                               gpointer klass_data)
{
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	fuzzy_clock_applet_parent_class = g_type_class_peek_parent (klass);
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_type_class_adjust_private_offset (klass, &FuzzyClockApplet_private_offset);
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	((BudgieAppletClass *) klass)->panel_position_changed = (void (*) (BudgieApplet*, BudgiePanelPosition)) fuzzy_clock_applet_real_panel_position_changed;
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	((BudgieAppletClass *) klass)->update_popovers = (void (*) (BudgieApplet*, BudgiePopoverManager*)) fuzzy_clock_applet_real_update_popovers;
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_fuzzy_clock_applet_get_property;
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_fuzzy_clock_applet_set_property;
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	G_OBJECT_CLASS (klass)->finalize = fuzzy_clock_applet_finalize;
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FUZZY_CLOCK_APPLET_UUID_PROPERTY, fuzzy_clock_applet_properties[FUZZY_CLOCK_APPLET_UUID_PROPERTY] = g_param_spec_string ("uuid", "uuid", "uuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3240 "FuzzyClockApplet.c"
}

static void
fuzzy_clock_applet_instance_init (FuzzyClockApplet * self,
                                  gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar** _tmp26_;
	FuzzyClockRule* _tmp27_;
	FuzzyClockRule* _tmp28_;
	FuzzyClockRule* _tmp29_;
	FuzzyClockRule* _tmp30_;
	FuzzyClockRule* _tmp31_;
	FuzzyClockRule* _tmp32_;
	FuzzyClockRule* _tmp33_;
	FuzzyClockRule* _tmp34_;
	FuzzyClockRule* _tmp35_;
	FuzzyClockRule* _tmp36_;
	FuzzyClockRule* _tmp37_;
	FuzzyClockRule* _tmp38_;
	FuzzyClockRule** _tmp39_;
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->priv = fuzzy_clock_applet_get_instance_private (self);
#line 61 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->priv->fuzzy_onpanel = TRUE;
#line 63 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = g_strdup ("com.solus-project.budgie-panel");
#line 63 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->priv->general_path = _tmp0_;
#line 98 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp1_ = g_strdup ("");
#line 98 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->priv->date_format = _tmp1_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp2_ = g_strdup (_ ("midnight"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp3_ = g_strdup (_ ("one"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp4_ = g_strdup (_ ("two"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp5_ = g_strdup (_ ("three"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp6_ = g_strdup (_ ("four"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp7_ = g_strdup (_ ("five"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp8_ = g_strdup (_ ("six"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp9_ = g_strdup (_ ("seven"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp10_ = g_strdup (_ ("eight"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp11_ = g_strdup (_ ("nine"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp12_ = g_strdup (_ ("ten"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp13_ = g_strdup (_ ("eleven"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp14_ = g_strdup (_ ("noon"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp15_ = g_strdup (_ ("one"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp16_ = g_strdup (_ ("two"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp17_ = g_strdup (_ ("three"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp18_ = g_strdup (_ ("four"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp19_ = g_strdup (_ ("five"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp20_ = g_strdup (_ ("six"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp21_ = g_strdup (_ ("seven"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp22_ = g_strdup (_ ("eight"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp23_ = g_strdup (_ ("nine"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp24_ = g_strdup (_ ("ten"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp25_ = g_strdup (_ ("eleven"));
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_ = g_new0 (gchar*, 24 + 1);
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[0] = _tmp2_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[1] = _tmp3_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[2] = _tmp4_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[3] = _tmp5_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[4] = _tmp6_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[5] = _tmp7_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[6] = _tmp8_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[7] = _tmp9_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[8] = _tmp10_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[9] = _tmp11_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[10] = _tmp12_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[11] = _tmp13_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[12] = _tmp14_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[13] = _tmp15_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[14] = _tmp16_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[15] = _tmp17_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[16] = _tmp18_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[17] = _tmp19_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[18] = _tmp20_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[19] = _tmp21_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[20] = _tmp22_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[21] = _tmp23_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[22] = _tmp24_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp26_[23] = _tmp25_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->hours = _tmp26_;
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->hours_length1 = 24;
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp27_ = fuzzy_clock_rule_new (_ ("%s-ish"), 0);
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp28_ = fuzzy_clock_rule_new (_ ("a bit past %s"), 0);
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp29_ = fuzzy_clock_rule_new (_ ("ten past %s"), 0);
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp30_ = fuzzy_clock_rule_new (_ ("quarter after %s"), 0);
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp31_ = fuzzy_clock_rule_new (_ ("twenty past %s"), 0);
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp32_ = fuzzy_clock_rule_new (_ ("almost half-past %s"), 0);
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp33_ = fuzzy_clock_rule_new (_ ("half-past %s"), 0);
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp34_ = fuzzy_clock_rule_new (_ ("twenty-five 'til %s"), 1);
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp35_ = fuzzy_clock_rule_new (_ ("twenty 'til %s"), 1);
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp36_ = fuzzy_clock_rule_new (_ ("quarter 'til %s"), 1);
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp37_ = fuzzy_clock_rule_new (_ ("ten 'til %s"), 1);
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp38_ = fuzzy_clock_rule_new (_ ("almost %s"), 1);
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp39_ = g_new0 (FuzzyClockRule*, 12 + 1);
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp39_[0] = _tmp27_;
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp39_[1] = _tmp28_;
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp39_[2] = _tmp29_;
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp39_[3] = _tmp30_;
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp39_[4] = _tmp31_;
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp39_[5] = _tmp32_;
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp39_[6] = _tmp33_;
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp39_[7] = _tmp34_;
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp39_[8] = _tmp35_;
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp39_[9] = _tmp36_;
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp39_[10] = _tmp37_;
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp39_[11] = _tmp38_;
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->rules = _tmp39_;
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->rules_length1 = 12;
#line 248 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->ampm = FALSE;
#line 254 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->priv->popover = NULL;
#line 255 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->priv->calprov = NULL;
#line 261 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->priv->orient = GTK_ORIENTATION_HORIZONTAL;
#line 263 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->priv->manager = NULL;
#line 3465 "FuzzyClockApplet.c"
}

static void
fuzzy_clock_applet_finalize (GObject * obj)
{
	FuzzyClockApplet * self;
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FUZZY_CLOCK_APPLET, FuzzyClockApplet);
#line 58 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_free0 (self->priv->_uuid);
#line 59 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->priv->panel_settings);
#line 60 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->priv->currpanelsubject_settings);
#line 63 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_free0 (self->priv->general_path);
#line 98 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_free0 (self->priv->date_format);
#line 100 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->hours = (_vala_array_free (self->hours, self->hours_length1, (GDestroyNotify) g_free), NULL);
#line 189 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	self->rules = (_vala_array_free (self->rules, self->rules_length1, (GDestroyNotify) fuzzy_clock_rule_unref), NULL);
#line 243 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->widget);
#line 244 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->layout);
#line 245 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->clock);
#line 246 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->date_label);
#line 250 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_date_time_unref0 (self->priv->time);
#line 252 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->settings);
#line 254 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->priv->popover);
#line 255 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->priv->calprov);
#line 256 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->priv->cal_button);
#line 257 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->priv->clock_format);
#line 258 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (self->priv->check_date);
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	G_OBJECT_CLASS (fuzzy_clock_applet_parent_class)->finalize (obj);
#line 3512 "FuzzyClockApplet.c"
}

GType
fuzzy_clock_applet_get_type (void)
{
	return fuzzy_clock_applet_type_id;
}

GType
fuzzy_clock_applet_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (FuzzyClockAppletClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) fuzzy_clock_applet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FuzzyClockApplet), 0, (GInstanceInitFunc) fuzzy_clock_applet_instance_init, NULL };
	fuzzy_clock_applet_type_id = g_type_module_register_type (module, budgie_applet_get_type (), "FuzzyClockApplet", &g_define_type_info, 0);
	FuzzyClockApplet_private_offset = sizeof (FuzzyClockAppletPrivate);
	return fuzzy_clock_applet_type_id;
}

static void
_vala_fuzzy_clock_applet_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	FuzzyClockApplet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FUZZY_CLOCK_APPLET, FuzzyClockApplet);
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	switch (property_id) {
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		case FUZZY_CLOCK_APPLET_UUID_PROPERTY:
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		g_value_set_string (value, fuzzy_clock_applet_get_uuid (self));
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		break;
#line 3546 "FuzzyClockApplet.c"
		default:
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		break;
#line 3552 "FuzzyClockApplet.c"
	}
}

static void
_vala_fuzzy_clock_applet_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	FuzzyClockApplet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FUZZY_CLOCK_APPLET, FuzzyClockApplet);
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	switch (property_id) {
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		case FUZZY_CLOCK_APPLET_UUID_PROPERTY:
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		fuzzy_clock_applet_set_uuid (self, g_value_get_string (value));
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		break;
#line 3572 "FuzzyClockApplet.c"
		default:
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 56 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
		break;
#line 3578 "FuzzyClockApplet.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 690 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	return self ? g_object_ref (self) : NULL;
#line 3587 "FuzzyClockApplet.c"
}

void
peas_register_types (GTypeModule* module)
{
	PeasObjectModule* objmodule = NULL;
	PeasObjectModule* _tmp0_;
#line 687 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	g_return_if_fail (module != NULL);
#line 687 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	fuzzy_clock_plugin_register_type (module);
#line 687 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	fuzzy_clock_rule_register_type (module);
#line 687 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	fuzzy_clock_applet_register_type (module);
#line 690 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (module, peas_object_module_get_type ()) ? ((PeasObjectModule*) module) : NULL);
#line 690 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	objmodule = _tmp0_;
#line 691 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	peas_object_module_register_extension_type (objmodule, budgie_plugin_get_type (), TYPE_FUZZY_CLOCK_PLUGIN);
#line 687 "../budgie-fuzzyclock/src/FuzzyClockApplet.vala"
	_g_object_unref0 (objmodule);
#line 3611 "FuzzyClockApplet.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

